<?php

namespace Teknisa\MAN\Utilities;

class Query {

    // -------------------------- OPERADOR --------------------------
    const GET_TURNOS = "
        SELECT NRSEQTURNO, NRTURNO AS NRTURNO, DSTURNO AS DSTURNO, DTINICIOTURNO AS DTINICIOTURNO, DTFIMTURNO AS DTFIMTURNO, IDATIVO AS IDATIVO
          FROM VND_TURNO
    ";

    const GET_FILIAIS = "
    SELECT DISTINCT  L.CDFILIAL||'_'||L.CDLOJA  AS FILIPAI, FL.CDFILIAL AS PARENT , FL.CDFILIAL, L.CDLOJA, 'Loja:'|| L.CDLOJA||' - '||L.NMLOJA AS DESCRICAO,
    'Filial:'||FL.CDFILIAL||' - '||FL.NMFILIAL||' '||'   Loja: '||L.CDLOJA||' - '||L.NMLOJA AS FILILOJA FROM LOJA L
    LEFT JOIN FILIAL FL ON FL.CDFILIAL = FL.CDFILIAL
    UNION
    SELECT F.CDFILIAL AS FILIPAI, '' AS PARENT, F.CDFILIAL AS FILIPAI, '' AS CDLOJA,  'Filial:'||F.CDFILIAL||' - '||F.NMFILIAL AS DESCRICAO, '' AS FILILOJA FROM FILIAL F
    ";

    const FIND_TURNOS = "
    SELECT DISTINCT RT.NRRELACIONAMENTO AS NRRELACIONAMENTO , RT.NRSEQTURNO AS NRSEQTURNO, L.CDFILIAL||'_'||L.CDLOJA  AS FILIPAIT, L.CDFILIAL AS PARENTT, FL.CDFILIAL, L.CDFILIAL AS CDFILIAL, L.CDLOJA, 'Loja:'|| L.CDLOJA||' - '||L.NMLOJA AS DESCRICAOT, 'Filial:'||FL.CDFILIAL||' - '||FL.NMFILIAL||' '||'   Loja: '||L.CDLOJA||' - '||L.NMLOJA AS FILILOJAT FROM LOJA L JOIN FILIAL FL ON L.CDFILIAL = FL.CDFILIAL AND L.NRORG   = FL.NRORG JOIN VND_RELACIONAMENTOTURNO RT ON RT.CDFILIAL = L.CDFILIAL AND RT.CDLOJA = L.CDLOJA
    WHERE RT.NRSEQTURNO = :NRSEQTURNO AND L.CDFILIAL||'_'||L.CDLOJA = :FILIPAIT";

    const GET_ALL_VND_PARAMETROS = "
    SELECT NRPARAMETRO, CODPARAMETRO, NRPARENT, DESCPARAMETRO AS PARAMETRO, CODPARAMETRO || ' - ' ||DESCPARAMETRO AS DESCRICAO FROM VND_PARAMETRO WHERE IDATIVO = :IDATIVO ORDER BY CODPARAMETRO
    ";

    const GET_ALL_VND_HIERARQUIAPARAM = "
    SELECT PA.CODPARAMETRO, PA.NRPARENT, PH.NRPARAMETRO, PH.NRRELHIERARQUIAPARAMETRO, PH.DESCHIERARQUIA, PH.NRPRIORIDADEHIERARQUIA FROM VND_RELHIERARQUIAPARAMETRO PH
    LEFT JOIN VND_PARAMETRO PA ON PH.NRPARAMETRO = PA.NRPARAMETRO
    ORDER BY PH.NRPARAMETRO, PH.NRPRIORIDADEHIERARQUIA
    ";

    const GET_TREE_PARAMSPDV_BY_NRORG = "
    SELECT DISTINCT  FL.NMFILIAL,'' AS NMLOJA, C.CDFILIAL||'_'||C.CDLOJA  AS FILIPAI, C.CDFILIAL AS PARENT , FL.CDFILIAL, C.CDLOJA, 'Loja:'|| C.CDLOJA||' - '||LJ.NMLOJA  AS DESCRICAO,
    '' AS FILILOJA, '' AS CDCAIXA, 'CDLOJA' AS ID,'true' AS \"_opened\" FROM CAIXA C
      LEFT JOIN FILIAL FL ON C.CDFILIAL = FL.CDFILIAL AND C.NRORG = FL.NRORG
    LEFT JOIN LOJA LJ ON C.CDLOJA= LJ.CDLOJA AND C.CDFILIAL = LJ.CDFILIAL AND C.NRORG = LJ.NRORG
    WHERE FL.NRORG = :NRORG

    UNION
    ---PAI----
    SELECT F.NMFILIAL, '' AS NMLOJA, F.CDFILIAL AS FILIPAI,  '' AS PARENT, F.CDFILIAL AS FILIPAI, '' AS CDLOJA,  'Filial:'||F.CDFILIAL||' - '||F.NMFILIAL AS DESCRICAO, '' AS FILILOJA, '' AS CDCAIXA,
    'CDFILIAL' AS ID,'true' AS \"_opened\" FROM FILIAL F
    WHERE F.NRORG = :NRORG

    UNION
    --- PDV ----
    SELECT DISTINCT  FL.NMFILIAL AS NMFILIAL, LJ.NMLOJA AS NMLOJA, C.CDFILIAL||'_'||C.CDLOJA||'_'||C.CDCAIXA  AS FILIPAI, C.CDFILIAL||'_'||C.CDLOJA AS PARENT , FL.CDFILIAL,C.CDLOJA AS CDLOJA,
    'PDV:'|| C.CDCAIXA||' - '||C.NMCAIXA AS DESCRICAO,'Filial:'||FL.CDFILIAL||' - '||FL.NMFILIAL||'  Loja:'||C.CDLOJA||'    PDV:'||C.CDCAIXA||' - '||C.NMCAIXA AS FILILOJA, C.CDCAIXA AS CDCAIXA,
    'CDCAIXA' AS ID,'true' AS \"_opened\" FROM CAIXA C
    LEFT JOIN FILIAL FL ON C.CDFILIAL = FL.CDFILIAL AND FL.NRORG = C.NRORG
    LEFT JOIN LOJA LJ ON C.CDLOJA= LJ.CDLOJA AND C.CDFILIAL = LJ.CDFILIAL AND C.NRORG = LJ.NRORG
    WHERE FL.NRORG = :NRORG
    ";

    const GET_MAXNRPARAMETRO = "
     SELECT MAX(NRPARAMETROVALOR) AS MAX FROM VND_PARAMETROVALOR
    ";

    const GET_MAXNRRELPARAMETRO = "
     SELECT MAX(NRRELPARAMETROVALOR) AS MAX FROM VND_RELPARAMETROVALOR
    ";

    const GET_PARAMVALUE_BYPARAM = "
     SELECT PR.NRRELPARAMETROVALOR, PR.NRPARAMETROVALOR, PR.DESCRELACIONAMENTO, PR.VALOR, PV.VALORPARAMETRO AS PARAMETROV,'GERAL' AS ID FROM VND_RELPARAMETROVALOR PR
     LEFT JOIN VND_PARAMETROVALOR PV ON PV.NRPARAMETROVALOR = PR.NRPARAMETROVALOR
     WHERE PV.NRPARAMETRO = :PARAMETRO AND PR.DESCRELACIONAMENTO= :RELACIONAMENTO AND PV.NRORG = :NRORG
     ";

     const INSERT_PARAMETROVALOR = "
     INSERT INTO VND_PARAMETROVALOR (NRPARAMETROVALOR, NRPARAMETRO, VALORPARAMETRO, NRORG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
     VALUES (:NRPARAMETROVALOR, :NRPARAMETRO, :VALORPARAMETRO, :NRORGINCLUSAO, SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO)
     ";

     const INSERT_RELPARAMETROVALOR = "
     INSERT INTO VND_RELPARAMETROVALOR (NRRELPARAMETROVALOR, NRPARAMETROVALOR, DESCRELACIONAMENTO, VALOR, NRORG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
     VALUES (:NRRELPARAMETROVALOR, :NRPARAMETROVALOR, :DESCRELACIONAMENTO, :VALOR, :NRORG, SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO)
     ";

     const UPDATE_RELPARAMETROVALOR = "
     UPDATE VND_RELPARAMETROVALOR SET NRPARAMETROVALOR = :NRPARAMETROVALOR, DTULTATU = SYSDATE, CDOPERULTATU = :CDOPERULTATU, NRORGULTATU = :NRORG WHERE DESCRELACIONAMENTO = :DESCRELACIONAMENTO AND
     NRRELPARAMETROVALOR = :NRRELPARAMETROVALOR AND NRORG = :NRORG
     ";

     const GETPARAMVALUE_BYNRPARAMETRO = "
     SELECT * FROM VND_PARAMETROVALOR WHERE NRPARAMETRO = :NRPARAMETRO AND NRORG = :NRORG
     ";

     const GETRELPARAMVALOR_BYNRPARAMETROVALOR = "
     SELECT PA.NRPARAMETRO, PV.NRPARAMETROVALOR, PV.VALORPARAMETRO, PR.DESCRELACIONAMENTO, PR.NRRELPARAMETROVALOR, PR.VALOR FROM VND_PARAMETROVALOR PV
     LEFT JOIN VND_PARAMETRO PA ON PA.NRPARAMETRO = PV.NRPARAMETRO
     LEFT JOIN VND_RELPARAMETROVALOR PR ON PR.NRPARAMETROVALOR = PV.NRPARAMETROVALOR AND PR.NRORG = PV.NRORG
     WHERE  PA.NRPARAMETRO = :NRPARAMETRO AND PR.DESCRELACIONAMENTO <> 'GERAL' AND PR.NRORG = :NRORG
     AND PR.DESCRELACIONAMENTO = :DESCRELACIONAMENTO AND PR.VALOR = :VALOR
     ";

     const GETRELPARAMVALOR_BYNRPARAMETROVALOR_GERAL = "
     SELECT PA.NRPARAMETRO, PV.NRPARAMETROVALOR, PV.VALORPARAMETRO, PR.DESCRELACIONAMENTO, PR.NRRELPARAMETROVALOR, PR.VALOR FROM VND_PARAMETROVALOR PV
     LEFT JOIN VND_PARAMETRO PA ON PA.NRPARAMETRO = PV.NRPARAMETRO
     LEFT JOIN VND_RELPARAMETROVALOR PR ON PR.NRPARAMETROVALOR = PV.NRPARAMETROVALOR AND PR.NRORG = PV.NRORG
     WHERE  PA.NRPARAMETRO = :NRPARAMETRO AND PR.NRORG = :NRORG
     AND PR.DESCRELACIONAMENTO = :DESCRELACIONAMENTO AND PR.VALOR IS NULL
     ";

     const GETRELPARAMVALOR_BYDESCRELACIONAMENTO = "
     SELECT PA.NRPARAMETRO, PV.NRPARAMETROVALOR, PV.VALORPARAMETRO, PR.DESCRELACIONAMENTO, PR.NRRELPARAMETROVALOR, PR.VALOR FROM VND_PARAMETROVALOR PV
     LEFT JOIN VND_PARAMETRO PA ON PA.NRPARAMETRO = PV.NRPARAMETRO
     LEFT JOIN VND_RELPARAMETROVALOR PR ON PR.NRPARAMETROVALOR = PV.NRPARAMETROVALOR AND PR.NRORG = PV.NRORG
     WHERE PA.NRPARAMETRO = :NRPARAMETRO AND PR.DESCRELACIONAMENTO <> 'GERAL' AND PR.NRORG = :NRORG
     AND PV.NRPARAMETROVALOR = :NRPARAMETROVALOR AND PR.DESCRELACIONAMENTO = :DESCRELACIONAMENTO AND PR.VALOR = :VALOR
     ";

     const GETRELPARAMVALUE_SEMVALOR = "
     SELECT PA.NRPARAMETRO, PV.NRPARAMETROVALOR, PV.VALORPARAMETRO, PR.DESCRELACIONAMENTO, PR.NRRELPARAMETROVALOR, PR.VALOR FROM VND_PARAMETROVALOR PV
     LEFT JOIN VND_PARAMETRO PA ON PA.NRPARAMETRO = PV.NRPARAMETRO
     LEFT JOIN VND_RELPARAMETROVALOR PR ON PR.NRPARAMETROVALOR = PV.NRPARAMETROVALOR AND PR.NRORG = PV.NRORG
     WHERE PA.NRPARAMETRO = :NRPARAMETRO AND PR.DESCRELACIONAMENTO <> 'GERAL' AND PR.NRORG = :NRORG
     AND PV.NRPARAMETROVALOR = :NRPARAMETROVALOR AND PR.DESCRELACIONAMENTO = :DESCRELACIONAMENTO
     ";

     const GETPARAMETROVALOR_BYVALORPARAMETRO = "
     SELECT NRPARAMETROVALOR FROM VND_PARAMETROVALOR WHERE NRPARAMETRO = :NRPARAMETRO  AND VALORPARAMETRO =:VALORPARAMETRO AND NRORG = :NRORG
     ";

     const GET_MAXCODPARAMETRO = "
     SELECT * FROM VND_PARAMETRO WHERE NRPARENT IS NULL
     ";

     const GET_ALLOPCAOPARAMETRO = "
     SELECT * FROM VND_OPCAOPARAMETRO
     ";

     const GET_TIPORECE = "
     SELECT T.CDTIPORECE, T.NMTIPORECE, T.VRTAXAADMI,  T.VRTAXAADMI AS VRTAXAADMID, T.NRDIASADMI, T.IDGERAFIN, T.IDGERAFIN AS IDGERAFIND, T.CDTPCTRECEB,T.CDTPCTRECEB||'- '||TC.DSTPCTRECEB AS CDTPCTRECEBD, T.CDTPBAIXAREC, T.CDTPBAIXAREC||'-  '||TB.NMTPBAIXAREC AS CDTPBAIXARECD,
     T.CDCLIENTE,T.CDCLIENTE||'-  '||C.NMFANTCLIE AS CDCLIENTED, T.CDFORMPGTO,T.CDFORMPGTO||'-  '||F.NMFORMPGTO AS CDFORMPGTOD,  T.NRORG FROM TIPORECE T
     LEFT JOIN FORMPGTO F ON F.CDFORMPGTO = T.CDFORMPGTO AND F.NRORG= T.NRORG
     LEFT JOIN TIPOBAIXAREC TB  ON TB.CDTPBAIXAREC = T.CDTPBAIXAREC AND TB.NRORG = T.NRORG
     LEFT JOIN TIPOCTRECEBER TC ON TC.CDTPCTRECEB = T.CDTPCTRECEB AND TC.NRORG = T.NRORG
     LEFT JOIN CLIENTE C  ON C.CDCLIENTE = T.CDCLIENTE AND C.NRORG= T.NRORG
     WHERE T.NRORG = :NRORG AND T.IDATIVO= 'S' ORDER BY T.CDTIPORECE
     ";

     const GET_FILIAIS_LOJAS = "
     SELECT DISTINCT  FL.NMFILIAL,'' AS NMLOJA, C.CDFILIAL||'_'||C.CDLOJA  AS FILIPAI, C.CDFILIAL AS PARENT , FL.CDFILIAL, C.CDLOJA, 'Loja:'|| C.CDLOJA||' - '||LJ.NMLOJA  AS DESCRICAO,
    '' AS FILILOJA, '' AS CDCAIXA, 'CDLOJA' AS ID,'true' AS \"_opened\" FROM CAIXA C
    LEFT JOIN FILIAL FL ON C.CDFILIAL = FL.CDFILIAL AND C.NRORG = FL.NRORG
    LEFT JOIN LOJA LJ ON C.CDLOJA= LJ.CDLOJA AND C.CDFILIAL = LJ.CDFILIAL AND C.NRORG = LJ.NRORG
    WHERE FL.NRORG = :NRORG

    UNION
    ---PAI----
    SELECT F.NMFILIAL, '' AS NMLOJA, F.CDFILIAL AS FILIPAI,  '' AS PARENT, F.CDFILIAL AS FILIPAI, '' AS CDLOJA,  'Filial:'||F.CDFILIAL||' - '||F.NMFILIAL AS DESCRICAO, '' AS FILILOJA, '' AS CDCAIXA,
    'CDFILIAL' AS ID,'true' AS \"_opened\" FROM FILIAL F WHERE F.NRORG = :NRORG
    ";

    const GET_PARAM_TIPORECE = "
    SELECT PR.NRRELPARAMETROVALOR, PR.NRPARAMETROVALOR, PR.DESCRELACIONAMENTO, PR.VALOR, PV.VALORPARAMETRO,'TIPORECE' AS ID FROM VND_RELPARAMETROVALOR PR
    LEFT JOIN VND_PARAMETROVALOR PV ON PV.NRPARAMETROVALOR = PR.NRPARAMETROVALOR
    WHERE PV.NRPARAMETRO = :PARAMETRO AND PR.DESCRELACIONAMENTO= :RELACIONAMENTO AND PV.NRORG = :NRORG AND VALOR = :VALOR
    ";

    const GET_CLIENTES = "
    SELECT C.CDCLIENTE, C.NMFANTCLIE, C.CDCLIENTE||'- '||C.NMFANTCLIE AS PARAMETROV, C.NRPARCNEGOCIO, PA.NRORG FROM CLIENTE C LEFT JOIN PARCNEGOCIO PC  ON PC.NRORG = C.NRORG AND PC.NRPARCNEGOCIO = C.NRPARCNEGOCIO LEFT JOIN PARCERIA PA     ON PA.NRPARCNEGOCIO = PC.NRPARCNEGOCIO AND PA.NRORG=PC.NRORG LEFT JOIN TIPOPARCEIRO TP ON  TP.CDTIPOPARCEIRO = PA.CDTIPOPARCEIRO AND TP.NRORG = PA.NRORG WHERE PA.CDTIPOPARCEIRO = 'CLIENTE' AND PA.NRORG = :NRORG
    ";

    const GET_FORMPGTO = "
    SELECT CDFORMPGTO, NMFORMPGTO, CDFORMPGTO||'- '||NMFORMPGTO AS PARAMETROV FROM FORMPGTO WHERE NRORG = :NRORG
    ";

    const GET_TIPOBAIXARECE = "
    SELECT CDTPBAIXAREC, NMTPBAIXAREC, CDTPBAIXAREC||'- '||NMTPBAIXAREC AS PARAMETROV FROM TIPOBAIXAREC WHERE NRORG = :NRORG ORDER BY CDTPBAIXAREC
    ";

    const GET_TIPORECEFILIAL = "
    SELECT TI.CDTIPORECE,  TI.NMTIPORECE, T.CDFILIAL, T.VRTAXAADMFIL  AS VRTAXAADMI, T.VRTAXAADMFIL  AS VRTAXAADMID, T.NRDIASADMIFIL AS NRDIASADMI,  T.NRDIASADMIFIL AS NRDIASADMID,
    T.IDGERAFINFIL  AS IDGERAFIN, T.IDGERAFINFIL  AS IDGERAFIND,  T.CDTPBAIXAREC||'-  '||TB.NMTPBAIXAREC AS CDTPBAIXARECD,  T.CDFORMPGTO,  T.CDFORMPGTO  ||'-  '||F.NMFORMPGTO AS CDFORMPGTOD,  T.NRORG FROM TIPORECE TI
    LEFT JOIN FORMPGTO F ON F.CDFORMPGTO = TI.CDFORMPGTO AND F.NRORG     = TI.NRORG
    LEFT JOIN TIPOBAIXAREC TB ON TB.CDTPBAIXAREC = TI.CDTPBAIXAREC AND TB.NRORG       = TI.NRORG
    LEFT JOIN TIPORECEFILIAL T ON TI.CDTIPORECE= T.CDTIPORECE AND TI.NRORG    =T.NRORG
    WHERE TI.NRORG  = :NRORG AND TI.IDATIVO  = 'S' ORDER BY TI.CDTIPORECE
    ";

    const GET_TIPORECEFILIAL_BYCDTIPORECE = "
    SELECT * FROM TIPORECEFILIAL WHERE NRORG = :NRORG AND CDTIPORECE = :CDTIPORECE AND IDATIVO = 'S'
    ";

    const GET_FILIAIS_BYNRORG = "
    SELECT F.CDFILIAL AS FILIPAI, '' AS PARENT, 'Filial:'||F.CDFILIAL||' - '||F.NMFILIAL AS DESCRICAO, '' AS FILILOJA FROM FILIAL F WHERE NRORG = :NRORG
    ";

    const GET_PARAMETRO_BYRELACIONAMENTOGERAL = "
    SELECT PA.NRPARAMETRO, PA.CODPARAMETRO, PA.DESCPARAMETRO, PV.NRPARAMETROVALOR, PV.VALORPARAMETRO, PR.DESCRELACIONAMENTO, PR.VALOR
    FROM VND_PARAMETRO PA
    LEFT JOIN VND_PARAMETROVALOR PV ON PV.NRPARAMETRO = PA.NRPARAMETRO
    LEFT JOIN VND_RELPARAMETROVALOR PR ON PR.NRPARAMETROVALOR = PV.NRPARAMETROVALOR AND PR.NRORG = PV.NRORG
    WHERE PA.CODPARAMETRO = :CODPARAMETRO AND PV.NRORG = :NRORG AND PR.DESCRELACIONAMENTO = 'GERAL'
    ";

    const GET_PARAMETRO_BYDESCRELAC_VALOR = "
    SELECT PA.NRPARAMETRO, PA.CODPARAMETRO, PA.DESCPARAMETRO, PV.NRPARAMETROVALOR, PV.VALORPARAMETRO, PR.DESCRELACIONAMENTO, PR.VALOR, PR.NRRELPARAMETROVALOR
    FROM VND_PARAMETRO PA
    LEFT JOIN VND_PARAMETROVALOR PV ON PV.NRPARAMETRO = PA.NRPARAMETRO
    LEFT JOIN VND_RELPARAMETROVALOR PR ON PR.NRPARAMETROVALOR = PV.NRPARAMETROVALOR AND PR.NRORG = PV.NRORG
    WHERE PA.CODPARAMETRO = :CODPARAMETRO AND PV.NRORG = :NRORG AND PR.DESCRELACIONAMENTO = :DESCRELACIONAMENTO AND PR.VALOR = :VALOR
    ";

    const GET_PARAMETRO_BYNRPARAMETROVALOR = "
    SELECT PA.NRPARAMETRO, PA.CODPARAMETRO, PV.NRPARAMETROVALOR, PV.VALORPARAMETRO, PR.DESCRELACIONAMENTO, PR.VALOR
    FROM VND_PARAMETRO PA
    LEFT JOIN VND_PARAMETROVALOR PV ON PV.NRPARAMETRO = PA.NRPARAMETRO
    LEFT JOIN VND_RELPARAMETROVALOR PR ON PR.NRPARAMETROVALOR = PV.NRPARAMETROVALOR AND PR.NRORG = PV.NRORG
    WHERE PA.CODPARAMETRO = :CODPARAMETRO AND PV.NRORG = :NRORG AND PR.NRPARAMETROVALOR = :NRPARAMETROVALOR AND PR.DESCRELACIONAMENTO <> :DESCRELACIONAMENTO
    ";

    const GET_PARAMETRO_BYNRPARAMETROVALOR_BYDESC_BYVALOR = "
    SELECT PA.NRPARAMETRO, PA.CODPARAMETRO, PV.NRPARAMETROVALOR, PV.VALORPARAMETRO, PR.DESCRELACIONAMENTO, PR.VALOR, PR.NRRELPARAMETROVALOR
    FROM VND_PARAMETRO PA
    LEFT JOIN VND_PARAMETROVALOR PV ON PV.NRPARAMETRO = PA.NRPARAMETRO
    LEFT JOIN VND_RELPARAMETROVALOR PR ON PR.NRPARAMETROVALOR = PV.NRPARAMETROVALOR AND PR.NRORG = PV.NRORG
    WHERE PA.CODPARAMETRO = :CODPARAMETRO AND PV.NRORG = :NRORG AND PR.NRPARAMETROVALOR = :NRPARAMETROVALOR AND PR.DESCRELACIONAMENTO = :DESCRELACIONAMENTO
    AND PR.VALOR = :VALOR
    ";

    const GET_PARAMETRO_BYNRPARAMETROVALOR_BYDESC = "
    SELECT PA.NRPARAMETRO, PA.CODPARAMETRO, PV.NRPARAMETROVALOR, PV.VALORPARAMETRO, PR.DESCRELACIONAMENTO, PR.VALOR
    FROM VND_PARAMETRO PA
    LEFT JOIN VND_PARAMETROVALOR PV ON PV.NRPARAMETRO = PA.NRPARAMETRO
    LEFT JOIN VND_RELPARAMETROVALOR PR ON PR.NRPARAMETROVALOR = PV.NRPARAMETROVALOR AND PR.NRORG = PV.NRORG
    WHERE PA.CODPARAMETRO = :CODPARAMETRO AND PV.NRORG = :NRORG AND PR.NRPARAMETROVALOR = :NRPARAMETROVALOR AND PR.DESCRELACIONAMENTO = :DESCRELACIONAMENTO
    ";

    const GET_HIERARQUIA_BYCODPARAM = "
    SELECT PH.NRPARAMETRO, PH.NRRELHIERARQUIAPARAMETRO FROM VND_PARAMETRO PA
    JOIN VND_RELHIERARQUIAPARAMETRO PH
    ON PA.NRPARAMETRO = PH.NRPARAMETRO
    WHERE PA.CODPARAMETRO = :CODPARAMETRO
    ";

    const GET_PARAMETRO_BYCODPARAMETRO = "
    SELECT NRPARAMETRO, NRPARENT FROM VND_PARAMETRO WHERE CODPARAMETRO = :CODPARAMETRO
    ";

    const GET_PARAMETRO_BYNRPARAMETRO = "
    SELECT CODPARAMETRO FROM VND_PARAMETRO WHERE NRPARAMETRO = :NRPARAMETRO
    ";



    const GET_HIERARQUIA_BYNRPARAMETRO = "
    SELECT PH.NRPARAMETRO, PH.DESCHIERARQUIA, PH.NRPRIORIDADEHIERARQUIA, PH.HIERARQUIAVALUE FROM VND_RELHIERARQUIAPARAMETRO PH
    LEFT JOIN VND_PARAMETRO PA
    ON PH.NRPARAMETRO = PA.NRPARAMETRO
    WHERE PH.NRPARAMETRO = :NRPARAMETRO ORDER BY PH.NRPRIORIDADEHIERARQUIA ASC
    ";

    const GET_RELTURNO_FILIAIS_LOJA ="
    SELECT CDLOJA, NRRELACIONAMENTO FROM VND_RELACIONAMENTOTURNO WHERE NRSEQTURNO = :NRSEQTURNO AND CDFILIAL = :CDFILIAL AND NRORG = :NRORG AND IDATIVO = 'S' AND CDLOJA IS NOT NULL
    ";


    const GET_TABELAPRECOBYLOJA = "
        SELECT REL.CDTABPREC, TV.DTINIVGPREC
          FROM VND_RELESTRUTURATABEPRECO REL
          JOIN TABEPREC TB
            ON TB.CDFILIAL = REL.CDFILIALTABPREC
            AND TB.CDTABEPREC = REL.CDTABPREC
            AND TB.NRORG = REL.NRORG
          JOIN TABEVEND TV
            ON TV.CDFILIAL = TB.CDFILIAL
            AND TV.CDTABEPREC = TB.CDTABEPREC
            AND TV.NRORG = TB.NRORG
            AND TO_DATE(:DATA||' 00:00:00', 'DD/MM/YYYY HH24:MI:SS') BETWEEN TV.DTINIVGPREC AND TV.DTFINVGPREC
          WHERE REL.CDFILIAL = :CDFILIAL
            AND REL.CDLOJA = :CDLOJA
            AND REL.NRORG = :NRORG
    ";

    const GET_TABELAPRECOBYFILIAL = "
        SELECT REL.CDTABPREC, TV.DTINIVGPREC
          FROM VND_RELESTRUTURATABEPRECO REL
          JOIN TABEPREC TB
          ON TB.CDFILIAL = REL.CDFILIAL
            AND TB.CDTABEPREC = REL.CDTABPREC
            AND TB.NRORG = REL.NRORG
          JOIN TABEVEND TV
            ON TV.CDFILIAL = TB.CDFILIAL
            AND TV.CDTABEPREC = TB.CDTABEPREC
            AND TV.NRORG = TB.NRORG
            AND TO_DATE(:DATA||' 00:00:00', 'DD/MM/YYYY HH24:MI:SS') BETWEEN TV.DTINIVGPREC AND TV.DTFINVGPREC
          WHERE REL.CDFILIAL= :CDFILIAL
            AND REL.CDLOJA IS NULL
            AND REL.NRORG = :NRORG
    ";

    const GET_DADOS_FILIAL = "
        SELECT NMRAZSOCFILI, NRINSJURFILI
        FROM FILIAL
        WHERE CDFILIAL = :CDFILIAL
        AND NRORG      = :NRORG
        AND IDATIVO    = 'S'
    ";

    const GET_DADOS_LOCAL = "
      SELECT CDFILIAL, CDPAIS, SGESTADO
      FROM ENDEFILI
      WHERE CDFILIAL = :CDFILIAL
      AND NRORG      = :NRORG
      AND IDATIVO    = 'S'
    ";

    const GET_PARAVEND = "
      SELECT IDAMBTRABNFCE,
        DSDIRARQLOGNFCE,
        CDCODSCONSHOMO,
        CDIDTOKENHOMO
      FROM PARAVEND
      WHERE CDFILIAL = :CDFILIAL
      AND NRORG      = :NRORG
      AND IDATIVO    = 'S'

    ";

    const UPDATE_PARAVEND = "
    UPDATE PARAVEND
    SET IDAMBTRABNFCE = :IDAMBTRABNFCE, DSDIRARQLOGNFCE = :DSDIRARQLOGNFCE, CDCODSCONSHOMO = :CDCODSCONSHOMO, CDIDTOKENHOMO = :CDIDTOKENHOMO, CDFILIAL = :CDFILIAL, NRORG = :NRORG, DTULTATU = :DTULTATU, CDOPERULTATU = :CDOPERULTATU, NRORGULTATU = :NRORGULTATU
    WHERE CDFILIAL = :CDFILIAL AND NRORG = :NRORG AND IDATIVO = 'S'
    ";

    const GET_MAXCDCAIXA = "
    SELECT
      MAX(CDCAIXA) AS MAX_COD
    FROM CAIXA
    WHERE CDFILIAL = :CDFILIAL
      AND NRORG = :NRORG
    ";

    const GET_LOJA = "
    SELECT *
    FROM LOJA
    WHERE CDFILIAL = :CDFILIAL
      AND CDLOJA = :CDLOJA
      AND NRORG = :NRORG
    ";

    const GET_NRCONFIGCAIXA = "
    SELECT NRCONFIGCAIXA
    FROM VND_CONFIGINDIVIDUALPDV
    WHERE CDFILIAL = :CDFILIAL
      AND CDCAIXA = :CDCAIXA
    ";

    const GET_MAXNRCONFIGCAIXA = "
    SELECT
      MAX(NRCONFIGCAIXA) AS MAX_NUM
    FROM VND_CONFIGINDIVIDUALPDV
    ";

    const DELETE_VND_RELACAIXAMODALIDADE = "
    DELETE
    FROM VND_RELACAIXAMODALIDADE
    WHERE CDFILIAL = :CDFILIAL
      AND CDCAIXA = :CDCAIXA
      AND NRORG = :NRORG
    ";

    const DELETE_VND_CONFIGINDIVIDUALPDV = "
    DELETE
    FROM VND_CONFIGINDIVIDUALPDV
    WHERE CDFILIAL = :CDFILIAL
      AND CDCAIXA = :CDCAIXA
    ";

    const UPDATE_VND_RELBICOCAIXA = "
    UPDATE VND_RELBICOCAIXA
      SET IDATIVO = 'N',
      DTULTATU = :DTULTATU,
      NRORGULTATU = :NRORGULTATU,
      CDOPERULTATU = :CDOPERULTATU
    WHERE CDCAIXA = :CDCAIXA
      AND CDFILIAL = :CDFILIAL
      AND NRORG = :NRORG
    ";

    const UPDATE_VND_RELALMOXARIFADOESTRUT_RESET_CAIXA = "
    UPDATE VND_RELALMOXARIFADOESTRUT
      SET IDATIVO = 'N',
      DTULTATU = :DTULTATU,
      NRORGULTATU = :NRORGULTATU,
      CDOPERULTATU = :CDOPERULTATU
    WHERE CDCAIXA = :CDCAIXA
      AND CDFILIAL = :CDFILIAL
      AND CDLOJA = :CDLOJA
      AND NRORG = :NRORG
    ";

    const UPDATE_VND_RELACAIXAMODALIDADE = "
    UPDATE VND_RELACAIXAMODALIDADE
      SET IDATIVO = 'N',
      DTULTATU = :DTULTATU,
      NRORGULTATU = :NRORGULTATU,
      CDOPERULTATU = :CDOPERULTATU
    WHERE CDCAIXA = :CDCAIXA
      AND CDFILIAL = :CDFILIAL
      AND NRORG = :NRORG
    ";

    const UPDATE_VND_CONFIGINDIVIDUALPDV = "
    UPDATE VND_CONFIGINDIVIDUALPDV
      SET IDATIVO = 'N',
      DTULTATU = :DTULTATU,
      NRORGULTATU = :NRORGULTATU,
      CDOPERULTATU = :CDOPERULTATU
    WHERE CDCAIXA = :CDCAIXA
      AND CDFILIAL = :CDFILIAL
      AND NRORG = :NRORG
    ";

    const PDV_ABRE_CAIXA = "
       UPDATE CAIXA SET
       IDAUTOIMPTAB = :IDAUTOIMPTAB,
       VRABERCAIX = :VRABERCAIX,
       IDPALFUTRABRCXA = :IDPALFUTRABRCXA,
       IDINFREDZNCAD = :IDINFREDZNCAD,
       IDVERIFCOTA = :IDVERIFCOTA,
       IDBAIXAPERIF = :IDBAIXAPERIF,
       IDCOLETOR = :IDCOLETOR
       WHERE
       (NRORG = :NRORG)
       AND (CDCAIXA = :CDCAIXA)
       AND (CDFILIAL = :CDFILIAL)
    ";

    const UPDATE_CAIXA = "
    UPDATE CAIXA
      SET IDATIVO = 'N',
      DTULTATU = :DTULTATU,
      NRORGULTATU = :NRORGULTATU,
      CDOPERULTATU = :CDOPERULTATU
    WHERE CDCAIXA = :CDCAIXA
      AND CDFILIAL = :CDFILIAL
      AND CDLOJA = :CDLOJA
      AND NRORG = :NRORG
    ";

    const GET_MAXNRRELCAIXAMODALIDADE = "
    SELECT
      MAX(NRRELCAIXAMODALIDADE) AS MAX_NUM
    FROM VND_RELACAIXAMODALIDADE
    ";

    const GET_CDCAIXA = "
    SELECT CDCAIXA,IDATIVO
    FROM CAIXA
    WHERE CDCAIXA = :CDCAIXA
      AND CDFILIAL = :CDFILIAL
      AND NRORG = :NRORG
    ";

    const GET_CDCAIXA_BY_FILIAL = "
    SELECT CDCAIXA,IDATIVO
    FROM CAIXA
    WHERE CDCAIXA = :CDCAIXA
      AND CDFILIAL = :CDFILIAL
      AND NRORG = :NRORG
    ";

    const GET_MAXCDSALA = "
    SELECT
      MAX(CDSALA) AS MAX_CDSALA
      FROM SALA
      WHERE CDFILIAL= :CDFILIAL
    ";

    const GET_MAXNRSEQRELACCATEGORIACONFIGURAC ="
    SELECT
      MAX(NRSEQRELACCATEGORIACONFIGURAC) AS MAX_ID
      FROM VND_RELCATEGORIACONF
    ";

    const UPDATE_VND_RELCATEGORIACONF = "
    UPDATE VND_RELCATEGORIACONF
      SET IDATIVO='N'
      WHERE NRSEQCONFIGURACAO = :NRSEQCONFIGURACAO
    ";

    const GET_MAXNRRELAATRIBUTOCONFIGURACAO = "
    SELECT
      MAX(NRRELAATRIBUTOCONFIGURACAO) AS MAX_ID
      FROM VND_RELATRIBUTOCONFIGURACAO
    ";

    const GET_MAXNRATRIBUTOVENDA = "
    SELECT
      MAX(NRATRIBUTOVENDA) AS MAX_ID
      FROM VND_ATRIBUTOVENDA
    ";

    const GET_MAXNRRELESTRUTURATABEPRECO = "
    SELECT
      MAX(NRRELESTRUTURATABEPRECO) AS MAX_ID
      FROM VND_RELESTRUTURATABEPRECO
    ";

    const GET_MAXNRRELESTRTURACONFIGURACAO = "
    SELECT
      MAX(NRRELESTRTURACONFIGURACAO) AS MAX_ID
      FROM VND_RELESTRTURACONFIGURACAO
    ";

    const GET_NRRELESTRTURACONFIGURACAO = "
    SELECT NRRELESTRTURACONFIGURACAO
      FROM VND_RELESTRTURACONFIGURACAO
      WHERE CDFILIAL = :CDFILIAL
        AND CDLOJA IS NULL
        AND CDCAIXA IS NULL
        AND NRORG = :NRORG
        AND IDATIVO = 'S'
    ";

    const GET_NRRELESTRTURACONFIGURACAO_BY_CDLOJA = "
    SELECT NRRELESTRTURACONFIGURACAO
      FROM VND_RELESTRTURACONFIGURACAO
      WHERE CDFILIAL = :CDFILIAL
        AND CDLOJA = :CDLOJA
        AND CDCAIXA IS NULL
        AND NRORG = :NRORG
        AND IDATIVO = 'S'
    ";

    const GET_NRRELESTRTURACONFIGURACAO_BY_CDCAIXA = "
    SELECT NRRELESTRTURACONFIGURACAO
      FROM VND_RELESTRTURACONFIGURACAO
      WHERE CDFILIAL = :CDFILIAL
        AND CDLOJA = :CDLOJA
        AND CDCAIXA = :CDCAIXA
        AND NRORG = :NRORG
        AND IDATIVO = 'S'
    ";

    const GET_NRRELESTRTURACONFIGURACAO_BY_NRSEQCONFIGURACAO = "
    SELECT NRRELESTRTURACONFIGURACAO
      FROM VND_RELESTRTURACONFIGURACAO
      WHERE CDFILIAL = :CDFILIAL
        AND CDLOJA = :CDLOJA
        AND CDCAIXA IS NULL
        AND NRSEQCONFIGURACAO = :NRSEQCONFIGURACAO
        AND NRORG = :NRORG
        AND IDATIVO = 'S'
    ";

    const GET_MAXNRRELACIONAMENTO = "
    SELECT
      MAX(NRRELACIONAMENTO) AS MAX_ID
      FROM VND_RELACIONAMENTOTURNO
    ";

    const GET_CDPRODUTO_ITEMPRECO = "
  SELECT CDPRODUTO
    FROM ITEMPRECO
      WHERE CDFILIAL = :CDFILIAL
        AND CDTABEPREC = :CDTABEPREC
        AND DTINIVGPREC = :DTINIVGPREC
        AND CDPRODUTO = :CDPRODUTO
        AND CDPRPAITABPR = :CDPRPAITABPR
        AND NRORG = :NRORG
    ";

    const GET_MAXNRSEQRELACPRODCATEGORIA = "
    SELECT
      MAX(NRSEQRELACPRODCATEGORIA) AS MAX_ID
      FROM VND_RELACPRODCATEGORIA
    ";

    const GET_MAXNRMODALIDADEPDV = "
    SELECT
      MAX(NRMODALIDADEPDV) AS MAX_ID
      FROM VND_MODALIDADEPDV
    ";

    const GET_MAXNRSEQMODALIDADEPDV = "
    SELECT
      MAX(NRSEQMODALIDADEPDV) AS MAX_ID
      FROM VND_RELACONFIGURACAOMODALIDADE
    ";

    const GET_VND_RELACONFIGURACAOMODALIDADE = "
  SELECT *
    FROM VND_RELACONFIGURACAOMODALIDADE
    WHERE NRSEQCONFIGURACAO = :NRSEQCONFIGURACAO
      AND NRORG = :NRORG
    ";

    const UPDATE_VND_RELACONFIGURACAOMODALIDADE_BY_NRORG = "
    UPDATE VND_RELACONFIGURACAOMODALIDADE
        SET IDATIVO = :IDATIVO,
        DTULTATU = :DTULTATU,
        NRORGULTATU = :NRORGULTATU,
        CDOPERULTATU = :CDOPERULTATU
    WHERE NRSEQCONFIGURACAO = :NRSEQCONFIGURACAO
      AND NRORG = :NRORG
    ";

    const UPDATE_ITEMPRECODIA = "
    UPDATE ITEMPRECODIA
            SET IDATIVO = 'N',
                      NRORGULTATU = :NRORGULTATU,
                      CDOPERULTATU = :CDOPERULTATU,
                      DTULTATU = :DTULTATU
            WHERE CDFILIAL   = :CDFILIAL
            AND CDTABEPREC   = :CDTABEPREC
            AND DTINIVGPREC  = to_date(:DTINIVGPREC, 'dd/mm/yyyy hh24:mi:ss')
            AND CDPRODUTO    = :CDPRODUTO
            AND CDPRPAITABPR = :CDPRPAITABPR
            AND NRDIASEMANPR = :NRDIASEMANPR
            AND HRINIPRECDIA = :HRINIPRECDIA
            AND CDTIPOCONSPD = :CDTIPOCONSPD
            AND NRORG        = :NRORG
    ";

    const GET_MAXCDNVPRODUTO = "
    SELECT
      MAX(CDNVPRODUTO) AS CDNVPRODUTO
        FROM PRODUTO
        WHERE NRORG = :NRORG
    ";

    const GET_MAXCDTABEPREC = "
    SELECT
      MAX(CDTABEPREC) AS MAX_ID
      FROM TABEPREC
    ";

    const GET_CDFILIAL = "
    SELECT
      CDFILIAL
        FROM TABEPREC
        WHERE NRORG = :NRORG
    ";

    const GET_MAXCDFILIAL = "
    SELECT
      MAX(CDFILIAL) AS CDFILIAL
        FROM FILIAL
        WHERE NRORG = :NRORG
    ";

    const GET_TABEPREC = "
    SELECT DISTINCT TP.CDFILIAL CDFILIAL,
          TP.CDTABEPREC CDTABEPREC,
          TP.NMTABEPREC NMTABEPREC,
          TV.DTINIVGPREC DTINIVGPREC,
          TV.DTFINVGPREC DTFINVGPREC,
          TP.IDATIVO,
          TP.NRORG
        FROM TABEPREC TP
        JOIN VND_RELESTRUTURATABEPRECO RTP
      ON TP.CDTABEPREC = RTP.CDTABPREC
      AND TP.CDFILIAL = RTP.CDFILIALTABPREC
      AND TP.NRORG     = RTP.NRORG
      AND RTP.IDATIVO  = 'S'
    JOIN TABEVEND TV
      ON TP.CDFILIAL    = TV.CDFILIAL
      AND TP.CDTABEPREC = TV.CDTABEPREC
      AND TP.NRORG      = TV.NRORG
      AND TP.IDATIVO = TV.IDATIVO
        WHERE (SYSDATE BETWEEN TV.DTINIVGPREC AND TV.DTFINVGPREC)
        AND TP.NRORG    = :P_NRORG
        AND TP.IDATIVO    = :IDATIVO
        AND TP.CDTABEPREC LIKE '%'||:CDTABEPREC||'%'
        AND TP.NMTABEPREC LIKE '%'||:NMTABEPREC||'%'
        AND RTP.CDFILIAL = :CDFILIAL
        AND RTP.CDLOJA IS NULL
    ";

    const GET_TABEPREC_BY_CDLOJA = "
    SELECT DISTINCT TP.CDFILIAL CDFILIAL,
          TP.CDTABEPREC CDTABEPREC,
          TP.NMTABEPREC NMTABEPREC,
          TV.DTINIVGPREC DTINIVGPREC,
          TV.DTFINVGPREC DTFINVGPREC,
          TP.IDATIVO,
          TP.NRORG
        FROM TABEPREC TP
        JOIN VND_RELESTRUTURATABEPRECO RTP
      ON TP.CDTABEPREC = RTP.CDTABPREC
      AND TP.CDFILIAL = RTP.CDFILIALTABPREC
      AND TP.NRORG     = RTP.NRORG
      AND RTP.IDATIVO  = 'S'
    JOIN TABEVEND TV
      ON TP.CDFILIAL    = TV.CDFILIAL
      AND TP.CDTABEPREC = TV.CDTABEPREC
      AND TP.NRORG      = TV.NRORG
      AND TP.IDATIVO = TV.IDATIVO
        WHERE (SYSDATE BETWEEN TV.DTINIVGPREC AND TV.DTFINVGPREC)
        AND TP.NRORG    = :P_NRORG
        AND TP.IDATIVO    = :IDATIVO
        AND TP.CDTABEPREC LIKE '%'||:CDTABEPREC||'%'
        AND TP.NMTABEPREC LIKE '%'||:NMTABEPREC||'%'
        AND RTP.CDFILIAL = :CDFILIAL
        AND RTP.CDLOJA = :CDLOJA
    ";

    const GET_TABEPREC_ORDER_CDTABEPREC = "
    SELECT DISTINCT TP.CDFILIAL CDFILIAL,
        TP.CDTABEPREC CDTABEPREC,
        TP.NMTABEPREC NMTABEPREC,
        TV.DTINIVGPREC DTINIVGPREC,
        TV.DTFINVGPREC DTFINVGPREC,
        TP.IDATIVO,
        TP.NRORG
      FROM TABEPREC TP
      JOIN VND_RELESTRUTURATABEPRECO RTP
        ON TP.CDTABEPREC = RTP.CDTABPREC
        AND TP.CDFILIAL = RTP.CDFILIALTABPREC
        AND TP.NRORG     = RTP.NRORG
        AND RTP.IDATIVO  = 'S'
      JOIN TABEVEND TV
        ON TP.CDFILIAL    = TV.CDFILIAL
        AND TP.CDTABEPREC = TV.CDTABEPREC
        AND TP.NRORG      = TV.NRORG
        AND TP.IDATIVO = TV.IDATIVO
      WHERE TP.NRORG    = :P_NRORG
        AND TP.IDATIVO    = :IDATIVO
        AND TP.CDTABEPREC LIKE '%'
          ||:CDTABEPREC
          ||'%'
        AND TP.NMTABEPREC LIKE '%'
          ||:NMTABEPREC
          ||'%'
        AND RTP.CDFILIAL    = :CDFILIAL
        AND RTP.CDLOJA     IS NULL
        AND (TV.DTINIVGPREC > :DTINI
        OR TV.DTINIVGPREC   = :DTINI)
        AND (TV.DTFINVGPREC < :DTFIM
        OR TV.DTFINVGPREC   = :DTFIM)
      ORDER BY CDTABEPREC
    ";

    const GET_TABEPREC_BY_DATES = "
    SELECT DISTINCT TP.CDFILIAL CDFILIAL,
      TP.CDTABEPREC CDTABEPREC,
      TP.NMTABEPREC NMTABEPREC,
      TV.DTINIVGPREC DTINIVGPREC,
      TV.DTFINVGPREC DTFINVGPREC,
      TP.IDATIVO,
      TP.NRORG
      FROM TABEPREC TP
      JOIN VND_RELESTRUTURATABEPRECO RTP
      ON TP.CDTABEPREC = RTP.CDTABPREC
      AND TP.CDFILIAL = RTP.CDFILIALTABPREC
      AND TP.NRORG     = RTP.NRORG
      AND RTP.IDATIVO  = 'S'
      JOIN TABEVEND TV
      ON TP.CDFILIAL    = TV.CDFILIAL
      AND TP.CDTABEPREC = TV.CDTABEPREC
      AND TP.NRORG      = TV.NRORG
      AND TP.IDATIVO = TV.IDATIVO
      WHERE TP.NRORG    = :P_NRORG
      AND TP.IDATIVO    = :IDATIVO
      AND TP.CDTABEPREC LIKE '%'||:CDTABEPREC||'%'
      AND TP.NMTABEPREC LIKE '%'||:NMTABEPREC||'%'
      AND RTP.CDFILIAL = :CDFILIAL
      AND RTP.CDLOJA = :CDLOJA
      AND (TV.DTINIVGPREC > :DTINI OR TV.DTINIVGPREC = :DTINI)
      AND (TV.DTFINVGPREC < :DTFIM OR TV.DTFINVGPREC = :DTFIM) ORDER BY CDTABEPREC
    ";

    const GET_ORGANIZATION_TABEPREC = "
    SELECT DISTINCT TP.CDFILIAL CDFILIAL,
      TP.CDTABEPREC CDTABEPREC,
      TP.NMTABEPREC NMTABEPREC,
      TO_CHAR(TV.DTINIVGPREC, 'dd/mm/YYYY') AS DTINIVGPREC,
      TO_CHAR(TV.DTFINVGPREC, 'dd/mm/YYYY') AS DTFINVGPREC,
      TP.IDATIVO,
      TP.NRORG,
      TP.DTINCLUSAO,
      TP.CDOPERINCLUSAO,
      TP.NRORGINCLUSAO
    FROM TABEPREC TP
    JOIN TABEVEND TV
      ON TP.CDFILIAL    = TV.CDFILIAL
      AND TP.CDTABEPREC = TV.CDTABEPREC
      AND TP.NRORG      = TV.NRORG
      AND TP.IDATIVO    = TV.IDATIVO
    WHERE  TP.NRORG   = :P_NRORG
      AND TP.IDATIVO = :IDATIVO
      AND TP.CDTABEPREC LIKE '%'
        ||:CDTABEPREC
        ||'%'
      AND TP.NMTABEPREC LIKE '%'
        ||:NMTABEPREC
        ||'%'
      AND (TV.DTINIVGPREC > :DTINI OR TV.DTINIVGPREC = :DTINI)
      AND (TV.DTFINVGPREC < :DTFIM OR TV.DTFINVGPREC = :DTFIM)
    ORDER BY CDTABEPREC
    ";

    const GET_CDTABEPREC_TABEPREC = "
    SELECT CDTABEPREC
      FROM TABEPREC
      WHERE CDFILIAL = :CDFILIAL
        AND CDTABEPREC = :CDTABEPREC
        AND NRORG = :NRORG
    ";

    const GET_MAXNRPARAMETROSTIPORECE = "
    SELECT
      MAX(NRPARAMETROSTIPORECE) AS MAX_NUM
      FROM VND_PARAMETROSTIPORECE
    ";

    const GET_NRPARAMETROSTIPORECE = "
    SELECT
      NRPARAMETROSTIPORECE AS NRPARAM
        FROM VND_PARAMETROSTIPORECE
        WHERE CDTIPORECE = :CDTIPORECE
    ";

    const GET_MAXNRTIPOEMISSAOVENDA = "
    SELECT
      MAX(NRTIPOEMISSAOVENDA) AS MAX_ID
      FROM VND_TIPOEMISSAOVENDA
    ";

    const GET_SALA = "
    SELECT CDSALA
      FROM SALA
      WHERE SGSALA = :SGSALA
        AND NRORG = :NRORG
    ";

    const GET_CDMODELO = "
    SELECT CDMODELO
      FROM MODELO
      WHERE CDMODELO = :CDMODELO
        AND NRORG = :NRORG
    ";

    const DELETE_VND_RELESTRTURACONFIGURACAO = "
    DELETE FROM VND_RELESTRTURACONFIGURACAO
      WHERE CDFILIAL = :CDFILIAL
        AND (NVL(CDLOJA, ' ') = NVL(:CDLOJA, ' '))
        AND (NVL(CDCAIXA, ' ') = NVL(:CDCAIXA, ' '))
        AND (NVL(NRORG, ' ') = NVL(:NRORG, ' '))
    ";

    const GET_VND_RELESTRUTURATABEPRECO = "
    SELECT CDLOJA,
      NRRELESTRUTURATABEPRECO
    FROM VND_RELESTRUTURATABEPRECO
    WHERE CDTABPREC = :CDTABPREC
      AND CDFILIALTABPREC = :CDFILIALTABPREC
      AND CDFILIAL = :CDFILIAL
      AND NRORG = :NRORG
      AND CDLOJA IS NOT NULL
    ";

    const GET_IDATIVO_VND_RELESTRUTURATABEPRECO = "
    SELECT IDATIVO,
      NRRELESTRUTURATABEPRECO
    FROM VND_RELESTRUTURATABEPRECO
    WHERE CDTABPREC = :CDTABPREC
      AND CDFILIALTABPREC = :CDFILIALTABPREC
      AND CDFILIAL = :CDFILIAL
      AND NRORG = :NRORG
      AND CDLOJA IS NULL
    ";

    const GET_VND_RELESTRUTURATABEPRECO_VALIDALOJA = "
    SELECT IDATIVO,
      NRRELESTRUTURATABEPRECO
    FROM VND_RELESTRUTURATABEPRECO
    WHERE CDTABPREC = :CDTABPREC
      AND CDFILIALTABPREC = :CDFILIALTABPREC
      AND CDFILIAL = :CDFILIAL
      AND CDLOJA = :CDLOJA
      AND NRORG = :NRORG
    ";

    const GET_VND_RELACIONAMENTOTURNO = "
    SELECT NRSEQTURNO
    FROM VND_RELACIONAMENTOTURNO
    WHERE NRSEQTURNO = :NRSEQTURNO
      AND (
            CDFILIAL = :CDFILIAL
            AND CDLOJA IS NULL
      )
      AND NRORG = :NRORG;
    ";

    const GET_NRSEQTURNO_VND_RELACIONAMENTOTURNO = "
    SELECT NRSEQTURNO
    FROM VND_RELACIONAMENTOTURNO
    WHERE NRSEQTURNO = :NRSEQTURNO
      AND CDFILIAL = :CDFILIAL
      AND CDLOJA = :CDLOJA
      AND NRORG = :NRORG
    ";

    const GET_IDATIVO_VND_RELACIONAMENTOTURNO = "
    SELECT IDATIVO,
      NRRELACIONAMENTO
    FROM VND_RELACIONAMENTOTURNO
    WHERE NRSEQTURNO = :NRSEQTURNO
      AND CDFILIAL = :CDFILIAL
      AND NRORG = :NRORG
      AND CDLOJA IS NULL
    ";

    const GET_VND_RELACIONAMENTOTURNO_VALIDALOJA = "
    SELECT IDATIVO,
      NRRELACIONAMENTO
    FROM VND_RELACIONAMENTOTURNO
    WHERE NRSEQTURNO = :NRSEQTURNO
      AND CDFILIAL = :CDFILIAL
      AND CDLOJA = :CDLOJA
      AND NRORG = :NRORG
    ";

    const GET_OPERADOR = "
    SELECT *
    FROM OPERADOR
      WHERE DSEMAILOPER = :DSEMAILOPER
    ";

    const GET_OPERADOR_BY_CDOPERADOR = "
    SELECT *
    FROM OPERADOR
      WHERE CDOPERADOR = :CDOPERADOR
    ";

    const UPDATE_TIPORECE = "
    UPDATE TIPORECE
      SET IDATIVO = :IDATIVO,
      DTULTATU = :DTULTATU,
      NRORGULTATU = :NRORGULTATU,
      CDOPERULTATU = :CDOPERULTATU
    WHERE CDTIPORECE = :CDTIPORECE
      AND NRORG = :NRORG
    ";

    const GET_CDTIPORECE = "
    SELECT CDTIPORECE
    FROM TIPORECE
    WHERE CDTIPORECE = :CDTIPORECE
      AND NRORG = :NRORG
    ";

    const GET_MAXNRRELAATRIBUTOTIPORECE = "
    SELECT
      MAX(NRRELAATRIBUTOTIPORECE) AS MAX_NUM
    FROM VND_RELATRIBUTOTIPORECE
    ";

    const GET_MAXNRRELTIPOTROCO = "
    SELECT
      MAX(NRRELTIPOTROCO) AS NRRELTIPOTROCO
    FROM VND_RELTIPOTROCO
    ";

    const GET_TIPORECE_TIPOTROCOS = "
    SELECT RT.NRRELTIPOTROCO,
      TR.CDTIPORECE AS CDTIPORECETROCO,
      RT.CDTIPORECETROCO AS CDTIPORECE,
      TR.NMTIPORECE,
      NVL(RT.IDATIVO, 'N')
      AS IDATIVO,
      RT.MAXTROCO,
      TR.NRORG,
      RT.CDOPERINCLUSAO,
      RT.CDOPERULTATU,
      RT.NRORGINCLUSAO,
      RT.NRORGULTATU,
      RT.DTINCLUSAO,
      RT.DTULTATU
    FROM TIPORECE TR
    LEFT JOIN VND_RELTIPOTROCO RT
      ON TR.CDTIPORECE = RT.CDTIPORECETROCO
      AND TR.NRORG = RT.NRORG
      AND RT.CDTIPORECE = :CDTIPORECE
    WHERE TR.NRORG = :NRORG
      AND TR.IDATIVO = 'S' ORDER BY TR.CDTIPORECE
    ";
    //-----------------------------------------INTEGRAÇÃO--------------------------------------//
    const GET_VENDAS_PERIODO = "
    SELECT P.NMPRODUTO, P.CDARVPROD, E.QTPRODVEND, E.VRUNITVEND,
           E.VRACRITVEND, E.VRDESITVEND, E.VRPEALPRODIT, E.QTPRODVEND*E.VRUNITVEND AS VRTOTALPROD,
           E.VRPEALPRODIT*E.QTPRODVEND*E.VRUNITVEND/100 AS IMPOSTO
      FROM ETLVENDAONLINE E JOIN PRODUTO P
                              ON E.CDPRODUTO = P.CDPRODUTO
    ";

    const GET_WEBSERVICE_URL = "
        SELECT NMENDWEBSER
          FROM PARAMGERAL
    ";

    const GET_MOV_EXPORT = "
        SELECT A.CDFILIAL, A.NMFILIAL, A.CDCAIXA, A.DTMOVTURCAIX,
               A.IDMOVEXPORT, A.IDCONFERCAIXA,
               CASE WHEN A.IDMOVEXPORT = 'S'
                        THEN 'Sim'
                    WHEN A.IDMOVEXPORT = 'N'
                        THEN 'Não'
                    ELSE 'Indefinido'
                     END AS DSIDMOVEXPORT,
               CASE WHEN A.IDCONFERCAIXA = 'S'
                        THEN 'Sim'
                    WHEN A.IDCONFERCAIXA = 'N'
                        THEN 'Não'
                    ELSE 'Indefinido'
                     END AS DSIDCONFERCAIXA
        FROM (
            SELECT D.*, ROWNUM as N FROM (
                SELECT TC.CDFILIAL, FI.NMFILIAL, TC.CDCAIXA, TC.DTMOVTURCAIX, TC.IDMOVEXPORT, TC.IDCONFERCAIXA
                    FROM TURCAIXA TC JOIN FILIAL FI
                                       ON TC.CDFILIAL = FI.CDFILIAL
                    WHERE TC.CDFILIAL LIKE (:CDFILIAL)
                      AND TC.CDCAIXA  LIKE (:CDCAIXA )
                      AND TC.DTMOVTURCAIX BETWEEN TO_DATE(:DTINIT, 'dd/mm/yyyy') AND TO_DATE(:DTFIM, 'dd/mm/yyyy')
            ) D
        ) A
        WHERE A.N BETWEEN  :FIRST AND :LAST
    ";

    const GET_MOV_REGISTER = "
        SELECT DISTINCT CA.CDLOJA, TC.CDFILIAL, TC.CDCAIXA, TC.DTMOVTURCAIX , TO_CHAR(TC.DTMOVTURCAIX,'YYYY-MM-DD') AS DTMOVIMENTO,
                        REPLACE(REPLACE(F.NRINSJURFILI,'.',''),'/','') NRINSJURFILI, NVL(V.QTD,0) AS QTDEVENDAS, V.IDTPEMISVEND AS ORIGEM
        FROM TURCAIXA TC JOIN FILIAL F
                           ON TC.CDFILIAL = F.CDFILIAL
                         JOIN CAIXA CA
                           ON CA.CDCAIXA = TC.CDCAIXA
                          AND CA.CDFILIAL = TC.CDFILIAL
                         JOIN (SELECT COUNT(*) AS QTD, CDFILIAL, CDCAIXA, DTENTRVENDA, IDTPEMISVEND
                                FROM VENDA
                                WHERE NVL(idstatusnfce, 'A') in ('A', 'C')
                                GROUP BY CDFILIAL, CDCAIXA, DTENTRVENDA, IDTPEMISVEND) V
                           ON TC.CDFILIAL = V.CDFILIAL
                          AND TC.CDCAIXA = V.CDCAIXA
                          AND TC.DTMOVTURCAIX = V.DTENTRVENDA
        WHERE TC.CDFILIAL = :CDFILIAL
          AND TC.CDCAIXA  = :CDCAIXA
          AND TC.DTMOVTURCAIX  = :DTMOVTURCAIX
    ";

    const UPDATE_MOV_REGISTER = "
        UPDATE TURCAIXA SET IDMOVEXPORT = 'S'
         WHERE TC.CDFILIAL = :CDFILIAL
           AND TC.CDCAIXA  = :CDCAIXA
           AND TC.DTMOVTURCAIX  = :DTMOVTURCAIX
    ";

    const UPDATE_ERP_PARAMS = "
        UPDATE PARAMGERAL
        SET NMENDWEBSER = :NMENDWEBSER
    ";

    // -------------------------- OPERADOR --------------------------
    const GET_OPERADOR_BY_FILIAL = "
        SELECT O.CDOPERADOR, O.CDSENHAOPERMD5, O.NMOPERADOR, F.CDFILIAL, O.DSEMAILOPER
          FROM OPERADOR O, FILIOPER F
         WHERE O.CDOPERADOR = F.CDOPERADOR
           AND F.CDFILIAL = :CDFILIAL
           AND LOWER(O.DSEMAILOPER) = LOWER(:DSEMAILOPER)
    ";

    const GET_OPERADOR_EMAIL = "
        SELECT NMOPERADOR, CDOPERADOR, CDSENHAOPERMD5, DSEMAILOPER
          FROM OPERADOR
          WHERE LOWER(DSEMAILOPER) = LOWER(:DSEMAILOPER)
    ";

    const UPDATE_CDSENHAOPERMD5_EMAIL = "
        UPDATE OPERADOR
          SET CDSENHAOPERMD5 = :CDSENHAOPERMD5
         WHERE LOWER(DSEMAILOPER) = LOWER(:DSEMAILOPER)
    ";

    const GET_SENHA_OPERADOR_EMAIL = "
        SELECT CDSENHAOPERMD5
          FROM OPERADOR
         WHERE LOWER(DSEMAILOPER) = LOWER(:DSEMAILOPER)
    ";

    const GET_FILIAL_OPERADOR = "
        SELECT
            F.CDFILIAL, F.NMFILIAL, F.CDFILIAL || ' - ' || F.NMFILIAL AS LABELFILIAL
          FROM
            FILIOPER FP JOIN FILIAL F ON FP.CDFILIAL = F.CDFILIAL
         WHERE
            CDOPERADOR = :CDOPERADOR
         ORDER BY F.CDFILIAL
    ";

    const GET_LOJAS_BY_FILIAL_OPERADOR = "
        SELECT L.CDLOJA, L.NMLOJA, L.CDLOJA || ' - ' || L.NMLOJA AS LABELLOJA,
               L.CDALMOXARIFE, L.CDLOCALESTOQ, A.DSALMOXARIFE,
               A.CDALMOXARIFE || ' - ' || A.DSALMOXARIFE AS LABELALMOXARIFE
          FROM LOJAOPER LP,
               LOJA L LEFT JOIN ALMOXARIFADO A
                             ON L.CDALMOXARIFE = A.CDALMOXARIFE
                            AND L.CDFILIAL = A.CDFILIAL
         WHERE LP.CDOPERADOR = :CDOPERADOR
           AND LP.CDFILIAL = :CDFILIAL
           AND LP.CDFILIAL = L.CDFILIAL
           AND LP.CDLOJA = L.CDLOJA
    ";

    const GET_OPERADORES = "
        SELECT CDOPERADOR, CDOPERADOR ||' - '|| NMOPERADOR AS LABELOPERADOR, NMOPERADOR, NRPARCNEGOCIO, '1' AS NRORG
          FROM OPERADOR
        ORDER BY CDOPERADOR
    ";

    const UPDATE_HASH_ALTERASENHA = "
        UPDATE
            OPERADOR
           SET
            DSHASHALTERASENHA = :DSHASHALTERASENHA
         WHERE
            CDOPERADOR = :CDOPERADOR
    ";

    const GET_HASH_BY_OPERADOR  = "
        SELECT DSHASHALTERASENHA FROM OPERADOR
         WHERE CDOPERADOR = :CDOPERADOR
    ";

        // ------------------------ #CAIXA ------------------------------
    const GET_CAIXA_BY_FILIAL_LOJA = "
        SELECT CDCAIXA, NMCAIXA, CDCAIXA || ' - ' || NMCAIXA AS LABELCAIXA,
               NRCONFTELA
          FROM CAIXA
         WHERE NRCONFTELA IS NOT NULL
           AND CDFILIAL = :CDFILIAL
           AND CDLOJA   = :CDLOJA
        ORDER BY CDCAIXA
    ";

    const BUSCA_PERFILOPER = "
        SELECT PERFACESSPARC.NRPERFILACESSO
          FROM PERFACESSPARC JOIN OPERADOR
                               ON OPERADOR.NRPARCNEGOCIO = PERFACESSPARC.NRPARCNEGOCIO
         WHERE CDOPERADOR = :CDOPERADOR
    ";

    const GETRULE_OPERADOR = "
        SELECT *
          FROM ZHU_ACCESS_CONTROL_RULE
         WHERE GROUP_ID = :GROUP_ID
    ";

        // -------------------------- #FILIAL --------------------------
    const GET_FILIAL = "
        SELECT CDFILIAL, NMFILIAL
          FROM FILIAL
         WHERE CDFILIAL = :CDFILIAL
        ORDER BY CDFILIAL
    ";
    const GET_FILIAL_CONSUMIDOR = "
        SELECT F.CDTIPOCONS, F.CDFILIAL, C.NMTIPOCONS
    FROM TIPOCONSFILI F
    JOIN TIPOCONS C
      ON F.CDTIPOCONS = C.CDTIPOCONS
        AND F.NRORG = C.NRORG
    WHERE  F.CDFILIAL = :CDFILIAL
      AND  F.NRORG = :NRORG
    ";

    const ALTERA_PERMISSAO_CONSUMIDOR = "
        UPDATE TIPOCONSFILI
           SET DSACESSOSITE = :DSACESSOSITE
         WHERE CDFILIAL = :CDFILIAL
           AND CDTIPOCONS = :CDTIPOCONS
    ";

    const BUSCA_PARAMETROS_VENDA_FILIAL = "
        SELECT F.CDFILIAL, F.NMFILIAL, P.CDINTEGRADOTZ, P.DSDIRARQDOTZ,
               F.CDFILIAL || ' - ' || F.NMFILIAL AS LABELFILIAL, P.CDCLIENTE, P.CDVENDEDOR, G.IDMODODLV,
         P.IDUTLQTDPED
          FROM PARAMGERAL G, PARAVEND P JOIN FILIAL F
                                          ON F.CDFILIAL = P.CDFILIAL
         WHERE F.CDFILIAL = P.CDFILIAL
         AND F.CDFILIAL = :CDFILIAL
    ";

    const ATUALIZA_PARAVEND_FILIAL_PARAMETRO = "
        UPDATE PARAVEND
           SET IDUTLQTDPED = :IDUTLQTDPED
         WHERE CDFILIAL = :CDFILIAL
    ";

    const GET_FILIAIS_MANAGE = "
        SELECT DAT.CDFILIAL, DAT.NMFILIAL, DAT.CDFILIAL||' - '||DAT.NMFILIAL AS LABELFILIAL, N
            FROM (
                SELECT D.*, ROWNUM as N FROM (
                    SELECT CDFILIAL, NMFILIAL, CDFILIAL||' - '||NMFILIAL AS LABELFILIAL
                        FROM FILIAL
                        WHERE UPPER (CDFILIAL||' - '||NMFILIAL) LIKE UPPER (:LABELFILIAL)
                    ORDER BY LABELFILIAL
                    ) D
                ) DAT
            WHERE N BETWEEN :FIRST AND :LAST
            ORDER BY LABELFILIAL
    ";

    const GET_FILTERED_FILIAIS = "
        SELECT DAT.CDFILIAL, DAT.NMFILIAL, DAT.CDFILIAL||' - '||DAT.NMFILIAL AS LABELFILIAL, N
        FROM (
            SELECT D.*, ROWNUM as N FROM (
                SELECT CDFILIAL, NMFILIAL, CDFILIAL||' - '||NMFILIAL AS LABELFILIAL
                    FROM FILIAL
                    WHERE (INSTR (UPPER (:LABELFILIAL), UPPER (CDFILIAL||' - '||NMFILIAL)) > 0)
                ORDER BY LABELFILIAL
                ) D
            ) DAT
        ORDER BY LABELFILIAL
    ";

    const GET_PARAMS_VEND_DELI = "
        SELECT F.CDFILIAL, F.NMFILIAL, F.CDFILIAL || ' - ' || F.NMFILIAL AS LABELFILIAL, P.NRTEMPMAXENTR, P.VRTXENTREGA,
               P.CDCLIENTE, P.CDVENDEDOR, G.IDMODODLV,
               CASE WHEN P.CDVENDEDOR IS NULL THEN NULL
               WHEN P.CDVENDEDOR IS NOT NULL THEN P.CDVENDEDOR || ' - ' || V.NMFANVEN
               END AS VENDEDORSELECAO,
               CASE WHEN P.CDCLIENTE IS NULL THEN NULL
               WHEN P.CDCLIENTE IS NOT NULL THEN P.CDCLIENTE || ' - ' || C.NMRAZSOCCLIE
               END AS CLIENTESELECAO
          FROM PARAMGERAL G, PARAVEND P JOIN FILIAL F
                                          ON F.CDFILIAL = P.CDFILIAL
                                        LEFT JOIN VENDEDOR V
                                          ON V.CDVENDEDOR = P.CDVENDEDOR
                                        LEFT JOIN CLIENTE C
                                          ON C.CDCLIENTE = P.CDCLIENTE
          WHERE P.CDFILIAL = :CDFILIAL
    ";

    const GET_FILIAL_LOJAS = "
        SELECT CDFILIAL, CDLOJA, NMLOJA
          FROM LOJA
          WHERE :CDFILIAL =CDFILIAL
    ";

    const GET_FILIAL_OPERADORES = "
        SELECT CDFILIAL, O.CDOPERADOR, O.NMOPERADOR, DSEMAILOPER, O.CDOPERADOR ||' - '|| NMOPERADOR AS LABELOPERADOR
          FROM FILIOPER F JOIN OPERADOR O ON F.CDOPERADOR = O.CDOPERADOR
          WHERE :CDFILIAL =CDFILIAL
    ";

    const GET_FILIAL_OPERADOR_EXPECIFICO = "
        SELECT COUNT(CDOPERADOR) AS TEMPOPERADOR
        FROM FILIOPER
          WHERE CDFILIAL    = :CDFILIAL
            AND CDOPERADOR  = :CDOPERADOR
    ";

    const GET_LOJA_OPERADOR_EXPECIFICO = "
        SELECT COUNT(CDOPERADOR) AS TEMPOPERADOR
        FROM LOJAOPER
          WHERE CDFILIAL    = :CDFILIAL
            AND CDLOJA      = :CDLOJA
            AND CDOPERADOR  = :CDOPERADOR
    ";

    const GET_LOJA_OPERADORES = "
        SELECT CDFILIAL, O.CDOPERADOR, O.NMOPERADOR, DSEMAILOPER
          FROM LOJAOPER L JOIN OPERADOR O ON L.CDOPERADOR = O.CDOPERADOR
          WHERE :CDFILIAL =CDFILIAL
          AND   :CDLOJA   =CDLOJA
    ";

    const GET_INTEGRACOES = "
        SELECT NMINTEGRACAO, IDINTEGRACAO, CDINTEGRACAO
        FROM INTEGRACAO
        ORDER BY CDINTEGRACAO
    ";

    const GET_FILTERED_INTEGRACOES = "
        SELECT DAT.NMINTEGRACAO, DAT.IDINTEGRACAO, DAT.CDINTEGRACAO, N
        FROM (
            SELECT D.*, ROWNUM as N FROM (
                SELECT NMINTEGRACAO, IDINTEGRACAO, CDINTEGRACAO
                    FROM INTEGRACAO
                    WHERE (INSTR (:CDINTEGRACAO, '|'||CDINTEGRACAO||'|') > 0)
                ORDER BY CDINTEGRACAO
                ) D
            ) DAT
        ORDER BY DAT.CDINTEGRACAO
    ";

    const GET_INTEGRACAO = "
        SELECT ITR.CDINTEGRACAO, ITR.CDTPRECEINTE, ITR.CDTIPORECE, ETR.NMTIPORECE
         FROM TIPORECEINTE ITR JOIN TIPORECE ETR
         ON ITR.CDTIPORECE = ETR.CDTIPORECE
         WHERE CDINTEGRACAO = :CDINTEGRACAO
    ";

    const GET_RECEBIMENTO = "
        SELECT ITR.CDINTEGRACAO, ITR.CDTPRECEINTE, ITR.CDTIPORECE, ETR.NMTIPORECE
         FROM TIPORECEINTE ITR JOIN TIPORECE ETR
         ON ITR.CDTIPORECE = ETR.CDTIPORECE
         WHERE CDINTEGRACAO = :CDINTEGRACAO
         AND ITR.CDTIPORECE = :CDTIPORECE
    ";

    const DELETE_INTEGRACAO = "
        DELETE FROM INTEGRACAO
              WHERE CDINTEGRACAO  = :CDINTEGRACAO
                AND NRORG = :NRORG
    ";

    const DELETE_RECEBIMENTO = "
        DELETE FROM TIPORECEINTE
              WHERE CDINTEGRACAO  = :CDINTEGRACAO
              AND CDTIPORECE      = :CDTIPORECE
              AND NRORG = :NRORG
    ";

    const INSERT_INTEGRACAO = "
        INSERT INTO INTEGRACAO
            (NMINTEGRACAO, IDINTEGRACAO, CDINTEGRACAO, NRORG)
        VALUES
            (:NMINTEGRACAO, UPPER(:IDINTEGRACAO), :CDINTEGRACAO, :NRORG)
    ";

    const INSERT_RECEBIMENTO = "
        INSERT INTO TIPORECEINTE
            (CDTIPORECE, CDTPRECEINTE, CDINTEGRACAO, NRORG)
        VALUES
            (:CDTIPORECE, :CDTPRECEINTE, :CDINTEGRACAO, :NRORG)
    ";

    const UPDATE_RECEBIMENTO =  "
        UPDATE TIPORECEINTE
              SET CDTPRECEINTE = :CDTPRECEINTE,
                  CDTIPORECE   = :CDTIPORECE
              WHERE CDINTEGRACAO = :CDINTEGRACAO
                AND CDTIPORECE   = :oldCDTIPORECE
                AND NRORG = :NRORG
    ";

    const GET_RECEBIMENTOS_ADD = "
        SELECT CDTIPORECE, NMTIPORECE FROM TIPORECE
          ORDER BY CDTIPORECE
    ";

    const GET_RECEBIMENTOS_INN = "
        SELECT CDTIPORECE, NMTIPORECE FROM TIPORECE
          ORDER BY CDTIPORECE
    ";

    const VALIDACAO_CODIGO_EXTERNO = "
        SELECT ITR.CDINTEGRACAO, ITR.CDTPRECEINTE, ITR.CDTIPORECE, ETR.NMTIPORECE
         FROM TIPORECEINTE ITR JOIN TIPORECE ETR
         ON ITR.CDTIPORECE = ETR.CDTIPORECE
         WHERE ITR.CDTPRECEINTE = :CDTPRECEINTE
           AND ITR.CDINTEGRACAO = :CDINTEGRACAO
           AND ITR.CDTIPORECE <> :CDTIPORECE
    ";

    //---- Associaçao de operador
    const SET_FILIAL_OPERADOR = "
        INSERT INTO FILIOPER
            (CDFILIAL, CDOPERADOR)
        VALUES
            (:CDFILIAL, :CDOPERADOR)
    ";

    const DELETE_FILIAL_OPERADOR = "
        DELETE FROM FILIOPER
              WHERE CDFILIAL    = :CDFILIAL
                AND CDOPERADOR  = :CDOPERADOR
    ";

    const SET_LOJA_OPERADOR = "
        INSERT INTO LOJAOPER
            (CDFILIAL, CDLOJA, CDOPERADOR)
        VALUES
            (:CDFILIAL, :CDLOJA, :CDOPERADOR)
    ";

    const DELETE_LOJA_OPERADOR = "
        DELETE FROM LOJAOPER
              WHERE CDFILIAL    = :CDFILIAL
                AND CDLOJA      = :CDLOJA
                AND CDOPERADOR  = :CDOPERADOR

    ";

    const GET_LOJAS_FILIAL = "
        SELECT CDLOJA, NMLOJA, CDFILIAL
          FROM LOJA
         WHERE CDFILIAL = :CDFILIAL
        ORDER BY CDFILIAL, CDLOJA
    ";

    //-----------------------------------------PARAM KDS

    //Setor
    const ALTERA_CDSETOR_SETORFILIAL = "
        UPDATE SETORFILIAL
        SET CDSETOR = :NOVOCDSETOR
        WHERE CDSETOR = :CDSETOR
    ";

    const ALTERA_CDSETOR_SETORPRODUTO = "
        UPDATE SETORPRODUTO
        SET CDSETOR = :NOVOCDSETOR
        WHERE CDSETOR = :CDSETOR
          AND CDPRODUTO = :CDPRODUTO
    ";

    const BUSCA_SETORES = "
        SELECT CDSETOR, SGSETOR, NMSETOR, IDTIPOSETOR, CDSETOR||' - '||NMSETOR AS LABELSETOR
          FROM SETOR
         ORDER BY CDSETOR
    ";

    const BUSCA_MAX_CDSETOR = "
        SELECT MAX(CDSETOR) AS CDSETOR
          FROM SETOR
    ";

    const CRIA_SETOR = "
        INSERT INTO SETOR
        (CDSETOR, SGSETOR, NMSETOR, IDTIPOSETOR, IDATIVO)
        VALUES
        (:CDSETOR, :SGSETOR, :NMSETOR, :IDTIPOSETOR, 'S')
    ";

    const VALIDA_SETORFILIAL = "
        SELECT CDSETOR
          FROM SETORFILIAL
         WHERE CDSETOR = :CDSETOR
           AND CDFILIAL = :CDFILIAL
    ";

    const ALTERA_SETOR = "
        UPDATE SETOR
          SET SGSETOR = :SGSETOR, NMSETOR = :NMSETOR, IDTIPOSETOR = :IDTIPOSETOR, CDSETOR = :NOVOCDSETOR
         WHERE CDSETOR = :CDSETOR
    ";

    const EXCLUI_SETOR = "
        DELETE FROM SETOR
         WHERE CDSETOR = :CDSETOR
    ";

    const EXCLUI_SETOR_LOJA = "
        DELETE FROM SETORLOJA
         WHERE CDSETOR   = :CDSETOR
           AND CDLOJA    = :CDLOJA
    ";

    const EXCLUI_PRODUTOS_SETOR = "
        DELETE FROM SETORPRODUTO
         WHERE CDSETOR = :CDSETOR
    ";

    const VALIDA_EXCLUSAO_SETOR ="
        SELECT CDSETOR
          FROM SETORFILIAL
         WHERE CDSETOR = :CDSETOR
    ";

    const VALIDA_EXCLUSAO_SETORPRODUTO ="
        SELECT CDSETOR
          FROM SETORPRODUTO
         WHERE CDSETOR = :CDSETOR
    ";

    //Produto

    const BUSCA_PROD_SETOR_ESPECIFICO = "
         SELECT SP.CDSETOR, P.CDARVPROD, P.CDPRODUTO, P.NMPRODUTO,
                SP.NRTEMPOPROD, P.CDARVPROD || ' - ' || P.NMPRODUTO AS PRODUTOSELECAO, SP.NRTEMPOEXIB,
                S.CDSETOR || ' - ' || S.NMSETOR AS SETORSELECAO
           FROM SETOR S JOIN SETORPRODUTO SP
                          ON S.CDSETOR   = SP.CDSETOR
                        JOIN PRODUTO P
                          ON P.CDPRODUTO = SP.CDPRODUTO
          WHERE S.CDSETOR = :CDSETOR
          ORDER BY NMPRODUTO
    ";

    const VALIDA_PRODUTO = "
        SELECT SP.CDPRODUTO, SP.NRTEMPOPROD, SP.CDSETOR, SE.IDTIPOSETOR
          FROM SETORPRODUTO SP JOIN SETOR SE
                                 ON SP.CDSETOR = SE.CDSETOR
         WHERE SP.CDPRODUTO = :CDPRODUTO
           AND SP.CDSETOR   = :CDSETOR
    ";

    const CRIA_PRODUTO_SETOR = "
        INSERT INTO SETORPRODUTO
        (CDSETOR, CDPRODUTO, NRTEMPOPROD, NRTEMPOEXIB)
        VALUES
        (:CDSETOR, :CDPRODUTO, :NRTEMPOPROD, :NRTEMPOEXIB)
    ";

    const ALTERA_PRODUTO_SETOR = "
        UPDATE SETORPRODUTO
          SET CDSETOR = :CDSETOR, CDPRODUTO = :CDPRODUTO, NRTEMPOPROD = :NRTEMPOPROD, NRTEMPOEXIB= :NRTEMPOEXIB
         WHERE CDSETOR =:CDSETOR
           AND CDPRODUTO =:CDPRODUTO
    ";

    const ALTERA_PRODUTO_SETORES = "
        UPDATE SETORPRODUTO
          SET CDPRODUTO = :CDPRODUTO, NRTEMPOPROD = :NRTEMPOPROD, NRTEMPOEXIB= :NRTEMPOEXIB
           WHERE CDPRODUTO =:CDPRODUTO
    ";

    const EXCLUI_PRODUTO_SETOR = "
        DELETE FROM SETORPRODUTO
         WHERE CDSETOR = :CDSETOR
           AND CDPRODUTO =:CDPRODUTO
    ";

    //Intervalo
    const BUSCA_PROD_INTER = "
         SELECT SI.CDSETOR, P.CDARVPROD, P.CDPRODUTO, P.NMPRODUTO,
                SI.NRTEMPOINTER, P.CDARVPROD || ' - ' || P.NMPRODUTO AS PRODUTOSELECAO, SI.NRSEQINTERVALO,
                S.CDSETOR || ' - ' || S.NMSETOR AS SETORSELECAO
           FROM SETOR S JOIN SETORPRODINTER SI
                          ON S.CDSETOR   = SI.CDSETOR
                        JOIN PRODUTO P
                          ON P.CDPRODUTO = SI.CDPRODUTO
          WHERE SI.CDSETOR = :CDSETOR
            AND SI.CDPRODUTO = :CDPRODUTO
            AND (SI.NRTEMPOINTER = :NRTEMPOINTER OR :NRTEMPOINTER IS NULL)
          ORDER BY NRSEQINTERVALO
    ";

    const CRIA_PRODUTO_INTER = "
        INSERT INTO SETORPRODINTER
        (CDPRODUTO, CDSETOR, NRSEQINTERVALO, NRTEMPOINTER)
        VALUES
        (:CDPRODUTO, :CDSETOR, :NRSEQINTERVALO, :NRTEMPOINTER)
    ";

    const ALTERA_PRODUTO_INTER = "
        UPDATE SETORPRODINTER
          SET NRTEMPOINTER = :NRTEMPOINTER
         WHERE CDPRODUTO      = :CDPRODUTO
           AND CDSETOR        = :CDSETOR
           AND NRSEQINTERVALO = :NRSEQINTERVALO
    ";

    const EXCLUI_PRODUTO_INTER = "
        DELETE FROM SETORPRODINTER
         WHERE CDPRODUTO      = :CDPRODUTO
           AND CDSETOR        = :CDSETOR
           AND NRSEQINTERVALO = :NRSEQINTERVALO
    ";

    //Produto Filial
    const BUSCA_SETOR_FILIAL = "
         SELECT SF.CDSETOR, SF.CDFILIAL, SE.NMSETOR,
         SE.SGSETOR, SE.IDTIPOSETOR, SF.IDHABSOMKDS, SF.IDHABROLLBKDS,
         SF.IDHABTIMERPROD, SF.IDHABCONTSOMPROD, SF.IDHABSOMPROD,
         SF.IDBLOQPRODKDS, SF.NRROLLBTIME, SF.IDHABPREENVIO,
         SF.IDCONTSOMKDS, SF.NRATRASOSOMPROD, SF.NRPRODATRAINISOM, SF.CDARQUIVO AS IDSOMBEEP,
         SF.IDCONCDIRETO, AR.CDARQUIVO, AR.NMARQUIVO, AR.TPARQUIVO, AR.ARQUIVO
           FROM SETORFILIAL SF JOIN SETOR SE
                                 ON SF.CDSETOR = SE.CDSETOR
                          LEFT JOIN ARQUIVOS AR
                                 ON AR.CDARQUIVO = SF.CDARQUIVO
          WHERE SF.CDFILIAL = :CDFILIAL
          ORDER BY SF.CDSETOR
    ";

    const VALIDA_PRODUTO_FILIAL = "
        SELECT SP.CDPRODUTO, SP.NRTEMPOPROD, SP.CDSETOR, SE.IDTIPOSETOR
          FROM SETORPRODUTOFIL SP JOIN SETOR SE
                                    ON SP.CDSETOR = SE.CDSETOR
         WHERE SP.CDPRODUTO = :CDPRODUTO
           AND SP.CDFILIAL = :CDFILIAL
    ";

    const GET_TIPO_SETOR = "
        SELECT IDTIPOSETOR
          FROM SETOR
         WHERE CDSETOR = :CDSETOR
    ";

    const VALIDA_SETOR = "
        SELECT CDSETOR
          FROM SETOR
         WHERE SGSETOR = :SGSETOR
           AND NMSETOR = :NMSETOR
           AND IDTIPOSETOR = :IDTIPOSETOR
           UNION
        SELECT CDSETOR
          FROM SETOR
         WHERE CDSETOR = :CDSETOR
    ";

    const VALIDA_SETORPRODUTO = "
        SELECT PR.NMPRODUTO||' - '||PR.CDARVPROD AS LABEL
          FROM SETOR SE JOIN SETORPRODUTO SP
                          ON SE.CDSETOR = SP.CDSETOR

                        JOIN PRODUTO PR
                          ON PR.CDPRODUTO = SP.CDPRODUTO

         WHERE SE.CDSETOR = :CDSETOR
           AND SP.CDPRODUTO IN (SELECT SPT.CDPRODUTO
                                  FROM SETORFILIAL SFT JOIN SETOR STR
                                                         ON SFT.CDSETOR = STR.CDSETOR

                                                       JOIN SETORPRODUTO SPT
                                                         ON STR.CDSETOR = SPT.CDSETOR
                                 WHERE SFT.CDSETOR <> :CDSETOR
                                   AND SFT.CDFILIAL = :CDFILIAL
                                   AND STR.IDTIPOSETOR = :IDTIPOSETOR)
    ";

    const CRIA_SETOR_FILIAL = "
        INSERT INTO SETORFILIAL
        (CDSETOR, CDFILIAL, IDHABSOMKDS, IDHABROLLBKDS,
         IDHABTIMERPROD, IDHABSOMPROD, IDHABCONTSOMPROD, IDBLOQPRODKDS,
         NRROLLBTIME, IDCONTSOMKDS, IDHABPREENVIO, NRATRASOSOMPROD,
         NRPRODATRAINISOM, CDARQUIVO, IDCONCDIRETO)
        VALUES
        (:CDSETOR, :CDFILIAL, :IDHABSOMKDS, :IDHABROLLBKDS,
         :IDHABTIMERPROD, :IDHABSOMPROD, :IDHABCONTSOMPROD, :IDBLOQPRODKDS,
         :NRROLLBTIME, :IDCONTSOMKDS, :IDHABPREENVIO, :TEMPOBEEP,
         :NRPRODATRAINISOM, :SOMBEEP, :IDCONCDIRETO)
    ";

    const ALTERA_SETOR_FILIAL = "
        UPDATE SETORFILIAL
          SET IDHABROLLBKDS = :IDHABROLLBKDS, IDHABSOMKDS = :IDHABSOMKDS,
              IDHABTIMERPROD = :IDHABTIMERPROD, IDHABSOMPROD = :IDHABSOMPROD, IDHABCONTSOMPROD = :IDHABCONTSOMPROD,
              IDBLOQPRODKDS = :IDBLOQPRODKDS, NRROLLBTIME = :NRROLLBTIME, IDCONTSOMKDS = :IDCONTSOMKDS,
              IDHABPREENVIO = :IDHABPREENVIO, NRATRASOSOMPROD = :TEMPOBEEP, NRPRODATRAINISOM = :NRPRODATRAINISOM,
              CDARQUIVO = :SOMBEEP, IDCONCDIRETO = :IDCONCDIRETO
         WHERE CDSETOR = :CDSETOR
           AND CDFILIAL = :CDFILIAL
    ";

    const EXCLUI_SETOR_FILIAL = "
        DELETE FROM SETORFILIAL
         WHERE CDSETOR   = :CDSETOR
           AND CDFILIAL  = :CDFILIAL
    ";

    const GET_ATRASO_PADRAO = "
        SELECT NVL(NRATRAPADRAO, 0) AS NRATRAPADRAO
          FROM PARAVEND
         WHERE CDFILIAL = :CDFILIAL
    ";

    const UPDATE_ATRASO_PADRAO = "
        UPDATE PARAVEND
           SET NRATRAPADRAO = :NRATRAPADRAO
         WHERE CDFILIAL = :CDFILIAL
    ";

    const BUSCA_CORES_PEDIDO = "
        SELECT NRSEQCORPEDIDO, NRINICIOCOR, NRFINALCOR, NRCORPEDIDO,
               IDPISCAPED
          FROM CORPEDIDO
         ORDER BY NRINICIOCOR
    ";

    const BUSCA_COR_PEDIDO = "
        SELECT NRSEQCORPEDIDO, NRINICIOCOR, NRFINALCOR, NRCORPEDIDO,IDPISCAPED
          FROM CORPEDIDO
        WHERE NRSEQCORPEDIDO = :NRSEQCORPEDIDO
         ORDER BY NRINICIOCOR
    ";

    const CRIA_COR = "
        INSERT INTO CORPEDIDO
            (NRINICIOCOR, NRFINALCOR, IDPISCAPED, NRCORPEDIDO, NRSEQCORPEDIDO)
        VALUES
            (:NRINICIOCOR, :NRFINALCOR, :IDPISCAPED, :NRCORPEDIDO, :NRSEQCORPEDIDO)
    ";

    const ALTERA_COR = "
        UPDATE CORPEDIDO
           SET NRINICIOCOR = :NRINICIOCOR,
               NRFINALCOR = :NRFINALCOR,
               IDPISCAPED = :IDPISCAPED,
               NRCORPEDIDO = :NRCORPEDIDO
         WHERE NRSEQCORPEDIDO = :NRSEQCORPEDIDO
    ";

    const VALIDA_COR = "
        SELECT NRSEQCORPEDIDO
          FROM CORPEDIDO
         WHERE (NRINICIOCOR BETWEEN :NRINICIOCOR AND :NRFINALCOR OR NRFINALCOR BETWEEN :NRINICIOCOR AND :NRFINALCOR)
           AND ((NRSEQCORPEDIDO <> :NRSEQCORPEDIDO AND :NRSEQCORPEDIDO IS NOT NULL) OR :NRSEQCORPEDIDO IS NULL)
    ";

    const EXCLUI_COR = "
        DELETE
          FROM CORPEDIDO
         WHERE NRSEQCORPEDIDO = :NRSEQCORPEDIDO
    ";

    const IMPORTA_PRODUTO = "
            INSERT INTO SETORPRODUTO
        (CDPRODUTO, CDSETOR, NRTEMPOPROD, NRTEMPOEXIB)
        SELECT S.CDPRODUTO, :CDSETOR, S.NRTEMPOPROD, S.NRTEMPOEXIB
           FROM SETORPRODUTO S
          WHERE S.CDSETOR = :ECDSETOR
            AND S.CDPRODUTO NOT IN (SELECT E.CDPRODUTO
                              FROM SETORPRODUTO E
                             WHERE E.CDSETOR = :CDSETOR)
    ";

    const BUSCA_SETOR_FILIAL_ESPECIFICA = "
         SELECT SF.CDSETOR, SF.CDFILIAL, SE.NMSETOR,
             SE.SGSETOR, SE.IDTIPOSETOR, SF.IDHABSOMKDS, SF.IDHABROLLBKDS,
             SF.IDHABTIMERPROD, SF.IDHABCONTSOMPROD, SF.IDHABSOMPROD,
             SF.IDBLOQPRODKDS, SF.NRROLLBTIME, SF.IDHABPREENVIO,
             SF.IDCONTSOMKDS, SF.NRATRASOSOMPROD, SF.NRPRODATRAINISOM, SF.CDARQUIVO AS IDSOMBEEP,
             SF.IDCONCDIRETO, AR.CDARQUIVO, AR.NMARQUIVO, AR.TPARQUIVO, AR.ARQUIVO
               FROM SETORFILIAL SF JOIN SETOR SE
                                     ON SF.CDSETOR = SE.CDSETOR
                              LEFT JOIN ARQUIVOS AR
                                     ON AR.CDARQUIVO = SF.CDARQUIVO
              WHERE SF.CDFILIAL = :CDFILIAL
          and SF.CDSETOR = :CDSETOR
              ORDER BY SF.CDSETOR
    ";

    const BUSCA_TECLAS = "
        SELECT NRKEY, IDFUNCAO, IDKEY
          FROM LAYOUTTECLAKDS
    ";

    const BUSCA_TECLA = "
        SELECT NRKEY, IDFUNCAO, IDKEY
            FROM LAYOUTTECLAKDS
          WHERE NRKEY = :NRKEY
    ";

    const DELETE_TECLA = "
        DELETE FROM LAYOUTTECLAKDS
        WHERE NRKEY = :NRKEY
    ";

    const UPDATE_TECLA = "
        UPDATE LAYOUTTECLAKDS
           SET IDFUNCAO = :IDFUNCAO,
               IDKEY = :IDKEY
         WHERE NRKEY = :NRKEY
    ";

    const INSERT_TECLA = "
        INSERT INTO LAYOUTTECLAKDS
            (NRKEY, IDFUNCAO, IDKEY)
        VALUES
            (:NRKEY, :IDFUNCAO, :IDKEY)
    ";

    const INSERT_SETOR_LOJA = "
        INSERT INTO SETORLOJA
            (CDFILIAL, CDLOJA, CDSETOR)
        VALUES
            (:CDFILIAL, :CDLOJA, :CDSETOR)
    ";

        // -------------------------- #PRODUTO --------------------------

    const BUSCA_PRODUTOS = "
        SELECT DISTINCT P.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO,
               P.CDARVPROD || ' - ' || P.NMPRODUTO AS PRODUTOSELECAO
          FROM PRODUTO P
         WHERE P.CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO)
        ORDER BY P.CDARVPROD
    ";

    const BUSCA_PRODUTO_ESPECIFICO = "
        SELECT DISTINCT P.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO,
               P.CDARVPROD || ' - ' || P.NMPRODUTO AS PRODUTOSELECAO
          FROM PRODUTO P
         WHERE CDPRODUTO = :CDPRODUTO
        ORDER BY P.CDARVPROD
    ";

    /* ------------ Query para buscar os produtos do cardápio e suas composições --------------- */

    const GET_PRODUCTS_AND_COMPOSITIONS = "
        -- BUSCA PRODUTOS DO CARDÁPIO
        SELECT I.DSBUTTON AS NMPRODUTO, P.CDARVPROD, P.CDPRODUTO, P.CDARVPROD || ' - ' || I.DSBUTTON AS PRODUTOSELECAO
          FROM ITMENUCONFTE I JOIN PRODUTO P
                                ON I.CDIDENTBUTON = P.CDPRODUTO
         WHERE I.CDFILIAL = :CDFILIAL
           AND I.NRCONFTELA = :NRCONFTELA
           AND I.IDTPBUTTON = '1'
           AND I.IDTPBUTONAUX = '2'

        UNION

        -- BUSCA COMPOSICAO LOCAL DO CARDÁPIO
        SELECT P.NMPRODUTO, P.CDARVPROD, P.CDPRODUTO, P.CDARVPROD || ' - ' || P.NMPRODUTO AS PRODUTOSELECAO
          FROM ITMENUCONFTE I JOIN ROTFABLOCAL RL
                                ON I.CDIDENTBUTON = RL.CDPRODUTO
                               AND I.CDFILIAL = RL.CDFILIAL

                              JOIN PRODUTO P
                                ON RL.CDSUBPRODLOC = P.CDPRODUTO
         WHERE I.CDFILIAL = :CDFILIAL
           AND I.NRCONFTELA = :NRCONFTELA
           AND I.IDTPBUTTON   = '1'
           AND I.IDTPBUTONAUX = '2'

        UNION

        -- BUSCA COMPOSIÇÃO DO CARDÁPIO
        SELECT P.NMPRODUTO, P.CDARVPROD, P.CDPRODUTO, P.CDARVPROD || ' - ' || P.NMPRODUTO AS PRODUTOSELECAO
          FROM ITMENUCONFTE I JOIN ROTFABRICA RF
                                ON I.CDIDENTBUTON = RF.CDPRODUTO
                               AND RF.CDPRODUTO NOT IN (SELECT DISTINCT CDPRODUTO
                                                          FROM ROTFABLOCAL
                                                         WHERE CDFILIAL = :CDFILIAL)
                              JOIN PRODUTO P
                                ON RF.CDSUBPRODUTO = P.CDPRODUTO
         WHERE I.CDFILIAL = :CDFILIAL
           AND I.NRCONFTELA = :NRCONFTELA
           AND I.IDTPBUTTON = '1'
           AND I.IDTPBUTONAUX = '2'

        ORDER BY CDARVPROD

    ";

    /* ------------------------ Busca Parâmetros de impressão ----------------- */

    const GET_PRODUCTS_PRODLOJA = "
        SELECT PL.CDFILIAL, PL.CDLOJA, PT.CDARVPROD, PT.CDPRODUTO, PT.NMPRODUTO, PL.IDIMPCANITEM, CASE PL.IDIMPCANITEM
                                                             WHEN 'S' THEN 'Sim'
                                                             WHEN 'N' THEN 'Não'
                                                         END AS DSIMPCANITEM,
               PL.NRSEQIMPRPROD, PL.NRSEQIMPRPROD || ' - ' || ILP.NMIMPRLOJA AS LABELIMPRPROD, ILP.NMIMPRLOJA AS NMIMPRPROD,
               PL.NRSEQIMPRPUXA, PL.NRSEQIMPRPUXA || ' - ' || ILX.NMIMPRLOJA AS LABELIMPRPUXA, ILX.NMIMPRLOJA AS NMIMPRPUXA,
               PL.CDSETOR, PL.CDSETOR || ' - ' || ST.NMSETOR AS NMSETOR
         FROM PRODLOJA PL JOIN PRODUTO PT
                            ON PL.CDPRODUTO = PT.CDPRODUTO
                AND PL.NRORG = PT.NRORG

                          LEFT JOIN IMPRLOJA ILP
                            ON ILP.NRSEQIMPRLOJA = PL.NRSEQIMPRPROD
                           AND ILP.CDFILIAL = PL.CDFILIAL
                           AND ILP.CDLOJA = PL.CDLOJA
                           AND ILP.NRORG = PL.NRORG

                          LEFT JOIN IMPRLOJA ILX
                            ON ILX.NRSEQIMPRLOJA = PL.NRSEQIMPRPUXA
                           AND ILX.CDFILIAL = PL.CDFILIAL
                           AND ILX.CDLOJA = PL.CDLOJA
                           AND ILX.NRORG = PL.NRORG

                          LEFT JOIN SETOR ST
                            ON ST.CDSETOR = PL.CDSETOR
                           AND ST.NRORG = PL.NRORG

        WHERE PL.CDFILIAL =  :CDFILIAL
          AND PL.CDLOJA   =  :CDLOJA
          AND PL.NRORG    =  :NRORG
      ORDER BY CDARVPROD
    ";

    const GET_PRODUCTS_PRODLOJA_WITH_ALLFIELDS = "
        SELECT PL.CDFILIAL, PL.CDLOJA, PT.CDARVPROD, PT.CDPRODUTO, PT.NMPRODUTO, PL.IDIMPCANITEM, CASE PL.IDIMPCANITEM
                                                             WHEN 'S' THEN 'Sim'
                                                             WHEN 'N' THEN 'Não'
                                                         END AS DSIMPCANITEM,
               PL.NRSEQIMPRPROD, PL.NRSEQIMPRPROD || ' - ' || ILP.NMIMPRLOJA AS LABELIMPRPROD, ILP.NMIMPRLOJA AS NMIMPRPROD,
               PL.NRSEQIMPRPUXA, PL.NRSEQIMPRPUXA || ' - ' || ILX.NMIMPRLOJA AS LABELIMPRPUXA, ILX.NMIMPRLOJA AS NMIMPRPUXA,
               PL.CDSETOR, PL.CDSETOR || ' - ' || ST.NMSETOR AS NMSETOR
         FROM PRODLOJA PL JOIN PRODUTO PT
                            ON PL.CDPRODUTO = PT.CDPRODUTO
                AND PL.NRORG = PT.NRORG

                          LEFT JOIN IMPRLOJA ILP
                            ON ILP.NRSEQIMPRLOJA = PL.NRSEQIMPRPROD
                           AND ILP.CDFILIAL = PL.CDFILIAL
                           AND ILP.CDLOJA = PL.CDLOJA
                           AND ILP.NRORG = PL.NRORG

                          LEFT JOIN IMPRLOJA ILX
                            ON ILX.NRSEQIMPRLOJA = PL.NRSEQIMPRPUXA
                           AND ILX.CDFILIAL = PL.CDFILIAL
                           AND ILX.CDLOJA = PL.CDLOJA
                           AND ILX.NRORG = PL.NRORG

                          LEFT JOIN SETOR ST
                            ON ST.CDSETOR = PL.CDSETOR
                           AND ST.NRORG = PL.NRORG

        WHERE PL.CDFILIAL =  :CDFILIAL
          AND PL.CDLOJA   =  :CDLOJA
          AND PL.NRORG    =  :NRORG
          AND INSTR(  PT.CDARVPROD ||
                      PT.NMPRODUTO ||
                      PL.NRSEQIMPRPROD || ' - ' || ILP.NMIMPRLOJA ||
                      PL.NRSEQIMPRPUXA || ' - ' || ILX.NMIMPRLOJA ,
                :ALLFIELDS) > 0
      ORDER BY CDARVPROD
    ";

    const BUSCA_OBSERVACAO_PRODUTO = "
         SELECT G.CDGRPOCOR, G.DSGRPOCOR, O.CDOCORR, O.DSOCORR,
                PR.CDPRODUTO || ' - ' || PR.NMPRODUTO AS PRODUTOSELECAO
           FROM GRUPOCOR G JOIN OCORRENCIA O
                             ON G.CDGRPOCOR = O.CDGRPOCOR
                           JOIN PRODOCORRE P
                             ON P.CDOCORR = O.CDOCORR
                           JOIN PRODUTO PR
                             ON P.CDPRODUTO = PR.CDPRODUTO
          WHERE P.CDPRODUTO LIKE :CDPRODUTO
       ORDER BY O.DSOCORR
    ";

    const BUSCA_PRODUTOS_RANGE = "
        SELECT CDPRODUTO
        FROM PRODUTO
          WHERE CDARVPROD BETWEEN :CDARVPROD AND :CDARVPROD2
          AND CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO) ORDER BY CDARVPROD
    ";

    const BUSCA_CDARVPROD = "
        SELECT CDARVPROD
          FROM PRODUTO
         WHERE CDPRODUTO = :CDPRODUTO
    ";

    const BUSCA_GRUPO_OCORRENCIA = "
        SELECT CDGRPOCOR, DSGRPOCOR, IDTIPGRP, CDGRPOCOR||' - '||DSGRPOCOR AS LABELGRPOCOR
          FROM GRUPOCOR
        ORDER BY CDGRPOCOR
    ";

    const CRIA_GRUPO_OCORRENCIA = "
        INSERT INTO GRUPOCOR
            (CDGRPOCOR, DSGRPOCOR, IDTIPGRP)
        VALUES
            (:CDGRPOCOR, :DSGRPOCOR, :IDTIPGRP)
    ";

    const ALTERA_GRUPO_OCORRENCIA = "
        UPDATE GRUPOCOR
           SET DSGRPOCOR = :DSGRPOCOR,
               IDTIPGRP = :IDTIPGRP
         WHERE CDGRPOCOR =:CDGRPOCOR
    ";

    const EXCLUI_GRUPO_OCORRENCIA = "
        DELETE
          FROM GRUPOCOR
         WHERE CDGRPOCOR = :CDGRPOCOR
    ";

    const BUSCA_OCORRENCIA_GRUPO_ESPECIFICO = "
        SELECT CDGRPOCOR, CDOCORR, DSOCORR, IDSINAL, NRCORSINAL, CDOCORR||' - '||DSOCORR AS LABELOCORR
          FROM OCORRENCIA
         WHERE CDGRPOCOR = :CDGRPOCOR
        ORDER BY DSOCORR
    ";

    const CRIA_OCORRENCIA = "
        INSERT INTO OCORRENCIA
        (CDGRPOCOR, CDOCORR, DSOCORR, IDSINAL,
         NRCORSINAL)
        VALUES
        (:CDGRPOCOR, :CDOCORR, :DSOCORR, :IDSINAL,
         :NRCORSINAL)
    ";

    const ALTERA_OCORRENCIA = "
        UPDATE OCORRENCIA
           SET DSOCORR   = :DSOCORR,
               IDSINAL = :IDSINAL,
               NRCORSINAL = :NRCORSINAL
         WHERE CDGRPOCOR = :CDGRPOCOR
           AND CDOCORR   = :CDOCORR
    ";

    const EXCLUI_OCORRENCIA = "
        DELETE FROM OCORRENCIA
         WHERE CDGRPOCOR = :CDGRPOCOR
           AND CDOCORR   = :CDOCORR
    ";

    const BUSCA_PRODUTO_OCORRENCIA = "
        SELECT P.CDARVPROD, P.CDPRODUTO, P.NMPRODUTO, PO.NRTEMPOPROD,
               P.CDARVPROD || ' - ' || P.NMPRODUTO AS PRODUTOSELECAO
          FROM PRODUTO P JOIN PRODOCORRE PO
                            ON P.CDPRODUTO = PO.CDPRODUTO

                          JOIN OCORRENCIA O
                            ON O.CDGRPOCOR = PO.CDGRPOCOR
                           AND O.CDOCORR   = PO.CDOCORR

         WHERE O.CDGRPOCOR = :CDGRPOCOR
           AND O.CDOCORR   = :CDOCORR
    ";

    const BUSCA_PRODUTO_OCORRENCIA_ESPECIFICO = "
        SELECT P.CDARVPROD, P.CDPRODUTO, P.NMPRODUTO,
               PO.NRTEMPOPROD, P.CDARVPROD || ' - ' || P.NMPRODUTO AS PRODUTOSELECAO
          FROM PRODUTO P JOIN PRODOCORRE PO
                            ON P.CDPRODUTO = PO.CDPRODUTO
                          JOIN OCORRENCIA O
                            ON O.CDGRPOCOR = PO.CDGRPOCOR
                           AND O.CDOCORR   = PO.CDOCORR
         WHERE PO.CDGRPOCOR   = :CDGRPOCOR
           AND PO.CDOCORR     = :CDOCORR
           AND PO.CDPRODUTO   = :CDPRODUTO
    ";

    const CRIA_PRODUTO_OCORRENCIA = "
        INSERT INTO PRODOCORRE
            (CDGRPOCOR, CDOCORR, CDPRODUTO, NRTEMPOPROD)
        VALUES
            (:CDGRPOCOR, :CDOCORR, :CDPRODUTO, :NRTEMPOPROD)
    ";

    const ALTERA_PRODUTO_OCORRENCIA = "
        UPDATE PRODOCORRE
           SET NRTEMPOPROD = :NRTEMPOPROD
         WHERE CDGRPOCOR   = :CDGRPOCOR
           AND CDOCORR     = :CDOCORR
           AND CDPRODUTO   = :CDPRODUTO
    ";

    const EXCLUI_PRODUTO_OCORRENCIA = "
        DELETE FROM PRODOCORRE
         WHERE CDGRPOCOR = :CDGRPOCOR
           AND CDOCORR   = :CDOCORR
           AND CDPRODUTO   = :CDPRODUTO
    ";

    const ADICIONA_OBSERVACAO_PRODUTO_SETOR = "
        INSERT INTO SETORPRODOBS
            (CDPRODUTO, CDSETOR, CDGRPOCOR, CDOCORR, NRTEMPOPROD)
        VALUES
            (:CDPRODUTO, :CDSETOR, :CDGRPOCOR, :CDOCORR, :NRTEMPOPROD)
    ";

    const BUSCA_OBSERVACAO_PRODUTO_SETOR = "
        SELECT S.CDPRODUTO, S.CDSETOR, S.CDGRPOCOR, S.CDOCORR, G.DSGRPOCOR,
               O.DSOCORR, P.CDARVPROD||' - '||P.NMPRODUTO AS PRODUTOSELECAO, S.NRTEMPOPROD,
               SE.CDSETOR || ' - ' || SE.NMSETOR AS SETORSELECAO
          FROM SETORPRODOBS S JOIN GRUPOCOR G
                                ON S.CDGRPOCOR = G.CDGRPOCOR
                              JOIN OCORRENCIA O
                                ON S.CDOCORR = O.CDOCORR
                               AND G.CDGRPOCOR = O.CDGRPOCOR
                              JOIN PRODUTO P
                                ON P.CDPRODUTO = S.CDPRODUTO
                              JOIN SETOR SE
                                ON S.CDSETOR = SE.CDSETOR
         WHERE S.CDPRODUTO = :CDPRODUTO
           AND S.CDSETOR = :CDSETOR
    ";

    const BUSCA_OBSERVACAO_PRODUTO_SETOR_ROW = "
        SELECT S.CDPRODUTO, S.CDSETOR, S.CDGRPOCOR, S.CDOCORR, G.DSGRPOCOR,
               O.DSOCORR, P.CDARVPROD||' - '||P.NMPRODUTO AS PRODUTOSELECAO, S.NRTEMPOPROD,
               SE.CDSETOR || ' - ' || SE.NMSETOR AS SETORSELECAO
          FROM SETORPRODOBS S JOIN GRUPOCOR G
                                ON S.CDGRPOCOR = G.CDGRPOCOR
                              JOIN OCORRENCIA O
                                ON S.CDOCORR = O.CDOCORR
                               AND G.CDGRPOCOR = O.CDGRPOCOR
                              JOIN PRODUTO P
                                ON P.CDPRODUTO = S.CDPRODUTO
                              JOIN SETOR SE
                                ON S.CDSETOR = SE.CDSETOR
         WHERE S.CDPRODUTO = :CDPRODUTO
           AND S.CDSETOR = :CDSETOR
       AND S.CDOCORR = :CDOCORR
    ";

    const EXCLUI_OBSERVACAO_PRODUTO_SETOR= "
        DELETE FROM SETORPRODOBS
         WHERE CDPRODUTO   = :CDPRODUTO
           AND CDSETOR = :CDSETOR
           AND CDGRPOCOR = :CDGRPOCOR
           AND CDOCORR   = :CDOCORR
    ";

    const VALIDA_OBSERVACAO = "
        SELECT CDPRODUTO, CDSETOR, CDGRPOCOR, CDOCORR
          FROM SETORPRODOBS
         WHERE CDPRODUTO = :CDPRODUTO
           AND CDSETOR = :CDSETOR
           AND CDGRPOCOR = :CDGRPOCOR
           AND CDOCORR = :CDOCORR
    ";

    const BUSCA_DETALHES_OBS = "
        SELECT CDSETOR, CDPRODUTO, CDOCORR, CDGRPOCOR, NRTEMPOPROD
        FROM SETORPRODOBS
        WHERE CDPRODUTO = :CDPRODUTO
           AND CDSETOR = :CDSETOR
           AND CDOCORR = :CDOCORR
           AND CDGRPOCOR = :CDGRPOCOR
    ";

    const ALTERA_DETALHES_OBS ="
        UPDATE SETORPRODOBS
          SET NRTEMPOPROD = :NRTEMPOPROD
        WHERE CDPRODUTO = :CDPRODUTO
           AND CDSETOR = :CDSETOR
           AND CDOCORR = :CDOCORR
           AND CDGRPOCOR = :CDGRPOCOR
    ";

    //------------------------SMTP----------------

    const UPDATE_SMTP = "
        UPDATE PARAMGERAL
           SET DSSMTPAUTVND     = :DSSMTPAUTVND,
               DSEMAILAUVND     = :DSEMAILAUVND,
               NRPORTAAUTVND    = :NRPORTAAUTVND,
               CDSENHAAUTVNDWEB = :CDSENHAAUTVNDWEB,
               DSEMAILCLUSO     = :DSEMAILCLUSO,
               DSSMTPCRIPT      = :DSSMTPCRIPT,
               IDTPAUTHSMTP     = :IDTPAUTHSMTP
    ";

    const BUSCA_CLIENTES = "
        SELECT  A.CDCLIENTE, A.NRINSJURCLIE, A.NMRAZSOCCLIE, A.NMFANTCLIE, A.CLIENTESELECAO, A.N
        FROM (
            SELECT D.*, ROWNUM as N FROM (
                SELECT  CDCLIENTE, NRINSJURCLIE, NMRAZSOCCLIE, NMFANTCLIE, CDCLIENTE || ' - ' || NMRAZSOCCLIE AS CLIENTESELECAO
                    FROM CLIENTE
                    WHERE CDCLIENTE IN (SELECT DISTINCT CDCLIENTE FROM CONSUMIDOR)
                    AND NMRAZSOCCLIE LIKE :NMRAZSOCCLIE
            ) D
        ) A
        WHERE A.N BETWEEN  :FIRST AND :LAST
        ORDER BY A.NRINSJURCLIE
    ";

    const BUSCA_CLIENTES_FILIAL = "
        SELECT C.CDCLIENTE,  C.NMRAZSOCCLIE, C.NMFANTCLIE,
               C.CDCLIENTE || ' - ' || C.NMRAZSOCCLIE AS CLIENTESELECAO
          FROM CLIENTE C, CLIENFILIAL F
         WHERE C.CDCLIENTE = F.CDCLIENTE
           AND F.CDFILIAL = :CDFILIAL
        ORDER BY C.CDCLIENTE
    ";

    const DADOS_CLIENTE_CAMPANHA = "
        SELECT DISTINCT C.CDCLIENTE, C.NMRAZSOCCLIE, C.NMFANTCLIE,
               C.CDCLIENTE || ' - ' || C.NMRAZSOCCLIE AS CLIENTESELECAO,
               M.CDCAMPANHA
          FROM CLIENTE C, MOVPONTOCONS M
         WHERE M.CDCLIENTE = C.CDCLIENTE
           AND M.CDCAMPANHA = :CDCAMPANHA
    ";

    const DADOS_CLIENTE_CAMPBENEFICIO = "
        SELECT DISTINCT C.CDCLIENTE, C.NMRAZSOCCLIE, C.NMFANTCLIE, C.CDCLIENTE || ' - ' || C.NMRAZSOCCLIE AS CLIENTESELECAO,
               M.CDCAMPANHA
          FROM CLIENTE C, MOVBENEFICIOCTR M
         WHERE M.CDCLIENTE = C.CDCLIENTE
           AND M.CDCAMPANHA = :CDCAMPANHA
        ORDER BY M.CDCAMPANHA, C.CDCLIENTE
    ";

    const BUSCA_CCUSCLIE = "
        SELECT CDCCUSCLIE AS CDCCUSCLIEFD, CDCCUSCLIE || ' - ' || NMCCUSCLIE AS CCUSCLIESELECAO, NMCCUSCLIE
          FROM CCUSCLIE
         WHERE CDCLIENTE = :CDCLIENTE
        ORDER BY CDCCUSCLIE
    ";

    const GET_SETORES_LOJA = "
        SELECT SL.*, S.NMSETOR
           FROM SETORLOJA SL JOIN SETOR S
            ON SL.CDSETOR = S.CDSETOR
        WHERE SL.CDFILIAL = :CDFILIAL
            AND SL.CDLOJA = :CDLOJA
    ";

    const GET_SETORES_DISPONIVEIS_LOJA = "
         SELECT SF.CDSETOR, SF.CDFILIAL, SE.NMSETOR,
         SE.SGSETOR, SE.IDTIPOSETOR, SF.IDHABSOMKDS, SF.IDHABROLLBKDS,
         SF.IDHABTIMERPROD, SF.IDHABCONTSOMPROD, SF.IDHABSOMPROD,
         SF.IDBLOQPRODKDS, SF.NRROLLBTIME, SF.IDHABPREENVIO,
         SF.IDCONTSOMKDS, SF.NRATRASOSOMPROD, SF.NRPRODATRAINISOM, SF.CDARQUIVO AS IDSOMBEEP,
         SF.IDCONCDIRETO, AR.CDARQUIVO, AR.NMARQUIVO, AR.TPARQUIVO, AR.ARQUIVO
           FROM SETORFILIAL SF JOIN SETOR SE
                                 ON SF.CDSETOR = SE.CDSETOR
                          LEFT JOIN ARQUIVOS AR
                                 ON AR.CDARQUIVO = SF.CDARQUIVO
          WHERE SF.CDFILIAL = :CDFILIAL
          AND SF.CDSETOR NOT IN(
           SELECT SL.CDSETOR
                 FROM SETORLOJA SL JOIN SETOR S
                     ON SL.CDSETOR = S.CDSETOR
                  WHERE SL.CDFILIAL = :CDFILIAL
                   AND SL.CDLOJA = :CDLOJA
          )
          ORDER BY SF.CDSETOR
    ";
    // ------------------------- BANCO -----------------------------
    const GET_BANCOS = "
        SELECT CDBANCO, NMBANCO
          FROM BANCO
        ORDER BY CDBANCO
    ";

    const GET_BANCO_ESPECIFICO = "
        SELECT B.CDBANCO, B.DSINSCEMPVND, B.QTDIASVENVND, B.CDAGENCIAVND, B.CDCONTCORVND,
               C.CDCONTCORR, CDCONTRATOVND, CDBANCOCONVVND,
               A.CDAGENCIA||' - '||A.NMAGENCIA AS NMAGENCIA, CDBANCCNAB
          FROM AGENCIA A, BANCO B, CONTCORR C
         WHERE B.CDBANCO = :CDBANCO
           AND A.CDAGENCIA = B.CDAGENCIAVND
           AND C.CDREDUCONT = B.CDCONTCORVND
    ";

    const UPDATE_BANCO = "
        UPDATE BANCO
           SET DSINSCEMPVND  = :DSINSCEMPVND,
               QTDIASVENVND  = :QTDIASVENVND,
               CDAGENCIAVND  = :CDAGENCIAVND,
               CDCONTCORVND  = :CDCONTCORVND,
               CDCONTRATOVND = :CDCONTRATOVND,
               CDBANCOCONVVND   = :CDBANCOCONVVND
         WHERE CDBANCO       = :CDBANCO
    ";

    const GET_AGENCIAS = "
        SELECT CDAGENCIA AS CDAGENCIAVND, CDAGENCIA||' - '||NMAGENCIA AS NMAGENCIA
          FROM AGENCIA
          WHERE CDBANCO = :CDBANCO
        ORDER BY CDAGENCIAVND
    ";

    const GET_CONTAS = "
        SELECT CDCONTCORR, CDREDUCONT
          FROM CONTCORR
         WHERE CDBANCO = :CDBANCO
           AND CDAGENCIA = :CDAGENCIA
        ORDER BY CDREDUCONT
    ";

    const GET_MASCARA = "
        SELECT CDPICTCONT, CDPICTAGEN
          FROM BANCO
         WHERE CDBANCO = :CDBANCO
    ";

    const GET_BANCO = "
        SELECT CDBANCO
          FROM BANCO
         WHERE CDBANCO = :CDBANCO
    ";

    const GET_BLOCKED_CARDS = "
        SELECT NRSEQCARTAOBLOQ, NRPRIMEIROS, NRULTIMOS, DESCCARTAO,
               NRPRIMEIROS||'-'||NRULTIMOS AS NRCOMPLETO
          FROM CARTAOBLOQ
         ORDER BY NRSEQCARTAOBLOQ
    ";

    const GET_BLOCKED_CARD = "
        SELECT NRSEQCARTAOBLOQ
          FROM CARTAOBLOQ
         WHERE NRPRIMEIROS = :NRPRIMEIROS
           AND NRULTIMOS = :NRULTIMOS
    ";

    const ADD_BLOCKED_CARD = "
        INSERT INTO CARTAOBLOQ
        VALUES (:NRSEQCARTAOBLOQ, :NRPRIMEIROS, :NRULTIMOS, :DESCCARTAO)
    ";

    const UPDATE_BLOCKED_CARD = "
        UPDATE CARTAOBLOQ
           SET NRPRIMEIROS = :NRPRIMEIROS,
               NRULTIMOS = :NRULTIMOS,
               DESCCARTAO = :DESCCARTAO
         WHERE NRSEQCARTAOBLOQ = :NRSEQCARTAOBLOQ
    ";
    // -------------------------- FIDELIDADE --------------------------

    const BUSCA_TODAS_CAMPANHAS = "
        SELECT CDCAMPANHA, DSCAMPANHA, CDCAMPANHA || ' - ' || DSCAMPANHA AS CAMPANHASELECAO
          FROM CAMPANHA
        ORDER BY CDCAMPANHA
    ";

    const CARREGA_CAMPANHAS_ESP_PRODUTO = "
        SELECT CDCAMPANHA, C.CDTPCAMPANHA, DSCAMPANHA, DTINIVIGCAMP,
               DTFIMVIGCAMP, T.NMTPCAMPANHA, NRDIASVALPONTO, IDCAMPANHA,
               IDUTILVOUCHER, VRPONTOVOUCHER, NRDIAVALVOUCHER
          FROM CAMPANHA C, TPCAMPANHA T
         WHERE C.CDTPCAMPANHA = T.CDTPCAMPANHA
           AND C.IDCAMPANHA = :IDCAMPANHA
           AND C.CDCAMPANHA = :CDCAMPANHA
        ORDER BY CDCAMPANHA
    ";

    const CARREGA_CAMPANHAS_ESP_DOTZ = "
        SELECT C.CDCAMPANHA, C.DSCAMPANHA, C.CDTPCAMPANHA, T.NMTPCAMPANHA,
               C.DTINIVIGCAMP, C.DTFIMVIGCAMP, C.CDPROMOCAODOTZ, C.VRPESOCAMP,
               C.VRPONTOCAMP, C.VRVENDAINIDOTZ, C.VRVENDAFINDOTZ
          FROM CAMPANHA C, TPCAMPANHA T
         WHERE C.CDTPCAMPANHA = T.CDTPCAMPANHA
           AND C.IDCAMPANHA = :IDCAMPANHA
           AND C.CDCAMPANHA = :CDCAMPANHA
        ORDER BY CDCAMPANHA
    ";

    const CARREGA_CAMPANHAS_ESP_DESCONTO = "
        SELECT C.CDCAMPANHA, C.DSCAMPANHA, C.CDTPCAMPANHA, T.NMTPCAMPANHA,
               C.DTINIVIGCAMP, C.DTFIMVIGCAMP
          FROM CAMPANHA C, TPCAMPANHA T
         WHERE C.CDTPCAMPANHA = T.CDTPCAMPANHA
           AND C.IDCAMPANHA = :IDCAMPANHA
           AND C.CDCAMPANHA = :CDCAMPANHA
        ORDER BY C.CDCAMPANHA
    ";

    const CARREGA_CAMPANHAS_ESP_BENEFICIO = "
        SELECT C.CDCAMPANHA, C.DSCAMPANHA, C.CDTPCAMPANHA, T.NMTPCAMPANHA,
               C.DTINIVIGCAMP, C.DTFIMVIGCAMP
          FROM CAMPANHA C, TPCAMPANHA T
         WHERE C.CDTPCAMPANHA = T.CDTPCAMPANHA
           AND C.IDCAMPANHA = :IDCAMPANHA
           AND C.CDCAMPANHA = :CDCAMPANHA
        ORDER BY C.CDCAMPANHA
    ";

    const CARREGA_CAMPANHAS_PRODUTO = "
        SELECT C.CDCAMPANHA, C.DSCAMPANHA, C.CDTPCAMPANHA, T.NMTPCAMPANHA,
               C.NRDIASVALPONTO, C.NRDIAVALVOUCHER, C.VRPONTOVOUCHER, C.CDPROMOCAODOTZ,
               C.VRPESOCAMP, C.VRPONTOCAMP, C.VRVENDAINIDOTZ, C.VRVENDAFINDOTZ,
               C.DTINIVIGCAMP, C.DTFIMVIGCAMP, C.CDCAMPANHA || ' - ' || C.DSCAMPANHA AS CAMPANHALABEL, C.IDUTILVOUCHER
          FROM CAMPANHA C, TPCAMPANHA T
         WHERE C.CDTPCAMPANHA = T.CDTPCAMPANHA
           AND C.IDCAMPANHA = :IDCAMPANHA
        ORDER BY C.CDCAMPANHA
    ";

    const CARREGA_CAMPANHAS_DOTZ = "
        SELECT C.CDCAMPANHA, C.DSCAMPANHA, C.CDTPCAMPANHA, T.NMTPCAMPANHA,
               C.NRDIASVALPONTO, C.NRDIAVALVOUCHER, C.VRPONTOVOUCHER, C.CDPROMOCAODOTZ,
               C.VRPESOCAMP, C.VRPONTOCAMP, C.VRVENDAINIDOTZ, C.VRVENDAFINDOTZ,
               C.DTINIVIGCAMP, C.DTFIMVIGCAMP, C.CDCAMPANHA || ' - ' || C.DSCAMPANHA AS CAMPANHALABEL
          FROM CAMPANHA C, TPCAMPANHA T
         WHERE C.CDTPCAMPANHA = T.CDTPCAMPANHA
           AND C.IDCAMPANHA = :IDCAMPANHA
        ORDER BY C.CDCAMPANHA
    ";

    const CARREGA_CAMPANHAS_DESCONTO = "
        SELECT C.CDCAMPANHA, C.DSCAMPANHA, C.CDTPCAMPANHA, T.NMTPCAMPANHA,
               C.NRDIASVALPONTO, C.NRDIAVALVOUCHER, C.VRPONTOVOUCHER, C.CDPROMOCAODOTZ,
               C.VRPESOCAMP, C.VRPONTOCAMP, C.VRVENDAINIDOTZ, C.VRVENDAFINDOTZ,
               C.DTINIVIGCAMP, C.DTFIMVIGCAMP, C.CDCAMPANHA || ' - ' || C.DSCAMPANHA AS CAMPANHALABEL
          FROM CAMPANHA C, TPCAMPANHA T
         WHERE C.CDTPCAMPANHA = T.CDTPCAMPANHA
           AND C.IDCAMPANHA = :IDCAMPANHA
        ORDER BY C.CDCAMPANHA
    ";

    const TIPOS_CAMPANHA = "
        SELECT CDTPCAMPANHA, NMTPCAMPANHA
          FROM TPCAMPANHA
        ORDER BY CDTPCAMPANHA
    ";

    const REGISTRAR_CAMPANHA = "
        INSERT INTO CAMPANHA
            (CDCAMPANHA, DSCAMPANHA, CDTPCAMPANHA, DTINIVIGCAMP,
            DTFIMVIGCAMP, IDCAMPANHA, NRDIASVALPONTO, IDUTILVOUCHER,
            VRPONTOVOUCHER, NRDIAVALVOUCHER, CDOPERULTATU, CDOPERINCLUSAO,
            NRORG, IDPONTUACAOCAMP, CDPROMOCAODOTZ, VRPESOCAMP,
            VRPONTOCAMP, VRVENDAINIDOTZ, VRVENDAFINDOTZ, DTINCLUSAO,
            DTULTATU)
        VALUES
            (:CDCAMPANHA, :DSCAMPANHA, :CDTPCAMPANHA, TO_DATE(:DTINIVIGCAMP, 'DD/MM/YY'),
            TO_DATE(:DTFIMVIGCAMP, 'DD/MM/YY'), :IDCAMPANHA, :NRDIASVALPONTO, :IDUTILVOUCHER,
            :VRPONTOVOUCHER, :NRDIAVALVOUCHER, :CDOPERULTATU, :CDOPERINCLUSAO,
            :NRORG, :IDPONTUACAOCAMP, :CDPROMOCAODOTZ, :VRPESOCAMP,
            :VRPONTOCAMP, :VRVENDAINIDOTZ, :VRVENDAFINDOTZ, SYSDATE,
            SYSDATE)
    ";

    const CAD_FILIAL_CAMPANHA = "
        INSERT INTO FILICAMPANHA
            (CDCAMPANHA, CDFILIAL, NRORG, DTINCLUSAO,
            DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU,
            CDOPERULTATU)
        VALUES
            (:CDCAMPANHA, :CDFILIAL, :NRORG, SYSDATE,
            SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO, :NRORGULTATU,
            :CDOPERULTATU)
    ";

    const INSERE_PROD_CAMPANHA = "
        INSERT INTO PRODCAMPANHA
            (CDCAMPANHA, NRSEQPRODCAMP, CDPRODUTO, IDPRODUTOGERA,
            VRPONTOPROD, DTINIVIGPROD, DTFIMVIGPROD, NRORG,
            DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO,
            NRORGULTATU, CDOPERULTATU)
        VALUES
            (:CDCAMPANHA, :NRSEQPRODCAMP, :CDPRODUTO, :IDPRODUTOGERA,
            :VRPONTOPROD, TO_DATE(:DTINIVIGPROD, 'DD/MM/YY'), TO_DATE(:DTFIMVIGPROD, 'DD/MM/YY'), :NRORG,
            SYSDATE, SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO,
            :NRORGULTATU, :CDOPERULTATU)
    ";

    const ATUALIZA_PROD_CAMPANHA = "
        UPDATE PRODCAMPANHA
           SET IDPRODUTOGERA = :IDPRODUTOGERA,
               VRPONTOPROD   = :VRPONTOPROD,
               DTINIVIGPROD  = TO_DATE(:DTINIVIGPROD, 'DD/MM/YY'),
               DTFIMVIGPROD  = TO_DATE(:DTFIMVIGPROD, 'DD/MM/YY'),
               NRORG         = :NRORG,
               DTULTATU      =  SYSDATE,
               NRORGINCLUSAO = :NRORGINCLUSAO,
               NRORGULTATU   = :NRORGULTATU,
               CDOPERULTATU  = :CDOPERULTATU
         WHERE CDCAMPANHA    = :CDCAMPANHA
           AND CDPRODUTO     = :CDPRODUTO
    ";

    const INSERE_BRINDE_CAMPANHA = "
        INSERT INTO BRINDECAMPANHA
            (CDCAMPANHA, CDPRODUTO, VRPONTOBRINDE, DSBRINDE,
            NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO,
            CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU)
        VALUES
            (:CDCAMPANHA, :CDPRODUTO, :VRPONTOBRINDE, :DSBRINDE,
            :NRORG, SYSDATE, SYSDATE, :NRORGINCLUSAO,
            :CDOPERINCLUSAO, :NRORGULTATU, :CDOPERULTATU)
    ";

    const ATUALIZA_BRINDE_CAMPANHA = "
        UPDATE BRINDECAMPANHA
           SET VRPONTOBRINDE = :VRPONTOBRINDE,
               DSBRINDE      = :DSBRINDE,
               NRORG         = :NRORG,
               DTULTATU      =  SYSDATE,
               NRORGINCLUSAO = :NRORGINCLUSAO,
               NRORGULTATU   = :NRORGULTATU,
               CDOPERULTATU  = :CDOPERULTATU
         WHERE CDCAMPANHA    = :CDCAMPANHA
           AND CDPRODUTO     = :CDPRODUTO
    ";

    const BUSCA_FILIAIS_CAMPANHA = "
        SELECT F.NMFILIAL, F.CDFILIAL
          FROM FILIAL F, FILICAMPANHA C
         WHERE F.CDFILIAL = C.CDFILIAL
           AND CDCAMPANHA = :CDCAMPANHA
        ORDER BY F.CDFILIAL
    ";

    const BUSCA_PRODUTOS_CAMPANHA = "
        SELECT P.CDARVPROD, P.CDPRODUTO, P.NMPRODUTO, C.DTINIVIGPROD,
               C.DTFIMVIGPROD, C.VRPONTOPROD
          FROM PRODUTO P, PRODCAMPANHA C
         WHERE C.CDCAMPANHA = :CDCAMPANHA
           AND P.CDPRODUTO = C.CDPRODUTO
        ORDER BY P.CDARVPROD
    ";

    const BUSCA_BRINDES_CAMPANHA = "
        SELECT P.CDARVPROD, P.CDPRODUTO, P.NMPRODUTO, C.DSBRINDE,
               VRPONTOBRINDE
          FROM PRODUTO P, BRINDECAMPANHA C
         WHERE C.CDCAMPANHA = :CDCAMPANHA
           AND P.CDPRODUTO = C.CDPRODUTO
        ORDER BY P.CDARVPROD
    ";

    const ALTERAR_CAMPANHA = "
        UPDATE CAMPANHA
           SET DSCAMPANHA      = :DSCAMPANHA,
               CDTPCAMPANHA    = :CDTPCAMPANHA,
               DTINIVIGCAMP    = TO_DATE(:DTINIVIGCAMP, 'DD/MM/YYYY'),
               DTFIMVIGCAMP    = TO_DATE(:DTFIMVIGCAMP, 'DD/MM/YYYY'),
               NRDIASVALPONTO  = :NRDIASVALPONTO,
               IDUTILVOUCHER   = :IDUTILVOUCHER,
               VRPONTOVOUCHER  = :VRPONTOVOUCHER,
               NRDIAVALVOUCHER = :NRDIAVALVOUCHER,
               CDPROMOCAODOTZ  = :CDPROMOCAODOTZ,
               VRPESOCAMP      = :VRPESOCAMP,
               VRPONTOCAMP     = :VRPONTOCAMP,
               VRVENDAINIDOTZ  = :VRVENDAINIDOTZ,
               VRVENDAFINDOTZ  = :VRVENDAFINDOTZ,
               NRORGINCLUSAO   = :NRORGINCLUSAO,
               CDOPERINCLUSAO  = :CDOPERINCLUSAO,
               NRORGULTATU     = :NRORGULTATU,
               CDOPERULTATU    = :CDOPERULTATU,
               DTULTATU        = SYSDATE
         WHERE CDCAMPANHA      = :CDCAMPANHA
    ";

    const DELETE_FILIAL_CAMPANHA = "
        DELETE
          FROM FILICAMPANHA
         WHERE CDCAMPANHA = :CDCAMPANHA
           AND CDFILIAL = :CDFILIAL
    ";

    const DELETE_PRODUTO_CAMPANHA = "
        DELETE
          FROM PRODCAMPANHA
         WHERE CDCAMPANHA = :CDCAMPANHA
           AND CDPRODUTO = :CDPRODUTO
    ";

    const DELETE_BRINDE_CAMPANHA = "
        DELETE
          FROM BRINDECAMPANHA
         WHERE CDCAMPANHA = :CDCAMPANHA
           AND CDPRODUTO = :CDPRODUTO
    ";

    const BUSCA_FILIAL_CAMPANHA = "
        SELECT CDFILIAL, CDCAMPANHA
          FROM FILICAMPANHA
         WHERE CDFILIAL = :CDFILIAL
        ORDER BY CDFILIAL, CDCAMPANHA
    ";

    const CAD_TIPO_CAMPANHA = "
        INSERT INTO TPCAMPANHA
            (CDTPCAMPANHA, NMTPCAMPANHA, NRORG, NRORGINCLUSAO,
            CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, DTINCLUSAO,
            DTULTATU)
        VALUES
            (:CDTPCAMPANHA, :NMTPCAMPANHA, :NRORG, :NRORGINCLUSAO,
            :CDOPERINCLUSAO, :NRORGULTATU, :CDOPERULTATU, SYSDATE,
            SYSDATE)
    ";

    const BUSCA_TIPO_INCLUIDO = "
        SELECT CDTPCAMPANHA, NMTPCAMPANHA
          FROM TPCAMPANHA
         WHERE CDTPCAMPANHA = :CDTPCAMPANHA
    ";

    const DELETAR_TODOS_BRINDES = "
        DELETE
          FROM BRINDECAMPANHA
         WHERE CDCAMPANHA = :CDCAMPANHA
    ";

    const DELETAR_TODOS_PRODUTOS = "
        DELETE
          FROM PRODCAMPANHA
         WHERE CDCAMPANHA = :CDCAMPANHA
    ";

    const DELETAR_TODAS_FILIAIS = "
        DELETE
          FROM FILICAMPANHA
         WHERE CDCAMPANHA = :CDCAMPANHA
    ";

    const DELETAR_CAMPANHA = "
        DELETE
          FROM CAMPANHA
         WHERE CDCAMPANHA = :CDCAMPANHA
    ";

    const BUSCA_PROD_CAMPANHA = "
        SELECT CDPRODUTO
          FROM PRODCAMPANHA
         WHERE CDCAMPANHA = :CDCAMPANHA
           AND CDPRODUTO = :CDPRODUTO
    ";

    const BUSCA_BRINDE_CAMPANHA = "
        SELECT CDPRODUTO
          FROM BRINDECAMPANHA
         WHERE CDCAMPANHA = :CDCAMPANHA
           AND CDPRODUTO = :CDPRODUTO
    ";

    const ALTERAR_TIPO_CAMPANHA = "
        UPDATE TPCAMPANHA
           SET NMTPCAMPANHA = :NMTPCAMPANHA
         WHERE CDTPCAMPANHA = :CDTPCAMPANHA
    ";

    const DELETE_TIPO_CAMPANHA = "
        DELETE
          FROM TPCAMPANHA
         WHERE CDTPCAMPANHA = :CDTPCAMPANHA
    ";

    const VERIFICA_UTIL_TPCAMPANHA = "
        SELECT CDTPCAMPANHA
          FROM CAMPANHA
         WHERE CDTPCAMPANHA = :CDTPCAMPANHA
    ";

    const BUSCA_MOVIMENTO = "
        SELECT M.IDTPMOVCONS, TO_CHAR(M.DTMOVPONTOCONS, 'DD/MM/YYYY HH24:MI:SS') AS DTMOVPONTOCONS,
               M.VRMOVPONTOCONS, M.VRSALDOCONS, M.CDFILIAL, F.NMFILIAL,
               M.CDCAIXA, M.NRSEQVENDA, M.DTVALIDAPONTO
          FROM MOVPONTOCONS M, FILIAL F, CAMPANHA C
         WHERE M.CDFILIAL     = F.CDFILIAL (+)
           AND M.CDCAMPANHA   = C.CDCAMPANHA
           AND M.CDCAMPANHA   = :CDCAMPANHA
           AND M.CDCLIENTE    = :CDCLIENTE
           AND M.CDCONSUMIDOR = :CDCONSUMIDOR
           AND C.IDCAMPANHA   = :IDCAMPANHA
        ORDER BY M.NRSEQMOVCONS
    ";

    const BUSCA_MOVIMENTO_DATA = "
        SELECT M.IDTPMOVCONS, TO_CHAR(M.DTMOVPONTOCONS, 'DD/MM/YYYY HH24:MI:SS') AS DTMOVPONTOCONS,
               M.VRMOVPONTOCONS, M.VRSALDOCONS, M.CDFILIAL, F.NMFILIAL,
               M.CDCAIXA, M.NRSEQVENDA, M.DTVALIDAPONTO
          FROM MOVPONTOCONS M, FILIAL F, CAMPANHA C
         WHERE M.CDFILIAL     = F.CDFILIAL (+)
           AND M.CDCAMPANHA   = C.CDCAMPANHA
           AND M.CDCAMPANHA   = :CDCAMPANHA
           AND M.CDCLIENTE    = :CDCLIENTE
           AND M.CDCONSUMIDOR = :CDCONSUMIDOR
           AND M.DTMOVPONTOCONS >= TO_DATE(:DTINICIO, 'DD/MM/YYYY')
        ORDER BY M.NRSEQMOVCONS
    ";

    const GRAVAR_MANUTENCAO = "
        INSERT INTO MOVPONTOCONS
            (CDCAMPANHA, CDCLIENTE, CDCONSUMIDOR, IDTPMOVCONS,
            VRMOVPONTOCONS, DTMOVPONTOCONS, VRSALDOCONS, NRSEQMOVCONS,
            NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO,
            CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, DSOBSMOVPTOCONS,
            DTVALIDAPONTO)
        VALUES
            (:CDCAMPANHA, :CDCLIENTE, :CDCONSUMIDOR, :IDTPMOVCONS,
            :VRMOVPONTOCONS, SYSDATE, :VRSALDOCONS, :NRSEQMOVCONS,
            :NRORG, SYSDATE, SYSDATE, :NRORGINCLUSAO,
            :CDOPERINCLUSAO, :NRORGULTATU, :CDOPERULTATU, :DSOBSMOVPTOCONS,
            TO_DATE(:DTVALIDAPONTO, 'DD/MM/YYYY'))
    ";

    const CARREGA_VOUCHERS = "
        SELECT V.CDCAMPANHA, C.DSCAMPANHA, V.CDCLIENTE, E.NMFANTCLIE,
               V.CDCONSUMIDOR, O.NMCONSUMIDOR, V.NRSEQVOUCHER, V.DTGERVOUCHER,
               V.DTVALVOUCHER, V.VRPTOVOUCHER, V.IDUTIVOUCHER, V.DTUTIVOUCHER
          FROM VOUCHERVND V, CAMPANHA C, CLIENTE E, CONSUMIDOR O
         WHERE V.CDCAMPANHA   = C.CDCAMPANHA
           AND V.CDCLIENTE    = E.CDCLIENTE
           AND V.CDCONSUMIDOR = O.CDCONSUMIDOR
           AND V.CDCAMPANHA   = :CDCAMPANHA
           AND V.CDCLIENTE    = :CDCLIENTE
           AND V.CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    const CREDITO_MAIS_ANTIGO = "
        SELECT DTMOVPONTOCONS, VRSALDOCONS, MIN(NRSEQMOVCONS) AS NRSEQMOVCONS
          FROM MOVPONTOCONS
         WHERE CDCAMPANHA   = :CDCAMPANHA
           AND CDCLIENTE    = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
           AND IDTPMOVCONS  = 'C'
           AND VRSALDOCONS  > 0
           AND (DTVALIDAPONTO > sysdate or DTVALIDAPONTO = NULL)
        GROUP BY DTMOVPONTOCONS, VRSALDOCONS
    ";

    const ATUALIZA_VRSALDOCONS = "
        UPDATE MOVPONTOCONS
           SET VRSALDOCONS  = :VRSALDOCONS
         WHERE CDCAMPANHA   = :CDCAMPANHA
           AND CDCLIENTE    = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
           AND NRSEQMOVCONS = :NRSEQMOVCONS
    ";

    const BUSCA_SALDO = "
        SELECT SUM(VRSALDOCONS) AS VRSALDOCONS
          FROM MOVPONTOCONS
         WHERE CDCAMPANHA   = :CDCAMPANHA
           AND CDCLIENTE    = :CDCLIENTE
           AND CDCONSUMIDOR = :CDCONSUMIDOR
           AND IDTPMOVCONS  = 'C'
           AND ((DTVALIDAPONTO >= sysdate) OR (DTVALIDAPONTO IS NULL))
    ";

    const QTD_CONS_CAMPANHA = "
        SELECT COUNT(DISTINCT CDCLIENTE||CDCONSUMIDOR) AS NRCONSUMIDORES
          FROM MOVPONTOCONS
         WHERE CDCAMPANHA = :CDCAMPANHA
           AND ((DTVALIDAPONTO >= SYSDATE) OR (DTVALIDAPONTO IS NULL))
    ";

    const DADOS_CAMPANHA = "
        SELECT (CDCAMPANHA || ' - ' || DSCAMPANHA) AS CAMPANHASELECAO, DTINIVIGCAMP, DTFIMVIGCAMP,
               IDCAMPANHA
          FROM CAMPANHA
         WHERE CDCAMPANHA = :CDCAMPANHA
    ";

    const BUSCA_VRTOTVENDAS = "
        SELECT NVL(A.VRTOTVENDAS,0) AS VRTOTVENDAS
          FROM (SELECT SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRTOTVENDAS
                  FROM VENDA V, ITEMVENDA I, MOVPONTOCONS M, PRODUTO P,
                       (SELECT O.CDARVPROD
                          FROM PRODCAMPANHA P, PRODUTO O
                         WHERE P.CDPRODUTO  = O.CDPRODUTO
                           AND P.CDCAMPANHA = :CDCAMPANHA) A
                 WHERE V.CDFILIAL    = I.CDFILIAL
                   AND V.CDCAIXA     = I.CDCAIXA
                   AND V.NRSEQVENDA  = I.NRSEQVENDA
                   AND V.CDFILIAL    = M.CDFILIAL
                   AND V.CDCAIXA     = M.CDCAIXA
                   AND V.NRSEQVENDA  = M.NRSEQVENDA
                   AND V.IDSITUVENDA = 'O'
                   AND M.CDCAMPANHA  = :CDCAMPANHA
                   AND M.IDTPMOVCONS = 'C'
                   AND P.CDPRODUTO   = I.CDPRODUTO
                   AND (P.CDARVPROD LIKE A.CDARVPROD||'%')
                   AND V.DTENTRVENDA BETWEEN TO_DATE(:DTINIVIGCAMP, 'DD/MM/YYYY') AND TO_DATE(:DTFIMVIGCAMP, 'DD/MM/YYYY')) A
    ";

    const DADOS_BENEFICIO = "
        SELECT COUNT(DISTINCT M.CDCLIENTE||M.CDCONSUMIDOR) AS NRBENEFICIADOS,
               (:NRCONSUMIDORES - COUNT(DISTINCT M.CDCLIENTE||M.CDCONSUMIDOR)) AS NRNAOBENEFICIADOS
          FROM MOVPONTOCONS M, VENDA V
         WHERE M.CDCAMPANHA  = :CDCAMPANHA
           AND M.CDFILIAL    = V.CDFILIAL
           AND M.CDCAIXA     = V.CDCAIXA
           AND M.NRSEQVENDA  = V.NRSEQVENDA
           AND M.IDTPMOVCONS = 'D'
           AND V.IDSITUVENDA = 'O'
           AND (V.DTENTRVENDA BETWEEN TO_DATE(:DTINIVIGCAMP, 'DD/MM/YYYY') AND TO_DATE(:DTFIMVIGCAMP, 'DD/MM/YYYY'))
    ";

    const DADOS_RESG_BRINDE = "
        SELECT COUNT(*) AS NRBRINDERESG, NVL(SUM(TRUNC(I.VRUNITVEND * I.QTPRODVEND,2)),0) AS VRTOTBRINDERESG
          FROM VENDA V, ITEMVENDA I, MOVPONTOCONS M
         WHERE V.CDFILIAL    = I.CDFILIAL
           AND V.CDCAIXA     = I.CDCAIXA
           AND V.NRSEQVENDA  = I.NRSEQVENDA
           AND V.CDFILIAL    = M.CDFILIAL
           AND V.CDCAIXA     = M.CDCAIXA
           AND V.NRSEQVENDA  = M.NRSEQVENDA
           AND V.IDSITUVENDA = 'O'
           AND M.CDCAMPANHA  = :CDCAMPANHA
           AND M.IDTPMOVCONS = 'D'
           AND (V.DTENTRVENDA BETWEEN TO_DATE(:DTINIVIGCAMP, 'DD/MM/YYYY') AND TO_DATE(:DTFIMVIGCAMP, 'DD/MM/YYYY'))
    ";

    const BUSCA_VIGENCIA_CAMPANHA = "
        SELECT DTINIVIGCAMP, DTFIMVIGCAMP
          FROM CAMPANHA
         WHERE CDCAMPANHA = :CDCAMPANHA
    ";

    const BUSCA_CAMPANHA_BRINDE_MANUTENCAO = "
        SELECT CDCAMPANHA, DSCAMPANHA, :CDCLIENTE AS CDCLIENTE, :CDCONSUMIDOR AS CDCONSUMIDOR
          FROM CAMPANHA
         WHERE IDCAMPANHA = 'P'
         ORDER BY CDCAMPANHA
    ";

    const BUSCA_CAMPANHA_DESCONTO_MANUTENCAO = "
        SELECT CDCAMPANHA, DSCAMPANHA, :CDCLIENTE AS CDCLIENTE, :CDCONSUMIDOR AS CDCONSUMIDOR
          FROM CAMPANHA
         WHERE IDCAMPANHA = 'D'
         ORDER BY CDCAMPANHA
    ";

    const BUSCA_CAMPANHA_BENEFICIOS_MANUTENCAO = "
        SELECT CDCAMPANHA, DSCAMPANHA, :CDCLIENTE AS CDCLIENTE, :CDCONSUMIDOR AS CDCONSUMIDOR
          FROM CAMPANHA
         WHERE IDCAMPANHA = 'C'
         ORDER BY CDCAMPANHA
    ";

    const BUSCA_BENEFICIOS = "
        SELECT NRSEQBENEFICIO, IDTPBENEFICIO, VRBENEFICIO, IDTPATIVABENEFICIO, DSBENEFICIO,
        QTDMAXDIASUBSEQ, QTDMAXDIACOMPRA
          FROM BENEFICIOFOS
        ORDER BY NRSEQBENEFICIO
    ";

    const BUSCA_BENEFICIO = "
        SELECT NRSEQBENEFICIO, IDTPBENEFICIO, VRBENEFICIO, IDTPATIVABENEFICIO, DSBENEFICIO,
        QTDMAXDIASUBSEQ, QTDMAXDIACOMPRA
          FROM BENEFICIOFOS
      where NRSEQBENEFICIO = :NRSEQBENEFICIO
        ORDER BY NRSEQBENEFICIO
    ";

    const CAD_BENEFICIO = "
        INSERT INTO BENEFICIOFOS
            (NRSEQBENEFICIO, IDTPBENEFICIO,  VRBENEFICIO, IDTPATIVABENEFICIO,
            NRORG, DTINCLUSAO, DTULTATU, NRORGINCLUSAO,
            CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, DSBENEFICIO, QTDMAXDIACOMPRA, QTDMAXDIASUBSEQ)
        VALUES
            (:NRSEQBENEFICIO, :IDTPBENEFICIO, :VRBENEFICIO, :IDTPATIVABENEFICIO,
            :NRORG, SYSDATE, SYSDATE, :NRORGINCLUSAO,
            :CDOPERINCLUSAO, :NRORGULTATU, :CDOPERULTATU, :DSBENEFICIO, :QTDMAXDIACOMPRA, :QTDMAXDIASUBSEQ)
    ";

    const ALT_BENEFICIO = "
        UPDATE BENEFICIOFOS
           SET IDTPBENEFICIO      = :IDTPBENEFICIO,
               VRBENEFICIO        = :VRBENEFICIO,
               IDTPATIVABENEFICIO = :IDTPATIVABENEFICIO,
               NRORG              = :NRORG,
               NRORGINCLUSAO      = :NRORGINCLUSAO,
               CDOPERINCLUSAO     = :CDOPERINCLUSAO,
               NRORGULTATU        = :NRORGULTATU,
               CDOPERULTATU       = :CDOPERULTATU,
               DTULTATU           = SYSDATE,
               DSBENEFICIO        = :DSBENEFICIO,
               QTDMAXDIACOMPRA    = :QTDMAXDIACOMPRA,
               QTDMAXDIASUBSEQ    = :QTDMAXDIASUBSEQ
         WHERE NRSEQBENEFICIO     = :NRSEQBENEFICIO
    ";

    const DELETAR_BENEFICIO = "
        DELETE
          FROM BENEFICIOFOS
         WHERE NRSEQBENEFICIO = :NRSEQBENEFICIO
    ";

    const VERIFICAR_UTIL_BENEFICIO = "
        SELECT NRSEQBENEFICIO
          FROM BENEFICIOCAMP
         WHERE NRSEQBENEFICIO = :NRSEQBENEFICIO
    ";

    const BUSCA_NRSEQPRODCAMP = "
        SELECT NRSEQPRODCAMP
          FROM PRODCAMPANHA
         WHERE CDCAMPANHA = :CDCAMPANHA
           AND CDPRODUTO = :CDPRODUTO
    ";

    const BUSCA_BENEFICIO_CAMPANHA = "
        SELECT C.CDCAMPANHA, C.NRSEQPRODCAMP, C.NRSEQBENEFICIO, C.QTBENEFICIOCAMP,
               F.IDTPBENEFICIO, F.VRBENEFICIO, C.NRDIASVALBENECAMP, F.IDTPATIVABENEFICIO,
               P.CDPRODUTO, C.NRORG
          FROM BENEFICIOCAMP C, BENEFICIOFOS F, PRODCAMPANHA P
         WHERE C.NRSEQBENEFICIO = F.NRSEQBENEFICIO
           AND C.CDCAMPANHA     = P.CDCAMPANHA
           AND C.NRSEQPRODCAMP  = P.NRSEQPRODCAMP
           AND C.CDCAMPANHA     = :CDCAMPANHA
           AND C.NRSEQPRODCAMP  = :NRSEQPRODCAMP
           AND C.NRORG = :NRORG
           AND F.NRORG = C.NRORG
           AND P.NRORG = C.NRORG
    ";

    const CADASTRO_BENEFICIO_CAMPANHA = "
        INSERT INTO BENEFICIOCAMP
            (CDCAMPANHA, NRSEQBENEFICIO, NRSEQPRODCAMP, NRDIASVALBENECAMP,
            QTBENEFICIOCAMP, NRORG, NRORGINCLUSAO, CDOPERINCLUSAO,
            NRORGULTATU, CDOPERULTATU, DTINCLUSAO, DTULTATU)
        VALUES
            (:CDCAMPANHA, :NRSEQBENEFICIO, :NRSEQPRODCAMP, :NRDIASVALBENECAMP,
            :QTBENEFICIOCAMP, :NRORG, :NRORGINCLUSAO, :CDOPERINCLUSAO,
            :NRORGULTATU, :CDOPERULTATU, SYSDATE, SYSDATE)
    ";

    const VERIFICA_UTIL_BENECAMP = "
        SELECT CDCAMPANHA, NRSEQPRODCAMP, NRSEQBENEFICIO
          FROM BENEFICIOCAMP
         WHERE CDCAMPANHA     = :CDCAMPANHA
           AND NRSEQPRODCAMP  = :NRSEQPRODCAMP
           AND NRSEQBENEFICIO = :NRSEQBENEFICIO
    ";

    const BUSCA_PROD_BENEFICIO = "
        SELECT P.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, P.CDARVPROD || ' - ' || P.NMPRODUTO AS PRODUTOSELECAO,
              'PRODUTOS' AS GRUPO, CDCAMPANHA, NRSEQBENEFICIO, NRSEQPRODCAMP
          FROM PRODUTO P, PRODBENECAMP B
         WHERE P.CDPRODUTO      = B.CDPRODUTO
           AND B.CDCAMPANHA     = :CDCAMPANHA
           AND B.NRSEQBENEFICIO = :NRSEQBENEFICIO
           AND B.NRSEQPRODCAMP  = :NRSEQPRODCAMP
        ORDER BY P.CDARVPROD
    ";

    const CAD_PROD_BENE_CAMP = "
        INSERT INTO PRODBENECAMP
            (CDCAMPANHA, NRSEQPRODCAMP, NRSEQBENEFICIO, CDPRODUTO,
            NRORG, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU,
            CDOPERULTATU, DTINCLUSAO, DTULTATU)
        VALUES
            (:CDCAMPANHA, :NRSEQPRODCAMP, :NRSEQBENEFICIO, :CDPRODUTO,
            :NRORG, :NRORGINCLUSAO, :CDOPERINCLUSAO, :NRORGULTATU,
            :CDOPERULTATU, SYSDATE, SYSDATE)
    ";

    const DEL_PROD_BENE_CAMP = "
        DELETE
          FROM PRODBENECAMP
         WHERE CDCAMPANHA     = :CDCAMPANHA
           AND CDPRODUTO      = :CDPRODUTO
           AND NRSEQBENEFICIO = :NRSEQBENEFICIO
           AND NRSEQPRODCAMP  = :NRSEQPRODCAMP
    ";

    const BUSCA_PRODBENECAMP = "
        SELECT CDPRODUTO
          FROM PRODBENECAMP
         WHERE CDCAMPANHA     = :CDCAMPANHA
           AND NRSEQPRODCAMP  = :NRSEQPRODCAMP
           AND NRSEQBENEFICIO = :NRSEQBENEFICIO
           AND CDPRODUTO      = :CDPRODUTO
    ";

    const VERIFICA_BENEFICIOCAMP = "
        SELECT NRSEQPRODCAMP
          FROM BENEFICIOCAMP
         WHERE NRSEQPRODCAMP = :NRSEQPRODCAMP
           AND CDCAMPANHA    = :CDCAMPANHA
    ";

    const DEL_BENEFICIO_CAMP = "
        DELETE
          FROM BENEFICIOCAMP
         WHERE CDCAMPANHA     = :CDCAMPANHA
           AND NRSEQBENEFICIO = :NRSEQBENEFICIO
           AND NRSEQPRODCAMP  = :NRSEQPRODCAMP
    ";

    const VERIFICA_PRODUTO_COM_BENEFICIO = "
        SELECT CDPRODUTO
          FROM PRODBENECAMP
         WHERE CDCAMPANHA     = :CDCAMPANHA
           AND NRSEQBENEFICIO = :NRSEQBENEFICIO
           AND NRSEQPRODCAMP  = :NRSEQPRODCAMP
    ";

    const ALT_BENEFICIO_CAMP = "
        UPDATE BENEFICIOCAMP
           SET NRDIASVALBENECAMP = :NRDIASVALBENECAMP,
               QTBENEFICIOCAMP   = :QTBENEFICIOCAMP,
               NRORGULTATU       = :NRORGULTATU,
               CDOPERULTATU      = :CDOPERULTATU,
               DTULTATU          =  sysdate
         WHERE CDCAMPANHA        = :CDCAMPANHA
           AND NRSEQBENEFICIO    = :NRSEQBENEFICIO
           AND NRSEQPRODCAMP     = :NRSEQPRODCAMP
    ";

    const QTD_CONS_CAMP_BENEFICIO = "
        SELECT COUNT(DISTINCT CDCLIENTE||CDCONSUMIDOR) AS NRCONSUMIDORES
          FROM MOVBENEFICIOCTR
         WHERE CDCAMPANHA = :CDCAMPANHA
    ";

    const BUSCA_VRTOTVENDAS_CAMPBENEFICIO = "
        SELECT NVL(A.VRTOTVENDAS,0) AS VRTOTVENDAS
          FROM (SELECT SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRTOTVENDAS
                  FROM VENDA V, ITEMVENDA I, MOVBENEFICIOCONS M, PRODUTO P,
                       (SELECT O.CDARVPROD
                          FROM PRODBENECAMP P, PRODUTO O
                         WHERE P.CDPRODUTO  = O.CDPRODUTO
                           AND P.CDCAMPANHA = :CDCAMPANHA) A
                 WHERE V.CDFILIAL    = I.CDFILIAL
                   AND V.CDCAIXA     = I.CDCAIXA
                   AND V.NRSEQVENDA  = I.NRSEQVENDA
                   AND V.CDFILIAL    = M.CDFILIAL
                   AND V.CDCAIXA     = M.CDCAIXA
                   AND V.NRSEQVENDA  = M.NRSEQVENDA
                   AND V.IDSITUVENDA = 'O'
                   AND M.CDCAMPANHA  = :CDCAMPANHA
                   AND P.CDPRODUTO   = I.CDPRODUTO
                   AND (P.CDARVPROD LIKE A.CDARVPROD||'%')
                   AND (V.DTENTRVENDA BETWEEN TO_DATE(:DTINIVIGCAMP, 'DD/MM/YYYY') AND TO_DATE(:DTFIMVIGCAMP, 'DD/MM/YYYY'))) A
    ";

    const DADOS_BENEFICIO_CAMPBENEFICIO = "
        SELECT COUNT(DISTINCT M.CDCLIENTE||M.CDCONSUMIDOR) AS NRBENEFICIADOS,
               (:NRCONSUMIDORES - COUNT(DISTINCT M.CDCLIENTE||M.CDCONSUMIDOR)) AS NRNAOBENEFICIADOS
          FROM MOVBENEFICIOCONS M, VENDA V
         WHERE M.CDCAMPANHA  = :CDCAMPANHA
           AND M.CDFILIAL    = V.CDFILIAL
           AND M.CDCAIXA     = V.CDCAIXA
           AND M.NRSEQVENDA  = V.NRSEQVENDA
           AND V.IDSITUVENDA = 'O'
           AND (V.DTENTRVENDA BETWEEN TO_DATE(:DTINIVIGCAMP, 'DD/MM/YYYY') AND TO_DATE(:DTFIMVIGCAMP, 'DD/MM/YYYY'))
    ";

    const DADOS_BRINDES_RESGATADOS = "
        SELECT P.CDARVPROD AS CDPRODUTO, P.NMPRODUTO, COUNT(I.CDPRODUTO) AS NRBRINRESG,
               (COUNT(I.CDPRODUTO) * B.VRPONTOBRINDE) AS NRPONTOSRESG
          FROM VENDA V, ITEMVENDA I, MOVPONTOCONS M, PRODUTO P,
               (SELECT P.CDARVPROD, B.VRPONTOBRINDE
                  FROM BRINDECAMPANHA B, PRODUTO P
                 WHERE B.CDPRODUTO  = P.CDPRODUTO
                   AND B.CDCAMPANHA = :CDCAMPANHA) B
         WHERE V.CDFILIAL    = I.CDFILIAL
           AND V.CDCAIXA     = I.CDCAIXA
           AND V.NRSEQVENDA  = I.NRSEQVENDA
           AND V.CDFILIAL    = M.CDFILIAL
           AND V.CDCAIXA     = M.CDCAIXA
           AND V.NRSEQVENDA  = M.NRSEQVENDA
           AND V.IDSITUVENDA = 'O'
           AND M.CDCAMPANHA  = :CDCAMPANHA
           AND M.IDTPMOVCONS = 'D'
           AND P.CDPRODUTO   = I.CDPRODUTO
           AND (P.CDARVPROD LIKE B.CDARVPROD||'%')
           AND (V.DTENTRVENDA BETWEEN TO_DATE(:DTINIVIGCAMP,'DD/MM/YYYY') AND TO_DATE(:DTFIMVIGCAMP,'DD/MM/YYYY'))
        GROUP BY P.CDARVPROD, P.NMPRODUTO, B.VRPONTOBRINDE
        ORDER BY P.CDARVPROD
    ";

    const BUSCA_BENEFICIO_UTILIZADO = "
        SELECT B.NRSEQBENEFICIO, B.IDTPBENEFICIO, B.VRBENEFICIO
          FROM BENEFICIOFOS B, MOVBENEFICIOCONS M, VENDA V
         WHERE B.NRSEQBENEFICIO = M.NRSEQBENEFICIO
           AND M.NRSEQVENDA     = V.NRSEQVENDA   (+)
           AND M.CDCAIXA        = V.CDCAIXA      (+)
           AND M.CDFILIAL       = V.CDFILIAL     (+)
           AND M.CDCLIENTE      = V.CDCLIENTE    (+)
           AND M.CDCONSUMIDOR   = V.CDCONSUMIDOR (+)
           AND M.CDCONSUMIDOR   = :CDCONSUMIDOR
           AND M.CDCLIENTE      = :CDCLIENTE
           AND M.CDCAMPANHA     = :CDCAMPANHA
           AND M.DTUTBENECONS IS NOT NULL
    ";

    const VERIFICA_MOVBENEFICIOCTR = "
        SELECT CDCAMPANHA
          FROM MOVBENEFICIOCTR
         WHERE CDCAMPANHA = :CDCAMPANHA
    ";

    const BUSCA_BENEFICIO_NAO_UTILIZADO = "
        SELECT P.NMPRODUTO, M.NRSEQPRODCAMP, B.NRSEQBENEFICIO, B.IDTPBENEFICIO,
               M.QTDEBENEFICIO, B.VRBENEFICIO, M.CDCONSUMIDOR, M.CDCLIENTE
          FROM BENEFICIOFOS B, MOVBENEFICIOCTR M, PRODCAMPANHA C, PRODUTO P
         WHERE B.NRSEQBENEFICIO = M.NRSEQBENEFICIO
           AND M.NRSEQPRODCAMP  = C.NRSEQPRODCAMP
           AND M.CDCAMPANHA     = C.CDCAMPANHA
           AND C.CDPRODUTO      = P.CDPRODUTO
           AND M.CDCONSUMIDOR   = :CDCONSUMIDOR
           AND M.CDCLIENTE      = :CDCLIENTE
           AND M.CDCAMPANHA     = :CDCAMPANHA

    ";

    const BUSCA_QTD_BENE_UTIL = "
        SELECT COUNT(M.NRSEQBENEFICIO) QTDBENEUTIL
          FROM MOVBENEFICIOCONS M
         WHERE M.DTUTBENECONS IS NOT NULL
    ";

    const BUSCA_QTD_BENE_NAO_UTIL = "
        SELECT COUNT(DISTINCT M.NRSEQBENEFICIO) AS QTDBENENAOUTIL
          FROM MOVBENEFICIOCTR M
         WHERE M.NRSEQBENEFICIO NOT IN (SELECT M.NRSEQBENEFICIO AS NRSEQBENEFICIO
                                          FROM MOVBENEFICIOCONS M
                                         WHERE CDCAMPANHA = :CDCAMPANHA)
         AND CDCAMPANHA = :CDCAMPANHA
    ";

    const BUSCA_TOTDESCCAMP = "
        SELECT NVL(SUM(I.VRDESITVEND *  I.QTPRODVEND),0) AS TOTDESCCAMP
          FROM ITEMVENDA I, VENDA V, MOVBENEFICIOCONS M, PRODUTO P,
               PRODBENECAMP B
         WHERE I.NRSEQVENDA = V.NRSEQVENDA
           AND I.CDFILIAL   = V.CDFILIAL
           AND I.CDCAIXA    = V.CDCAIXA
           AND M.NRSEQVENDA = V.NRSEQVENDA
           AND M.CDFILIAL   = V.CDFILIAL
           AND M.CDCAIXA    = V.CDCAIXA
           AND I.CDPRODUTO  = P.CDPRODUTO
           AND P.CDPRODUTO  = B.CDPRODUTO
           AND B.CDCAMPANHA = M.CDCAMPANHA
           AND M.CDCAMPANHA = :CDCAMPANHA
    ";

    const BUSCA_MOVIMENTO_BENEFICIO = "
    SELECT M.NRSEQBENECONS, NVL(M.DTINCLUSAO, SYSDATE) AS DTINCLUSAO, B.IDTPBENEFICIO, B.VRBENEFICIO,
               M.DTUTBENECONS, M.CDFILIAL, M.CDCAIXA, M.NRSEQVENDA, M.CDCAMPANHA, M.CDCLIENTE, M.CDCONSUMIDOR
          FROM MOVBENEFICIOCONS M, BENEFICIOFOS B
         WHERE M.CDCAMPANHA     = :CDCAMPANHA
           AND M.CDCLIENTE      = :CDCLIENTE
           AND M.CDCONSUMIDOR   = :CDCONSUMIDOR
           AND M.NRSEQBENEFICIO = B.NRSEQBENEFICIO
        ORDER BY NRSEQBENECONS
    ";

    const BUSCA_BENEFICIOCAMP = "
        SELECT B.NRSEQBENEFICIO, B.IDTPBENEFICIO, B.VRBENEFICIO, C.NRSEQPRODCAMP
          FROM BENEFICIOFOS B, BENEFICIOCAMP C
         WHERE B.NRSEQBENEFICIO = C.NRSEQBENEFICIO
           AND C.CDCAMPANHA = :CDCAMPANHA
    ";

    const INSERT_DATA_UTIL_BENEFEICIO = "
        INSERT INTO MOVBENEFICIOCONS
         (NRSEQBENECONS, CDCLIENTE, CDCONSUMIDOR, CDCAMPANHA, NRSEQPRODCAMP, DTUTBENECONS, NRSEQBENEFICIO, NRORG, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, DTINCLUSAO, DTULTATU)
        VALUES
         (:NRSEQBENECONS, :CDCLIENTE, :CDCONSUMIDOR, :CDCAMPANHA, :NRSEQPRODCAMP, TO_DATE(:DTUTBENECONS, 'DD/MM/YYYY'), :NRSEQBENEFICIO, :NRORG, :NRORGINCLUSAO, :CDOPERINCLUSAO, :NRORGULTATU, :CDOPERULTATU, sysdate, sysdate)
    ";

    const VERIFICAR_BENEFICIOCAMP = "
        SELECT CDCAMPANHA
          FROM BENEFICIOCAMP
         WHERE CDCAMPANHA = :CDCAMPANHA
    ";

    const BLOQUEAR_CARTAO = "
        UPDATE CONSUMIDOR
           SET IDSITCONSUMI = '2'
         WHERE CDIDCONSUMID = :CDIDCONSUMID
    ";

    const VERIFICAR_CARTAO = "
        SELECT CDIDCONSUMID
          FROM CONSUMIDOR
         WHERE CDIDCONSUMID = :CDIDCONSUMID
    ";

    const BUSCA_PROD_CAMP_BEN = "
        SELECT P.CDARVPROD, P.CDPRODUTO, P.NMPRODUTO, C.NRSEQPRODCAMP
          FROM PRODUTO P, PRODCAMPANHA C
         WHERE P.CDPRODUTO = C.CDPRODUTO
           AND C.CDCAMPANHA = :CDCAMPANHA
    ";

    const BUSCA_BENEFICIO_DISPONIVEL = "
        SELECT B.NRSEQBENEFICIO, B.IDTPBENEFICIO, B.VRBENEFICIO, B.IDTPATIVABENEFICIO, M.QTDEBENEFICIO,
        TO_CHAR(M.DTINIVALBENECONS,'dd/mm/yyyy') AS DTINIVALBENECONS, TO_CHAR(M.DTFIMVALBENECONS,'dd/mm/yyyy') AS DTFIMVALBENECONS
          FROM BENEFICIOFOS B, MOVBENEFICIOCTR M
         WHERE B.NRSEQBENEFICIO = M.NRSEQBENEFICIO
         AND CDCLIENTE     = :CDCLIENTE
         AND CDCONSUMIDOR  = :CDCONSUMIDOR
         AND CDCAMPANHA    = :CDCAMPANHA
         AND NRSEQPRODCAMP = :NRSEQPRODCAMP
    ";

    const CHECK_BENEFICIO_MOVBENEFICIOCTR = "
        SELECT M.CDCLIENTE, M.CDCONSUMIDOR, M.CDCAMPANHA, M.NRSEQPRODCAMP, M.NRSEQBENEFICIO, M.QTDEBENEFICIO,
               B.VRBENEFICIO, B.IDTPATIVABENEFICIO, B.IDTPBENEFICIO
          FROM MOVBENEFICIOCTR M, BENEFICIOFOS B
         WHERE M.CDCLIENTE        = :CDCLIENTE
           AND M.CDCONSUMIDOR     = :CDCONSUMIDOR
           AND M.CDCAMPANHA           = :CDCAMPANHA
           AND M.NRSEQPRODCAMP    = :NRSEQPRODCAMP
           AND M.NRSEQBENEFICIO       = :NRSEQBENEFICIO
           AND M.NRSEQBENEFICIO   = B.NRSEQBENEFICIO
    ";

    const INSERE_BENEFICIO_MOVBENEFICIOCTR = "
        INSERT INTO MOVBENEFICIOCTR
            (CDCAMPANHA, CDCLIENTE, CDCONSUMIDOR, DTFIMVALBENECONS,
             DTINIVALBENECONS, IDTPDESBENECONS, NRSEQBENEFICIO, QTDEBENEFICIO,
             VRDESBENECONS, NRSEQPRODCAMP, NRORG, NRORGINCLUSAO, CDOPERINCLUSAO,
             NRORGULTATU, CDOPERULTATU, IDIMPTMOVCTR)
        VALUES
            (:CDCAMPANHA, :CDCLIENTE, :CDCONSUMIDOR, TO_DATE(:DTFIMVALBENECONS, 'DD/MM/YYYY'),
             TO_DATE(:DTINIVALBENECONS, 'DD/MM/YYYY'), :IDTPDESBENECONS, :NRSEQBENEFICIO, :QTDEBENEFICIO,
             :VRDESBENECONS, :NRSEQPRODCAMP, :NRORG, :NRORGINCLUSAO,
             :CDOPERINCLUSAO, :NRORGULTATU, :CDOPERULTATU, 'N')
    ";

    const UPDATE_BENEFICIO_MOVBENEFICIOCTR = "
        UPDATE MOVBENEFICIOCTR
           SET QTDEBENEFICIO  = :QTDEBENEFICIO,
               NRORGULTATU    = :NRORGULTATU,
               CDOPERULTATU   = :CDOPERULTATU
         WHERE CDCAMPANHA     = :CDCAMPANHA
           AND CDCLIENTE      = :CDCLIENTE
           AND CDCONSUMIDOR   = :CDCONSUMIDOR
           AND NRSEQPRODCAMP  = :NRSEQPRODCAMP
           AND NRSEQBENEFICIO = :NRSEQBENEFICIO
    ";

    const INSERE_BENEFICIO_DOACAO = "
        INSERT INTO MOVBENEFICIOCTR
            (CDCAMPANHA, CDCLIENTE, CDCONSUMIDOR, DTFIMVALBENECONS,
             DTINIVALBENECONS, IDTPDESBENECONS, NRSEQBENEFICIO, QTDEBENEFICIO,
             VRDESBENECONS, NRSEQPRODCAMP, NRORG, NRORGINCLUSAO, CDOPERINCLUSAO,
             NRORGULTATU, CDOPERULTATU, IDIMPTMOVCTR)
        VALUES
            (:CDCAMPANHA, :CDCLIENTE, :CDCONSUMIDOR, TO_DATE(:DTFIMVALBENECONS, 'DD/MM/YYYY'),
             sysdate, :IDTPDESBENECONS, :NRSEQBENEFICIO, :QTDEBENEFICIO,
             :VRDESBENECONS, :NRSEQPRODCAMP, :NRORG, :NRORGINCLUSAO,
             :CDOPERINCLUSAO, :NRORGULTATU, :CDOPERULTATU, :IDIMPTMOVCTR)
    ";

    const BUSCA_VALIDADE_BENEFICIO = "
        SELECT NRDIASVALBENECAMP
          FROM BENEFICIOCAMP
         WHERE CDCAMPANHA = :CDCAMPANHA
           AND NRSEQPRODCAMP = :NRSEQPRODCAMP
           AND NRSEQBENEFICIO = :NRSEQBENEFICIO
    ";

    const BUSCA_MECANICA = "
        SELECT IDCAMPANHA
          FROM CAMPANHA
         WHERE CDCAMPANHA = :CDCAMPANHA
    ";

    const UPDATE_FIDELIDADE_PARAMGERAL = "
        UPDATE PARAMGERAL
           SET
          CDCLIENTEFD  = :CDCLIENTEFD,
          CDTIPOCONSFD = :CDTIPOCONSFD,
          CDCCUSCLIEFD = :CDCCUSCLIEFD
    ";

    const BUSCA_PARAMGERAL_FIDELIDADE = "
        SELECT P.CDCLIENTEFD AS CDCLIENTE, P.CDTIPOCONSFD AS CDTIPOCONS, P.CDCCUSCLIEFD, C.NMRAZSOCCLIE, T.NMTIPOCONS, E.NMCCUSCLIE,
               P.CDCLIENTEFD  || ' - ' || C.NMRAZSOCCLIE AS CLIENTESELECAO,
               P.CDTIPOCONSFD || ' - ' || T.NMTIPOCONS AS TIPOCONSSELECAO,
               P.CDCLIENTEFD  || ' - ' || E.NMCCUSCLIE AS CCUSCLIESELECAO,
               P.NRORG, C.NMRAZSOCCLIE
          FROM PARAMGERAL P, TIPOCONS T, CLIENTE C, CCUSCLIE E
         WHERE P.CDTIPOCONSFD = T.CDTIPOCONS
           AND P.CDCLIENTEFD = C.CDCLIENTE
           AND P.NRORG = :NRORG
           AND T.NRORG = P.NRORG
           AND C.NRORG = P.NRORG
           AND E.NRORG = P.NRORG
         AND P.CDCLIENTEFD = E.CDCLIENTE
    ";

    //-----------------------------------------DOAÇAO DE CARTOES
    const GET_CARTOES = "
        SELECT CDIDCONSUMID
          FROM CONSUMIDOR
         WHERE CDIDCONSUMID LIKE ('DOA%')
         ORDER BY CDIDCONSUMID
    ";

    const UPDATE_CARTAO_DOACAO = "
        INSERT INTO CONSUMIDOR
            (CDCLIENTE, CDCONSUMIDOR,CDIDCONSUMID, NMCONSUMIDOR,
            IDSITCONSUMI, CDCCUSCLIE, IDCONSUMIDOR, IDATUCONSUMI,
            IDTPVENDACONS, IDIMPCPFCUPOM, IDCADCONFLIBCON, IDPERCONSPRODEX,
            IDTPSELMANHA, IDTPSEALMOCO, IDTPSELTARDE, IDCRACHAMESTRE, NRORG)
        VALUES
            (:CDCLIENTE, :CDCONSUMIDOR, :CDIDCONSUMID, :NMCONSUMIDOR,
             :IDSITCONSUMI, :CDCCUSCLIE, :IDCONSUMIDOR, :IDATUCONSUMI,
             '3', :IDIMPCPFCUPOM, :IDCADCONFLIBCON, :IDPERCONSPRODEX,
             :IDTPSELMANHA, :IDTPSEALMOCO, :IDTPSELTARDE, :IDCRACHAMESTRE, :NRORG)
    ";

    const UPDATE_BENEFIT_EXPIRATION = "
        UPDATE MOVBENEFICIOCTR
           SET DTINIVALBENECONS = :DTINIVALBENECONS,
               DTFIMVALBENECONS = :DTFIMVALBENECONS
         WHERE CDCLIENTE      = :CDCLIENTE
           AND CDCONSUMIDOR   = :CDCONSUMIDOR
           AND CDCAMPANHA     = :CDCAMPANHA
           AND NRSEQBENEFICIO = :NRSEQBENEFICIO
    ";

    const ALTERA_DSBENEFICIO_QTDMAXDIASUBSEQ_QTDMAXDIACOMPRA = "
        UPDATE BENEFICIOFOS
           SET DSBENEFICIO = :DSBENEFICIO,
           QTDMAXDIASUBSEQ = :QTDMAXDIASUBSEQ,
           QTDMAXDIACOMPRA = :QTDMAXDIACOMPRA
         WHERE NRSEQBENEFICIO  = :NRSEQBENEFICIO
    ";

        // -------------------------- #CONSUMIDOR --------------------------
    const BUSCA_CONSUMIDOR = "
                SELECT CDCONSUMIDOR,CDIDCONSUMID,CDCLIENTE, NMCONSUMIDOR, NRORG
                  FROM CONSUMIDOR
                 WHERE CDCLIENTE = :CDCLIENTE AND
                       IDATIVO = 'S' AND
                       NRORG = :NRORG
    ORDER BY CDCONSUMIDOR
    ";

    const DADOS_CONS_CAMPANHA = "
        SELECT A.CDCLIENTE, A.CDCONSUMIDOR, A.NMCONSUMIDOR, NVL(A.VRSALDOCONS,0) AS VRSALDOCONS,
               NVL(B.VRTOTCOMPRAS,0) AS VRTOTCOMPRAS
          FROM (SELECT M.CDCLIENTE, M.CDCONSUMIDOR, C.NMCONSUMIDOR, SUM(M.VRSALDOCONS) AS VRSALDOCONS
                  FROM MOVPONTOCONS M, CONSUMIDOR C
                 WHERE M.CDCLIENTE    = C.CDCLIENTE
                   AND M.CDCONSUMIDOR = C.CDCONSUMIDOR
                   AND M.CDCAMPANHA   = :CDCAMPANHA
                   AND M.CDCLIENTE    = :CDCLIENTE
                   AND M.IDTPMOVCONS  = 'C'
                   AND ((M.DTVALIDAPONTO >= TO_CHAR(sysdate, 'DD/MM/YYYY')) OR (M.DTVALIDAPONTO IS NULL))
                GROUP BY M.CDCLIENTE, M.CDCONSUMIDOR, C.NMCONSUMIDOR) A,

               (SELECT M.CDCLIENTE, M.CDCONSUMIDOR,
                       SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRTOTCOMPRAS
                  FROM VENDA V, ITEMVENDA I, MOVPONTOCONS M, PRODUTO P,
                       (SELECT O.CDARVPROD
                          FROM PRODCAMPANHA P, PRODUTO O
                         WHERE P.CDPRODUTO  = O.CDPRODUTO
                           AND P.CDCAMPANHA = :CDCAMPANHA) C
                 WHERE V.CDFILIAL    = I.CDFILIAL
                   AND V.CDCAIXA     = I.CDCAIXA
                   AND V.NRSEQVENDA  = I.NRSEQVENDA
                   AND V.CDFILIAL    = M.CDFILIAL
                   AND V.CDCAIXA     = M.CDCAIXA
                   AND V.NRSEQVENDA  = M.NRSEQVENDA
                   AND V.IDSITUVENDA = 'O'
                   AND M.CDCAMPANHA  = :CDCAMPANHA
                   AND M.CDCLIENTE   = :CDCLIENTE
                   AND M.IDTPMOVCONS = 'C'
                   AND P.CDPRODUTO   = I.CDPRODUTO
                   AND P.CDARVPROD LIKE C.CDARVPROD||'%'
                   AND (V.DTENTRVENDA BETWEEN TO_DATE(:DTINIVIGCAMP, 'DD/MM/YYYY') AND TO_DATE(:DTFIMVIGCAMP, 'DD/MM/YYYY'))
                GROUP BY M.CDCLIENTE, M.CDCONSUMIDOR) B

         WHERE A.CDCLIENTE = B.CDCLIENTE (+)
           AND A.CDCONSUMIDOR = B.CDCONSUMIDOR(+)
           AND A.CDCLIENTE = :CDCLIENTE
        ORDER BY A.CDCONSUMIDOR
    ";

    const BUSCA_CONS_CLIBENEFICIO = "
        SELECT DISTINCT C.CDCONSUMIDOR, C.NMCONSUMIDOR, C.CDCLIENTE, M.CDCAMPANHA
          FROM CONSUMIDOR C, MOVBENEFICIOCTR M
         WHERE C.CDCONSUMIDOR = M.CDCONSUMIDOR
           AND C.CDCLIENTE = M.CDCLIENTE
           AND M.CDCAMPANHA = :CDCAMPANHA
    ";

    const BUSCA_CONSUMIDOR_ESPECIFICO = "
        SELECT NMCONSUMIDOR, NRCPFRESPCON, NRORG
          FROM CONSUMIDOR
         WHERE CDIDCONSUMID = :CDIDCONSUMID
         AND NRORG = :NRORG
    ";

    const DADOS_CONSUMIDOR = "
        SELECT  C.CDCONSUMIDOR, C.CDCLIENTE, C.NMCONSUMIDOR, C.IDSITCONSUMI, C.CDPAIS, C.SGESTADO,
                C.CDMUNICIPIO, C.CDTIPOCONS, C.CDCCUSCLIE AS CCUSCLIESELECAO, C.CDIDCONSUMID,
                NVL(C.VRLIMDEBCONS,0) AS VRLIMDEBCONS,NVL(C.VRMAXDEBCONS,0) AS VRMAXDEBCONS,NVL(C.VRAVIDEBCONS,0) AS VRAVIDEBCONS,
                C.DSENDECONS, C.NMBAIRCONS, C.NRCEPCONS, C.NRTELECONS, C.NRRAMAL1CONS, C.DSEMAILCONS,
                C.IDVERSALDCON, C.NRRGCONSUMID, C.CDSENHACONS, C.NRCPFRESPCON, C.NMRESPCONS, C.NMLOGINCONS,
                C.IDSEXOCONS, C.DTNASCCONS, C.CDSENHASITE, C.IDTPVENDACONS, C.NRCELULARCONS, C.CDMUNICIPIO, C.CDBAIRRO,
                C.IDIMPCPFCUPOM, C.IDCADCONFLIBCON, C.IDPERCONSPRODEX, C.IDTPSELMANHA, C.IDTPSEALMOCO,
                C.IDTPSELTARDE, C.CDSENHACONSUMIDORWEB, C.DTVALIDADECONSUMIDOR, P.NMPAIS, M.NMMUNICIPIO, B.NMBAIRRO,
                E.NMESTADO, T.NMTIPOCONS, C.NRORG
          FROM  CONSUMIDOR C LEFT JOIN PAIS P
                               ON P.CDPAIS = C.CDPAIS
                             LEFT JOIN ESTADO E
                               ON E.CDPAIS = C.CDPAIS
                              AND E.SGESTADO = C.SGESTADO
                             LEFT JOIN MUNICIPIO M
                               ON M.CDPAIS = C.CDPAIS
                              AND M.SGESTADO = C.SGESTADO
                              AND M.CDMUNICIPIO = C.CDMUNICIPIO
                             LEFT JOIN BAIRRO B
                               ON B.CDPAIS = C.CDPAIS
                              AND B.SGESTADO = C.SGESTADO
                              AND B.CDMUNICIPIO = C.CDMUNICIPIO
                              AND B.CDBAIRRO = C.CDBAIRRO
                             LEFT JOIN TIPOCONS T
                              ON C.CDTIPOCONS = T.CDTIPOCONS
         WHERE  CDCLIENTE = :CDCLIENTE
           AND  CDCONSUMIDOR = :CDCONSUMIDOR

        ORDER BY CDCONSUMIDOR
    ";

    const GET_REPORT_STRIPE_DATES = "
        SELECT PE.DTPEDIDOFOS, SYSDATE
        FROM PEDIDOFOS PE
        JOIN ITPEDIDOFOS IT
          ON IT.CDFILIAL = PE.CDFILIAL
         AND IT.NRPEDIDOFOS = PE.NRPEDIDOFOS
        WHERE ROWNUM < 2
        ORDER BY PE.DTPEDIDOFOS ASC
    ";

    const GET_FILTERED_ANALYTIC_REPORT_DATA = "
        SELECT FI.NMFILIAL, PE.NRPEDIDOFOS, PE.DTPEDIDOFOS AS DTPEDIDOFOS, SE.NMSETOR,
               PR.CDARVPROD, PR.NMPRODUTO, NVL(IT.NRTEMPOEXIBIT , NVL(IT.NRTEMPOPRODIT , 0)) AS NRTEMPOPROD,
               NVL((IT.DTHRFINPRODUCAO - IT.DTHRINIPRODUCAO), 0) AS TEMPOPRODDEVERDADE,
               NVL((IT.DTHRINIPRODUCAO - IT.DTHREXIBICAOPROD), 0) AS TEMPOPROCESSO,
               CO.NRCORPEDIDO
        FROM ITPEDIDOFOS IT JOIN PEDIDOFOS PE
          ON IT.CDFILIAL = PE.CDFILIAL
         AND IT.NRPEDIDOFOS = PE.NRPEDIDOFOS
        JOIN PRODUTO PR
          ON IT.CDPRODUTO = PR.CDPRODUTO
        JOIN FILIAL FI
          ON PE.CDFILIAL = FI.CDFILIAL
        JOIN SETOR SE
          ON SE.CDSETOR = PE.CDSETOR
          JOIN CORPEDIDO CO
            ON  NVL((IT.DTHRINIPRODUCAO - IT.DTHREXIBICAOPROD), 241) BETWEEN CO.NRINICIOCOR AND CO.NRFINALCOR
        WHERE ((FI.CDFILIAL IN (:CDFILIAL)) OR (:CDFILIAL LIKE 'null'))
          AND ((SE.CDSETOR IN (:CDSETOR)) OR (:CDSETOR LIKE 'null'))
          AND ((PR.CDPRODUTO IN (:CDPRODUTO)) OR (:CDPRODUTO LIKE 'null'))
          AND (TRUNC(PE.DTPEDIDOFOS) BETWEEN :DTINIT AND :DTFIM)
    ";

    const BUSCA_TIPO_CONSUMIDOR = "
        SELECT CDTIPOCONS, NMTIPOCONS,
               CDTIPOCONS || ' - ' || NMTIPOCONS AS TIPOCONSSELECAO
         FROM TIPOCONS
        ORDER BY CDTIPOCONS
    ";

    const BUSCA_CONS_ESPECIFICO = "
        SELECT CDCLIENTE, CDCONSUMIDOR
          FROM CONSUMIDOR
         WHERE CDCLIENTE = :CDCLIENTE AND CDCONSUMIDOR =:CDCONSUMIDOR
    ";

    const ATUALIZA_CONSUMIDOR = "
        UPDATE CONSUMIDOR
    SET CDCLIENTE = :CDCLIENTE,
        CDCONSUMIDOR = :CDCONSUMIDOR,
        NMCONSUMIDOR = :NMCONSUMIDOR,
        IDSITCONSUMI = :IDSITCONSUMI,
        CDPAIS = :CDPAIS,
        SGESTADO = :SGESTADO,
        CDMUNICIPIO = :CDMUNICIPIO,
        CDTIPOCONS = :CDTIPOCONS,
        CDCCUSCLIE = :CDCCUSCLIE,
        CDIDCONSUMID = :CDIDCONSUMID,
        DSENDECONS = :DSENDECONS,
        NMBAIRCONS = :NMBAIRCONS,
        NRCEPCONS = :NRCEPCONS,
        NRTELECONS = :NRTELECONS,
        NRRAMAL1CONS = :NRRAMAL1CONS,
        DSEMAILCONS = :DSEMAILCONS,
        IDVERSALDCON = :IDVERSALDCON,
        VRLIMDEBCONS = :VRLIMDEBCONS,
        VRMAXDEBCONS = :VRMAXDEBCONS,
        VRAVIDEBCONS = :VRAVIDEBCONS,
        NRRGCONSUMID = :NRRGCONSUMID,
        NRCPFRESPCON = :NRCPFRESPCON,
        NMRESPCONS = :NMRESPCONS,
        NMLOGINCONS = :NMLOGINCONS,
        IDSEXOCONS = :IDSEXOCONS,
        DTNASCCONS = :DTNASCCONS,
        IDTPVENDACONS = :IDTPVENDACONS,
        NRCELULARCONS = :NRCELULARCONS,
        CDBAIRRO = :CDBAIRRO,
        IDIMPCPFCUPOM = :IDIMPCPFCUPOM,
        IDCADCONFLIBCON = :IDCADCONFLIBCON,
        IDPERCONSPRODEX = :IDPERCONSPRODEX,
        IDTPSELMANHA = :IDTPSELMANHA,
        IDTPSEALMOCO = :IDTPSEALMOCO,
        IDTPSELTARDE = :IDTPSELTARDE,
        IDATIVO = :IDATIVO,
        NRORG = :NRORG
     WHERE CDCLIENTE = :CDCLIENTE
      AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

    const INSERE_CONSUMIDOR = "
        INSERT INTO CONSUMIDOR
            (CDCLIENTE, CDCONSUMIDOR, NMCONSUMIDOR, IDSITCONSUMI, CDPAIS, SGESTADO, CDMUNICIPIO, CDTIPOCONS, CDCCUSCLIE, CDIDCONSUMID,
             DSENDECONS, NMBAIRCONS, NRCEPCONS, NRTELECONS, NRRAMAL1CONS, DSEMAILCONS, IDVERSALDCON, NRRGCONSUMID, CDSENHACONS, NRCPFRESPCON,
             NMRESPCONS, NMLOGINCONS, IDSEXOCONS, DTNASCCONS, CDSENHASITE, IDTPVENDACONS, NRCELULARCONS, CDBAIRRO, IDIMPCPFCUPOM, IDCADCONFLIBCON,
             IDPERCONSPRODEX, IDTPSELMANHA, IDTPSEALMOCO, IDTPSELTARDE, CDSENHACONSUMIDORWEB, DTVALIDADECONSUMIDOR,VRLIMDEBCONS, VRMAXDEBCONS, VRAVIDEBCONS, NRORG)
        VALUES
            (:CDCLIENTE, :CDCONSUMIDOR, :NMCONSUMIDOR, :IDSITCONSUMI, :CDPAIS, :SGESTADO, :CDMUNICIPIO, :CDTIPOCONS, :CDCCUSCLIE, :CDIDCONSUMID, :DSENDECONS, :NMBAIRCONS,
             :NRCEPCONS, :NRTELECONS, :NRRAMAL1CONS, :DSEMAILCONS, :IDVERSALDCON, :NRRGCONSUMID, :CDSENHACONS, :NRCPFRESPCON, :NMRESPCONS, :NMLOGINCONS, :IDSEXOCONS,
             :DTNASCCONS, :CDSENHASITE, :IDTPVENDACONS, :NRCELULARCONS, :CDBAIRRO, :IDIMPCPFCUPOM, :IDCADCONFLIBCON, :IDPERCONSPRODEX, :IDTPSELMANHA,
             :IDTPSEALMOCO, :IDTPSELTARDE, :CDSENHACONSUMIDORWEB,:DTVALIDADECONSUMIDOR,:VRLIMDEBCONS,:VRMAXDEBCONS,:VRAVIDEBCONS, :NRORG)
    ";


    const DELETA_SENHAMD5 = "
        UPDATE CONSUMIDOR
        SET CDSENHACONSMD5 = '', CDSENHASITE = '', CDSENHACONS = '', CDSENHACONSWEB = '', CDSENHACONSUMIDORWEB =''
        WHERE CDCLIENTE = :CDCLIENTE
        AND CDCONSUMIDOR = :CDCONSUMIDOR
    ";

        //--------------------------Forgot my Password------------

    const GET_CONSUMER_DETAILS = "
      SELECT NMCONSUMIDOR, CDSENHACONSMD5, CDCONSUMIDOR, CDCLIENTE
        FROM CONSUMIDOR
       WHERE NMLOGINCONS = :NMLOGINCONS
    ";

    const GET_CDIDCONSUMID_BY_NMLOGINCONS = "
        SELECT CDIDCONSUMID
          FROM CONSUMIDOR
         WHERE NMLOGINCONS = :NMLOGINCONS
           AND IDSITCONSUMI = '1'
    ";

    const UPDATE_HASH_ALTERASENHA_CONSUMIDOR = "
        UPDATE CONSUMIDOR
           SET  DSHASHALTERASENHA = :DSHASHALTERASENHA
         WHERE CDCONSUMIDOR = :CDCONSUMIDOR
          AND CDCLIENTE = :CDCLIENTE
    ";

    /* ------------------------------------ PARAMS VENDA ONLINE --------------------------------*/

    const BUSCA_CLIENTE_GERAL = "
        SELECT CDCLIENTE || ' - ' || NMRAZSOCCLIE AS CLIENTESELECAO, NRINSJURCLIE, NMRAZSOCCLIE
          FROM CLIENTE
        WHERE CDCLIENTE = :CDCLIENTE AND
        NRORG = :NRORG
    ";

    const UPDATE_PARAMS_TEF_MOBILE = "
            UPDATE CAIXA
               SET IDTPTEF = :IDTPTEF WHERE CDFILIAL = :CDFILIAL AND CDCAIXA = :CDCAIXA
    ";

    const GET_CAIXAS_BY_FILIAL = "
        SELECT CDCAIXA, CDFILIAL || '_' || CDCAIXA AS FILICAIXA
          FROM CAIXA
         WHERE (INSTR( :CDFILIAL, CDFILIAL) <> 0) AND
               ((INSTR( :CDLOJA,   CDLOJA) <> 0) OR (:TCDLOJA = 'T')) AND
               NRORG = :NRORG
     ORDER BY CDCAIXA, CDLOJA, CDFILIAL
    ";

    const GET_LOJAS_BY_FILIAL = "
        SELECT CDLOJA
          FROM LOJA
         WHERE (INSTR( :CDFILIAL, CDFILIAL) <> 0) AND
               NRORG = :NRORG
     ORDER BY CDLOJA, CDFILIAL
    ";

    const UPDATE_PASSWORD = "
        UPDATE OPERADOR
           SET CDSENHAOPERMD5 = :CDSENHAOPERMD5
         WHERE CDOPERADOR = :CDOPERADOR
    ";

    const GET_IMPRESSORAS = "
        SELECT NRSEQIMPRLOJA, NMIMPRLOJA, NRSEQIMPRLOJA || ' - ' || NMIMPRLOJA AS LABELIMPRESSORA
          FROM IMPRLOJA
         WHERE CDFILIAL = :CDFILIAL
           AND CDLOJA   = :CDLOJA
           AND NRORG    = :NRORG
    ";

    const GET_PRODUCTS_FOR_ADD = "
        SELECT CDPRODUTO, NMPRODUTO, CDARVPROD || ' - ' || NMPRODUTO AS LABELPRODUTO
      FROM PRODUTO
          WHERE CDPRODUTO NOT IN ( SELECT CDPRODUTO
                                                      FROM PRODLOJA
                                                  WHERE CDFILIAL = :CDFILIAL
                                                        AND CDLOJA   = :CDLOJA
                                                        AND NRORG    = :NRORG ) AND PRODUTO.CDPRODUTO <> PRODUTO.CDPRODESTO
            AND NRORG = :NRORG
      ORDER BY CDARVPROD
     ";

    const GET_SETORES = "
        SELECT CDSETOR, SGSETOR, NMSETOR, SGSETOR || ' - ' || NMSETOR AS LABELSETOR
          FROM SETOR
         WHERE IDATIVO = 'S'
          AND NRORG = :NRORG
        ORDER BY 1, 2, 3
    ";

    const UPDATE_PRODLOJA = "
        UPDATE PRODLOJA
           SET IDIMPCANITEM = :IDIMPCANITEM,
               CDSETOR = :CDSETOR,
               NRSEQIMPRPROD = :NRSEQIMPRPROD,
                 NRSEQIMPRPUXA = :NRSEQIMPRPUXA,
                 DTULTATUPLOJ = SYSDATE
         WHERE CDFILIAL  = :CDFILIAL
           AND CDLOJA    = :CDLOJA
           AND CDPRODUTO = :CDPRODUTO
           AND NRORG     = :NRORG
    ";

    const INSERT_PRODLOJA = "
        INSERT INTO PRODLOJA
          (CDFILIAL, CDLOJA, CDPRODUTO, IDIMPCANITEM, CDSETOR, NRSEQIMPRPROD,
            NRSEQIMPRPUXA, CDPORIMPPROD, CDTIPIMPPROD, NRORG)
        VALUES
          (:CDFILIAL, :CDLOJA, :CDPRODUTO, :IDIMPCANITEM, :CDSETOR, :NRSEQIMPRPROD,
            :NRSEQIMPRPUXA, ' ', '0', :NRORG)
    ";

    const REMOVE_PRODLOJA = "
        DELETE FROM PRODLOJA
              WHERE CDFILIAL   = :CDFILIAL
                AND CDLOJA     = :CDLOJA
                AND CDPRODUTO  = :CDPRODUTO
    ";

    const GET_PRODPROMOGRUPO = "
       SELECT DISTINCT ITP.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, ITP.NRORG
      FROM ITEMPRECO ITP
      JOIN PRODUTO P
        ON ITP.CDPRODUTO = P.CDPRODUTO
        AND ITP.NRORG = P.NRORG
      JOIN TABEVEND T
        ON ITP.CDFILIAL = T.CDFILIAL
        AND ITP.NRORG = T.NRORG
        AND ITP.CDTABEPREC = T.CDTABEPREC
      JOIN ALIQIMPFIS L
        ON ITP.CDFILIAL = L.CDFILIAL
        AND ITP.CDPRODUTO = L.CDPRODUTO
        AND P.CDPRODUTO = L.CDPRODUTO
        AND L.NRORG = ITP.NRORG
      JOIN IMPOSTO IMP
        ON L.CDIMPOSTO = IMP.CDIMPOSTO
      WHERE ITP.NRORG = :NRORG
        AND P.CDARVPROD BETWEEN :CDPRODUTOI AND :CDPRODUTOF
        AND ITP.CDPRODUTO = ITP.CDPRPAITABPR
        AND (T.DTFINVGPREC - T.DTINIVGPREC) > 0
        AND SYSDATE BETWEEN T.DTINIVGPREC AND T.DTFINVGPREC
        AND P.CDPRODUTO NOT IN (SELECT CDPRODUTO
                                 FROM PRODGRUPROMOC
                                 WHERE  CDGRUPROMOC = :CDGRUPROMOC
                                  AND  NRORG = :NRORG)
      ORDER BY CDARVPROD
    ";

    const GET_AMBIENTES = "
        SELECT CDAMBIENTE, NMAMBIENTE, CDAMBIENTE || ' - ' || NMAMBIENTE AS LABELAMBIENTE
          FROM AMBIENTES
         WHERE CDFILIAL = :CDFILIAL
           AND NRCONFTELA = :NRCONFTELA
    ";

    const GET_PRODAMBIENTES = "
        SELECT PA.NRPRODAMBIENTE, PA.CDFILIAL, PA.CDLOJA,
               AM.CDAMBIENTE, AM.NMAMBIENTE, AM.CDAMBIENTE|| ' - ' ||AM.NMAMBIENTE AS LABELAMBIENTE,
               CT.NRCONFTELA, CT.NMCONFTELA, CT.NRCONFTELA || ' - ' || CT.NMCONFTELA AS LABELCONFTELA,
               IL.NRSEQIMPRLOJA, IL.NRSEQIMPRLOJA || ' - ' || IL.NMIMPRLOJA AS LABELIMPRESSORA
          FROM PRODAMBIENTE PA JOIN AMBIENTES AM
                                 ON AM.CDFILIAL   = PA.CDFILIAL
                                AND AM.NRCONFTELA = PA.NRCONFTELA
                                AND AM.CDAMBIENTE = PA.CDAMBIENTE

                               JOIN IMPRLOJA IL
                                 ON IL.CDFILIAL      = PA.CDFILIAL
                                AND IL.CDLOJA        = PA.CDLOJA
                                AND IL.NRSEQIMPRLOJA = PA.NRSEQIMPRLOJA

                               JOIN CONFTELA CT
                                 ON CT.CDFILIAL   = PA.CDFILIAL
                                AND CT.CDLOJA     = PA.CDLOJA
                                AND CT.NRCONFTELA = PA.NRCONFTELA

         WHERE PA.CDFILIAL   = :CDFILIAL
           AND PA.CDLOJA     = :CDLOJA
           AND PA.CDPRODUTO  = :CDPRODUTO
    ";

        const GET_PRODAMBIENTE = "
        SELECT PA.NRPRODAMBIENTE, PA.CDFILIAL, PA.CDLOJA,
               AM.CDAMBIENTE, AM.NMAMBIENTE, AM.NMAMBIENTE AS LABELAMBIENTE,
               CT.NRCONFTELA, CT.NMCONFTELA, CT.NRCONFTELA || ' - ' || CT.NMCONFTELA AS LABELCONFTELA,
               IL.NRSEQIMPRLOJA, IL.NRSEQIMPRLOJA || ' - ' || IL.NMIMPRLOJA AS LABELIMPRESSORA
          FROM PRODAMBIENTE PA JOIN AMBIENTES AM
                                 ON AM.CDFILIAL   = PA.CDFILIAL
                                AND AM.NRCONFTELA = PA.NRCONFTELA
                                AND AM.CDAMBIENTE = PA.CDAMBIENTE

                               JOIN IMPRLOJA IL
                                 ON IL.CDFILIAL      = PA.CDFILIAL
                                AND IL.CDLOJA        = PA.CDLOJA
                                AND IL.NRSEQIMPRLOJA = PA.NRSEQIMPRLOJA

                               JOIN CONFTELA CT
                                 ON CT.CDFILIAL   = PA.CDFILIAL
                                AND CT.CDLOJA     = PA.CDLOJA
                                AND CT.NRCONFTELA = PA.NRCONFTELA

         WHERE PA.CDFILIAL   = :CDFILIAL
           AND PA.CDLOJA     = :CDLOJA
           AND PA.CDPRODUTO  = :CDPRODUTO
       AND PA.NRPRODAMBIENTE = :NRPRODAMBIENTE
    ";

    const GET_PRODAMBIENTE_DUPLICADO = "
        SELECT NRPRODAMBIENTE
          FROM PRODAMBIENTE
         WHERE CDFILIAL      = :CDFILIAL
           AND CDLOJA        = :CDLOJA
           AND CDPRODUTO     = :CDPRODUTO
           AND NRCONFTELA    = :NRCONFTELA
           AND CDAMBIENTE    = :CDAMBIENTE
           AND NRSEQIMPRLOJA = :NRSEQIMPRLOJA
    ";

    const GET_PRODAMBIENTE_DUPLICADO_EDIT = "
        SELECT NRPRODAMBIENTE
          FROM PRODAMBIENTE
         WHERE CDFILIAL      = :CDFILIAL
           AND CDLOJA        = :CDLOJA
           AND CDPRODUTO     = :CDPRODUTO
           AND NRCONFTELA    = :NRCONFTELA
           AND CDAMBIENTE    = :CDAMBIENTE
           AND NRSEQIMPRLOJA = :NRSEQIMPRLOJA
       AND NRPRODAMBIENTE <> :NRPRODAMBIENTE
    ";

    const GET_CONFTELA = "
        SELECT NRCONFTELA, NMCONFTELA, NRCONFTELA || ' - ' || NMCONFTELA AS LABELCONFTELA
          FROM CONFTELA
         WHERE CDFILIAL = :CDFILIAL
           AND CDLOJA   = :CDLOJA
    ";

    const INSERT_PRODAMBIENTE = "
        INSERT INTO PRODAMBIENTE
            (CDFILIAL, CDLOJA, CDPRODUTO, NRPRODAMBIENTE, NRCONFTELA, CDAMBIENTE, NRSEQIMPRLOJA)
        VALUES
            (:CDFILIAL, :CDLOJA, :CDPRODUTO, :NRPRODAMBIENTE, :NRCONFTELA, :CDAMBIENTE, :NRSEQIMPRLOJA)
    ";

    const DELETE_PRODAMBIENTE = "
        DELETE FROM PRODAMBIENTE
              WHERE CDFILIAL       = :CDFILIAL
                AND CDLOJA         = :CDLOJA
                AND CDPRODUTO      = :CDPRODUTO
                AND NRPRODAMBIENTE = :NRPRODAMBIENTE
    ";

    const UPDATE_PRODAMBIENTE = "
        UPDATE PRODAMBIENTE
           SET NRCONFTELA = :NRCONFTELA, CDAMBIENTE = :CDAMBIENTE,
               NRSEQIMPRLOJA = :NRSEQIMPRLOJA, DTULTATU = SYSDATE
         WHERE CDFILIAL       = :CDFILIAL
           AND CDLOJA         = :CDLOJA
           AND CDPRODUTO      = :CDPRODUTO
           AND NRPRODAMBIENTE = :NRPRODAMBIENTE
    ";

        //-----------------------------------ESTRUTURA---------------------------

    const INSERE_TIPO_ESTRUTURA = "
        INSERT INTO TIPOESTRUTURA
            (NRTIPOESTRUTURA, NMTIPOESTRUTURA, NRORG, DTINCLUSAO)
        VALUES
            (:NRTIPOESTRUTURA, :NMTIPOESTRUTURA, :NRORG, SYSDATE)
    ";

    const INSERE_ESTRUTURA = "
        INSERT INTO ESTRUTURAM
            (NRESTRUTURAM, NRORG, NRTIPOESTRUTURA, NMESTRUTURAM,
             CDINTESTRUTURA,DTINIVIGENCIA, DTINCLUSAO)
        VALUES
            (:NRESTRUTURAM, :NRORG, :NRTIPOESTRUTURA, :NMESTRUTURAM,
             :CDINTESTRUTURA, SYSDATE, SYSDATE)
    ";

    const INSERE_HIERARQUIA = "
        INSERT INTO HIERARQUIAORG
            (NRHIERARQUIAORG, NRORG, NRTIPOHIERARQORG, NRESTRUTURAMREL,
             NRESTRUTURAMSUP, DTINIVIGENCIA, DTINCLUSAO)
        VALUES
            (:NRHIERARQUIAORG, :NRORG, :NRTIPOHIERARQORG, :NRESTRUTURAMREL,
             :NRESTRUTURAMSUP, SYSDATE, SYSDATE)
    ";

    const INSERE_TIPO_HIERARQUIA = "
        INSERT INTO TIPOHIERARQORG
            (NRTIPOHIERARQORG, NMTIPOHIERARQORG, NRTIPOESTRUTREL, NRTIPOESTRUTSUP, NRORG,
             DTINCLUSAO)
        VALUES
            (:NRTIPOHIERARQORG, :NMTIPOHIERARQORG, :NRTIPOESTRUTREL, :NRTIPOESTRUTSUP, :NRORG,
             SYSDATE)
    ";

    const BUSCA_TIPOS_ESTRUTURA = "
        SELECT NMTIPOESTRUTURA, NRTIPOESTRUTURA
          FROM TIPOESTRUTURA
         WHERE NRORG = '1'
      ORDER BY NMTIPOESTRUTURA
    ";

    const BUSCA_ESTRUTURAS = "
        SELECT NMESTRUTURAM, NRESTRUTURAM, NRTIPOESTRUTURA
          FROM ESTRUTURAM
         WHERE NMESTRUTURAM IS NOT NULL
           AND NRTIPOESTRUTURA = :NRTIPOESTRUTSUP
    ";

    const BUSCA_TIPOS_HIERARQUIA = "
        SELECT NRTIPOHIERARQORG, NMTIPOHIERARQORG, NRTIPOESTRUTSUP, NRTIPOESTRUTREL
          FROM TIPOHIERARQORG
        WHERE NRTIPOESTRUTREL = :NRTIPOESTRUTREL
    ";

    const BUSCA_TIPOS_HIERARQUIA_SEM_FILTRO = "
        SELECT NRTIPOHIERARQORG, NMTIPOHIERARQORG, NRTIPOESTRUTSUP, NRTIPOESTRUTREL
          FROM TIPOHIERARQORG
    ";


    const BUSCA_ESTRUTURAS_HIERARQUIZADAS = "
        SELECT E.CDINTESTRUTURA, O.NMORGANIZACAO AS NAME, 'O' AS TYPE,E.NRESTRUTURAM, E.NMESTRUTURAM, E.NRTIPOESTRUTURA, H.NRESTRUTURAMSUP , H.NRESTRUTURAMREL, TE.NMTIPOESTRUTURA
          FROM ORGANIZACAO O
          JOIN ESTRUTURAM E ON 'O,NRORG:'||O.NRORG = E.CDINTESTRUTURA
              LEFT JOIN HIERARQUIAORG H
                   ON E.NRESTRUTURAM = H.NRESTRUTURAMREL
                       JOIN TIPOESTRUTURA TE
                       ON E.NRTIPOESTRUTURA = TE.NRTIPOESTRUTURA
                WHERE E.NMESTRUTURAM IS NOT NULL
        UNION
            SELECT E.CDINTESTRUTURA, R.NMAREAGERE AS NAME, 'R' AS TYPE, E.NRESTRUTURAM, E.NMESTRUTURAM, E.NRTIPOESTRUTURA, H.NRESTRUTURAMSUP , H.NRESTRUTURAMREL, TE.NMTIPOESTRUTURA
            FROM AREAGERE R
            JOIN ESTRUTURAM E ON 'R,CDAREAGERE:'||R.CDAREAGERE = E.CDINTESTRUTURA
                  LEFT JOIN HIERARQUIAORG H
                       ON E.NRESTRUTURAM = H.NRESTRUTURAMREL
                           JOIN TIPOESTRUTURA TE
                           ON E.NRTIPOESTRUTURA = TE.NRTIPOESTRUTURA
                    WHERE E.NMESTRUTURAM IS NOT NULL
        UNION
            SELECT E.CDINTESTRUTURA, C.NMCAIXA AS NAME, 'C' AS TYPE, E.NRESTRUTURAM, E.NMESTRUTURAM, E.NRTIPOESTRUTURA, H.NRESTRUTURAMSUP , H.NRESTRUTURAMREL, TE.NMTIPOESTRUTURA
                FROM CAIXA C
                JOIN FILIAL F
                    ON C.CDFILIAL = F.CDFILIAL
                        JOIN ESTRUTURAM E
                        ON 'C,CDFILIAL:'||F.CDFILIAL||',CDCAIXA:'||C.CDCAIXA = E.CDINTESTRUTURA
                          LEFT JOIN HIERARQUIAORG H
                               ON E.NRESTRUTURAM = H.NRESTRUTURAMREL
                                    JOIN TIPOESTRUTURA TE
                                    ON E.NRTIPOESTRUTURA = TE.NRTIPOESTRUTURA
                            WHERE E.NMESTRUTURAM IS NOT NULL
        UNION
            SELECT E.CDINTESTRUTURA, NMLOJA AS NAME, 'L' AS TYPE, E.NRESTRUTURAM, E.NMESTRUTURAM, E.NRTIPOESTRUTURA, H.NRESTRUTURAMSUP , H.NRESTRUTURAMREL, TE.NMTIPOESTRUTURA
            FROM LOJA L
            JOIN FILIAL F
                ON L.CDFILIAL = F.CDFILIAL
                    JOIN ESTRUTURAM E
                        ON 'L,CDFILIAL:'||F.CDFILIAL||',CDLOJA:'||L.CDLOJA = E.CDINTESTRUTURA
                          LEFT JOIN HIERARQUIAORG H
                               ON E.NRESTRUTURAM = H.NRESTRUTURAMREL
                                    JOIN TIPOESTRUTURA TE
                                    ON E.NRTIPOESTRUTURA = TE.NRTIPOESTRUTURA
                            WHERE E.NMESTRUTURAM IS NOT NULL
        UNION
            SELECT DISTINCT E.CDINTESTRUTURA, S.NMSUPERVISOR AS NAME, 'S' AS TYPE, E.NRESTRUTURAM, E.NMESTRUTURAM, E.NRTIPOESTRUTURA, H.NRESTRUTURAMSUP , H.NRESTRUTURAMREL, TE.NMTIPOESTRUTURA
            FROM SUPERVISOR S
            JOIN ESTRUTURAM E
            ON 'S,CDSUPERVISOR:'||S.CDSUPERVISOR = E.CDINTESTRUTURA
                LEFT JOIN HIERARQUIAORG H
                           ON E.NRESTRUTURAM = H.NRESTRUTURAMREL
                               JOIN TIPOESTRUTURA TE
                               ON E.NRTIPOESTRUTURA = TE.NRTIPOESTRUTURA
                        WHERE E.NMESTRUTURAM IS NOT NULL
        UNION
            SELECT E.CDINTESTRUTURA, F.NMFILIAL AS NAME, 'F' AS TYPE, E.NRESTRUTURAM, E.NMESTRUTURAM, E.NRTIPOESTRUTURA, H.NRESTRUTURAMSUP , H.NRESTRUTURAMREL, TE.NMTIPOESTRUTURA
            FROM FILIAL F
            JOIN ESTRUTURAM E
            ON 'F,CDFILIAL:'||F.CDFILIAL = E.CDINTESTRUTURA
                LEFT JOIN HIERARQUIAORG H
                           ON E.NRESTRUTURAM = H.NRESTRUTURAMREL
                               JOIN TIPOESTRUTURA TE
                               ON E.NRTIPOESTRUTURA = TE.NRTIPOESTRUTURA
                        WHERE E.NMESTRUTURAM IS NOT NULL
        UNION
            SELECT 'Estrutura sem registro' AS CDINTESTRUTURA, 'Estrutura sem registro' AS NAME, 'Estrutura sem tipo' AS TYPE, E.NRESTRUTURAM, E.NMESTRUTURAM, E.NRTIPOESTRUTURA, H.NRESTRUTURAMSUP , H.NRESTRUTURAMREL, TE.NMTIPOESTRUTURA
              FROM ESTRUTURAM E
              LEFT JOIN HIERARQUIAORG H
                           ON E.NRESTRUTURAM = H.NRESTRUTURAMREL
                               JOIN TIPOESTRUTURA TE
                               ON E.NRTIPOESTRUTURA = TE.NRTIPOESTRUTURA
             WHERE E.NMESTRUTURAM IS NOT NULL
               AND E.CDINTESTRUTURA IS NULL
        ";

    const DELETE_ESTRUTURA = "
        DELETE FROM ESTRUTURAM
         WHERE NRESTRUTURAM = :NRESTRUTURAM
    ";

    const DELETE_HIERARQUIA_ESTRUTURA = "
        DELETE FROM HIERARQUIAORG
         WHERE NRESTRUTURAMREL = :NRESTRUTURAM
    ";

    const BUSCA_FILHOS_ESTRUTURA = "
        SELECT NRESTRUTURAMREL
          FROM HIERARQUIAORG
         WHERE NRESTRUTURAMSUP = :NRESTRUTURAMREL
    ";

    const UPDATE_ESTRUTURA_SUPERIOR = "
        UPDATE HIERARQUIAORG
           SET NRESTRUTURAMSUP = :NRESTRUTURAMSUP
         WHERE NRESTRUTURAMREL = :NRESTRUTURAM
    ";

    const ALTERA_NOME_ESTRUTURA ="
        UPDATE ESTRUTURAM
           SET NMESTRUTURAM = :NMESTRUTURAM
         WHERE NRESTRUTURAM = :NRESTRUTURAM
    ";

    const ALTERA_ESTRUTURA_PAI = "
        UPDATE HIERARQUIAORG
           SET NRESTRUTURAMSUP = :NRESTRUTURAMSUP,
               NRTIPOHIERARQORG = :NRTIPOHIERARQORG
         WHERE NRESTRUTURAMREL = :NRESTRUTURAM
    ";

    const BUSCA_ESTRUTURAOOPER_PELA_ESTRUTURA = "
        SELECT NRESTRUTURAOPER, NRORGANIZACAOOPER
          FROM ESTRUTURAOPER
         WHERE NRESTRUTURAMREL = :NRESTRUTURAM
    ";

    const BUSCA_ORGANIZACAOPER = "
        SELECT NRORGANIZACAOOPER, CDOPERADOR
          FROM ORGANIZACAOOPER
         WHERE NRORGREL = :NRORG
           AND NRORGANIZACAOOPER = :NRORGANIZACAOOPER
    ";

    const BUSCA_OPERADOR_LIAGADO_ESTRUTURA = "
        SELECT CDOPERADOR, NMOPERADOR
          FROM OPERADOR
         WHERE CDOPERADOR = :CDOPERADOR
        ORDER BY CDOPERADOR
    ";

    const BUSCA_OPERADORES_ASSOCIAR = "
        SELECT CDOPERADOR, NMOPERADOR, CDOPERADOR||' - '||NMOPERADOR AS LABELOPERADOR, N
            FROM
                (
                 SELECT D.*, ROWNUM as N FROM (
                SELECT CDOPERADOR, NMOPERADOR, CDOPERADOR||' - '||NMOPERADOR AS LABELOPERADOR
                    FROM OPERADOR
                    WHERE UPPER (NMOPERADOR) LIKE UPPER (:NMOPERADOR)
                ORDER BY LABELOPERADOR
                ) D
                 ) data
            WHERE N BETWEEN  :FIRST AND :LAST
            ORDER BY LABELOPERADOR
    ";

    const INSERE_ORGANIZACAO_OPERADOR = "
        INSERT INTO ORGANIZACAOOPER
            (NRORGANIZACAOOPER, NRORGREL, CDOPERADOR, DTINCLUSAO)
        VALUES
            (:NRORGANIZACAOOPER, :NRORGREL, :CDOPERADOR, SYSDATE)
    ";

    const INSERE_ESTRUTURA_OPERADOR = "
        INSERT INTO ESTRUTURAOPER
            (NRESTRUTURAOPER, NRORGANIZACAOOPER, NRESTRUTURAMREL, DTINCLUSAO)
        VALUES
            (:NRESTRUTURAOPER, :NRORGANIZACAOOPER, :NRESTRUTURAMREL, SYSDATE)
    ";

    const GET_ORGANIZACAOOPER = "
        SELECT NRORGANIZACAOOPER
          FROM ORGANIZACAOOPER
         WHERE CDOPERADOR = :CDOPERADOR
           AND NRORGREL = :NRORGREL
    ";

    const EXCLUI_ASSOCIACAO_OPERADOR_ESTRUTURA = "
        DELETE FROM ESTRUTURAOPER
        WHERE NRORGANIZACAOOPER = :NRORGANIZACAOOPER
          AND NRESTRUTURAMREL = :NRESTRUTURAMREL
    ";

    const BUSCA_OPERADORES_ASSOCIADOS = "
        SELECT NRESTRUTURAOPER, NRORGANIZACAOOPER, NRESTRUTURAMREL
          FROM ESTRUTURAOPER
         WHERE NRESTRUTURAMREL = :NRESTRUTURAMREL
    ";

    const RETORNA_MAXNRPERFACESSO = "
        SELECT MAX(NRPERFILACESSO) AS MAXNRPERFILACESSO
          FROM PERFILACESSO
    ";

    const DELETE_PERFILACESSO = "
        DELETE
          FROM PERFILACESSO
         WHERE NRPERFILACESSO = :CDPERFIL
           AND NRORG = :NRORG
    ";

    const DELETE_REGRAS_PERFACESSO = "
        DELETE
          FROM ZHU_ACCESS_CONTROL_RULE
         WHERE GROUP_ID= :GROUP_ID
           AND ORGANIZATION_ID = :ORGANIZATION_ID
    ";

    const DELETE_ASSOCIETED_PERFACESSOPARC = "
        DELETE
          FROM PERFACESSPARC
         WHERE NRPERFILACESSO = :CDPERFIL
           AND NRORG = :NRORG
    ";

    const INSERT_PERFILACESSO = "
        INSERT INTO PERFILACESSO
            (NRPERFILACESSO, NMPERFILACESSO, NRORG, IDATIVO, NRUSERGROUP, DTINCLUSAO, DTULTATU)
        VALUES
            (:NRPERFILACESSO, :NMPERFILACESSO, :NRORG, :IDATIVO, :NRUSERGROUP, SYSDATE, SYSDATE)
    ";

    const ALTERA_PERFILACESSO = "
        UPDATE PERFILACESSO
           SET NMPERFILACESSO = :NMPERFILACESSO
         WHERE NRPERFILACESSO = :NRPERFILACESSO
           AND NRORG = :NRORG
    ";

    const RETORNA_MAXNRPERFACESSOPARC = "
        SELECT MAX(NRPERFACESSPARC) AS MAXNRPERFACESSPARC
          FROM PERFACESSPARC
    ";

    const INSERT_PERFACESSPARCOPERADOR = "
        INSERT INTO PERFACESSPARC
            (NRPERFACESSPARC, NRORG, IDATIVO, DTVALPERFILPARC, NRPARCNEGOCIO, NRPERFILACESSO)
        VALUES
            (:NRPERFACESSPARC, :NRORG, :IDATIVO, :DTVALPERFILPARC, :NRPARCNEGOCIO, :NRPERFILACESSO)
    ";

    const DELETE_PERFACESSPARC = "
        DELETE
          FROM PERFACESSPARC
         WHERE NRPERFACESSPARC = :NRPERFIL
    ";

    const GET_OPER_IN_PERFILACESSO = "
        SELECT *
          FROM PERFACESSPARC
         WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO
           AND NRPERFILACESSO = :NRPERFILACESSO
    ";

    //----------------------------------------- Endereços -----------------------------------------



    const GET_CITIES = "
        SELECT CDPAIS, SGESTADO, CDMUNICIPIO, NMMUNICIPIO, CDMUNICIBGE, N, POSITION
        FROM
            (
             SELECT D.*, ROWNUM as N FROM (
            SELECT CDPAIS, SGESTADO, CDMUNICIPIO, NMMUNICIPIO, CDMUNICIBGE, DECODE(CDMUNICIPIO, '7107', 1,  '5') AS POSITION
                FROM MUNICIPIO
                WHERE SGESTADO = :SGESTADO
                AND UPPER(NMMUNICIPIO) LIKE UPPER(:NMMUNICIPIO)
            ORDER BY DECODE(CDMUNICIPIO, '7107', 1,  '5'), NMMUNICIPIO
            ) D
             ) data
        WHERE N BETWEEN  :FIRST AND :LAST
        ORDER BY POSITION, NMMUNICIPIO
    ";

        //----------------------------------------- Sales monitor
    const GET_STORE_DATA = "
            SELECT A.NMFILIAL, A.CDFILIAL, A.CDCAIXA, C.NMCAIXA, B.DTVENDA, B.EXCEEDEDTIME
          FROM (SELECT F.NMFILIAL, V.CDFILIAL, V.CDCAIXA
                  FROM caixa V JOIN FILIAL F ON F.CDFILIAL = V.CDFILIAL
                 GROUP BY F.NMFILIAL, V.CDFILIAL, V.CDCAIXA
                 ORDER BY V.CDFILIAL) A
           LEFT JOIN (SELECT CDFILIAL, CDCAIXA, MAX(DTVENDA) AS DTVENDA,
                              SYSDATE - MAX(DTVENDA) AS EXCEEDEDTIME
                        FROM VENDA
                        --WHERE DTENTRVENDA=TRUNC(SYSDATE)
                        WHERE DTENTRVENDA between sysdate-30 and SYSDATE
                       GROUP BY CDFILIAL, CDCAIXA
                       ORDER BY CDFILIAL) B

            ON B.CDFILIAL = A.CDFILIAL
           AND B.CDCAIXA  = A.CDCAIXA
           JOIN CAIXA C
           ON C.CDFILIAL = A.CDFILIAL
           AND C.CDFILIAL = B.CDFILIAL
         ORDER BY A.CDFILIAL
    ";

    const GET_PRODUTO_TO_REGISTER = "
        SELECT DISTINCT I.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO
          FROM ITEMPRECO I
          JOIN PRODUTO P
            ON I.CDPRODUTO = P.CDPRODUTO
         WHERE I.CDFILIAL = :CDFILIAL
           AND I.CDPRODUTO = I.CDPRPAITABPR
           AND I.CDTABEPREC IN (SELECT T.CDTABEPREC
                                 FROM TABEVEND T
                                WHERE T.CDFILIAL   = :CDFILIAL
                                  AND (T.DTFINVGPREC - T.DTINIVGPREC) > 0
                                  AND T.DTFINVGPREC > SYSDATE)
    ";

    // Verifies if there's a registry for this Vendor in the ENDEVENDE table
    const VERIFY_VENDOR_ADDRESS = "
    SELECT *
    FROM ENDEVENDE
    WHERE CDVENDEDOR = :CDVENDEDOR
    AND NRORG = :NRORG
    ";

  // Verifies if there's a registry for this Vendor in the ENDEVENDE table
    const GET_VENDOR = "
    SELECT *
    FROM VENDEDOR
    WHERE CDVENDEDOR = :CDVENDEDOR
    ";



  // Gets all the products from an interval that are not registered in a store.
    const GET_AVAIBLE_PRODUCTS = "
    SELECT CDPRODUTO
    FROM PRODUTO
    WHERE
        CDARVPROD BETWEEN :CDPRODINICIAL AND :CDPRODFINAL AND
        CDNVPRODUTO = (SELECT Max(CDNVPRODUTO) FROM PRODUTO) AND
        CDPRODUTO NOT IN (SELECT CDPRODUTO
                          FROM PRODLOJA
                          WHERE CDFILIAL = :CDFILIAL
                               AND CDLOJA = :CDLOJA
                               AND NRORG = :NRORG
                               AND (CDARVPROD BETWEEN :CDPRODINICIAL AND :CDPRODFINAL) )
    ORDER BY nlssort(CDARVPROD, 'NLS_SORT=BINARY')
    ";

  // PRODUCTS FOR ADD
    const PRODUCTS_FOR_ADD = "
      SELECT CDPRODUTO, CDARVPROD, NMPRODUTO, CDNVPRODUTO, IDATIVO, CDNVPRODUTO || ' - ' || NMPRODUTO AS LABELPRODUTO, NRORG
        FROM PRODUTO
        WHERE CDNVPRODUTO = :CDNVPRODUTO
          AND CDPRODUTO NOT IN (SELECT CDPRODUTO
                              FROM PRODLOJA
                              WHERE CDFILIAL = :CDFILIAL
                                AND CDLOJA = :CDLOJA
                                AND NRORG = :NRORG )
     ORDER BY nlssort(CDARVPROD, 'NLS_SORT=BINARY')";


    // Returns a number with the products that are related to the NRSEQIMPRLOJA
    const COUNT_PRODUCTS_BY_PRINTER_IN_A_STORE = '
    SELECT Count(*) AS PRODUCTS
    FROM PRODUTO
    WHERE NRORG = :NRORG
      AND CDNVPRODUTO = ( SELECT MAX(CDNVPRODUTO)
                          FROM PRODUTO
                          WHERE NRORG = :NRORG )
      AND CDPRODUTO IN (SELECT CDPRODUTO
                        FROM PRODLOJA
                        WHERE  (NRSEQIMPRPROD =  :NRSEQIMPRLOJA
                                         OR NRSEQIMPRPUXA = :NRSEQIMPRLOJA )
                                         AND NRORG = :NRORG
                                         AND CDFILIAL = :CDFILIAL
                                         AND CDLOJA = :CDLOJA  )';

   /*
   *
   * Tela vnd00600_fechamentocaixa
   *
   */

  // Query para validar se a redução Z do caixa selecionado já foi aprovada.

    const IS_REDUCAOZ_APPROVED = "
    SELECT RZ.CDFILIAL, RZ.CDCAIXA, RZ.DTREDUCAOZ,
           RZ.NRECFREDZ, RZ.IDSTATUS
    FROM REDUCAOZ RZ
    WHERE CDFILIAL   = :CDFILIAL AND
          CDCAIXA    = :CDCAIXA  AND
          (NRORG       = :NRORG  ) AND
          DTREDUCAOZ = :DTABERCAIX AND
          ((IDSTATUS)   = 'E' OR (IDSTATUS = 'A'))";

  //Se o caixa não for ECF (IDTPEMISSAOFOS)
  //Se não for vazio, "Operação não permitida. As vendas NFC-e ou CF-e-SAT já foram aprovadas."

    const IS_VENDA_NFCE_APPROVED = "
    SELECT IDAPROVACAONFCE
    FROM
       VENDA
    WHERE
       (CDFILIAL  = :CDFILIAL  ) AND
       (CDCAIXA   = :CDCAIXA   ) AND
       (NRORG     = :NRORG  ) AND
       (DTABERTUR = :DTABERCAIX) AND
       (IDAPROVACAONFCE = 'A'    )";


  // Se o caixa tiver venda pendente, não deixa fechar.
  // "Operação não permitida. Este Caixa possui venda pendente."

    const VENDA_PENDENTE_EXISTS = "
    SELECT NRSEQVENDA
    FROM
       VENDA
    WHERE
       (CDFILIAL    = :CDFILIAL ) AND
       (CDCAIXA     = :CDCAIXA  ) AND
       (NRORG       = :NRORG  ) AND
       (IDSITUVENDA = 'P'         ) AND
       (DTABERTUR   = :DTABERCAIX)";

    const FECHAR_CAIXA = "
    UPDATE TURCAIXA
    SET
      CDOPERFECH    = :CDOPERFECH,
      DTFECHCAIX    = :DTFECHCAIX,
      DTULTATU      = :DTULTATU,
      NRORGULTATU   = :NRORGULTATU,
      CDOPERULTATU  = :CDOPERULTATU

    WHERE CDFILIAL   = :CDFILIAL
      AND CDCAIXA    = :CDCAIXA
      AND DTABERCAIX = :DTABERCAIX
      AND NRORG      = :NRORG
      AND CDOPERADOR = :CDOPERADOR

    ";

    const DELETE_FECHAMENTO_CAIXA = "
    UPDATE TURCAIXA
    SET
      CDOPERFECH    = NULL,
      DTFECHCAIX    = NULL,
      DTULTATU      = :DTULTATU,
      NRORGULTATU   = :NRORGULTATU,
      CDOPERULTATU  = :CDOPERULTATU

    WHERE CDFILIAL   = :CDFILIAL
      AND CDCAIXA    = :CDCAIXA
      AND DTABERCAIX = :DTABERCAIX
      AND NRORG      = :NRORG
      AND CDOPERADOR = :CDOPERADOR
    ";

    const INSERT_PENDING_SALE = "
        INSERT INTO VENDA
            (CDFILIAL, CDCAIXA, CDCLIENTE, CDCONSUMIDOR, CDSERVFILI, CDVENDEDOR,
             DTABERTUR, DTENTRVENDA, DTVENDA, IDORIGEMVENDA, IDSITUVENDA,
             IDTIPOVENDA, IDTPEMISVEND, NRCUPOMFIS, NRSEQVENDA,
             NRORDEMVND, NRSERIEIMPVND, NRSERIEVND,NRSUBSERIEVND,
             CDFILIALTUR, CDCAIXATUR, CDEMPRESA, CDLOJA, CDOPERADOR, NRORG)
        VALUES
            (:CDFILIAL, :CDCAIXA, :CDCLIENTE, :CDCONSUMIDOR, :CDSERVFILI, :CDVENDEDOR,
             TO_DATE(:DTABERTUR,'DD/MM/YY HH24:MI:SS'), :DTENTRVENDA,
             TO_DATE(:DTVENDA,'DD/MM/YY HH24:MI:SS'), :IDORIGEMVENDA, :IDSITUVENDA,
             :IDTIPOVENDA, :IDTPEMISVEND, :NRCUPOMFIS, :NRSEQVENDA,
             :NRORDEMVND, :NRSERIEIMPVND, :NRSERIEVND,:NRSUBSERIEVND,
             :CDFILIAL, :CDCAIXA, :CDEMPRESA, :CDLOJA ,:CDOPERADOR, :NRORG)
    ";

    const INSERT_ITEM = "
        INSERT INTO ITEMVENDA
            (CDFILIAL, CDCAIXA, NRSEQVENDA, NRSEQUITVEND, QTPRODVEND, VRUNITVEND, VRDESITVEND,
             VRPERCVEND, CDPRODUTO, VRUNITVENDCL, VRACRITVEND, NRORG, CDOPERINCLUSAO)
        VALUES
            (:CDFILIAL, :CDCAIXA, :NRSEQVENDA, :NRSEQUITVEND, :QTPRODVEND, :VRUNITVEND, :VRDESITVEND,
             :VRPERCVEND, :CDPRODUTO, :VRUNITVENDCL, :VRACRITVEND, :NRORG, :CDOPERINCLUSAO)
    ";

    const INSERT_ITEM_IMPOSTO = "
        INSERT INTO ITVENDAIMPOS
            (CDFILIAL, CDCAIXA, NRSEQVENDA, NRSEQUITVEND, NRSEQITIMPOS, CDIMPOSTO,
             VRPEALPRODIT, VRIMPOPRODIT, CDIMPOSTOEX, NRORG, CDOPERINCLUSAO)
        VALUES
            (:CDFILIAL, :CDCAIXA, :NRSEQVENDA, :NRSEQUITVEND, :NRSEQITIMPOS, :CDIMPOSTO,
             :VRPEALPRODIT, :VRIMPOPRODIT, :CDIMPOSTOEX, :NRORG, :CDOPERINCLUSAO)
    ";

    const INSERT_CANCEL_ITEM = "
        INSERT INTO ITVENDACAN
            (CDFILIAL, CDCAIXA, NRSEQVENDA, NRSEQITVENDC, QTPRODVENDC, VRUNITVENDC, VRDESITVENDC, VRPERCVENDC,
             CDPRODUTO, VRUNITVENCLC, VRACRITVENDC, NRORG, CDOPERINCLUSAO)
        VALUES
            (:CDFILIAL, :CDCAIXA, :NRSEQVENDA, :NRSEQITVENDC, :QTPRODVENDC, :VRUNITVENDC, :VRDESITVENDC, :VRPERCVENDC,
             :CDPRODUTO, :VRUNITVENCLC, :VRACRITVENDC, :NRORG, :CDOPERINCLUSAO)
    ";

    const INSERT_MOVCAIXA = "
        INSERT INTO MOVCAIXA
            (CDTIPORECE, VRMOVIVEND, CDFILIAL, CDCAIXA, DTABERCAIX, NRSEQUMOVI, IDTIPOMOVIVE, DTHRINCMOV,
             NRSEQVENDA, DTMOVIMCAIXA, VRMOVIVEOUT, VRCOTINDOUT, QTPARCRECEB, NRORG, CDOPERINCLUSAO, NRENVELOPE)
        VALUES
            (:CDTIPORECE, :VRMOVIVEND, :CDFILIAL, :CDCAIXA, TO_DATE(:DTABERCAIX,'DD/MM/YY HH24:MI:SS'), :NRSEQUMOVI, :IDTIPOMOVIVE, SYSDATE,
             :NRSEQVENDA, :DTMOVIMCAIXA, :VRMOVIVEOUT, '0', :QTPARCRECEB, :NRORG, :CDOPERINCLUSAO, :NRENVELOPE)
    ";

    const SEQITEMVENDA = "
        SELECT NVL(MAX(NRSEQUITVEND), '0')+'1' AS NRSEQUITVEND
          FROM ITEMVENDA
         WHERE NRSEQVENDA = :NRSEQVENDA
           AND CDFILIAL = :CDFILIAL
           AND CDCAIXA = :CDCAIXA
    ";

    const SEQITEMVENDACAN = "
        SELECT NVL(MAX(NRSEQITVENDC), '0')+'1' AS NRSEQITVENDC
          FROM ITVENDACAN
         WHERE NRSEQVENDA = :NRSEQVENDA
           AND CDFILIAL = :CDFILIAL
           AND CDCAIXA = :CDCAIXA
    ";

    const CLOSE_SALE = "
        UPDATE VENDA
           SET IDSITUVENDA = 'O'
         WHERE CDFILIAL    = :CDFILIAL
           AND CDCAIXA     = :CDCAIXA
           AND NRSEQVENDA  = :NRSEQVENDA
           AND IDSITUVENDA = 'P'
    ";

    const TOTVEND = "
        SELECT SUM(QTPRODVEND * VRUNITVEND) AS TOTVEND
          FROM ITEMVENDA
         WHERE CDFILIAL = :CDFILIAL
           AND CDCAIXA = :CDCAIXA
           AND NRSEQVENDA = :NRSEQVENDA
    ";
    /*
        Tela Abertura de caixa
    */

    const IS_REGISTER_OPEN = "
      SELECT
      TC.CDOPERADOR,
      OP.NMOPERADOR,
      TC.DTABERCAIX,
      TC.DTFECHCAIX
      FROM
      TURCAIXA TC,
      OPERADOR OP
      WHERE
      (TC.CDFILIAL = :CDFILIAL) AND
      (TC.CDCAIXA = :CDCAIXA) AND
      (TC.NRORG = :NRORG) AND
      (TC.CDOPERADOR = OP.CDOPERADOR(+)) AND
      ((DTFECHCAIX IS NULL) OR (DTFECHCAIX > TO_DATE(:DTABERTURA,'DD/MM/YYYY HH24:MI:SS')))
    ";


    const INSERT_MOVCAIXA_ABERTURA = "
      INSERT INTO MOVCAIXA
            (CDFILIAL,              CDCAIXA,              DTABERCAIX,              NRSEQUMOVI,              IDTIPOMOVIVE,              DSMOVIVEND,              VRMOVIVEND,
             CDTIPORECE,              DTHRINCMOV,              NRCONTRAVALE,              DTMOVIMCAIXA,             NRORG,             NRORGINCLUSAO,             NRORGULTATU,
             CDOPERINCLUSAO,             CDOPERULTATU,             DTULTATU,             DTINCLUSAO,             IDATIVO)
      VALUES (:CDFILIAL,              :CDCAIXA,              :DTABERCAIX,              :NRSEQUMOVI,              :IDTIPOMOVIVE,              :DSMOVIVEND,              :VRMOVIVEND,
             :CDTIPORECE,              :DTHRINCMOV,              :NRCONTRAVALE,              :DTMOVIMCAIXA,             :NRORG,             :NRORGINCLUSAO,             :NRORGULTATU,
             :CDOPERINCLUSAO,             :CDOPERULTATU,             SYSDATE,             SYSDATE,             'S')
    ";

    const GET_EMPRESA = "
        SELECT CDEMPRESA FROM FILIAL WHERE CDFILIAL = :CDFILIAL AND NRORG = :NRORG
    ";

    const GET_LOJA_ON_CAIXA = "
        SELECT CDLOJA FROM CAIXA WHERE CDFILIAL = :CDFILIAL AND CDCAIXA = :CDCAIXA
    ";

    const CHECK_CONFCAIXA = "
      UPDATE TURCAIXA

      SET IDCONFERCAIXA = 'S',
          DTULTATU      =  SYSDATE,
          CDOPERULTATU  = :CDOPERULTATU,
          NRORGULTATU   = :NRORG

        WHERE NRORG       = :NRORG      AND
            DTABERCAIX  = :DTABERCAIX AND
            CDFILIAL    = :CDFILIAL   AND
            CDCAIXA     = :CDCAIXA
    ";

    const SELECT_CONFERENCIACAIXA_S = "
     SELECT A.CDTIPORECE,
            A.NMTIPORECE,
            SUM(A.VRMOVIVEND) AS VRMOVIVEND,
            SUM(A.VRMOVIVENDAUX) AS VRMOVIVENDAUX,
            SUM(A.DIFERENCA) AS DIFERENCA,
            A.CDFILIAL, A.NRORG, A.CDCAIXA, A.NRENVELOPE, A.DTABERCAIX
       FROM (
            SELECT DISTINCT MO.CDFILIAL, MO.CDCAIXA, MO.DTABERCAIX,
                   MO.CDTIPORECE AS CDTIPORECE, TR.NMTIPORECE,
                   DECODE(IDTIPOMOVIVE, 'G', SUM( MO.VRMOVIVEND), '0') AS VRMOVIVEND,
                   DECODE(IDTIPOMOVIVE, 'E', SUM( MO.VRMOVIVEND), '0') - DECODE(IDTIPOMOVIVE, 'S', SUM( MO.VRMOVIVEND), '0') AS VRMOVIVENDAUX,
                   DECODE(IDTIPOMOVIVE, 'G', SUM( MO.VRMOVIVEND), '0') - (DECODE(IDTIPOMOVIVE, 'E', SUM( MO.VRMOVIVEND), '0') - DECODE(IDTIPOMOVIVE, 'S', SUM( MO.VRMOVIVEND), '0')) AS DIFERENCA,
                   MO.NRORG, MO.NRENVELOPE
              FROM MOVCAIXA MO
              JOIN TIPORECE TR
                ON MO.NRORG = TR.NRORG
               AND MO.CDTIPORECE = TR.CDTIPORECE
              JOIN FILIAL FI
                ON MO.NRORG = FI.NRORG
               AND MO.CDFILIAL = FI.CDFILIAL
              JOIN CAIXA CX
                ON MO.NRORG = CX.NRORG
               AND MO.CDFILIAL = CX.CDFILIAL
               AND MO.CDCAIXA = CX.CDCAIXA
              JOIN TURCAIXA TU
                ON MO.NRORG = TU.NRORG
               AND MO.CDFILIAL = TU.CDFILIAL
               AND MO.CDCAIXA = TU.CDCAIXA
               AND MO.DTABERCAIX = TU.DTABERCAIX
             WHERE FI.CDFILIAL = :CDFILIAL
               AND CX.CDCAIXA  = :CDCAIXA
               AND MO.NRORG = :NRORG
               AND MO.DTABERCAIX = :DTABERCAIX
               AND TU.DTFECHCAIX IS NOT NULL
               AND MO.IDTIPOMOVIVE IN ('E', 'S', 'G')
             GROUP BY MO.CDFILIAL, MO.CDCAIXA, MO.DTABERCAIX, MO.CDTIPORECE, TR.NMTIPORECE, MO.IDTIPOMOVIVE, MO.NRORG, MO.NRENVELOPE
            ) A
        GROUP BY A.CDFILIAL, A.CDCAIXA, A.DTABERCAIX, A.CDTIPORECE, A.NMTIPORECE, A.NRORG, A.NRENVELOPE

      UNION

      SELECT C.CDTIPORECE,
             C.NMTIPORECE,
             NVL(C.VRMOVIVEND,0) AS VRMOVIVEND,
             0 AS VRMOVIVENDAUX,
             NVL(C.VRMOVIVEND,0) AS DIFERENCA,
             C.CDFILIAL, C.NRORG, C.CDCAIXA, C.NRENVELOPE, C.DTABERCAIX
        FROM (
             SELECT MO.CDFILIAL, MO.CDCAIXA, MO.DTABERCAIX, MO.IDTIPOMOVIVE, MO.CDTIPORECE AS CDTIPORECE,
                    TR.NMTIPORECE, SUM(MO.VRMOVIVEND) AS VRMOVIVEND, MO.NRENVELOPE, MO.NRORG
               FROM MOVCAIXA MO
               JOIN TIPORECE TR
                 ON MO.NRORG = TR.NRORG
                AND MO.CDTIPORECE = TR.CDTIPORECE
               JOIN FILIAL FI
                 ON MO.NRORG = FI.NRORG
                AND MO.CDFILIAL = FI.CDFILIAL
               JOIN CAIXA CX
                 ON MO.NRORG = CX.NRORG
                AND MO.CDFILIAL = CX.CDFILIAL
                AND MO.CDCAIXA = CX.CDCAIXA
               JOIN TURCAIXA TU
                 ON MO.NRORG = TU.NRORG
                AND MO.CDFILIAL = TU.CDFILIAL
                AND MO.CDCAIXA = TU.CDCAIXA
                AND MO.DTABERCAIX = TU.DTABERCAIX
              WHERE MO.CDFILIAL = :CDFILIAL
                AND MO.CDCAIXA  = :CDCAIXA
                AND MO.NRORG = :NRORG
                AND MO.DTABERCAIX = :DTABERCAIX
                AND TU.DTFECHCAIX IS NOT NULL
                AND MO.IDTIPOMOVIVE = 'G'
                AND (NOT EXISTS (SELECT DISTINCT M.CDTIPORECE
                                   FROM MOVCAIXA M
                                  WHERE M.CDFILIAL     = :CDFILIAL
                                    AND M.CDCAIXA      = :CDCAIXA
                                    AND M.NRORG = :NRORG
                                    AND M.DTABERCAIX = :DTABERCAIX
                                    AND M.IDTIPOMOVIVE = 'E'
                                    AND M.NRORG = MO.NRORG
                                    AND TR.CDTIPORECE = M.CDTIPORECE
                                )
                    )
           GROUP BY MO.CDFILIAL, MO.CDCAIXA, MO.DTABERCAIX, IDTIPOMOVIVE, MO.CDTIPORECE, NMTIPORECE, NRENVELOPE, MO.NRORG
        ) C
        ";

    const GET_CDGRUPPROD = "
    SELECT
     PV.CDGRPRODPDV,
     GP.CDGRUPPROD||' - '||GP.NMGRUPPROD AS GRUPOPROD
    FROM
       PARAVEND PV, GRUPPROD GP
    WHERE
       (PV.CDFILIAL    = :P_CDFILIAL  ) AND
       (PV.CDGRPRODPDV = GP.CDGRUPPROD)
    ";

    const GET_NRCONFIG = "
        SELECT NRCONFIG
            FROM
            (SELECT
                COUNT(*) AS NRCONFIG
              FROM PRSUBGRPROD
            WHERE
               (CDFILISUBGR = :P_CDFILISUBGR) AND
               (CDGRUPPROD  = :P_CDGRUPPROD )
            )
    ";//CDFILIAL CDGRPRODPDV

    const GET_CDSEGMER = "
        SELECT DISTINCT
           FI.CDFILIAL  , FI.NMFILIAL, FI.CDSEGMER, FI.CDEMPRESA,
           FI.CDINSCESTA, E.CDPAIS   , E.SGESTADO , E.CDMUNICIPIO,
           SE.CDSEGMER||' - '||SE.DSSEGMER AS SEGMENTO,
           PA.IDPRECDIFCOM
        FROM
           FILIAL FI, SEGMERCADO SE, PARAVEND PA, ENDEFILI E
        WHERE
          (FI.CDFILIAL = :P_CDFILIAL) AND
          (FI.CDFILIAL = E.CDFILIAL (+)) AND
          (FI.CDSEGMER = SE.CDSEGMER(+)) AND
          (FI.CDFILIAL = PA.CDFILIAL(+))
        ORDER BY
           FI.CDFILIAL
    ";

    const INSERT_ITEMPRECO = "
    INSERT INTO ITEMPRECO
      (CDFILIAL,CDTABEPREC,DTINIVGPREC,CDPRODUTO,VRPRECITEM,VRCUSTITEM,VRPRESUGITEM,
      IDPRECVARIA,VRPRECITEMCL,IDPRODPROMOC,CDPRPAITABPR,IDATIVO,CDOPERULTATU,DTULTATU,
      NRORGULTATU,CDOPERINCLUSAO,DTINCLUSAO,NRORG,NRORGINCLUSAO)
    VALUES
      (:CDFILIAL,:CDTABEPREC,:DTINIVGPREC,:CDPRODUTO,:VRPRECITEM,:VRCUSTITEM,:VRPRESUGITEM,
      :IDPRECVARIA,:VRPRECITEMCL,:IDPRODPROMOC,:CDPRPAITABPR,:IDATIVO,:CDOPERULTATU,:DTULTATU,
      :NRORGULTATU,:CDOPERINCLUSAO,:DTINCLUSAO,:NRORG,:NRORGINCLUSAO)
    ";

    const UPDATE_ITEMPRECO = "
    UPDATE ITEMPRECO SET
      VRPRECITEM   = :VRPRECITEM,
      VRCUSTITEM   = :VRCUSTITEM,
      VRPRESUGITEM = :VRPRESUGITEM,
      IDPRECVARIA  = :IDPRECVARIA,
      VRPRECITEMCL = :VRPRECITEMCL,
      IDPRODPROMOC = :IDPRODPROMOC,
      CDPRPAITABPR = :CDPRPAITABPR

    WHERE CDFILIAL     = :CDFILIAL
      AND CDPRODUTO    = :CDPRODUTO
      AND CDTABEPREC   = :CDTABEPREC
      AND DTINIVGPREC  = :DTINIVGPREC
      AND NRORG        = :NRORG";

    const GET_VALID_INSERT_VIGDATE = "
  SELECT DTINIVGPREC AS INICIO,
         DTFINVGPREC AS FIM
  FROM TABEVEND

  WHERE CDFILIAL = :CDFILIAL
    AND CDTABEPREC = :CDTABEPREC

  UNION ALL

  SELECT MIN(DTINIVGPREC) AS INICIO,
         MAX(DTFINVGPREC) AS FIM
    FROM TABEVEND
  WHERE CDFILIAL = :CDFILIAL
    AND CDTABEPREC = :CDTABEPREC";

    const INSERT_VIGENCIA = "
  INSERT INTO TABEVEND (CDFILIAL,CDTABEPREC,DTINIVGPREC,DTFINVGPREC,CDOPERINCLUSAO,DTINCLUSAO,NRORGINCLUSAO,NRORG,CDOPERULTATU,DTULTATU,NRORGULTATU) VALUES
  (:CDFILIAL, :CDTABEPREC, :DTINIVGPREC, :DTFINVGPREC, :CDOPERINCLUSAO, :DTINCLUSAO, :NRORGINCLUSAO, :NRORG, :CDOPERULTATU, :DTULTATU, :NRORGULTATU)
    ";

    const UPDATE_VIGENCIA = "
      UPDATE TABEVEND
        SET DTFINVGPREC = :DTFINVGPREC,
            CDOPERULTATU = :CDOPERULTATU,
            DTULTATU = :DTULTATU,
            NRORGULTATU = :NRORGULTATU
      WHERE DTINIVGPREC = :OLD_DTINIVGPREC AND
            DTFINVGPREC = :OLD_DTFINVGPREC AND
            CDFILIAL = :CDFILIAL AND
            CDTABEPREC = :CDTABEPREC AND
            NRORG = :NRORG";

    const GET_VALID_UPDATE_VIGDATE = "
    SELECT DTINIVGPREC AS INICIO,
           DTFINVGPREC AS FIM
      FROM TABEVEND
      WHERE CDFILIAL = :CDFILIAL
        AND CDTABEPREC = :CDTABEPREC
        AND DTINIVGPREC <> :DTINIVGPREC
        AND DTFINVGPREC <> :DTFINVGPREC

    UNION ALL

    SELECT * FROM
      (SELECT MIN(DTINIVGPREC) AS INICIO,
              MAX(DTFINVGPREC) AS FIM
      FROM TABEVEND
      WHERE CDFILIAL = :CDFILIAL
        AND CDTABEPREC = :CDTABEPREC)

    WHERE INICIO <> :DTINIVGPREC
          AND FIM <> :DTFINVGPREC
    ";


    const IS_PARAMETERIZED_BY_CLIENTEFILIAL = "
    SELECT CDFILIAL
    FROM CLIENFILIAL
    WHERE (CDCFILTABPRE = :CDFILIAL)
    AND (CDTABEPREC = :CDTABEPREC)";

    const IS_PARAMETERIZED_BY_LOJA = "
  SELECT CDLOJA
    FROM LOJA
  WHERE (CDFILIAL = :CDFILIAL)
  AND (CDTABEPREC = :CDTABEPREC)";

    const IS_PARAMETERIZED_BY_FILIAL = "
  SELECT CDFILIAL
  FROM PARAVEND
  WHERE (CDFILIAL = :CDFILIAL)
  AND (CDTABEPREC = :CDTABEPREC)";


    const IS_PARAMETERIZED_BY_CLIENTE = "
  SELECT CDCLIENTE
  FROM CLIENTE
  WHERE (CDFILTABPREC = :CDFILIAL)
  AND (CDTABEPREC = :CDTABEPREC)";

    const UPDATE_PRECODIFERENCIADO = "
  UPDATE ITEMPRECODIA
    SET VRPRECODIA = :VRPRECODIA,
        DTFINVALPREC = :DTFINVALPREC,
        IDPERVALORPR = :IDPERVALORPR,
        IDDESCACREPR = :IDDESCACREPR,
        HRFINPRECDIA = :HRFINPRECDIA,
        IDVISUACUPOM = :IDVISUACUPOM,
        CDOPERULTATU = :CDOPERULTATU,
        DTULTATU = :DTULTATU,
        VRPRECODIF = :VRPRECODIF,
        NRORGULTATU = :NRORGULTATU

    WHERE CDFILIAL      = :CDFILIAL     AND
          CDTABEPREC    = :CDTABEPREC   AND
          DTINIVGPREC   = :DTINIVGPREC  AND
          CDPRODUTO     = :CDPRODUTO    AND
          CDPRPAITABPR  = :CDPRPAITABPR AND
          NRDIASEMANPR  = :NRDIASEMANPR AND
          HRINIPRECDIA  = :HRINIPRECDIA AND
          DTINIVALPREC  = :DTINIVALPREC AND
          CDTIPOCONSPD  = :CDTIPOCONSPD AND
          NRORG         = :NRORG
    ";

    const GET_PRODUTO_PAI = "
         SELECT IT.CDPRODUTO AS CDPRODPAI,
       PR.NMPRODUTO AS NMPRODPAI,
       '1' AS TIPO,
       PR.CDARVPROD,
       PR.CDBARPRODUTO AS CDBARPRODPAI,
       IT.CDFILIAL,
       FI.NMFILIAL,
       COUNT(DISTINCT VE.CDFILIAL||VE.CDCAIXA||VE.NRSEQVENDA) AS NRCUPONS,
       SUM(IT.QTPRODVEND) AS QUANTPRODPAI,
       SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2)) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0)) AS TOTALVENDA,
       IT.CDPRODPROMOCAO||' - '||PR.NMPRODUTO AS LABELPRODPROMOCAO,
       IT.NRORG
    FROM ITEMVENDA IT,
     VENDA VE,
     PRODUTO PR,
     FILIAL FI
    WHERE (IT.CDFILIAL = FI.CDFILIAL)
  AND (IT.CDFILIAL = VE.CDFILIAL)
  AND (IT.CDCAIXA = VE.CDCAIXA)
  AND (IT.NRSEQVENDA = VE.NRSEQVENDA)
  AND (IT.CDPRODUTO = PR.CDPRODUTO)
  AND (IT.CDPRODUTO = IT.CDPRODPROMOCAO)
  AND (VE.IDSITUVENDA = 'O')
  AND IT.NRORG = VE.NRORG
  AND IT.NRORG = FI.NRORG
  AND IT.NRORG = PR.NRORG
  AND IT.NRORG = :NRORG
  AND (EXISTS
         (SELECT ES.CDFILIAL
          FROM ITEMVENDAEST ES
          WHERE (ES.CDFILIAL = IT.CDFILIAL)
            AND (ES.CDCAIXA = IT.CDCAIXA)
            AND (ES.NRSEQVENDA = IT.NRSEQVENDA)
            AND (ES.NRSEQUITVEND = IT.NRSEQUITVEND)))
  AND (VE.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIM)
  AND (PR.CDARVPROD BETWEEN :PRODINI AND :PRODFIM)
  AND ((INSTR(:CDFILIAL, IT.CDFILIAL) <> 0)
       OR (:P_TCDFILIAL = 'T'))
    GROUP BY IT.CDFILIAL,
         FI.NMFILIAL,
         IT.CDPRODUTO,
         PR.NMPRODUTO,
         PR.CDARVPROD,
         PR.CDBARPRODUTO,
         IT.CDPRODPROMOCAO,
         IT.NRORG
    UNION
    SELECT IT.CDPRODPROMOCAO AS CDPRODPAI,
       PR.NMPRODUTO AS NMPRODPAI,
       '2' AS TIPO,
       PR.CDARVPROD,
       PR.CDBARPRODUTO AS CDBARPRODPAI,
       IT.CDFILIAL,
       FI.NMFILIAL,
       COUNT(DISTINCT VE.CDFILIAL||VE.CDCAIXA||VE.NRSEQVENDA) AS NRCUPONS,
       SUM(IT.QTPRODVEND) AS QUANTPRODPAI,
       SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2)) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0)) AS TOTALVENDA,
       IT.CDPRODPROMOCAO||' - '||PR.NMPRODUTO AS LABELPRODPROMOCAO,
       IT.NRORG
    FROM ITEMVENDA IT,
     PRODUTO PR,
     VENDA VE,
     FILIAL FI
    WHERE (IT.CDPRODPROMOCAO = PR.CDPRODUTO)
  AND (IT.CDFILIAL = FI.CDFILIAL)
  AND (IT.CDFILIAL = VE.CDFILIAL)
  AND (IT.CDCAIXA = VE.CDCAIXA)
  AND (IT.NRSEQVENDA = VE.NRSEQVENDA)
  AND (VE.IDSITUVENDA = 'O')
  AND (IT.CDPRODPROMOCAO <> IT.CDPRODUTO)
  AND (IT.CDPRODPROMOCAO IS NOT NULL)
  AND (VE.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIM)
  AND (PR.CDARVPROD BETWEEN :PRODINI AND :PRODFIM)
  AND IT.NRORG = VE.NRORG
  AND IT.NRORG = FI.NRORG
  AND IT.NRORG = PR.NRORG
  AND IT.NRORG = :NRORG
  AND ((INSTR(:CDFILIAL, IT.CDFILIAL) <> 0)
       OR (:P_TCDFILIAL = 'T'))
    GROUP BY IT.CDFILIAL,
         FI.NMFILIAL,
         IT.CDPRODPROMOCAO,
         PR.NMPRODUTO,
         PR.CDARVPROD,
         PR.CDBARPRODUTO,
         IT.NRORG
    ORDER BY 6,
         2
    ";

    const GET_PRODUTO_FILHO ="
     (SELECT ES.CDPRODUTO AS CDSUBPRODFIL,
          PR.NMPRODUTO AS NMSUBPRODFIL,
          PR.CDBARPRODUTO AS CDBARPRODFIL,
          SUM(ES.QTITVENDAEST) AS QUANTPRODFIL,
          IT.CDPRODPROMOCAO,
          SUM(TRUNC(ES.VRUNVENDAEST * ES.QTITVENDAEST,2) - NVL(ES.VRDESITVENDAEST,0)) AS TOTALVENDFIL,
          IT.NRORG
   FROM ITEMVENDAEST ES,
        VENDA VE,
        PRODUTO PR,
        ITEMVENDA IT
   WHERE (IT.CDFILIAL = ES.CDFILIAL)
     AND (IT.CDCAIXA = ES.CDCAIXA)
     AND (IT.NRSEQVENDA = ES.NRSEQVENDA)
     AND (IT.NRSEQUITVEND = ES.NRSEQUITVEND)
     AND (IT.CDFILIAL = VE.CDFILIAL)
     AND (IT.CDCAIXA = VE.CDCAIXA)
     AND (IT.NRSEQVENDA = VE.NRSEQVENDA)
     AND (VE.IDSITUVENDA = 'O')
     AND (ES.CDPRODUTO = PR.CDPRODUTO)
     AND (IT.CDPRODUTO = IT.CDPRODPROMOCAO)
     AND (IT.CDFILIAL = :CDFILIAL)
     AND (IT.CDPRODPROMOCAO = :CDPRODPAI)
     AND (:TIPO= '1')
     AND (VE.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIM)
     AND VE.NRORG = :NRORG
     AND VE.NRORG = IT.NRORG
   GROUP BY ES.CDPRODUTO,
            PR.NMPRODUTO,
            PR.CDBARPRODUTO,
            IT.CDPRODPROMOCAO,
            IT.NRORG)
    UNION
  (SELECT IT.CDPRODUTO AS CDSUBPRODFIL,
          PR.NMPRODUTO AS NMSUBPRODFIL,
          PR.CDBARPRODUTO AS CDBARPRODFIL,
          SUM(IT.QTPRODVEND) AS QUANTPRODFIL,
          IT.CDPRODPROMOCAO,
          SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL, 0)), 2)) - NVL(IT.VRDESITVEND, 0) + NVL(IT.VRACRITVEND, 0)) AS TOTALVENDFIL,
          IT.NRORG
   FROM ITEMVENDA IT,
        VENDA VE,
        PRODUTO PR
   WHERE (VE.CDFILIAL = :CDFILIAL)
     AND (VE.CDFILIAL = IT.CDFILIAL)
     AND (VE.CDCAIXA = IT.CDCAIXA)
     AND (VE.NRSEQVENDA = IT.NRSEQVENDA)
     AND (VE.IDSITUVENDA = 'O')
     AND (IT.CDPRODUTO = PR.CDPRODUTO)
     AND (IT.CDPRODPROMOCAO = :CDPRODPAI)
     AND (:TIPO= '2')
     AND (VE.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIM)
     AND VE.NRORG = :NRORG
     AND VE.NRORG = IT.NRORG
   GROUP BY IT.CDPRODUTO,
            PR.NMPRODUTO,
            PR.CDBARPRODUTO,
            IT.CDPRODPROMOCAO,
            IT.NRORG)
    ORDER BY 4 DESC
    ";

    const GET_MAX_STRLENGTH_OF_CDARVPROD_BY_CDNVPRODUTO = "
        SELECT MAX(LENGTH(CDARVPROD)) AS NIVELLENGTH
          FROM PRODUTO
          WHERE (CDNVPRODUTO <= :CDNVPRODUTO
             OR  :TCDNVPRODUTO = 'T')
            AND NRORG = :NRORG
          GROUP BY CDNVPRODUTO
      ORDER BY NIVELLENGTH ASC
    ";

    const DADOS_RECEBIMENTO = "
    SELECT DISTINCT
    M.CDTIPORECE, T.NMTIPORECE, V.CDFILIAL
    FROM
    VENDA V, MOVCAIXA M, TIPORECE T
    WHERE
    (V.CDFILIAL = M.CDFILIAL ) AND
    (V.CDCAIXA = M.CDCAIXA ) AND
    (V.NRSEQVENDA = M.NRSEQVENDA) AND
    (V.IDSITUVENDA = 'O' ) AND
    (M.CDTIPORECE = T.CDTIPORECE) AND
    (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN) AND
    ((INSTR(:P_CDFILIAL, V.CDFILIAL ) <> 0) OR (:P_TCDFILIAL = 'T')) AND
    ((INSTR(:P_CDLOJA , V.CDFILIAL||V.CDLOJA) <> 0) OR (:P_TCDLOJA = 'T')) AND
    V.NRORG = :NRORG
    ORDER BY
    M.CDTIPORECE
    ";


    const SAI_RECEBIMENTO = "
        SELECT
        SUM(NVL(M.VRMOVIVEND,0)) AS SAIDA
        FROM
        VENDA V, MOVCAIXA M
        WHERE
        (V.CDFILIAL = M.CDFILIAL ) AND
        (V.CDCAIXA = M.CDCAIXA ) AND
        (V.NRSEQVENDA = M.NRSEQVENDA) AND
        (V.NRORG = M.NRORG) AND
        (V.IDSITUVENDA = 'O' ) AND
        (V.CDFILIAL = :CDFILIAL ) AND
        (M.CDTIPORECE = :CDTIPORECE ) AND
        (V.NRORG = :NRORG) AND
        (M.IDTIPOMOVIVE = 'S' ) AND
        (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN)
    ";
    const ENTR_RECEBIMENTO = "
    SELECT
   SUM(NVL(M.VRMOVIVEND,0)) AS ENTRADA
FROM
   MOVCAIXA M
WHERE
   (M.CDFILIAL     = :CDFILIAL   ) AND
   (M.CDTIPORECE   = :CDTIPORECE ) AND
   (M.NRSEQVENDA   IS NULL       ) AND
   (M.IDTIPOMOVIVE = 'G'         ) AND
   (M.DTMOVIMCAIXA BETWEEN :P_DTINI AND :P_DTFIN)
    ";
    const PER_ENTR_RECEBIMENTO = "
    SELECT
   SUM(NVL(M.VRMOVIVEND,0)) AS ENTRADA
FROM
   MOVCAIXA M
WHERE
   (M.CDFILIAL     = :CDFILIAL   ) AND
   (M.CDTIPORECE   = :CDTIPORECE ) AND
   (M.NRSEQVENDA   IS NULL       ) AND
   (M.IDTIPOMOVIVE = 'G'         ) AND
   (M.DTMOVIMCAIXA BETWEEN :P_DTINI AND :P_DTFIN)
    ";

    const PER_SAI_RECEBIMENTO = "
  SELECT
  SUM(NVL(M.VRMOVIVEND,0)) AS SAIDA
  FROM
  VENDA V, MOVCAIXA M
  WHERE
  (V.CDFILIAL = M.CDFILIAL ) AND
  (V.CDCAIXA = M.CDCAIXA ) AND
  (V.NRSEQVENDA = M.NRSEQVENDA) AND
  (V.NRORG = M.NRORG) AND
  (V.IDSITUVENDA = 'O' ) AND
  (V.CDFILIAL = :CDFILIAL ) AND
  (V.NRORG = :NRORG) AND
  (M.IDTIPOMOVIVE = 'S' ) AND
  (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN)
    ";

     const GET_PARAVEND_FILIAL = "
    SELECT
            P.IDCONSUMIOBR, P.DTINITESCONS, P.CDLOJA,
            P.IDATUEST, P.IDGERANFVENPROD, P.IDBLOQCONSOLIDA,
            P.CDTIPORETI, P.IDPERCONVESTNEG, P.CDSETOR,
        F.CDTIPCUSTEST, F.IDUTILALMOX, F.IDUTILLCESTQ,
        F.IDCTRLESTQ, F.IDPERMESTNEG, F.IDMENSESTNEG,   F.IDLANCDTMENFIL,
        F.NRDIASSAIDFIL, F.IDLANCDTMAIFIL, F.NRDIASSAIDPDFIL,
        F.CDALMOXARIFE, F.CDLOCALESTOQ,
        DECODE(PG.IDUTILDTPROC, 'S', TO_CHAR(F.DTPROCESSA, 'DD/MM/YYYY'), TO_CHAR(SYSDATE, 'DD/MM/YYYY')) AS DTPROCESSA
        FROM
            PARAVEND P, PARAMFILIAL F, PARAMGERAL PG
        WHERE
            (P.CDFILIAL   = :CDFILIAL  ) AND
        (P.NRORG      = :NRORG     ) AND
        (P.CDFILIAL   = F.CDFILIAL ) AND
        (P.NRORG      = F.NRORG    )
    ";

     const GET_LOJA_ALMOXARIFE = "
    SELECT
      CDALMOXARIFE, CDLOCALESTOQ
    FROM
      LOJA
    WHERE
      CDFILIAL = :CDFILIAL AND
      CDLOJA   = :CDLOJA   AND
      NRORG    = :NRORG
    ";

    const GET_CONSOLIDACAO_PENDENTE = "
    SELECT COUNT(1) NRVENDA
    FROM VENDA VE,
      ITEMVENDA IT
    WHERE (VE.CDFILIAL = :CDFILIAL)
    AND (VE.NRORG = :NRORG)
    AND (VE.DTENTRVENDA BETWEEN :DTINITESCONS AND :DTFINAL)
    AND (VE.IDSITUVENDA      = 'O')
    AND (IT.CDFILIAL         = VE.CDFILIAL)
    AND (IT.CDCAIXA          = VE.CDCAIXA)
    AND (IT.NRSEQVENDA       = VE.NRSEQVENDA)
    AND (IT.NRORG            = VE.NRORG)
    AND (IT.CDFILIALNF      IS NULL)
    AND (IT.NRLANCTONF      IS NULL)
    AND (IT.CDFILIALEST     IS NULL)
    AND (IT.NRLANCESTQ      IS NULL)
    AND (VE.DTENTRVENDA NOT IN
      (SELECT DISTINCT VE.DTENTRVENDA
      FROM VENDA VE,
        ITEMVENDA IT
      WHERE (VE.CDFILIAL = :CDFILIAL)
      AND (VE.NRORG = :NRORG)
      AND (VE.DTENTRVENDA BETWEEN :DTINICIAL AND :DTFINAL)
      AND (VE.IDSITUVENDA  = 'O')
      AND (IT.CDFILIAL     = VE.CDFILIAL)
      AND (IT.CDCAIXA      = VE.CDCAIXA)
      AND (IT.NRSEQVENDA   = VE.NRSEQVENDA)
      AND (IT.NRORG        = VE.NRORG)
      AND (IT.CDFILIALNF  IS NULL)
      AND (IT.NRLANCTONF  IS NULL)
      AND (IT.CDFILIALEST IS NULL)
      AND (IT.NRLANCESTQ  IS NULL)
      ))
    ";

    const GET_CONSOLIDACAO_PENDENTE_ALMOXARIFADO = "
    SELECT COUNT(1) NRVENDA
    FROM VENDA VE,
      ITEMVENDA IT,
      LOJA LO
    WHERE (VE.CDFILIAL = :CDFILIAL)
    AND (VE.NRORG      = :NRORG)
    AND (VE.DTENTRVENDA BETWEEN :DTINITESCONS AND :DTFINAL)
    AND (VE.IDSITUVENDA      = 'O')
    AND (IT.CDFILIAL         = VE.CDFILIAL)
    AND (IT.CDCAIXA          = VE.CDCAIXA)
    AND (IT.NRSEQVENDA       = VE.NRSEQVENDA)
    AND (IT.NRORG            = VE.NRORG)
    AND (IT.CDFILIALNF      IS NULL)
    AND (IT.NRLANCTONF      IS NULL)
    AND (IT.CDFILIALEST     IS NULL)
    AND (IT.NRLANCESTQ      IS NULL)
    AND (LO.CDFILIAL         = VE.CDFILIAL)
    AND (LO.CDLOJA           = VE.CDLOJA)
    AND (LO.NRORG            = VE.NRORG)
    AND (LO.CDALMOXARIFE     = :CDALMOXARIFE)
    AND ((LO.CDLOCALESTOQ = :CDLOCALESTOQ) OR (:UTILOCALESTQ = 'T'))
    AND (VE.DTENTRVENDA NOT IN
      (SELECT DISTINCT VE.DTENTRVENDA
      FROM VENDA VE,
        ITEMVENDA IT,
        LOJA LO
      WHERE (VE.CDFILIAL = :CDFILIAL)
      AND (VE.NRORG      = :NRORG)
      AND (VE.DTENTRVENDA BETWEEN :DTINICIAL AND :DTFINAL)
      AND (VE.IDSITUVENDA  = 'O')
      AND (IT.CDFILIAL     = VE.CDFILIAL)
      AND (IT.CDCAIXA      = VE.CDCAIXA)
      AND (IT.NRSEQVENDA   = VE.NRSEQVENDA)
      AND (IT.NRORG        = VE.NRORG)
      AND (IT.CDFILIALNF  IS NULL)
      AND (IT.NRLANCTONF  IS NULL)
      AND (IT.CDFILIALEST IS NULL)
      AND (IT.NRLANCESTQ  IS NULL)
      AND (LO.CDFILIAL     = VE.CDFILIAL)
      AND (LO.CDLOJA       = VE.CDLOJA)
      AND (LO.NRORG        = VE.NRORG)
      AND (LO.CDALMOXARIFE = :CDALMOXARIFE)
      AND ((LO.CDLOCALESTOQ = :CDLOCALESTOQ) OR (:UTILOCALESTQ = 'T'))
      ))
    ";

    const GET_PARAMESTOQUE = "
    SELECT
      IDLANCDTMEN, NRDIASSAID,   IDLANCDTMAI,
      IDTRATAVENC, IDBLOQFORIRR, IDCONSFORNFJ,
      NRDIASSAIDPD
    FROM
      PARAMESTOQUE
    WHERE NRORG = :NRORG
    ";

    const GET_MODIFIEDSTOCK = "
    SELECT DISTINCT L.CDFILIAL, TO_CHAR(MAX(L.DTLANCESTQ), 'DD/MM/YYYY') AS DTLANCESTQ
    FROM LANCTOESTOQ L, ITLANCTOEST I
    WHERE L.CDFILIMOVI = :CDFILIAL           AND
      DTLANCESTQ  BETWEEN TO_DATE(:DTLANCESTQI, 'DD/MM/YY') AND TO_DATE(:DTLANCESTQF, 'DD/MM/YY') AND
      L.NRORG = :NRORG                       AND
      L.IDTPLANCTO IN ('0','1')              AND
      I.CDFILIAL   = L.CDFILIMOVI            AND
      I.NRLANCESTQ = L.NRLANCESTQ            AND
      I.NRORG      = L.NRORG                 AND
      I.IDORDEMCLC = 'U'
      GROUP BY L.CDFILIAL
    ";

    const GET_BAIXAESTOQUE = "
      SELECT
             A.DTENTRVENDA,
             A.CDPRODUTO,
             A.NMPRODUTO,
             A.CDPRODESTO,
             A.IDCNTRESTOQ,
             A.VRFATOCONV,
             SUM(A.QTPRODVEND) AS QTPRODVEND,
             A.CDPRODPAI,
             A.NRSEQVENDA
      FROM
          (
              SELECT
                  TO_CHAR(V.DTENTRVENDA, 'DD/MM/YYYY') AS DTENTRVENDA,
                  V.NRSEQVENDA,
                  I.CDPRODUTO,
                  P.NMPRODUTO,
                  P.CDPRODESTO,
                  PF.IDCNTRESTOQ,
                  P.VRFATOCONV,
                  I.QTPRODVEND + NVL(I.QTPRODREFIL, 0) AS QTPRODVEND,
                  I.CDPRODUTO AS CDPRODPAI
              FROM VENDA V
                   JOIN CAIXA CX ON (CX.CDFILIAL = V.CDFILIAL) AND (CX.CDCAIXA = V.CDCAIXA)
                   JOIN CLIENTE C ON (C.CDCLIENTE = V.CDCLIENTE)
                   JOIN ITEMVENDA I ON (I.CDFILIAL = V.CDFILIAL) AND (I.CDCAIXA = V.CDCAIXA) AND (I.NRSEQVENDA = V.NRSEQVENDA)
              LEFT JOIN CONSUMIDOR O ON (V.CDCLIENTE = O.CDCLIENTE) AND (V.CDCONSUMIDOR = O.CDCONSUMIDOR)
                   JOIN PRODUTO P ON (P.CDPRODUTO = I.CDPRODUTO)
                   JOIN PRODFILI PF ON (PF.CDFILIAL = V.CDFILIAL) AND (PF.CDPRODUTO = I.CDPRODUTO)
              LEFT JOIN LANCTOESTOQ L ON (I.CDFILIAL = L.CDFILIAL) AND (I.NRLANCTONF = L.NRLANCTONF)
              WHERE ( V.CDFILIAL = :CDFILIAL )
                  AND ( V.CDLOJA = :CDLOJA )
                  AND (V.NRORG  = :NRORG)
                  AND ( ( :TODASVND = 'S' ) OR ( INSTR(:NRSEQVENDA, V.CDFILIAL || V.CDCAIXA || V.NRSEQVENDA) > 0 ) )
                  AND ( V.DTENTRVENDA BETWEEN :DTINICIAL AND :DTFINAL )
                  AND ( V.IDSITUVENDA = 'O' )
                  AND ( NVL(V.IDTPFORPGVEN, 'V') <> 'P' )
                  AND ( ( :TCDCAIXA = 'T' ) OR ( INSTR(:CDCAIXA, V.CDCAIXA) > 0 ) )
                  AND ( ( :TCDCLIENTE = 'T' ) OR ( INSTR(:CDCLIENTE, V.CDCLIENTE) > 0 )  )
                  AND ( ( INSTR(:CDCCUSCLIE, V.CDCLIENTE || V.CDCCUSCLIE) > 0 ) OR ( :TCDCCUSCLIE = 'T' ) )
                  AND ( ( INSTR(:CDPRODUTO, I.CDPRODUTO) > 0 ) OR ( :TCDPRODUTO = 'T' ) )
                  AND ( ( :TCDTIPOCONS = 'S' ) OR ( INSTR(:CDTIPOCONS, O.CDTIPOCONS) > 0 ) )
                  AND NOT EXISTS (
                      SELECT
                          IE.CDFILIAL
                          || IE.CDCAIXA
                          || IE.NRSEQVENDA
                          || IE.NRSEQUITVEND
                      FROM
                          ITEMVENDAEST IE
                      WHERE
                          IE.CDFILIAL = I.CDFILIAL
                          AND IE.CDCAIXA = I.CDCAIXA
                          AND IE.NRSEQVENDA = I.NRSEQVENDA
                          AND IE.NRSEQUITVEND = I.NRSEQUITVEND
                  )
                  AND ( P.IDPRODATIVPR = 'S' )
                  AND ( I.CDFILIALEST IS NULL )
                  AND ( I.NRLANCESTQ IS NULL )
                  AND ( L.NRLANCESTQ IS NULL )
                  AND I.IDIMPPRGRPROMO <> 'S'
              UNION ALL
                  SELECT
                  TO_CHAR(V.DTENTRVENDA, 'DD/MM/YYYY') AS DTENTRVENDA,
                  V.NRSEQVENDA,
                  IE.CDPRODUTO,
                  P.NMPRODUTO,
                  P.CDPRODESTO,
                  PF.IDCNTRESTOQ,
                  P.VRFATOCONV,
                  IE.QTITVENDAEST AS QTPRODVEND,
                  I.CDPRODUTO AS CDPRODPAI
                FROM VENDA V
                JOIN CAIXA CX ON (CX.CDFILIAL = V.CDFILIAL) AND (CX.CDCAIXA = V.CDCAIXA)
                JOIN CLIENTE C ON (C.CDCLIENTE = V.CDCLIENTE)
           LEFT JOIN CONSUMIDOR O ON (V.CDCLIENTE = O.CDCLIENTE) AND (V.CDCONSUMIDOR = O.CDCONSUMIDOR)
                JOIN ITEMVENDA I ON (I.CDFILIAL = V.CDFILIAL) AND (I.CDCAIXA = V.CDCAIXA) AND (I.NRSEQVENDA = V.NRSEQVENDA)
                JOIN ITEMVENDAEST IE ON (IE.CDFILIAL = I.CDFILIAL) AND (IE.CDCAIXA = I.CDCAIXA) AND (IE.NRSEQVENDA = I.NRSEQVENDA) AND (IE.NRSEQUITVEND = I.NRSEQUITVEND)
                JOIN PRODUTO P ON (P.CDPRODUTO = IE.CDPRODUTO)
                JOIN PRODFILI PF ON (PF.CDFILIAL = V.CDFILIAL) AND (PF.CDPRODUTO = IE.CDPRODUTO)
           LEFT JOIN LANCTOESTOQ L ON (I.CDFILIAL = L.CDFILIAL) AND (I.NRLANCTONF = L.NRLANCTONF)
                  WHERE ( V.CDFILIAL = :CDFILIAL )
                  AND ( V.CDLOJA = :CDLOJA )
                  AND (V.NRORG  = :NRORG)
                  AND ( ( :TODASVND = 'S' ) OR ( INSTR(:NRSEQVENDA, V.CDFILIAL || V.CDCAIXA || V.NRSEQVENDA) > 0 ) )
                  AND ( V.DTENTRVENDA BETWEEN :DTINICIAL AND :DTFINAL )
                  AND ( V.IDSITUVENDA = 'O' )
                  AND ( NVL(V.IDTPFORPGVEN, 'V') <> 'P' )
                  AND ( ( :TCDCAIXA = 'T' ) OR ( INSTR(:CDCAIXA, V.CDCAIXA) > 0 ) )
                  AND ( ( :TCDCLIENTE = 'T' ) OR ( INSTR(:CDCLIENTE, V.CDCLIENTE) > 0 ) )
                  AND ( ( INSTR(:CDCCUSCLIE, V.CDCLIENTE || V.CDCCUSCLIE) > 0 ) OR ( :TCDCCUSCLIE = 'T' ) )
                  AND ( ( INSTR(:CDPRODUTO, I.CDPRODUTO) > 0 ) OR ( :TCDPRODUTO = 'T' ) )
                  AND ( ( :TCDTIPOCONS = 'S' ) OR ( INSTR(:CDTIPOCONS, O.CDTIPOCONS) > 0 ) )
                  AND ( P.IDPRODATIVPR = 'S' )
                  AND ( I.CDFILIALEST IS NULL )
                  AND ( I.NRLANCESTQ IS NULL )
                  AND ( L.NRLANCESTQ IS NULL )
              UNION ALL
                  SELECT
                  TO_CHAR(V2.DTENTRVENDA, 'DD/MM/YYYY') AS DTENTRVENDA,
                  V2.NRSEQVENDA,
                  A2.CDSUBPRODUTO AS CDPRODUTO,
                  P2.NMPRODUTO,
                  P2.CDPRODESTO,
                  PF2.IDCNTRESTOQ,
                  P2.VRFATOCONV,
                  ( A2.QTPRODADIC * I2.QTPRODVEND ) AS QTPRODVEND,
                  I2.CDPRODUTO AS CDPRODPAI
              FROM VENDA V2
              JOIN CAIXA CX2 ON (V2.CDFILIAL     = CX2.CDFILIAL ) AND (V2.CDCAIXA      = CX2.CDCAIXA )
              JOIN CLIENTE C2 ON (V2.CDCLIENTE    = C2.CDCLIENTE )
         LEFT JOIN CONSUMIDOR O2 ON (V2.CDCLIENTE    = O2.CDCLIENTE ) AND (V2.CDCONSUMIDOR = O2.CDCONSUMIDOR )
              JOIN ITEMVENDA I2 ON (V2.CDFILIAL     = I2.CDFILIAL ) AND (V2.CDCAIXA      = I2.CDCAIXA ) AND (V2.NRSEQVENDA   = I2.NRSEQVENDA )
         LEFT JOIN LANCTOESTOQ L2 ON (I2.CDFILIAL = L2.CDFILIAL  ) AND (I2.NRLANCTONF = L2.NRLANCTONF)
              JOIN PRODFILI PF2 ON (I2.CDFILIAL     = PF2.CDFILIAL )
              JOIN PRODUTOADIC A2 ON (A2.CDPRODUTO    = PF2.CDPRODUTO) AND (A2.CDPRODUTO    = I2.CDPRODUTO )
              JOIN PRODUTO P2 ON (A2.CDSUBPRODUTO = P2.CDPRODUTO )
              WHERE ( V2.CDFILIAL = :CDFILIAL )
                  AND ( V2.CDLOJA = :CDLOJA )
                  AND (V2.NRORG = :NRORG)
                  AND ( V2.IDSITUVENDA = 'O' )
                  AND ( I2.CDFILIALEST IS NULL )
                  AND ( I2.NRLANCESTQ IS NULL )
                  AND ( L2.NRLANCESTQ IS NULL )
                  AND ( NVL(V2.IDTPFORPGVEN, 'V') <> 'P' )
                  AND ( P2.IDPRODATIVPR = 'S' )
                  AND ( DECODE(SUBSTR(NVL(I2.IDORIGEMVENDA, V2.IDORIGEMVENDA), 1, 3), 'BGR', 'BAL', SUBSTR(NVL(I2.IDORIGEMVENDA, V2.IDORIGEMVENDA), 1, 3)) = A2.IDMODOVENDA )
                  AND ( V2.DTENTRVENDA BETWEEN :DTINICIAL AND :DTFINAL ) AND ( ( INSTR(:NRSEQVENDA, V2.CDFILIAL || V2.CDCAIXA || V2.NRSEQVENDA) > 0 ) OR ( :TODASVND = 'S' ) )
                  AND ( ( INSTR(:CDCAIXA, V2.CDCAIXA) > 0 ) OR ( :TCDCAIXA = 'T' ) )
                  AND ( ( INSTR(:CDCCUSCLIE, V2.CDCLIENTE || V2.CDCCUSCLIE) > 0 ) OR ( :TCDCCUSCLIE = 'T' ) )
                  AND ( ( INSTR(:CDPRODUTO, I2.CDPRODUTO) > 0 ) OR ( :TCDPRODUTO = 'T' ) )
                  AND ( ( INSTR(:CDTIPOCONS, O2.CDTIPOCONS) > 0 ) OR ( :TCDTIPOCONS = 'S' ) )
                  AND ( ( INSTR(:CDCLIENTE, V2.CDCLIENTE) > 0 ) OR ( :TCDCLIENTE = 'T' ) )
              UNION ALL
                  SELECT
                  TO_CHAR(V.DTENTRVENDA, 'DD/MM/YYYY') AS DTENTRVENDA,
                  V.NRSEQVENDA,
                  IC.CDPRODUTO,
                  P.NMPRODUTO,
                  P.CDPRODESTO,
                  PF.IDCNTRESTOQ,
                  P.VRFATOCONV,
                  IC.QTPRODVENDC AS QTPRODVEND,
                  IC.CDPRODUTO AS CDPRODPAI
             FROM VENDA V
                JOIN CAIXA CX ON (CX.CDFILIAL = V.CDFILIAL) AND (CX.CDCAIXA = V.CDCAIXA)
                JOIN CLIENTE C ON (C.CDCLIENTE = V.CDCLIENTE)
             LEFT JOIN CONSUMIDOR O ON (V.CDCLIENTE = O.CDCLIENTE) AND (V.CDCONSUMIDOR = O.CDCONSUMIDOR)
                JOIN ITVENDACAN IC ON (IC.CDFILIAL = V.CDFILIAL) AND (IC.CDCAIXA = V.CDCAIXA) AND (IC.NRSEQVENDA = V.NRSEQVENDA)
                JOIN PRODUTO P ON (P.CDPRODUTO = IC.CDPRODUTO)
                JOIN PRODFILI PF ON (PF.CDFILIAL = V.CDFILIAL) AND (PF.CDPRODUTO = IC.CDPRODUTO)
                JOIN PARAMGERAL PG ON (V.NRORG = PG.NRORG)
              WHERE ( V.CDFILIAL = :CDFILIAL )
                  AND ( V.CDLOJA = :CDLOJA )
                  AND (V.NRORG  = :NRORG)
                  AND ( ( :TODASVND = 'S' ) OR ( INSTR(:NRSEQVENDA, V.CDFILIAL || V.CDCAIXA || V.NRSEQVENDA) > 0 ) )
                  AND ( V.DTENTRVENDA BETWEEN :DTINICIAL AND :DTFINAL )
                  AND ( NVL(V.IDTPFORPGVEN, 'V') <> 'P' )
                  AND ( ( :TCDCAIXA = 'T' ) OR ( INSTR(:CDCAIXA, V.CDCAIXA) > 0 ) )
                  AND ( ( :TCDCLIENTE = 'T' ) OR ( INSTR(:CDCLIENTE, V.CDCLIENTE) > 0 ) )
                  AND ( ( INSTR(:CDCCUSCLIE, V.CDCLIENTE || V.CDCCUSCLIE) > 0 ) OR ( :TCDCCUSCLIE = 'T' ) )
                  AND ( ( INSTR(:CDPRODUTO, IC.CDPRODUTO) > 0 ) OR ( :TCDPRODUTO = 'T' ) )
                  AND ( ( :TCDTIPOCONS = 'S' ) OR ( INSTR(:CDTIPOCONS, O.CDTIPOCONS) > 0 ) )
                  AND ( PG.IDINFPRODPRODUZ = 'S' )
                  AND ( IC.IDPRODPRODUZC = 'S' )
                  AND ( EXISTS (
                      SELECT
                          1
                      FROM
                          ITEMVENDA I
                      WHERE
                          I.CDFILIAL = V.CDFILIAL
                          AND I.CDCAIXA = V.CDCAIXA
                          AND I.NRSEQVENDA = V.NRSEQVENDA
                          AND I.CDFILIALEST IS NULL
                          AND I.NRLANCESTQ IS NULL
                          AND (I.IDIMPPRGRPROMO <> 'S')
                  ) OR ( V.IDSITUVENDA = 'C' ) )
                  AND ( P.IDPRODATIVPR = 'S' )
          ) A
      GROUP BY
          A.DTENTRVENDA,
          A.CDPRODUTO,
          A.NMPRODUTO,
          A.CDPRODESTO,
          A.IDCNTRESTOQ,
          A.VRFATOCONV,
          A.CDPRODPAI,
          A.NRSEQVENDA
      ORDER BY
          A.DTENTRVENDA
    ";

    const GET_OBSERVACOES = "
   SELECT TO_CHAR(V.DTENTRVENDA, 'DD/MM/YYYY') AS DTENTRVENDA, V.CDFILIAL, O.IDCONTROLAOBS, O.CDPRODUTO, I.CDPRODUTO AS CDPRODPAI,
       SUM(I.QTPRODVEND + NVL(I.QTPRODREFIL,0)) AS QTPRODVEND, P.NMPRODUTO, P.VRFATOCONV, P.CDPRODESTO,
       MAX(NVL(PF.IDCNTRESTOQ, 'S')) AS IDCNTRESTOQ
    FROM VENDA V, ITEMVENDA I, OBSITEMVENDA B, OCORRENCIA O, CONSUMIDOR C, CLIENTE L, PRODUTO P, PRODFILI PF
    WHERE V.CDFILIAL     = :CDFILIAL
      AND V.CDLOJA       = :CDLOJA
      AND V.NRORG        = :NRORG
      AND V.IDSITUVENDA  = 'O'
      AND V.DTENTRVENDA BETWEEN :DTINICIAL AND :DTFINAL
      AND I.CDFILIALEST IS NULL
      AND I.NRLANCESTQ IS NULL
      AND I.CDFILIAL     = V.CDFILIAL
      AND I.CDCAIXA      = V.CDCAIXA
      AND I.NRSEQVENDA   = V.NRSEQVENDA
      AND I.CDFILIAL     = B.CDFILIAL
      AND I.CDCAIXA      = B.CDCAIXA
      AND I.NRSEQVENDA   = B.NRSEQVENDA
      AND I.NRSEQUITVEND = B.NRSEQUITVEND
      AND B.CDGRPOCOR    = O.CDGRPOCOR
      AND B.CDOCORR      = O.CDOCORR
      AND O.IDCONTROLAOBS IN ('R','O')
      AND O.CDPRODUTO IS NOT NULL
      AND V.CDCLIENTE    = C.CDCLIENTE(+)
      AND V.CDCONSUMIDOR = C.CDCONSUMIDOR(+)
      AND V.CDCLIENTE    = L.CDCLIENTE
      AND P.CDPRODUTO    = O.CDPRODUTO
      AND V.CDFILIAL = PF.CDFILIAL(+)
      AND P.CDPRODUTO = PF.CDPRODUTO(+)
      AND ((INSTR(:NRSEQVENDA, V.CDFILIAL||V.CDCAIXA||V.NRSEQVENDA) > 0) OR (:TODASVND = 'S'))
      AND ((INSTR(:CDCAIXA, V.CDCAIXA              ) > 0) OR (:TCDCAIXA    = 'T'))
      AND ((INSTR(:CDCCUSCLIE, V.CDCLIENTE||V.CDCCUSCLIE          ) > 0) OR (:TCDCCUSCLIE = 'T'))
      AND ((INSTR(:CDPRODUTO, I.CDPRODUTO                        ) > 0) OR (:TCDPRODUTO  = 'T'))
      AND ((INSTR(:CDTIPOCONS, C.CDTIPOCONS                       ) > 0) OR (:TCDTIPOCONS = 'S'))
      AND ((INSTR(:CDCLIENTE , V.CDCLIENTE                        ) > 0) OR (:TCDCLIENTE  = 'T'))
    GROUP BY V.DTENTRVENDA, V.CDFILIAL, O.IDCONTROLAOBS, O.CDPRODUTO, I.CDPRODUTO, P.NMPRODUTO, P.VRFATOCONV, P.CDPRODESTO
    ORDER BY V.DTENTRVENDA, O.IDCONTROLAOBS
    ";

    const GET_ROTFABLOCAL_ITEMS = "
    SELECT
      RF.CDSUBPRODLOC AS CDPRODUTO, P.NMPRODUTO, P.CDPRODESTO, NVL(PF.IDCNTRESTOQ, 'S') AS IDCNTRESTOQ, P.VRFATOCONV, RF.QTSUBPRODLOC AS QTPRODVEND
    FROM
      ROTFABLOCAL RF, PRODFILI PF, PRODUTO P
    WHERE (RF.CDFILIAL  = :CDFILIAL      )
      AND (RF.CDPRODUTO = :CDPRODUTO     )
      AND (RF.NRORG     = :NRORG         )
      AND (RF.CDSUBPRODLOC = P.CDPRODUTO )
      AND (RF.NRORG     = P.NRORG        )
      AND (RF.CDFILIAL  = PF.CDFILIAL    )
      AND (RF.NRORG     = PF.NRORG       )
      AND (PF.CDPRODUTO = P.CDPRODESTO   )
    ";

    const GET_ROTFABRICA_ITEMS = "
    SELECT
      RF.CDSUBPRODUTO AS CDPRODUTO, P.NMPRODUTO, P.CDPRODESTO, NVL(PF.IDCNTRESTOQ, 'S') AS IDCNTRESTOQ, P.VRFATOCONV, RF.QTSUBPRODROT AS QTPRODVEND
    FROM
      ROTFABRICA RF, PRODFILI PF, PRODUTO P
    WHERE (RF.CDPRODUTO = :CDPRODUTO     )
      AND (RF.NRORG     = :NRORG         )
      AND (RF.CDSUBPRODUTO = P.CDPRODUTO )
      AND (RF.NRORG     = P.NRORG        )
      AND (PF.CDFILIAL  = :CDFILIAL      )
      AND (RF.NRORG     = PF.NRORG       )
      AND (PF.CDPRODUTO = P.CDPRODESTO   )
    ";

    const GET_PARAM_PRODFILI = "
      SELECT NVL(CDALMOXCONSVND, CDALMOXARIFE) AS CDALMOXARIFE, NVL(CDLOCALCONSVND, CDLOCALESTOQ) AS CDLOCALESTOQ
      FROM PRODFILI PF, PRODUTO P
      WHERE PF.CDFILIAL = :CDFILIAL
        AND PF.NRORG = :NRORG
        AND P.CDPRODUTO = :CDPRODUTO
        AND PF.CDPRODUTO = P.CDPRODESTO
    ";
    
    const GET_CDALMOXARIFE_BY_LOJA = "
      SELECT CDALMOXARIFE, CDLOCALESTOQ FROM LOJA WHERE CDFILIAL = :CDFILIAL
    ";



    const GET_CUSTO_PRODUTO_LCEST = "
    SELECT
      CUSTO_PRODUTO_LCEST(
        :P_CDFILIAL, :P_CDPRODUTO, TO_NUMBER(:P_NRTIPOCUSTO), TO_DATE(:P_DTREFERENCIA), TO_DATE(:P_DTATUAL), :P_ALMOXARIFE, :P_LOCALESTOQ, :P_NRLOTEESTQ, :P_NRSUBLOTE
      ) AS VRUNILANCTO
    FROM DUAL
    ";

    const GET_CDCENTCUST = "
    SELECT  CDCENTCUST
    FROM SETOR
    WHERE CDSETOR = :CDSETOR AND NRORG = :NRORG
    ";

    const INSERE_LANCTOEST_PDV = "
    INSERT INTO LANCTOESTOQ
      (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, DSLANCESTQ,
      IDALTCUSMED, CDFILIMOVI, CDOPERADOR, NRORG, NRORGINCLUSAO,
      DTINCLUSAO, CDOPERINCLUSAO)
    VALUES
      (:CDFILIAL, :NRLANCESTQ, :IDTPLANCTO, :DTLANCESTQ, :DSLANCESTQ,
      :IDALTCUSMED, :CDFILIMOVI, :CDOPERADOR, :NRORG, :NRORGINCLUSAO,
      SYSDATE, :CDOPERINCLUSAO)
    ";

    const INSERE_RETIRADAEST = "
    INSERT INTO RETIRADAESTO
      (CDFILIAL, NRRETEST, DTRETEST, DSRETEST, CDFILIALLAN,
      NRLANCESTQ, CDSETOR, CDCENTCUST, NRORG, NRORGINCLUSAO,
      DTINCLUSAO, CDOPERINCLUSAO)
    VALUES
      (:CDFILIAL, :NRRETEST, :DTRETEST, :DSRETEST, :CDFILIALLAN,
      :NRLANCESTQ, :CDSETOR, :CDCENTCUST, :NRORG, :NRORGINCLUSAO,
      SYSDATE, :CDOPERINCLUSAO)
    ";

    const GET_LOTE_PRODUTO = "
    SELECT CDPRODUTO
    FROM LOTE
    WHERE (:CDFILIAL   =  CDFILIAL   )
      AND (:NRLOTEESTQ =  NRLOTEESTQ )
      AND (:NRSUBLOTE  =  NRSUBLOTE  )
      AND (:NRORG      =  NRORG      )
      AND (INSTR(:CDPRODUTO, CDPRODUTO) > 0)
    ";

    const GET_PRODUTO_NO_LOTE = "
    SELECT CDPRODUTO
    FROM LOTE
    WHERE (:CDFILIAL   =  CDFILIAL   )
      AND (:NRLOTEESTQ =  NRLOTEESTQ )
      AND (:NRSUBLOTE  =  NRSUBLOTE  )
      AND (:NRORG      =  NRORG      )
      AND (:CDPRODUTO = CDPRODUTO )
    ";

    const INSERT_LOTE_PRODUTO = "
    INSERT INTO LOTE
      (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO,
      IDSTATLOTE, DTENTRLOTE, NRORG, NRORGINCLUSAO, CDOPERINCLUSAO, DTINCLUSAO)
      (
        SELECT :CDFILIAL CDFILIAL, :NRLOTEESTQ NRLOTEESTQ, :NRSUBLOTE NRSUBLOTE,
          :CDPRODUTO CDPRODUTO, :IDSTATLOTE IDSTATLOTE, SYSDATE DTENTRLOTE, :NRORG NRORG,
          :NRORGINCLUSAO NRORGINCLUSAO, :CDOPERINCLUSAO CDOPERINCLUSAO, SYSDATE DTINCLUSAO
        FROM PARAMGERAL
        MINUS
        SELECT :CDFILIAL CDFILIAL,:NRLOTEESTQ NRLOTEESTQ,:NRSUBLOTE NRSUBLOTE, :CDPRODUTO CDPRODUTO, :IDSTATLOTE IDSTATLOTE,
        SYSDATE DTENTRLOTE,:NRORG NRORG, :NRORGINCLUSAO NRORGINCLUSAO, :CDOPERINCLUSAO CDOPERINCLUSAO,
        SYSDATE DTINCLUSAO
        FROM LOTE
        WHERE :CDFILIAL   =  CDFILIAL
          AND :NRLOTEESTQ =  NRLOTEESTQ
          AND :NRSUBLOTE  =  NRSUBLOTE
          AND :CDPRODUTO  =  CDPRODUTO
          AND :NRORG      = NRORG
      )
    ";

    const INSERT_ITLANCTOEST = "
    INSERT INTO ITLANCTOEST
      (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO,  CDALMOXARIFE,
      CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDFILIMOVI, CDPRODMOVI,
      IDORDEMCLC, DTLANCMOVI, IDEVOLESTOQ, CDTIPORETI, CDCENTCUST,
      QTTOTLANCTO, IDTIPOMOVI, QTLANCTOEST, VRUNILANCTO, VRTOTLANCTO,
      QTDEVOLESTOQ, VRLANCTOEST, VRLANCTOBRUT, NRORG, NRORGINCLUSAO,
      CDOPERINCLUSAO, DTINCLUSAO, CDPRODPAI)
    VALUES
      (:CDFILIAL, :NRLANCESTQ, :NRSEQUITEM, :CDPRODUTO, :CDALMOXARIFE,
      :CDLOCALESTOQ, :NRLOTEESTQ, :NRSUBLOTE, :CDFILIMOVI, :CDPRODMOVI,
      :IDORDEMCLC, :DTLANCMOVI, :IDEVOLESTOQ, :CDTIPORETI, :CDCENTCUST,
      :QTTOTLANCTO, :IDTIPOMOVI, :QTLANCTOEST, :VRUNILANCTO, :VRTOTLANCTO,
      :QTDEVOLESTOQ, :VRLANCTOEST, :VRLANCTOBRUT, :NRORG, :NRORGINCLUSAO,
      :CDOPERINCLUSAO, SYSDATE, :CDPRODPAI)
    ";

    const UPDATE_ITEMVENDA = "
    UPDATE ITEMVENDA
    SET
      CDFILIALEST  = :CDFILIALEST,
      NRLANCESTQ   = :NRLANCESTQ,
      NRORGULTATU  = :NRORGULTATU,
      CDOPERULTATU = :CDOPERULTATU,
      DTULTATU     = SYSDATE
    WHERE
      (CDFILIAL     = :CDFILIAL  ) AND
      (CDCAIXA      = :CDCAIXA   ) AND
      (NRSEQVENDA   = :NRSEQVENDA) AND
      (NRORG        = :NRORG     ) AND
      (CDFILIALEST IS NULL      ) AND
      (NRLANCESTQ  IS NULL      ) AND
      (NOT EXISTS (SELECT 1
        FROM LANCTOESTOQ
        WHERE CDFILIAL   = ITEMVENDA.CDFILIAL
          AND NRLANCTONF = ITEMVENDA.NRLANCTONF
          AND NRORG      = ITEMVENDA.NRORG
          AND NRLANCESTQ IS NOT NULL))
    ";

    const GET_MOVILOTE = "
    SELECT DISTINCT P.CDARVPROD, P.CDPRODUTO, P.NMPRODUTO, TO_CHAR(M.DTMOVILOTE, 'DD/MM/YYYY') AS DTLANCMOVI
    FROM MOVILOTE M, PRODUTO P, PRODFILI PF
    WHERE
      (M.NRMOVILOTE = :CDFILINRLANC OR
       M.NRLANCTOORIG = :CDFILINRLANC)
      AND (M.NRORG        = :NRORG       )
      AND (M.CDPRODUTO    = P.CDPRODUTO  )
      AND (M.NRORG        = P.NRORG      )
      AND (PF.CDPRODUTO = P.CDPRODUTO)
      AND (PF.CDFILIAL = :CDFILIAL)
      AND (PF.IDCNTRESTOQ = 'S')
    ";

    const DELETE_MOVILOTE = "
    DELETE FROM MOVILOTE
    WHERE (NRLANCTOORIG = :CDFILINRLANC
      OR NRMOVILOTE     = :CDFILINRLANC)
      AND (NRORG        = :NRORG       )
    ";

    const GET_QTESTOQ_ARVPROD = "
    SELECT
      NVL(PD.QTESTOQDIA, 0) AS QTESTOQDIA,
      P.CDARVPROD
    FROM
      POSESTDIA PD, PRODUTO P
    WHERE (PD.CDFILIAL     = :CDFILIAL    )
      AND (PD.CDALMOXARIFE = :CDALMOXARIFE)
      AND (PD.CDLOCALESTOQ = :CDLOCALESTOQ)
      AND (PD.NRLOTEESTQ   = :NRLOTEESTQ  )
      AND (PD.NRSUBLOTE    = :NRSUBLOTE   )
      AND (PD.CDPRODUTO    = :CDPRODUTO   )
      AND (PD.NRORG        = :NRORG       )
      AND (PD.CDPRODUTO    = P.CDPRODUTO  )
      AND (PD.NRORG        = P.NRORG      )
      AND (PD.DTPOSIESTQ   = (SELECT MAX(DTPOSIESTQ)
        FROM POSESTDIA
        WHERE (CDFILIAL     = :CDFILIAL    )
          AND (CDALMOXARIFE = :CDALMOXARIFE)
          AND (CDLOCALESTOQ = :CDLOCALESTOQ)
          AND (NRLOTEESTQ   = :NRLOTEESTQ  )
          AND (NRSUBLOTE    = :NRSUBLOTE   )
          AND (CDPRODUTO    = :CDPRODUTO   )
          AND (DTPOSIESTQ  <= :DTPOSIESTQ  )
          AND (NRORG        = :NRORG       )))
    ";

    const GET_VENDAS_MENSAIS = "
        SELECT NVL(SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)),0) AS TOTALDIA, COUNT(V.NRSEQVENDA) AS QT
        FROM ITEMVENDA I
            JOIN VENDA V ON I.CDFILIAL = V.CDFILIAL
                        AND I.CDCAIXA = V.CDCAIXA
                        AND I.NRSEQVENDA = V.NRSEQVENDA
        WHERE I.CDFILIAL = :CDFILIAL AND
              I.NRORG    = :NRORG
        AND V.DTENTRVENDA BETWEEN trunc(SYSDATE, 'mm') AND SYSDATE";

    const GET_VENDAS_DIARIAS = "
    SELECT SUM(TOTALDIA) AS TOTALDIA, SUM(QTO) AS QTO, SUM(QTC) AS QTC FROM (
        SELECT SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS TOTALDIA, 0 AS QTO, 0 AS QTC
        FROM ITEMVENDA I
        JOIN VENDA V
            ON I.CDFILIAL = V.CDFILIAL
            AND I.CDCAIXA = V.CDCAIXA
            AND I.NRSEQVENDA = V.NRSEQVENDA
        WHERE I.CDFILIAL = :CDFILIAL
            AND V.DTENTRVENDA = :DTENTRVENDA
            AND V.IDSITUVENDA = 'O'

        UNION

        SELECT 0, 0, COUNT(V.NRSEQVENDA) AS QTC
        FROM VENDA V
        WHERE V.DTENTRVENDA = :DTENTRVENDA
            AND V.CDFILIAL = :CDFILIAL
            AND V.IDSITUVENDA = 'C'

        UNION

        SELECT 0, COUNT(V.NRSEQVENDA) AS QTO, 0 AS QTC
        FROM VENDA V
        WHERE V.DTENTRVENDA = :DTENTRVENDA
            AND V.CDFILIAL = :CDFILIAL
            AND V.IDSITUVENDA = 'O')
    ";

    const GET_PRODUTOS_MAIS_VENDIDOS = "
    SELECT * FROM (SELECT
      P.NMPRODUTO,COUNT(*) as QTD_VENDIDA
    FROM ITEMVENDA I
    JOIN VENDA V
    ON I.CDFILIAL    = V.CDFILIAL
    AND I.CDCAIXA    = V.CDCAIXA
    AND I.NRORG      = V.NRORG
    AND I.NRSEQVENDA = V.NRSEQVENDA
    JOIN PRODUTO P
    ON I.CDPRODUTO      = P.CDPRODUTO
    AND I.NRORG         = P.NRORG
    WHERE V.DTENTRVENDA = :DTENTRVENDA
    AND I.CDFILIAL      = :CDFILIAL
    AND I.NRORG         = :NRORG
    GROUP BY I.CDPRODUTO,
      P.NMPRODUTO
    ORDER BY 2 DESC) WHERE ROWNUM <= 5
    ";

    const EXPORT_OBJETIVO_WITHOUT_OVERWRITE = "
      MERGE INTO OBJVENDAMES A USING
      (SELECT :CDFILIAL AS CDFILIAL,
              :CDOBJMES AS CDOBJMES,
              :CDOBJANO AS CDOBJANO,
              :VROBJREALMES AS VROBJREALMES,
              :VROBJDESAFIOMES AS VROBJDESAFIOMES,
              :VRTICKETMES AS VRTICKETMES,
              :NRORG AS NRORG,
              SYSDATE AS DTULTATU,
              :CDOPERADOR AS CDOPERULTATU,
              :NRORG AS NRORGULTATU,
              :CDOPERADOR AS CDOPERINCLUSAO,
              :NRORG AS NRORGINCLUSAO,
              SYSDATE AS DTINCLUSAO
       FROM DUAL) B ON (A.CDFILIAL = B.CDFILIAL
                        AND A.CDOBJMES = B.CDOBJMES
                        AND A.CDOBJANO = B.CDOBJANO
                        AND A.NRORG = B.NRORG) WHEN NOT MATCHED THEN
        INSERT (CDFILIAL,
                CDOBJMES,
                CDOBJANO,
                VROBJREALMES,
                VROBJDESAFIOMES,
                VRTICKETMES,
                NRORG,
                DTULTATU,
                CDOPERULTATU,
                NRORGULTATU,
                CDOPERINCLUSAO,
                NRORGINCLUSAO,
                DTINCLUSAO)
        VALUES (B.CDFILIAL,
                B.CDOBJMES,
                B.CDOBJANO,
                B.VROBJREALMES,
                B.VROBJDESAFIOMES,
                B.VRTICKETMES,
                B.NRORG,
                B.DTINCLUSAO,
                B.CDOPERINCLUSAO,
                B.NRORGINCLUSAO,
                B.CDOPERULTATU,
                B.NRORGULTATU,
                B.DTULTATU)
    ";

    const EXPORT_OBJETIVODIA_WITHOUT_OVERWRITE = "
      MERGE INTO OBJVENDADIA A USING
        (SELECT :CDFILIAL AS CDFILIAL,
                :CDOBJMES AS CDOBJMES,
                :CDOBJANO AS CDOBJANO,
                :NRDIASEMANA AS NRDIASEMANA,
                VROBJREALDIA AS VROBJREALDIA,
                VROBJDESAFIODIA AS VROBJDESAFIODIA,
                VRTICKETDIA AS VRTICKETDIA,
                NRORG AS NRORG
         FROM OBJVENDADIA
         WHERE CDFILIAL = :CDFILIAL_ORIGEM
           AND NRORG = :NRORG
           AND CDOBJANO = :CDOBJANO_ORIGEM
           AND CDOBJMES = :CDOBJMES_ORIGEM
           AND NRDIASEMANA = :NRDIASEMANA) B ON (A.CDFILIAL = B.CDFILIAL
                                                 AND A.CDOBJMES = B.CDOBJMES
                                                 AND A.CDOBJANO = B.CDOBJANO
                                                 AND A.NRORG = B.NRORG) WHEN NOT MATCHED THEN
      INSERT (CDFILIAL,
              CDOBJMES,
              CDOBJANO,
              NRDIASEMANA,
              VROBJREALDIA,
              VROBJDESAFIODIA,
              VRTICKETDIA,
              NRORG)
      VALUES (B.CDFILIAL,
              B.CDOBJMES,
              B.CDOBJANO,
              B.NRDIASEMANA,
              B.VROBJREALDIA,
              B.VROBJDESAFIODIA,
              B.VRTICKETDIA,
              B.NRORG)
    ";

    const EXPORT_OVERWRITE_OBJETIVOMES = "
      MERGE INTO OBJVENDAMES A USING
        (SELECT :CDFILIAL AS CDFILIAL,
                :CDOBJMES AS CDOBJMES,
                :CDOBJANO AS CDOBJANO,
                :VROBJREALMES AS VROBJREALMES,
                :VROBJDESAFIOMES AS VROBJDESAFIOMES,
                :VRTICKETMES AS VRTICKETMES,
                :NRORG AS NRORG,
                SYSDATE AS DTULTATU,
                TO_CHAR(:CDOPERADOR) AS CDOPERULTATU,
                :NRORG AS NRORGULTATU,
                TO_CHAR(:CDOPERADOR) AS CDOPERINCLUSAO,
                :NRORG AS NRORGINCLUSAO,
                SYSDATE AS DTINCLUSAO
         FROM DUAL) B ON (A.CDFILIAL = B.CDFILIAL
                          AND A.CDOBJMES = B.CDOBJMES
                          AND A.CDOBJANO = B.CDOBJANO
                          AND A.NRORG = B.NRORG) WHEN MATCHED THEN
      UPDATE
      SET A.VROBJREALMES = B.VROBJREALMES,
          A.VROBJDESAFIOMES = B.VROBJDESAFIOMES,
          A.VRTICKETMES = B.VRTICKETMES,
          A.DTULTATU = B.DTULTATU,
          A.CDOPERULTATU = B.CDOPERULTATU,
          A.NRORGULTATU = B.NRORGULTATU WHEN NOT MATCHED THEN
      INSERT ( CDFILIAL,
               CDOBJMES,
               CDOBJANO,
               VROBJREALMES,
               VROBJDESAFIOMES,
               VRTICKETMES,
               NRORG,
               DTULTATU,
               CDOPERULTATU,
               NRORGULTATU,
               CDOPERINCLUSAO,
               NRORGINCLUSAO,
               DTINCLUSAO )
      VALUES ( B.CDFILIAL,
               B.CDOBJMES,
               B.CDOBJANO,
               B.VROBJREALMES,
               B.VROBJDESAFIOMES,
               B.VRTICKETMES,
               B.NRORG,
               B.DTINCLUSAO,
               B.CDOPERINCLUSAO,
               B.NRORGINCLUSAO,
               B.CDOPERULTATU,
               B.NRORGULTATU,
               B.DTULTATU )";

    const EXPORT_OVERWRITE_OBJETIVODIA = "
     MERGE INTO OBJVENDADIA A USING
      (SELECT :CDFILIAL AS CDFILIAL,
        :CDOBJMES       AS CDOBJMES,
        :CDOBJANO       AS CDOBJANO,
        :NRDIASEMANA    AS NRDIASEMANA,
        VROBJREALDIA    AS VROBJREALDIA,
        VROBJDESAFIODIA AS VROBJDESAFIODIA,
        VRTICKETDIA     AS VRTICKETDIA,
        NRORG           AS NRORG
      FROM OBJVENDADIA
      WHERE CDFILIAL     = :CDFILIAL_ORIGEM
      AND NRORG          = :NRORG
      AND CDOBJANO       = :CDOBJANO_ORIGEM
      AND CDOBJMES       = :CDOBJMES_ORIGEM
      AND NRDIASEMANA    = :NRDIASEMANA
      ) B ON (A.CDFILIAL = B.CDFILIAL AND A.CDOBJMES = B.CDOBJMES AND A.CDOBJANO = B.CDOBJANO AND A.NRDIASEMANA = B.NRDIASEMANA AND A.NRORG = B.NRORG)
    WHEN MATCHED THEN
      UPDATE
      SET VROBJREALDIA  = B.VROBJREALDIA,
        VROBJDESAFIODIA = B.VROBJDESAFIODIA,
        VRTICKETDIA     = B.VRTICKETDIA
        WHEN NOT MATCHED THEN
      INSERT
        (
          CDFILIAL,
          CDOBJMES,
          CDOBJANO,
          NRDIASEMANA,
          VROBJREALDIA,
          VROBJDESAFIODIA,
          VRTICKETDIA,
          NRORG
        )
        VALUES
        (
          B.CDFILIAL,
          B.CDOBJMES,
          B.CDOBJANO,
          B.NRDIASEMANA,
          B.VROBJREALDIA,
          B.VROBJDESAFIODIA,
          B.VRTICKETDIA,
          B.NRORG
        )
    ";

    const CHECK_CODIGO_CONSUMIDOR = "
    SELECT CDCONSUMIDOR,IDATIVO,CDCLIENTE FROM CONSUMIDOR
      WHERE CDCONSUMIDOR = :CDCONSUMIDOR AND
            NRORG = :NRORG AND CDCLIENTE = :CDCLIENTE
    ";

    const GET_PRODOCOR_SEQ = "
        SELECT (O1.CDOCORR + 1) AS CDOCORR
        FROM OCORRENCIA O1
        WHERE NOT EXISTS (SELECT O2.CDOCORR FROM OCORRENCIA O2 WHERE O2.CDOCORR = O1.CDOCORR + 1 AND O2.CDGRPOCOR = :CDGRPOCOR)
        AND O1.CDGRPOCOR = :CDGRPOCOR
        AND O1.CDOCORR < '99'
    ";

    const BUSCA_NOME_FILIAL ="
        SELECT CDFILIAL, CDFILIAL || ' - '|| NMFILIAL AS NMFILIAL
           FROM FILIAL
         WHERE CDFILIAL = :P_CDFILIAL
    ";


  const ADQTOTAISPROD = "
  SELECT
     VE.CDEMPRESA, VE.CDFILIAL,
     COUNT(DISTINCT VE.CDFILIAL||VE.CDCAIXA||VE.NRSEQVENDA) AS G
  FROM
     VENDA VE, ITEMVENDA IV
  WHERE (VE.CDFILIAL   = IV.CDFILIAL )
   AND  (VE.CDCAIXA    = IV.CDCAIXA  )
   AND  (VE.NRSEQVENDA = IV.NRSEQVENDA)
   AND  (VE.CDEMPRESA  = :P_CDEMPRESA)
   AND  (:P_CDFILIAL   = VE.CDFILIAL )
   AND  (VE.IDSITUVENDA = 'O'       )
   AND  ((INSTR(:P_CDCAIXA , VE.CDCAIXA ) <> 0) OR (:P_TCDCAIXA  = 'T'))
   AND  ((INSTR(:P_CDLOJA  , VE.CDLOJA  ) <> 0) OR (:P_TCDLOJA   = 'T'))
   AND  ((INSTR(:P_CDSUBGRPROD, IV.CDSUBGRPROD) > 0) OR (:P_TCDSUBGRPROD = 'T'))
   AND  (VE.DTENTRVENDA BETWEEN :P_DTVENDAINI AND :P_DTVENDAFIN)
  GROUP BY
     VE.CDEMPRESA, VE.CDFILIAL
  ";

  const ADQREDUCAOZ =
  "
  SELECT
   SUM(NRVENDA) AS NRCUPONS
  FROM
     (SELECT
        (R.NRULTCFREDZ - R.NRPRIMCFREDZ) AS NRVENDA
     FROM
        REDUCAOZ R, CAIXA C
     WHERE
        (R.CDFILIAL   = C.CDFILIAL ) AND
        (R.CDCAIXA    = C.CDCAIXA  ) AND
        (R.CDFILIAL   = :P_CDFILIAL) AND
        ((INSTR(:P_CDCAIXA , R.CDCAIXA ) <> 0) OR (:P_TCDCAIXA  = 'T')) AND
        ((INSTR(:P_CDLOJA  , C.CDLOJA  ) <> 0) OR (:P_TCDLOJA   = 'T')) AND
        (R.DTREDUCAOZ BETWEEN :P_DTVENDAINI AND :P_DTVENDAFIN) ) A
  ";

  const ADQFRETE =
  "
  SELECT
   SUM(NVL(VRREALNESTO,0)) VRFRETE
  FROM
   CUSTNESTO A, PRODUTO P
  WHERE
   (A.CDFILIAL  = :P_CDFILIAL) AND
   (A.DTCUSTNESTO BETWEEN '01/'||:P_DATAINI AND LAST_DAY(:P_DATAFIM))  AND
   (SUBSTR(P.CDARVPROD,1,1) = 'F') AND
   (P.CDPRODUTO = A.CDPRODUTO)
  ";

  const GET_PERIODO_CONT = "
  SELECT NVL(IDCONSVNDDFS, 'N') IDCONSVNDDFS, DTINIINTCONTDFS AS DTINICIALDFS, DTFININTCONTDFS AS DTFINALDFS
    FROM FILIAL F LEFT JOIN CONTOPECTBL C
    ON C.NRORG = F.NRORG
    AND C.CDEMPRESA = F.CDEMPRESA
    WHERE F.CDFILIAL = :CDFILIAL
    AND F.NRORG = :NRORG
  ";

    const INSERT_TABEPREC = "
    INSERT INTO TABEPREC
        (CDFILIAL,CDTABEPREC,NMTABEPREC,IDATIVO,CDOPERULTATU,DTULTATU,
      NRORGULTATU,CDOPERINCLUSAO,DTINCLUSAO,NRORG,NRORGINCLUSAO)
    VALUES
      (:CDFILIAL,:CDTABEPREC,:NMTABEPREC,:IDATIVO,:CDOPERULTATU,:DTULTATU,
      :NRORGULTATU,:CDOPERINCLUSAO,:DTINCLUSAO,:NRORG,:NRORGINCLUSAO)
  ";

  const DELETE_TABEVEND = "
    DELETE FROM TABEVEND
     WHERE CDFILIAL       = :CDFILIAL
       AND DTINIVGPREC  = :DTINIVGPREC
       AND CDTABEPREC     = :CDTABEPREC
       AND NRORG          = :NRORG
  ";

    const ADQTBPRECCLIENFILI = "
    SELECT
    CDTABEPREC,
    CDCFILTABPRE
  FROM
    CLIENFILIAL
  WHERE
    CDCLIENTE = :P_CDCLIENTE  AND CDFILIAL = :P_CDFILIAL";

  const ADQTABEPRECCLIE = "
  SELECT
     CDFILTABPREC,
     CDTABEPREC
  FROM
     CLIENTE
  WHERE
     (CDCLIENTE = :P_CDCLIENTE)
  ";

  const ADQTABEPRECLOJA = "
  SELECT
    CDTABEPREC
  FROM
    LOJA
  WHERE
    (CDFILIAL = :P_CDFILIAL) AND
    (CDLOJA   = :P_CDLOJA  )
  ";

  const ADQPARAVEND = "
  SELECT
    CDTABEPREC, IDPRECDIFCOM
  FROM
    PARAVEND
  WHERE
    (CDFILIAL = :P_CDFILIAL)
  ";

  const ADQTABEVEND = "
  SELECT
    DTINIVGPREC
  FROM
    TABEVEND
  WHERE
    (CDFILIAL   = :P_CDFILIAL  ) AND
    (CDTABEPREC = :P_CDTABEPREC) AND
    (:P_DATA   BETWEEN DTINIVGPREC AND DTFINVGPREC)
  ";

  const ADQITEMPRECO = "
  SELECT
    NVL(VRPRECITEM,0) AS PRECO, NVL(VRPRECITEMCL,0) AS PRECOCLIE,
    NVL(VRPRESUGITEM,0) AS PRECOSUGER, IDPRECVARIA
  FROM
    ITEMPRECO
  WHERE
    (CDFILIAL    = :P_CDFILIAL   ) AND
    (CDTABEPREC  = :P_CDTABEPREC ) AND
    (DTINIVGPREC = :P_DTINIVGPREC) AND
    (CDPRODUTO   = :P_CDPRODUTO  )
  ";

  const GET_PARAMS_VENDA_GERAL = "
  SELECT P.CDPARGERAL, P.IDCADPRODCMP, P.DSEMAISACVND, P.DSEMAILAUVND,
       P.CDSENHAUTVND, P.DSSMTPAUTVND, P.DSPREVCONSPDV, P.DSDIRSALVCAT,
       P.IDUTTABPRECLVDC, P.TXHELPNFPSITE, P.TXHELPREFEXSITE, P.NRPORTAAUTVND,
       P.DSDIRDESTARQTC, P.IDBLOQSEMIMP, P.CDVENDEDORDLV, V.NMRAZSOCVEN,
       P.IDEXCONSATGER, P.IDVALIDAATEN, P.CDLOJAESITEF, P.DSDIRARQXMLNFCE
    FROM
       PARAMGERAL P, VENDEDOR V
    WHERE
       (P.CDVENDEDORDLV = V.CDVENDEDOR(+))
   ";

   const UPDATE_PARAMS_VENDA_GERAL = "
      UPDATE PARAMGERAL
        SET
          IDCADPRODCMP    = :IDCADPRODCMP,
          DSPREVCONSPDV   = :DSPREVCONSPDV,
          DSDIRSALVCAT    = :DSDIRSALVCAT,
          DSDIRDESTARQTC  = :DSDIRDESTARQTC,
          IDUTTABPRECLVDC = :IDUTTABPRECLVDC,
          IDBLOQSEMIMP    = :IDBLOQSEMIMP,
          IDEXCONSATGER   = :IDEXCONSATGER,
          DSDIRARQXMLNFCE = :DSDIRARQXMLNFCE
  ";

    const REL_TOTAL_VENDAS_NIVEL_PROD = "
    SELECT PR.NRORG,      PR.CDARVPROD,       PR.NMPRODUTO,
      SUM(TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))) - NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0),2)) AS VALOR,
      FI.NMFILIAL,      PR.SGUNIDADE,      VE.CDFILIAL      || ' - '      || FI.NMFILIAL      || ' - '      || ' Período: '      || :DTVENDAINI      || ' a '      || :DTVENDAFIN      AS CDFILIAL,
      SUM(IT.VRACRITVEND) AS ACRESCIMO,      SUM(IT.QTPRODVEND)  AS QTDE,      PR.CDNVPRODUTO
    FROM PRODUTO PR,      PRODUTO PP,      VENDA VE,      ITEMVENDA IT,      FILIAL FI
    WHERE ( VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN )
    AND ( VE.IDSITUVENDA                    = 'O' )
    AND ( ( INSTR(:CDFILIAL , VE.CDFILIAL ) <> 0 )
    OR( :TCDFILIAL                          = 'T' ) )
    AND ( ( INSTR(:CDCAIXA , VE.CDFILIAL      ||VE.CDCAIXA) <> 0 )    OR( :TCDCAIXA    = 'T' ) )
    AND ( ( INSTR(:CDCLIENTE, VE.CDFILIAL      ||VE.CDCLIENTE ) <> 0 )    OR( :TCDCLIENTE     = 'T' ) )
    AND ( ( INSTR(:CDCONSUMIDOR , '_'      ||VE.CDCLIENTE      ||VE.CDCONSUMIDOR      ||'_')                                   <> 0 )    OR( :TCDCONSUMIDOR                          = 'T' ) )
    AND ( ( INSTR( :CDVENDEDOR , VE.CDVENDEDOR ) <> 0 )    OR( :TCDVENDEDOR                            = 'T' ) )
    AND ( ( :TCDPRODUTO                         = 'T' )    OR ( PR.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM ) )
    AND ( VE.CDFILIAL   = IT.CDFILIAL )
    AND ( VE.CDCAIXA    = IT.CDCAIXA )
    AND ( VE.NRSEQVENDA = IT.NRSEQVENDA )
    AND ( VE.CDFILIAL   = FI.CDFILIAL )
    AND ( PP.CDPRODUTO  = IT.CDPRODUTO )
    AND ( PR.CDARVPROD  = SUBSTR(PP.CDARVPROD,1, :CDNVPRODUTO ) )
    AND PR.NRORG        =  :NRORG
    AND VE.NRORG        = PR.NRORG
    AND FI.NRORG        = PR.NRORG
    AND PP.NRORG        = PR.NRORG
    AND IT.NRORG        = PR.NRORG
    GROUP BY PR.NRORG,      VE.CDFILIAL,      PR.CDARVPROD,      PR.SGUNIDADE,      PR.NMPRODUTO,      FI.NMFILIAL,      PR.CDNVPRODUTO
    ORDER BY VE.CDFILIAL,
      PR.CDARVPROD" ;

  const SELECT_CAIXA = "
  SELECT CDTECLADO,       IDSELLOJTOT,    CDGRUPPROD,         IDTIPOCAIXA,          CDTIPOOPER,           DSSTRINGCON,        IDUTILTEF,
   IDUTILCHEQ,       CDLOJATEF,           CDTERTEF,           DSENDIPSITEF,         IDINFCLIECAI,         IDTPTELAVE,         NRCONFTELA,           CDFILICONFTE,
   TPEXTFOTOPR,      IDVERIFCOTA,         VRABERCAIX,         IDAUTOIMPTAB,         IDCOLETOR,            DSCAIXAVEN,         DSCAIXATAB,           IDEMIRECSANG,
   IDEMIRELPROD,     IDTRIBRELPRO,        IDIMPREDZ,          IDAUTOIMPVEN,         IDDIGCODPLM,          CDPORTAIMPFI,       IDTPVENDIMPNF1,       IDTPVENDIMPNF2,
   IDGERADEBUG,      CDPORTABAL,          IDTIPOBAL,          NRVELOCBAL,           IDTIPOGAVETA,         IDTIPODISP,         CDPORTADISP,          IDBLOQIDCART,
   IDTIPOPROX,       CDPORTAPROX,         NRVELOCPROX,        IDINFVENBAL,          IDIMPBARRCUP,         NMPADBARRCUP,       IDIMPLEITURAX,        IDSOLNUMDEPFC,
   IDSOLICITACPF,    IDBAIXAPERIF,        IDGRAVAMFD,         IDINFREDZNCAD,        IDTIPOMICROTERM,      IDTIPINFCONS,       IDPAISINTEGRA,        CDPREFINTGCOL,
   NRCUPINIINTGCOL,  NRCUPFININTGCOL,     DSRESOLINTGCOL,     IDPERCOMVENCPDC,      IDIMPVENDCON,         DSMENSCPFCUP,       IDLCDBARBALATOL,      NRPOSINICODBARR,
   NRPOSFINCODBARR,  NRPOSINIQTCDBAR,     NRPOSFINQTCDBAR,    NRPOSINIVRCDBAR,      NRPOSFINVRCDBAR,      IDIMPCOMPDEBCON,    IDIMPCOMPCREDPE,      IDIMPCOMPCUPVEN,
   IDGERAARQVNDRIO,  IDPERABERCOMCXA,     IDTPCONTRREPIQ,     NRDIASVENDAMSDE,      IDFREQLIMPVENDA,      NRDIASBXVNDMSDE,    IDUTILBINADEL,        IDPALFUTRABRCXA,
   IDSOLCONICNFIS,   IDSOLDIGOBSDC,       IDSOLDIGCONS,       IDSOLTPSANGRIACX,     IDGERALOGFOS,         VRPEMAXREPIQVND,    IDIMPCOMPVCP,         DSGRANCONTRIB,
   IDUTILFECHCEGO,   NRSEQIMPRLOJA1,      NRSEQIMPRLOJA2,     IDSINCCAIXADLV,       IDGERBKPMSDE,         IDIMPPEDPROD,       IDTPVENDIMPNF3,       NRSEQIMPRLOJA3,
   DSOBSCUPFIS,      IDPERMCANCVND,       DSAUTORETENT,       IDSENHACUP,           NRSEQIMPRLOJA4
  FROM CAIXA
  WHERE CDFILIAL = :CDFILIAL
    AND CDCAIXA  = :CDCAIXA
    AND CDLOJA   = :CDLOJA
    AND NRORG    = :NRORG
  ";

  const EXPORT_PARATRIZACAO = "
    UPDATE
       CAIXA
    SET
       CDTECLADO        = :CDTECLADO,             IDSELLOJTOT      = :IDSELLOJTOT,        CDGRUPPROD       = :CDGRUPPROD,
       IDTIPOCAIXA      = :IDTIPOCAIXA,           CDTIPOOPER       = :CDTIPOOPER,         DSSTRINGCON      = :DSSTRINGCON,
       IDUTILTEF        = :IDUTILTEF,             IDUTILCHEQ       = :IDUTILCHEQ,         CDLOJATEF        = :CDLOJATEF,
       CDTERTEF         = :CDTERTEF,              DSENDIPSITEF     = :DSENDIPSITEF,       IDINFCLIECAI     = :IDINFCLIECAI,
       IDTPTELAVE       = :IDTPTELAVE,            NRCONFTELA       = :NRCONFTELA,         CDFILICONFTE     = :CDFILICONFTE,
       TPEXTFOTOPR      = :TPEXTFOTOPR,           IDVERIFCOTA      = :IDVERIFCOTA,        VRABERCAIX       = :VRABERCAIX,
       IDAUTOIMPTAB     = :IDAUTOIMPTAB,          IDCOLETOR        = :IDCOLETOR,          DSCAIXAVEN       = :DSCAIXAVEN,
       DSCAIXATAB       = :DSCAIXATAB,            IDEMIRECSANG     = :IDEMIRECSANG,       IDEMIRELPROD     = :IDEMIRELPROD,
       IDTRIBRELPRO     = :IDTRIBRELPRO,          IDIMPREDZ        = :IDIMPREDZ,          IDAUTOIMPVEN     = :IDAUTOIMPVEN,
       IDDIGCODPLM      = :IDDIGCODPLM,           CDPORTAIMPFI     = :CDPORTAIMPFI,       IDTPVENDIMPNF1   = :IDTPVENDIMPNF1,
       IDTPVENDIMPNF2   = :IDTPVENDIMPNF2,        IDGERADEBUG      = :IDGERADEBUG,        CDPORTABAL       = :CDPORTABAL,
       IDTIPOBAL        = :IDTIPOBAL,             NRVELOCBAL       = :NRVELOCBAL,         IDTIPOGAVETA     = :IDTIPOGAVETA,
       IDTIPODISP       = :IDTIPODISP,            CDPORTADISP      = :CDPORTADISP,        IDBLOQIDCART     = :IDBLOQIDCART,
       DSOBSCUPFIS      = :DSOBSCUPFIS,           IDTIPOPROX       = :IDTIPOPROX,         CDPORTAPROX      = :CDPORTAPROX,
       NRVELOCPROX      = :NRVELOCPROX,           IDINFVENBAL      = :IDINFVENBAL,        IDIMPBARRCUP     = :IDIMPBARRCUP,
       NMPADBARRCUP     = :NMPADBARRCUP,          IDIMPLEITURAX    = :IDIMPLEITURAX,      IDSOLNUMDEPFC    = :IDSOLNUMDEPFC,
       IDPERMCANCVND    = :IDPERMCANCVND,         IDSOLICITACPF    = :IDSOLICITACPF,      IDBAIXAPERIF     = :IDBAIXAPERIF,
       IDGRAVAMFD       = :IDGRAVAMFD,            IDINFREDZNCAD    = :IDINFREDZNCAD,      IDTIPOMICROTERM  = :IDTIPOMICROTERM,
       IDTIPINFCONS     = :IDTIPINFCONS,          IDPAISINTEGRA    = :IDPAISINTEGRA,      CDPREFINTGCOL    = :CDPREFINTGCOL,
       NRCUPINIINTGCOL  = :NRCUPINIINTGCOL,       NRCUPFININTGCOL  = :NRCUPFININTGCOL,    DSRESOLINTGCOL   = :DSRESOLINTGCOL,
       IDPERCOMVENCPDC  = :IDPERCOMVENCPDC,       IDIMPVENDCON     = :IDIMPVENDCON,       DSMENSCPFCUP     = :DSMENSCPFCUP,
       IDLCDBARBALATOL  = :IDLCDBARBALATOL,       NRPOSINICODBARR  = :NRPOSINICODBARR,    NRPOSFINCODBARR  = :NRPOSFINCODBARR,
       NRPOSINIQTCDBAR  = :NRPOSINIQTCDBAR,       NRPOSFINQTCDBAR  = :NRPOSFINQTCDBAR,    NRPOSINIVRCDBAR  = :NRPOSINIVRCDBAR,
       NRPOSFINVRCDBAR  = :NRPOSFINVRCDBAR,       IDIMPCOMPDEBCON  = :IDIMPCOMPDEBCON,    IDIMPCOMPCREDPE  = :IDIMPCOMPCREDPE,
       IDIMPCOMPCUPVEN  = :IDIMPCOMPCUPVEN,       IDGERAARQVNDRIO  = :IDGERAARQVNDRIO,    IDPERABERCOMCXA  = :IDPERABERCOMCXA,
       IDTPCONTRREPIQ   = :IDTPCONTRREPIQ ,       NRDIASVENDAMSDE  = :NRDIASVENDAMSDE,    IDFREQLIMPVENDA  = :IDFREQLIMPVENDA,
       NRDIASBXVNDMSDE  = :NRDIASBXVNDMSDE,       IDUTILBINADEL    = :IDUTILBINADEL,      IDPALFUTRABRCXA  = :IDPALFUTRABRCXA,
       IDSOLCONICNFIS   = :IDSOLCONICNFIS,        IDSOLDIGOBSDC    = :IDSOLDIGOBSDC,      IDSOLDIGCONS     = :IDSOLDIGCONS,
       IDSOLTPSANGRIACX = :IDSOLTPSANGRIACX,      IDGERALOGFOS     = :IDGERALOGFOS,       VRPEMAXREPIQVND  = :VRPEMAXREPIQVND,
       IDIMPCOMPVCP     = :IDIMPCOMPVCP,          DSGRANCONTRIB    = :DSGRANCONTRIB,      DSAUTORETENT     = :DSAUTORETENT,
       IDUTILFECHCEGO   = :IDUTILFECHCEGO,        NRSEQIMPRLOJA1   = :NRSEQIMPRLOJA1,     NRSEQIMPRLOJA2   = :NRSEQIMPRLOJA2,
       IDSINCCAIXADLV   = :IDSINCCAIXADLV,        IDGERBKPMSDE     = :IDGERBKPMSDE,       IDIMPPEDPROD     = :IDIMPPEDPROD,
       IDTPVENDIMPNF3   = :IDTPVENDIMPNF3,        NRSEQIMPRLOJA3   = :NRSEQIMPRLOJA3,     IDSENHACUP       = :IDSENHACUP,
       NRSEQIMPRLOJA4   = :NRSEQIMPRLOJA4
    WHERE
       CDFILIAL     = :OLD_CDFILIAL
       AND CDCAIXA  = :OLD_CDCAIXA
       AND CDLOJA   = :OLD_CDLOJA
       AND NRORG    = :NRORG
  ";

    const GET_PARAMS_GERAL_FISCAL = "
    SELECT
      CDPARFISCAL, DSDIRARQMAG, IDREPPARAMFOS
    FROM
      PARAMFISCAL
    ";

    const UPDATE_PARAMS_GERAL_FISCAL = "
      UPDATE PARAMFISCAL
        SET
          DSDIRARQMAG    = :DSDIRARQMAG,
          IDREPPARAMFOS  = :IDREPPARAMFOS
    ";

    const GET_PARAMS_GERAL_INT_DELIVERY = "
    SELECT
       P.CDVENDEDORDLV, V.NMRAZSOCVEN, P.CDLOJAESITEF, P.IDVALIDAATEN
    FROM
       PARAMGERAL P, VENDEDOR V
    WHERE
       (P.CDVENDEDORDLV = V.CDVENDEDOR(+))
   ";

   const UPDATE_PARAMS_GERAL_INT_DELIVERY = "
      UPDATE PARAMGERAL
        SET CDVENDEDORDLV = :CDVENDEDORDLV,
            CDLOJAESITEF  = :CDLOJAESITEF,
            IDVALIDAATEN  = :IDVALIDAATEN
        WHERE NRORG = :NRORG
    ";

   const GET_VENDEDOR = "
    SELECT
        CDVENDEDOR, NMRAZSOCVEN
    FROM VENDEDOR
     ORDER BY
        CDVENDEDOR
   ";

  const GET_CDPICTPROD = "
    SELECT
      CDPICTPROD
        FROM PARAMGERAL
        WHERE NRORG = :NRORG
  ";

  const GET_PARAMS_EXPORT_IMPORT = "
    SELECT
      DSCAIXAVEN, DSCAIXATAB
    FROM
      CAIXA
    WHERE
      CDFILIAL = :CDFILIAL AND
      CDCAIXA = :CDCAIXA AND
      NRORG  = :NRORG
  ";
  const UPDATE_PARAMS_EXPORT = "
    UPDATE CAIXA
     SET
      DSCAIXAVEN = :DSCAIXAVEN
    WHERE
      CDFILIAL = :CDFILIAL AND
      CDCAIXA = :CDCAIXA AND
      NRORG = :NRORG
  ";

  const UPDATE_PARAMS_IMPORT = "
    UPDATE CAIXA
     SET
      DSCAIXATAB = :DSCAIXATAB
    WHERE
      CDFILIAL = :CDFILIAL AND
      CDCAIXA = :CDCAIXA AND
      NRORG = :NRORG
  ";

  const CAIXA_BASICO = "
   SELECT CDCAIXA,CDFILIAL,NMCAIXA
   FROM CAIXA
   WHERE (INSTR( :CDCAIXA, CDCAIXA) <> 0) AND
   CDFILIAL = :CDFILIAL AND
   NRORG = :NRORG
  ";

  const CAIXA_IMPORTACAO = "
  SELECT C.CDCAIXA, C.NMCAIXA, L.CDLOJA, L.NMLOJA
  FROM CAIXA C
  JOIN LOJA L
  ON C.CDLOJA = L.CDLOJA
  AND C.CDFILIAL = L.CDFILIAL
  JOIN(SELECT CDFILIAL, DSCAIXATAB, CDLOJA
  FROM CAIXA
  WHERE CDFILIAL = :CDFILIAL
  AND CDLOJA = :CDLOJA
  AND CDCAIXA = :CDCAIXA) IMPORTACAO
  ON C.CDFILIAL = IMPORTACAO.CDFILIAL
  AND L.CDLOJA = IMPORTACAO.CDLOJA
  AND (INSTR(IMPORTACAO.DSCAIXATAB, C.CDCAIXA) = 0 OR IMPORTACAO.DSCAIXATAB IS NULL)
  ";

  const UPDATE_PARAGERAIS_PRODUTO = "
      UPDATE PRODUTO
        SET
          IDPESAPROD      = :IDPESAPROD,
          QTTARAPROD      = :QTTARAPROD,
          CDBARPRODUTO    = :CDBARPRODUTO,
          NMPRODIMPFIS    = :NMPRODIMPFIS,
          IDCOBTXSERV     = :IDCOBTXSERV,
          IDTIPOPROD      = :IDTIPOPROD,
          CDPROTECLADO    = :CDPROTECLADO,
          IDIMPPRODUTO    = :IDIMPPRODUTO,
          IDIMPRODUVEZ    = :IDIMPRODUVEZ,
          IDSOLLOCIMP     = :IDSOLLOCIMP,
          DSDADOSFORNVND  = :DSDADOSFORNVND,
          QTDIAVALPRODVND = :QTDIAVALPRODVND,
          DSINFADIPRODVND = :DSINFADIPRODVND,
          QTPORCAOVND     = :QTPORCAOVND,
          IDUNPORCAOVND   = :IDUNPORCAOVND,
          IDPADEMEDCASVND = :IDPADEMEDCASVND,
          IDTIPOMEDCASVND = :IDTIPOMEDCASVND,
          QTMEDCASVND     = :QTMEDCASVND,
          IDORIGPRODPR    = :IDORIGPRODPR
       WHERE
          CDPRODUTO = :CDPRODUTO AND
          NRORG     = :NRORG
    ";

    const DELETE_BLOCKED_CARD = "
        DELETE FROM CARTAOBLOQ
         WHERE NRSEQCARTAOBLOQ = :NRSEQCARTAOBLOQ
         AND NRORG = :NRORG
    ";

    const DELETE_LOJA_DIA = "
        DELETE
          FROM ATENDELOJA
         WHERE CDFILIAL        = :CDFILIAL
           AND CDLOJA          = :CDLOJA
           AND NRORG           = :NRORG
           AND NRSEQATENDELOJA = :NRSEQATENDELOJA
    ";

    const VERIFICA_LOJA_DIA = "
        SELECT NRDIAATENDELOJA
          FROM ATENDELOJA
         WHERE NRDIAATENDELOJA = :NRDIAATENDELOJA
           AND CDLOJA = :CDLOJA
           AND NRSEQATENDELOJA <> :NRSEQATENDELOJA
           AND CDFILIAL = :CDFILIAL
           AND IDTPATENDELOJA = :IDTPATENDELOJA
           AND NRORG = :NRORG
           AND (((:HRINIATENDELOJA >= HRINIATENDELOJA) AND (:HRINIATENDELOJA <= HRFIMATENDELOJA))
            OR ((:HRFIMATENDELOJA >= HRINIATENDELOJA) AND (:HRFIMATENDELOJA <= HRFIMATENDELOJA))
            OR ((:HRINIATENDELOJA <= HRINIATENDELOJA) AND (:HRFIMATENDELOJA >= HRFIMATENDELOJA)))
    ";

    const INSERT_AREAATEND = "
        INSERT INTO AREAATEND (CDAREA, COORDAREA, NMAREA, DSAREA, NRORG,
        DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERULTATU, CDOPERINCLUSAO, NRORGULTATU)
        VALUES (:CDAREA, :COORDAREA, :NMAREA, :DSAREA, :NRORG,
        :DTINCLUSAO, :DTULTATU, :NRORGINCLUSAO, :CDOPERULTATU, :CDOPERINCLUSAO, :NRORGULTATU)
    ";

    const UPDATE_AREAATEND = "
        UPDATE AREAATEND
        SET COORDAREA = :COORDAREA,
            NMAREA = :NMAREA,
            DSAREA = :DSAREA,
            DTULTATU = :DTULTATU,
            CDOPERULTATU = :CDOPERULTATU,
            NRORGULTATU = :NRORGULTATU
        WHERE CDAREA = :CDAREA AND NRORG = :NRORG
    ";

    const DELETE_POLYGON = "
        DELETE FROM AREAATEND
         WHERE CDAREA = :CDAREA
         AND NRORG = :NRORG
    ";

    const DELETE_FILIAL_SERVICE_AREA = "
        DELETE FROM FILIALAREA
        WHERE CDFILIAL = :CDFILIAL
          AND CDAREA = :CDAREA
          AND NRORG = :NRORG
    ";

  const GET_COD_IMPOSTO = "SELECT CDIMPOSTO FROM IMPOSTO WHERE SGIMPOSTO = :P_SGIMPOSTO";

  const INSERT_REDZ_IMPOS = "
        INSERT INTO IMPOSTOREDZ
            (DTREDUCAOZ, NRECFREDZ, CDFILIAL, CDCAIXA, NRORG,
             CDIMPOSTO, VRALIQIMPRZ, VRBCALCIMPRZ, VRIMPOSTORZ, NRSEQALIQIMPRZ)
        VALUES
            (:DTREDUCAOZ, :NRECFREDZ, :CDFILIAL, :CDCAIXA, :NRORG,
             :CDIMPOSTO, :VRALIQIMPRZ, :VRBCALCIMPRZ, :VRIMPOSTORZ, :NRSEQALIQIMPRZ)
    ";

    const INSERT_REDZ_TOT = "
        INSERT INTO TOTNFISCREDZ
            (DTREDUCAOZ, NRECFREDZ, CDFILIAL, CDCAIXA, NRORG,
             NRTOTNFISCRZ, DSTOTNFISCRZ, NRCONTOTNFIS, VRACUTOTNFIS)
        VALUES
            (:DTREDUCAOZ, :NRECFREDZ, :CDFILIAL, :CDCAIXA, :NRORG,
             :NRTOTNFISCRZ, :DSTOTNFISCRZ, :NRCONTOTNFIS, :VRACUTOTNFIS)
    ";

    const INSERT_REDZ_PAY = "
        INSERT INTO FORMPGTOREDZ
            (DTREDUCAOZ, NRECFREDZ, CDFILIAL, CDCAIXA, NRORG, CDTIPORECE, VRFORMPGTORZ, CDTPRECEORIG)
        VALUES
            (:DTREDUCAOZ, :NRECFREDZ, :CDFILIAL, :CDCAIXA, :NRORG, :CDTIPORECE, :VRFORMPGTORZ, :CDTPRECEORIG)
    ";

    const INSERT_OBS_REDZ = "
        INSERT INTO OBSERVAREDZ
            (DTREDUCAOZ, NRECFREDZ, CDFILIAL, CDCAIXA, NRORG, NRSEQOBSREDZ, DTOBSERVREDZ, DSOBSERVREDZ)
        VALUES
            (:DTREDUCAOZ, :NRECFREDZ, :CDFILIAL, :CDCAIXA, :NRORG, :NRSEQOBSREDZ, :DTOBSERVREDZ, :DSOBSERVREDZ)
    ";

    const INSERT_REDZ = "
        INSERT INTO REDUCAOZ
            (DTREDUCAOZ, NRECFREDZ, NRREINIREDZ, NRSERIEREDZ, NRREDREDZ, NRLEITREDZ, NRGERCNFREDZ, NRCANCFREDZ, NRPRIMCFREDZ,
             NRULTCFREDZ, VRGTREDZ, VRVENBRUREDZ, VRISSREDZ, VRTOTCANREDZ, VRTOTDESREDZ, VRVENLIQREDZ, VRTOTACRREDZ,
             IDORIGEMREDZ, DSMODMARCAECF, NRORG, CDFILIAL, CDCAIXA, VRSTRIBREDZ, VRISENCREDZ, VRNINCIDREDZ, QTTEMLIGREDZ, QTTEMPCFREDZ, QTMEMRESREDZ)
        VALUES
            (:DTREDUCAOZ, :NRECFREDZ, :NRREINIREDZ, :NRSERIEREDZ, :NRREDREDZ, :NRLEITREDZ, :NRGERCNFREDZ, :NRCANCFREDZ, :NRPRIMCFREDZ,
             :NRULTCFREDZ, :VRGTREDZ, :VRVENBRUREDZ, :VRISSREDZ, :VRTOTCANREDZ, :VRTOTDESREDZ, :VRVENLIQREDZ, :VRTOTACRREDZ,
             :IDORIGEMREDZ, :DSMODMARCAECF, :NRORG, :CDFILIAL, :CDCAIXA, :VRSTRIBREDZ, :VRISENCREDZ, :VRNINCIDREDZ, :QTTEMLIGREDZ, :QTTEMPCFREDZ, :QTMEMRESREDZ)
    ";

    const UPDATE_REDZ_IMPOS = "
        UPDATE IMPOSTOREDZ
           SET VRBCALCIMPRZ = :VRBCALCIMPRZ, VRIMPOSTORZ = :VRIMPOSTORZ
         WHERE CDFILIAL = :CDFILIAL AND CDCAIXA = :CDCAIXA AND NRORG = :NRORG AND DTREDUCAOZ = :DTREDUCAOZ AND NRECFREDZ = :NRECFREDZ AND CDIMPOSTO = :CDIMPOSTO AND VRALIQIMPRZ = :VRALIQIMPRZ AND NRSEQALIQIMPRZ = :NRSEQALIQIMPRZ
    ";

    const UPDATE_REDZ_TOT = "
        UPDATE TOTNFISCREDZ
           SET DSTOTNFISCRZ = :DSTOTNFISCRZ, NRCONTOTNFIS = :NRCONTOTNFIS, VRACUTOTNFIS = :VRACUTOTNFIS
         WHERE CDFILIAL = :CDFILIAL AND CDCAIXA = :CDCAIXA AND NRORG = :NRORG AND DTREDUCAOZ = :DTREDUCAOZ AND NRECFREDZ = :NRECFREDZ AND NRTOTNFISCRZ = :NRTOTNFISCRZ
    ";

    const UPDATE_REDZ_PAY = "
        UPDATE FORMPGTOREDZ
           SET VRFORMPGTORZ = :VRFORMPGTORZ, CDTPRECEORIG = :CDTPRECEORIG
         WHERE CDFILIAL = :CDFILIAL AND CDCAIXA = :CDCAIXA AND NRORG = :NRORG AND DTREDUCAOZ = :DTREDUCAOZ AND NRECFREDZ = :NRECFREDZ AND CDTIPORECE = :CDTIPORECE
    ";

    const UPDATE_REDZ = "
        UPDATE REDUCAOZ
           SET DTREDUCAOZ = :DTREDUCAOZ, NRECFREDZ = :NRECFREDZ, NRREINIREDZ = :NRREINIREDZ, NRSERIEREDZ = :NRSERIEREDZ,
               NRREDREDZ = :NRREDREDZ, NRLEITREDZ = :NRLEITREDZ, NRGERCNFREDZ = :NRGERCNFREDZ, NRCANCFREDZ = :NRCANCFREDZ,
               NRPRIMCFREDZ = :NRPRIMCFREDZ, NRULTCFREDZ = :NRULTCFREDZ, VRGTREDZ = :VRGTREDZ,
               VRVENBRUREDZ = :VRVENBRUREDZ, VRISSREDZ = :VRISSREDZ, VRTOTCANREDZ = :VRTOTCANREDZ, VRTOTDESREDZ = :VRTOTDESREDZ,
               VRVENLIQREDZ = :VRVENLIQREDZ, VRTOTACRREDZ = :VRTOTACRREDZ, IDORIGEMREDZ = :IDORIGEMREDZ, DSMODMARCAECF = :DSMODMARCAECF,
               VRSTRIBREDZ = VRSTRIBREDZ, VRISENCREDZ = :VRISENCREDZ, VRNINCIDREDZ = :VRNINCIDREDZ, QTTEMLIGREDZ = :QTTEMLIGREDZ,
               QTTEMPCFREDZ = :QTTEMPCFREDZ, QTMEMRESREDZ = :QTMEMRESREDZ
         WHERE CDFILIAL = :CDFILIAL AND CDCAIXA = :CDCAIXA AND NRORG = :NRORG AND DTREDUCAOZ = :DTREDUCAOZ AND NRECFREDZ = :NRECFREDZ
    ";

    const GET_NRSEQOBSREDZ = "
     SELECT NVL(MAX(NRSEQOBSREDZ), 0)+1 AS NRSEQOBSREDZ
       FROM OBSERVAREDZ
      WHERE CDFILIAL   = :CDFILIAL
        AND CDCAIXA    = :CDCAIXA
        AND NRECFREDZ  = :NRECFREDZ
        AND DTREDUCAOZ = :DTREDUCAOZ
    ";

    const GET_NRTOTNFISCRZ = "
     SELECT NVL(MAX(NRTOTNFISCRZ), 0)+1 AS NRTOTNFISCRZ
       FROM TOTNFISCREDZ
      WHERE CDFILIAL   = :CDFILIAL
        AND CDCAIXA    = :CDCAIXA
        AND NRECFREDZ  = :NRECFREDZ
        AND DTREDUCAOZ = :DTREDUCAOZ
    ";

    const DELETE_IMP_REDZ = "
        DELETE
          FROM IMPOSTOREDZ
         WHERE CDFILIAL = :CDFILIAL AND CDCAIXA = :CDCAIXA AND DTREDUCAOZ = :DTREDUCAOZ AND NRECFREDZ = :NRECFREDZ AND NRORG = :NRORG
    ";

    const DELETE_TOT_REDZ = "
        DELETE
          FROM TOTNFISCREDZ
         WHERE CDFILIAL = :CDFILIAL AND CDCAIXA = :CDCAIXA AND DTREDUCAOZ = :DTREDUCAOZ AND  NRECFREDZ = :NRECFREDZ AND NRORG = :NRORG
    ";

    const DELETE_PAY_REDZ = "
        DELETE
          FROM FORMPGTOREDZ
         WHERE CDFILIAL = :CDFILIAL AND CDCAIXA = :CDCAIXA AND DTREDUCAOZ = :DTREDUCAOZ AND NRECFREDZ = :NRECFREDZ AND NRORG = :NRORG
    ";

    const DELETE_OBS_REDZ = "
        DELETE
          FROM OBSERVAREDZ
         WHERE CDFILIAL =  :CDFILIAL AND CDCAIXA = :CDCAIXA AND DTREDUCAOZ = :DTREDUCAOZ AND NRECFREDZ = :NRECFREDZ AND NRORG = :NRORG
    ";

    const VERIFY_TIPORECE = "
        SELECT CDTIPORECE
          FROM FORMPGTOREDZ
          WHERE CDFILIAL = :CDFILIAL AND CDCAIXA = :CDCAIXA AND DTREDUCAOZ = :DTREDUCAOZ AND NRECFREDZ = :NRECFREDZ AND CDTIPORECE = :CDTIPORECE
    ";

    const VERIFY_REDZ = "
        SELECT NRECFREDZ
          FROM REDUCAOZ
         WHERE DTREDUCAOZ = :DTREDUCAOZ AND NRECFREDZ = :NRECFREDZ AND CDFILIAL = :CDFILIAL AND CDCAIXA = :CDCAIXA
    ";

    const GET_NRSEQALIQIMPRZ = "
     SELECT NVL(MAX(NRSEQALIQIMPRZ), 0)+1 AS NRSEQOBSREDZ
       FROM IMPOSTOREDZ
      WHERE CDFILIAL   = :CDFILIAL
        AND CDCAIXA    = :CDCAIXA
        AND NRECFREDZ  = :NRECFREDZ
        AND DTREDUCAOZ = :DTREDUCAOZ
    ";
    
    const GET_NRSEQALIQIMPRZ_EDIT = "
      SELECT NVL(MAX(NRSEQALIQIMPRZ), 0) AS NRSEQOBSREDZ
       FROM IMPOSTOREDZ
      WHERE CDFILIAL   = :CDFILIAL
        AND CDCAIXA    = :CDCAIXA
        AND NRECFREDZ  = :NRECFREDZ
        AND DTREDUCAOZ = :DTREDUCAOZ
    ";

    const GET_PRODUCT_TO_SETOR ="
        SELECT DISTINCT I.CDPRODUTO
          FROM ITEMPRECO I
          JOIN PRODUTO P
          ON I.CDPRODUTO = P.CDPRODUTO
          AND I.NRORG    = P.NRORG
          JOIN TABEVEND T
          ON I.CDFILIAL    = T.CDFILIAL
          AND I.NRORG      = T.NRORG
          AND I.CDTABEPREC = T.CDTABEPREC
          JOIN ALIQIMPFIS L
          ON I.CDFILIAL   = L.CDFILIAL
          AND I.CDPRODUTO = L.CDPRODUTO
          AND P.CDPRODUTO = L.CDPRODUTO
          JOIN IMPOSTO I
          ON L.CDIMPOSTO                      = I.CDIMPOSTO
          WHERE I.NRORG                         = :NRORG
          AND I.CDPRODUTO                     = I.CDPRPAITABPR
          AND (T.DTFINVGPREC - T.DTINIVGPREC) > 0
          AND T.DTFINVGPREC                   > SYSDATE
          AND T.DTINIVGPREC                   < SYSDATE
          AND P.CDARVPROD BETWEEN :CDARVPRODINI AND :CDARVPRODFINAL
          ORDER BY CDPRODUTO
    ";

    const UPDATE_ITEMPRECO_INLINE = "
    UPDATE ITEMPRECO SET
      VRPRECITEM   = :VRPRECITEM,
      VRCUSTITEM   = :VRCUSTITEM,
      VRPRESUGITEM = :VRPRESUGITEM,
      VRPRECITEMCL = :VRPRECITEMCL,
      IDPRODPROMOC = :IDPRODPROMOC

    WHERE CDFILIAL     = :CDFILIAL
      AND CDPRODUTO    = :CDPRODUTO
      AND CDTABEPREC   = :CDTABEPREC
      AND DTINIVGPREC  = :DTINIVGPREC
      AND NRORG        = :NRORG";


   const FISCAL_GERENCIAL = "
  SELECT A.NMFILIAL, A.CDFILIAL, A.CDLOJA, A.IDVENDAGERENCIAL, A.NMTIPORECE, SUM(NVL(A.VALOR, 0) - NVL(B.VALOR, 0)) AS TOTAL FROM (SELECT  V.CDFILIAL|| ' - ' || F.NMFILIAL || ' - Período: ' || :P_DTINI || ' a ' || :P_DTFIN AS NMFILIAL,V.CDFILIAL, V.CDLOJA, (CASE V.IDVENDAGERENCIAL WHEN 'S' THEN 'Venda Gerencial' WHEN 'N' THEN 'Venda Fiscal' END) AS IDVENDAGERENCIAL,T.CDTIPORECE ||' - '|| T.NMTIPORECE AS NMTIPORECE,
         SUM(M.VRMOVIVEND) AS VALOR, T.CDTIPORECE, V.CDCAIXA, V.NRSEQVENDA
    FROM VENDA V, MOVCAIXA M, TIPORECE T,FILIAL F
   WHERE
     V.CDFILIAL = M.CDFILIAL  AND
     V.CDCAIXA = M.CDCAIXA AND
     V.NRSEQVENDA = M.NRSEQVENDA AND
     M.CDTIPORECE = T.CDTIPORECE AND
     V.IDVENDAGERENCIAL = 'S' AND
     V.IDSITUVENDA = 'O' AND
     V.CDFILIAL = F.CDFILIAL AND
     M.CDFILIAL = F.CDFILIAL AND
     M.IDTIPOMOVIVE = 'E' AND
     (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN) AND
     ((INSTR(:P_CDFILIAL, V.CDFILIAL          ) <> 0) OR (:P_TCDFILIAL = 'T'))
  GROUP BY V.CDFILIAL, V.CDLOJA, V.IDVENDAGERENCIAL,T.NMTIPORECE,T.CDTIPORECE,F.NMFILIAL, V.CDCAIXA, V.NRSEQVENDA
  ORDER BY CDFILIAL, CDLOJA,NMTIPORECE) A
  LEFT JOIN
  (SELECT  V.CDFILIAL|| ' - ' || F.NMFILIAL || ' - Período: ' || :P_DTINI || ' a ' || :P_DTFIN AS NMFILIAL,V.CDFILIAL, V.CDLOJA, (CASE V.IDVENDAGERENCIAL WHEN 'S' THEN 'Venda Gerencial' WHEN 'N' THEN 'Venda Fiscal' END) AS IDVENDAGERENCIAL,T.CDTIPORECE ||' - '|| T.NMTIPORECE AS NMTIPORECE,
         SUM(M.VRMOVIVEND) AS VALOR, T.CDTIPORECE, V.CDCAIXA, V.NRSEQVENDA
    FROM VENDA V, MOVCAIXA M, TIPORECE T,FILIAL F
   WHERE
     V.CDFILIAL = M.CDFILIAL  AND
     V.CDCAIXA = M.CDCAIXA AND
     V.NRSEQVENDA = M.NRSEQVENDA AND
     M.CDTIPORECE = T.CDTIPORECE AND
     V.IDVENDAGERENCIAL = 'S' AND
     V.IDSITUVENDA = 'O' AND
     V.CDFILIAL = F.CDFILIAL AND
     M.CDFILIAL = F.CDFILIAL AND
     M.IDTIPOMOVIVE = 'S' AND
     (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN) AND
     ((INSTR(:P_CDFILIAL, V.CDFILIAL          ) <> 0) OR (:P_TCDFILIAL = 'T'))
  GROUP BY V.CDFILIAL, V.CDLOJA, V.IDVENDAGERENCIAL,T.NMTIPORECE,T.CDTIPORECE,F.NMFILIAL, V.CDCAIXA, V.NRSEQVENDA
  ORDER BY CDFILIAL, CDLOJA,NMTIPORECE) B
  ON A.CDFILIAL = B.CDFILIAL
  AND A.CDCAIXA = B.CDCAIXA
  AND A.CDTIPORECE = B.CDTIPORECE
  AND A.NRSEQVENDA = B.NRSEQVENDA
  GROUP BY A.NMFILIAL, A.CDFILIAL, A.CDLOJA, A.IDVENDAGERENCIAL, A.NMTIPORECE
  UNION
  SELECT A.NMFILIAL, A.CDFILIAL, A.CDLOJA, A.IDVENDAGERENCIAL, A.NMTIPORECE, SUM(NVL(A.VALOR, 0) - NVL(B.VALOR, 0)) AS TOTAL FROM (SELECT  V.CDFILIAL|| ' - ' || F.NMFILIAL || ' - Período: ' || :P_DTINI || ' a ' || :P_DTFIN AS NMFILIAL,V.CDFILIAL, V.CDLOJA, (CASE V.IDVENDAGERENCIAL WHEN 'S' THEN 'Venda Gerencial' WHEN 'N' THEN 'Venda Fiscal' END) AS IDVENDAGERENCIAL,T.CDTIPORECE ||' - '|| T.NMTIPORECE AS NMTIPORECE,
         SUM(M.VRMOVIVEND) AS VALOR, T.CDTIPORECE, V.CDCAIXA, V.NRSEQVENDA
    FROM VENDA V, MOVCAIXA M, TIPORECE T,FILIAL F
   WHERE
     V.CDFILIAL = M.CDFILIAL  AND
     V.CDCAIXA = M.CDCAIXA AND
     V.NRSEQVENDA = M.NRSEQVENDA AND
     M.CDTIPORECE = T.CDTIPORECE AND
     V.IDVENDAGERENCIAL = 'N' AND
     V.IDSITUVENDA = 'O' AND
     V.CDFILIAL = F.CDFILIAL AND
     M.CDFILIAL = F.CDFILIAL AND
     M.IDTIPOMOVIVE = 'E' AND
     (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN) AND
     ((INSTR(:P_CDFILIAL, V.CDFILIAL          ) <> 0) OR (:P_TCDFILIAL = 'T'))
  GROUP BY V.CDFILIAL, V.CDLOJA, V.IDVENDAGERENCIAL,T.NMTIPORECE,T.CDTIPORECE,F.NMFILIAL, V.CDCAIXA, V.NRSEQVENDA
  ORDER BY CDFILIAL, CDLOJA,NMTIPORECE) A
  LEFT JOIN
  (SELECT  V.CDFILIAL|| ' - ' || F.NMFILIAL || ' - Período: ' || :P_DTINI || ' a ' || :P_DTFIN AS NMFILIAL,V.CDFILIAL, V.CDLOJA, (CASE V.IDVENDAGERENCIAL WHEN 'S' THEN 'Venda Gerencial' WHEN 'N' THEN 'Venda Fiscal' END) AS IDVENDAGERENCIAL,T.CDTIPORECE ||' - '|| T.NMTIPORECE AS NMTIPORECE,
         SUM(M.VRMOVIVEND) AS VALOR, T.CDTIPORECE, V.CDCAIXA, V.NRSEQVENDA
    FROM VENDA V, MOVCAIXA M, TIPORECE T,FILIAL F
   WHERE
     V.CDFILIAL = M.CDFILIAL  AND
     V.CDCAIXA = M.CDCAIXA AND
     V.NRSEQVENDA = M.NRSEQVENDA AND
     M.CDTIPORECE = T.CDTIPORECE AND
     V.IDVENDAGERENCIAL = 'N' AND
     V.IDSITUVENDA = 'O' AND
     V.CDFILIAL = F.CDFILIAL AND
     M.CDFILIAL = F.CDFILIAL AND
     M.IDTIPOMOVIVE = 'S' AND
     (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN) AND
     ((INSTR(:P_CDFILIAL, V.CDFILIAL          ) <> 0) OR (:P_TCDFILIAL = 'T'))
  GROUP BY V.CDFILIAL, V.CDLOJA, V.IDVENDAGERENCIAL,T.NMTIPORECE,T.CDTIPORECE,F.NMFILIAL, V.CDCAIXA, V.NRSEQVENDA
  ORDER BY CDFILIAL, CDLOJA,NMTIPORECE) B
  ON A.CDFILIAL = B.CDFILIAL
  AND A.CDCAIXA = B.CDCAIXA
  AND A.CDTIPORECE = B.CDTIPORECE
  AND A.NRSEQVENDA = B.NRSEQVENDA
  GROUP BY A.NMFILIAL, A.CDFILIAL, A.CDLOJA, A.IDVENDAGERENCIAL, A.NMTIPORECE
  ";

  const TOTAL_FISCAL_GERENCIAL = "
  SELECT SUM(NVL(A.TOTALFILIAL, 0) - NVL(B.TOTALFILIAL, 0)) AS TOTALFILIAL
  FROM (SELECT SUM(M.VRMOVIVEND) AS TOTALFILIAL, V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, M.CDTIPORECE
    FROM VENDA V, MOVCAIXA M, TIPORECE T
   WHERE
     V.CDFILIAL = M.CDFILIAL  AND
     V.CDCAIXA = M.CDCAIXA AND
     V.NRSEQVENDA = M.NRSEQVENDA AND
     M.CDTIPORECE = T.CDTIPORECE AND
     V.IDSITUVENDA = 'O' AND
     M.IDTIPOMOVIVE = 'E' AND
     (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN) AND
     ((INSTR(:P_CDFILIAL, V.CDFILIAL ) <> 0) OR (:P_TCDFILIAL = 'T'))
    GROUP BY V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, M.CDTIPORECE) A
   LEFT JOIN (SELECT SUM(M.VRMOVIVEND) AS TOTALFILIAL, V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, M.CDTIPORECE
    FROM VENDA V, MOVCAIXA M, TIPORECE T
   WHERE
     V.CDFILIAL = M.CDFILIAL  AND
     V.CDCAIXA = M.CDCAIXA AND
     V.NRSEQVENDA = M.NRSEQVENDA AND
     M.CDTIPORECE = T.CDTIPORECE AND
     V.IDSITUVENDA = 'O' AND
     M.IDTIPOMOVIVE = 'S' AND
     (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN) AND
     ((INSTR(:P_CDFILIAL, V.CDFILIAL ) <> 0) OR (:P_TCDFILIAL = 'T'))
    GROUP BY V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, M.CDTIPORECE) B
    ON A.CDFILIAL = B.CDFILIAL
    AND A.CDCAIXA = B.CDCAIXA
    AND A.CDTIPORECE = B.CDTIPORECE
    AND A.NRSEQVENDA = B.NRSEQVENDA
  ";

  const PER_FISCAL_GERENCIAL = "
  SELECT SUM(NVL(A.TOTALLOJA, 0) - NVL(B.TOTALLOJA, 0)) AS TOTALLOJA, A.IDVENDAGERENCIAL  FROM (SELECT SUM(M.VRMOVIVEND) AS TOTALLOJA,(CASE V.IDVENDAGERENCIAL WHEN 'S' THEN 'Venda Gerencial' WHEN 'N' THEN 'Venda Fiscal' END) AS IDVENDAGERENCIAL, V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, M.CDTIPORECE
  FROM VENDA V, MOVCAIXA M, TIPORECE T
  WHERE
  V.CDFILIAL = M.CDFILIAL AND
  V.CDCAIXA = M.CDCAIXA AND
  V.NRSEQVENDA = M.NRSEQVENDA AND
  M.CDTIPORECE = T.CDTIPORECE AND
  V.IDSITUVENDA = 'O' AND
  M.IDTIPOMOVIVE = 'E' AND
  (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN) AND
  ((INSTR(:P_CDFILIAL, V.CDFILIAL ) <> 0) OR (:P_TCDFILIAL = 'T')) AND
  ((INSTR(:P_CDLOJA, V.CDLOJA) <> 0) OR (:P_TCDLOJA = 'T'))
  GROUP BY V.IDVENDAGERENCIAL, V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, M.CDTIPORECE) A
  LEFT JOIN (SELECT SUM(M.VRMOVIVEND) AS TOTALLOJA,(CASE V.IDVENDAGERENCIAL WHEN 'S' THEN 'Venda Gerencial' WHEN 'N' THEN 'Venda Fiscal' END), V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, M.CDTIPORECE
              FROM VENDA V, MOVCAIXA M, TIPORECE T
              WHERE V.CDFILIAL = M.CDFILIAL AND
                V.CDCAIXA = M.CDCAIXA AND
                V.NRSEQVENDA = M.NRSEQVENDA AND
                M.CDTIPORECE = T.CDTIPORECE AND
                V.IDSITUVENDA = 'O' AND
                M.IDTIPOMOVIVE = 'S' AND
                (V.DTENTRVENDA BETWEEN :P_DTINI AND :P_DTFIN) AND
                ((INSTR(:P_CDFILIAL, V.CDFILIAL ) <> 0) OR (:P_TCDFILIAL = 'T')) AND
                ((INSTR(:P_CDLOJA, V.CDLOJA) <> 0) OR (:P_TCDLOJA = 'T'))
                GROUP BY V.IDVENDAGERENCIAL, V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA, M.CDTIPORECE) B
   ON A.CDFILIAL = B.CDFILIAL
   AND A.CDCAIXA = B.CDCAIXA
   AND A.NRSEQVENDA = B.NRSEQVENDA
   AND A.CDTIPORECE = B.CDTIPORECE
   GROUP BY A.IDVENDAGERENCIAL
  ";

    const REFRESH_PRODUCTS = "
        INSERT INTO PRODFILI(CDFILIAL, CDPRODUTO, IDCNTRESTOQ, IDUTCTRLLOTE, IDPRODATIV, NRORG)
        (SELECT :CDFILIAL AS CDFILIAL, P.CDPRODUTO, PF.IDCTRLESTQ AS IDCNTRESTOQ, PF.IDUTILLOTE AS IDUTCTRLLOTE, 'A' AS IDPRODATIV , PF.NRORG
           FROM PRODUTO P , PARAMFILIAL PF
          WHERE P.CDNVPRODUTO IN (SELECT MAX(CDNVPRODUTO) AS CDNVPRODUTO FROM PRODUTO)
            AND P.IDPRODATIVPR = 'S'
            AND PF.CDFILIAL = :CDFILIAL
            AND PF.NRORG = P.NRORG
            AND P.NRORG = :NRORG
            AND NOT EXISTS (SELECT :CDFILIAL, CDPRODUTO
                              FROM PRODFILI F
                             WHERE F.CDFILIAL  = :CDFILIAL
                               AND F.CDPRODUTO = P.CDPRODUTO
                               AND F.NRORG = :NRORG))
    ";

    const GET_MAX_CODE_CAMPANHA = "SELECT MAX(CDCAMPANHA) AS MAX FROM CAMPANHA WHERE NRORG = :NRORG";

    const GET_PRODUCTS_BETWEEN_TWO = "SELECT  CDARVPROD, CDPRODUTO, NMPRODUTO, CDNVPRODUTO FROM PRODUTO WHERE CDARVPROD BETWEEN :CDARVPRODINI AND :CDARVPRODFIN AND CDNVPRODUTO = :CDNVPRODUTO AND CDARVPROD NOT IN :PRODUTOS ORDER BY CDARVPROD";

    const GET_MAX_SEQCODE_PRODUCT = "SELECT MAX(NRSEQPRODCAMP) AS MAX FROM PRODCAMPANHA WHERE CDCAMPANHA = :CDCAMPANHA";

    const GET_MAX_NRSEQBANDEIRA = "SELECT MAX(NRSEQBANDEIRA)+1 AS NRSEQBANDEIRA FROM BANDEIRAESITEF WHERE NRORG = :NRORG ORDER BY NRSEQBANDEIRA";

    const GET_MAX_NRSEQBANDEIRA_FILIAL = "SELECT MAX(NRSEQBANDEIRA)+1 AS NRSEQBANDEIRA FROM BANDESITEFFIL WHERE NRORG = :NRORG AND CDFILIAL = :CDFILIAL ORDER BY NRSEQBANDEIRA";

    const GET_PRODUCTS_INI_FIN = "
    SELECT DISTINCT I.CDPRODUTO
    FROM ITEMPRECO I
    JOIN PRODUTO P ON I.CDPRODUTO = P.CDPRODUTO
    AND I.NRORG = P.NRORG
    JOIN TABEVEND T ON I.CDFILIAL = T.CDFILIAL
    AND I.NRORG = T.NRORG
    AND I.CDTABEPREC = T.CDTABEPREC
    JOIN ALIQIMPFIS L ON I.CDFILIAL = L.CDFILIAL
    AND I.CDPRODUTO = L.CDPRODUTO
    AND P.CDPRODUTO = L.CDPRODUTO
    AND I.NRORG = L.NRORG
    JOIN IMPOSTO I ON L.CDIMPOSTO = I.CDIMPOSTO
    WHERE I.NRORG = :NRORG
      AND P.CDARVPROD BETWEEN :CDARVPRODINI AND :CDARVPRODFIM
      AND I.CDPRODUTO NOT IN
        (SELECT PO.CDPRODUTO
         FROM PRODOCORRE PO
         WHERE PO.CDGRPOCOR = :CDGRPOCOR
           AND PO.CDOCORR = :CDOCORR
           AND PO.NRORG = :NRORG)
      AND I.CDPRODUTO = I.CDPRPAITABPR
      AND (T.DTFINVGPREC - T.DTINIVGPREC) > 0
      AND T.DTFINVGPREC > SYSDATE
      AND T.DTINIVGPREC < SYSDATE
  ";

    const INSERT_PRODOCORRE = "
        INSERT INTO PRODOCORRE
                (CDPRODUTO, CDGRPOCOR, CDOCORR, NRORG, DTULTATUPOCO)
        VALUES
            (:CDPRODUTO, :CDGRPOCOR, :CDOCORR, :NRORG, :DTULTATUPOCO)
    ";

    const GET_ECF_FILIAL = "
      SELECT ECF.NRATIVO,
         ECF.NRORG,
         ECF.NRLACRE,
         ECF.NRMODELO,
         ECF.CDFABRIC,
         FB.NMFABRIC,
         ECF.CDFILIAL,
         F.NMFILIAL,
         ECF.CDCAIXA,
         CX.NMCAIXA,
         ECF.NRECF,
         ECF.NRSERIE,
         CX.CDCAIXA||'-'||CX.NMCAIXA AS CPNAVI,
         ECF.CDTIPOECF,
         ECF.NRAPLICATIVO,
         ECF.DTVALIDADE
  FROM FILIAL F,
       CADASTROECF ECF,
       CAIXA CX,
       FABRICANTE FB
  WHERE (F.CDFILIAL = CX.CDFILIAL)
    AND (ECF.CDFILIAL = F.CDFILIAL)
    AND (ECF.CDCAIXA = CX.CDCAIXA)
    AND (ECF.CDFABRIC = FB.CDFABRIC(+))
    AND (ECF.NRSERIE = :NRSERIE)
    AND (ECF.CDFILIAL = :CDFILIAL)
  ORDER BY 5,
           7
";

    const DELETE_ITLACTOEST = "
        DELETE
        FROM ITLANCTOEST
        WHERE (CDFILIAL = :CDFILIAL)
            AND (NRLANCESTQ = :NRLANCESTQ)
            AND (INSTR(:CDPRODPAI, CDPRODUTO) <> 0)
            AND (CDFILIMOVI = :CDFILIMOVI)
            AND (NRORG = :NRORG)
    ";

    const INSERT_MOVILOTE = "
        INSERT INTO MOVILOTE
            (NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ,
             CDPRODUTO, NRLOTEESTQ, NRSUBLOTE, DTMOVILOTE, DTMOVILOTEANT, NRORG)
        VALUES
            (:NRMOVILOTE,:CDFILIAL,:CDALMOXARIFE,:CDLOCALESTOQ,
             :CDPRODUTO,:NRLOTEESTQ,:NRSUBLOTE,:DTMOVILOTE,:DTMOVILOTEANT,:NRORG)
    ";


    const GET_PROD_LIST = "
        SELECT CDARVPROD, CDNVPRODUTO, CDPRODUTO, IDPESAPROD, QTTARAPROD, IDCOBTXSERV, IDTIPOPROD, IDIMPPRODUTO, IDIMPRODUVEZ
          FROM PRODUTO
         WHERE CDNVPRODUTO = :CDNVPRODUTO
           AND CDARVPROD BETWEEN :CDARVPRODINI AND :CDARVPRODFIN
           AND NRORG = :NRORG
    ";

    const GET_ECF = "
      SELECT ECF.NRATIVO,
         ECF.NRORG,
         ECF.NRLACRE,
         ECF.NRMODELO,
         ECF.CDFABRIC,
         FB.NMFABRIC,
         ECF.CDFILIAL,
         F.NMFILIAL,
         ECF.CDCAIXA,
         CX.NMCAIXA,
         ECF.NRECF,
         ECF.NRSERIE,
         CX.CDCAIXA||'-'||CX.NMCAIXA AS CPNAVI,
         ECF.CDTIPOECF,
         ECF.NRAPLICATIVO, ECF.DTVALIDADE
        FROM FILIAL F, CADASTROECF ECF, CAIXA CX, FABRICANTE FB
       WHERE (F.CDFILIAL = CX.CDFILIAL)
         AND (ECF.CDFILIAL = F.CDFILIAL)
         AND (ECF.CDCAIXA = CX.CDCAIXA)
         AND (ECF.CDFABRIC = FB.CDFABRIC(+))
         AND (ECF.NRSERIE = :NRSERIE)
      ORDER BY 5, 7
    ";

const FIELD_AMBIENTE = "
  SELECT * FROM(SELECT I.NRORG,
       C.CDLOJA,
       I.CDFILIAL,
       I.NRCONFTELA,
       C.NMCONFTELA,
       I.NRPGCONFTELA,
       I.IDTPBUTTON,
       I.NRBUTTON,
       I.DSBUTTON,
       I.CDIDENTBUTON,
       S.CDSALA,
       S.NMSALA,
       I.NRCOLORTEXT,
       I.NRCOLORBACK,
       TO_CHAR(I.NRFONTETEXT) AS NRFONTETEXT,
       IDTPBUTONAUX,
       NRBUTTONAUX,
       NRPGCONFTAUX
FROM ITMENUCONFTE I,
     CONFTELA C,
     SALA S
WHERE (I.CDFILIAL = :CDFILIAL)
  AND (I.NRORG = :NRORG)
  AND (I.NRORG = C.NRORG)
  AND (I.NRORG = S.NRORG)
  AND (I.IDTPBUTTON = '4')
  AND (I.CDFILIAL = C.CDFILIAL)
  AND (I.NRCONFTELA = C.NRCONFTELA)
  AND (C.CDLOJA = :CDLOJA)
  AND (S.CDSALA (+) = I.CDIDENTBUTON)
  AND (S.CDFILIAL(+) = I.CDFILIAL)
ORDER BY TO_NUMBER(I.NRPGCONFTELA),
         I.NRBUTTON) WHERE NRBUTTON = :NRBUTTON
";

    const GET_PROD_TO_PRECODIA = "
        SELECT I.CDPRODUTO
          FROM ITEMPRECO I
          JOIN PRODUTO P
            ON I.CDPRODUTO = P.CDPRODUTO
         WHERE P.CDARVPROD BETWEEN :CDARVPRODINI AND :CDARVPRODFINAL
           AND I.CDTABEPREC = :CDTABEPREC
           AND I.CDFILIAL = :CDFILIAL
           AND I.DTINIVGPREC = :DTINIVGPREC
    ";

    const CLEAR_PRODDIA = "
        DELETE ITEMPRECODIA I
         WHERE I.CDPRODUTO = :CDPRODUTO
           AND I.CDTABEPREC = :CDTABEPREC
           AND I.CDFILIAL = :CDFILIAL
           AND I.DTINIVGPREC = :DTINIVGPREC
    ";

    const GET_ALL_PROD_TO_PRECODIA = "
        SELECT I.CDPRODUTO
          FROM ITEMPRECO I
          JOIN PRODUTO P
            ON I.CDPRODUTO = P.CDPRODUTO
         WHERE I.CDTABEPREC = :CDTABEPREC
           AND I.CDFILIAL = :CDFILIAL
           AND I.DTINIVGPREC = :DTINIVGPREC
    ";

    const INSERT_ITEMPRECOFROMSELECT = "
        INSERT INTO ITEMPRECO
            (CDFILIAL, CDTABEPREC, DTINIVGPREC, CDPRODUTO, CDPRPAITABPR,
            VRPRECITEM, VRPRECITEMCL, IDPRECVARIA, NRORG)
        SELECT
            :CDFILIALDES, :CDTABEPRECDES, I.DTINIVGPREC, I.CDPRODUTO, I.CDPRPAITABPR,
            I.VRPRECITEM, I.VRPRECITEMCL, I.IDPRECVARIA, I.NRORG
        FROM
            ITEMPRECO I, PRODUTO R
        WHERE
            (I.CDFILIAL   = :CDFILIALORI)   AND
            (I.CDTABEPREC = :CDTABEPRECORI) AND
            (I.NRORG      = :NRORG)         AND
            (R.CDPRODUTO  = I.CDPRODUTO)    AND
            (R.NRORG      = I.NRORG)        AND
            (NVL(R.IDPRODATIVPR,'S') = 'S')
    ";

    const INSERT_ITEMPRECODIAFROMSELECT = "
        INSERT INTO ITEMPRECODIA
            (CDFILIAL, CDTABEPREC, DTINIVGPREC, DTINIVALPREC, DTFINVALPREC, CDPRODUTO, CDPRPAITABPR, NRDIASEMANPR,
            HRINIPRECDIA, HRFINPRECDIA, VRPRECODIA, IDPERVALORPR, IDDESCACREPR, CDTIPOCONSPD, NRORG)
        SELECT
            :CDFILIALDES, :CDTABEPRECDES, I.DTINIVGPREC, I.DTINIVALPREC, I.DTFINVALPREC, I.CDPRODUTO, I.CDPRPAITABPR, I.NRDIASEMANPR,
            I.HRINIPRECDIA, I.HRFINPRECDIA, I.VRPRECODIA, I.IDPERVALORPR, I.IDDESCACREPR, I.CDTIPOCONSPD, I.NRORG
        FROM
            ITEMPRECODIA I,  PRODUTO R
        WHERE
            (I.CDFILIAL   = :CDFILIALORI)   AND
            (I.CDTABEPREC = :CDTABEPRECORI) AND
            (I.NRORG      = :NRORG)         AND
            (R.CDPRODUTO  = I.CDPRODUTO)    AND
            (R.NRORG      = I.NRORG)        AND
            (NVL(R.IDPRODATIVPR,'S') = 'S')
    ";

    const INSERT_ITEMPRECOWITHVALIDITY = "
    INSERT INTO ITEMPRECO
        (CDFILIAL, CDTABEPREC, DTINIVGPREC, CDPRODUTO, CDPRPAITABPR, VRPRECITEM, VRPRECITEMCL, VRPRECMAXITE,
        IDPRECVARIA, VRPRESUGITEM, VRCUSTITEM, VRMKUPITEM, IDPRODPROMOC, NRORG)
    SELECT
        :CDFILIALDESC, :CDTABEPRECDES, :DTINIVGPREC, I.CDPRODUTO, I.CDPRPAITABPR, I.VRPRECITEM, I.VRPRECITEMCL, I.VRPRECMAXITE,
        I.IDPRECVARIA, I.VRPRESUGITEM, I.VRCUSTITEM, I.VRMKUPITEM, I.IDPRODPROMOC, I.NRORG
    FROM ITEMPRECO I, TABEVEND T
    WHERE
        (I.CDFILIAL        = :CDFILIALORI)
        AND (I.CDTABEPREC  = :CDTABEPRECORI)
        AND (INSTR(:CDPRODUTO, I.CDPRODUTO) <> 0)
        AND (I.NRORG       = :NRORG)
        AND (I.CDFILIAL    = T.CDFILIAL)
        AND (I.CDTABEPREC  = T.CDTABEPREC)
        AND (I.DTINIVGPREC = T.DTINIVGPREC)
        AND (I.NRORG       = T.NRORG)
        AND (SYSDATE BETWEEN I.DTINIVGPREC AND T.DTFINVGPREC)
    ";



    const FIELD_MESA = "
    SELECT * FROM (SELECT M.CDSALA,
       C.CDLOJA,
       I.NRORG,
       I.CDFILIAL,
       I.NRCONFTELA,
       C.NMCONFTELA,
       I.NRPGCONFTELA,
       I.IDTPBUTTON,
       I.NRBUTTON,
       I.NRPGCONFTAUX,
       I.IDTPBUTONAUX,
       I.NRBUTTONAUX,
       I.DSBUTTON,
       I.CDIDENTBUTON,
       M.NRMESA,
       M.NMMESA,
       I.NRCOLORTEXT,
       I.NRCOLORBACK,
       TO_CHAR(I.NRFONTETEXT) AS NRFONTETEXT
FROM ITMENUCONFTE I,
     CONFTELA C,
     MESA M,
     SALA S
WHERE (I.CDFILIAL = :CDFILIAL)
  AND (I.IDTPBUTTON = '3')
  AND (I.CDFILIAL = C.CDFILIAL)
  AND (I.NRCONFTELA = C.NRCONFTELA)
  AND (C.CDLOJA = :CDLOJA)
  AND (I.NRORG = :NRORG)
  AND (I.NRORG = C.NRORG)
  AND (I.NRORG = M.NRORG)
  AND (I.NRORG = S.NRORG)
  AND (M.NRMESA (+) = I.CDIDENTBUTON)
  AND (M.CDFILIAL (+) = I.CDFILIAL)
  AND (M.CDLOJA = C.CDLOJA)
  AND (M.CDSALA = S.CDSALA)
  AND S.CDFILIAL = C.CDFILIAL
ORDER BY TO_NUMBER(I.NRPGCONFTELA),
         I.NRBUTTON) WHERE NRBUTTON = :NRBUTTON AND CDSALA = :CDSALA
    ";

  const GET_MAX_CDTIPOCAMPANHA = "
    SELECT MAX(CDTPCAMPANHA) AS CDTPCAMPANHA FROM TPCAMPANHA WHERE (NRORG = :NRORG)
  ";
  const GET_PRODUCT_TO_SETOR_WITHOUT_SETOR ="
        SELECT DISTINCT I.CDPRODUTO
          FROM ITEMPRECO I
          JOIN PRODUTO P
          ON I.CDPRODUTO = P.CDPRODUTO
          AND I.NRORG    = P.NRORG
          JOIN TABEVEND T
          ON I.CDFILIAL    = T.CDFILIAL
          AND I.NRORG      = T.NRORG
          AND I.CDTABEPREC = T.CDTABEPREC
          JOIN ALIQIMPFIS L
          ON I.CDFILIAL   = L.CDFILIAL
          AND I.CDPRODUTO = L.CDPRODUTO
          AND P.CDPRODUTO = L.CDPRODUTO
          JOIN IMPOSTO I
          ON L.CDIMPOSTO                      = I.CDIMPOSTO
          WHERE
          P.CDPRODUTO NOT IN ( SELECT PRD.CDPRODUTO
                                 FROM SETOR STT
                                 JOIN SETORPRODUTO SP
                                 ON STT.CDSETOR = SP.CDSETOR
                                 JOIN PRODUTO PRD
                                 ON PRD.CDPRODUTO = SP.CDPRODUTO )
          AND I.NRORG                         = :NRORG
          AND I.CDPRODUTO                     = I.CDPRPAITABPR
          AND (T.DTFINVGPREC - T.DTINIVGPREC) > 0
          AND T.DTFINVGPREC                   > SYSDATE
          AND T.DTINIVGPREC                   < SYSDATE
          AND P.CDARVPROD BETWEEN :CDARVPRODINI AND :CDARVPRODFINAL
          ORDER BY CDPRODUTO
    ";

        const BUSCA_TIPO_CONSUMIDOR_POR_CLIENTE = "
        SELECT DISTINCT TC.NRORG,
      CL.CDCLIENTE,
      TC.CDTIPOCONS,
      TP.NMTIPOCONS,
      TC.NMTIPOCONSCLI
    FROM CLIENTE CL
      JOIN TIPOCONSCLI TC
      ON ((CL.CDCLIENTE = TC.CDCLIENTE)
      AND (CL.NRORG     = TC.NRORG)
      AND TC.NRORG      = :NRORG)
      JOIN TIPOCONS TP
      ON ((TC.CDTIPOCONS = TP.CDTIPOCONS)
      AND (TC.NRORG      = TP.NRORG)
      AND TP.NRORG       = :NRORG
      AND TC.CDCLIENTE =   :CDCLIENTE)
      ORDER BY CDCLIENTE
    ";


    const DATE_PARAM = "
      SELECT DTPROCVND,
        IDPERLANCANTDP,
        IDPERLANCPOSDP,
        NRDIAANTLANC,
        NRDIAPOSLANC
    FROM PARAVEND
    WHERE CDFILIAL = :CDFILIAL
      AND CDPARAVEND ='1'
      AND NRORG = :NRORG
";

    const TIPO_IMPOSTO= "
        SELECT P.CDSITUTRIB, P.DSSITUTRIB
          FROM FILIAL F
          JOIN PARAMEMPRESA PF
            ON F.CDEMPRESA = PF.CDEMPRESA
           AND F.NRORG = PF.NRORG
          JOIN PARAMCST P
            ON P.NRORG = F.NRORG
         WHERE (P.CDIMPOSTO = '00')
           AND (P.IDENTRSAIDOP = 'S')
           AND PF.CDSITUCRT = '3'
           AND F.CDFILIAL = :CDFILIAL
           AND F.NRORG = :NRORG
    ";

    const BUSCA_MAX_NRSEQUMOVI = "
    SELECT MAX (NRSEQUMOVI) AS NRSEQUMOVI
    FROM MOVCAIXA
    WHERE CDFILIAL = :CDFILIAL
      AND NRORG = :NRORG
      AND CDCAIXA = :CDCAIXA
      AND TO_CHAR (DTABERCAIX, 'DD/MM/YYYY HH24:MI:SS') = :DTABERCAIX
    ";

    const BUSCA_SUM_TOTAL_MOVIVEND = "
        SELECT
        (SUM((I.QTPRODVEND * (I.VRUNITVEND + I.VRUNITVENDCL)) - I.VRDESITVEND + I.VRACRITVEND
      )) AS VRTOT
      FROM
      ITEMVENDA I
      JOIN
      ITVENDAIMPOS IT
          ON I.CDFILIAL = IT.CDFILIAL
          AND I.CDCAIXA = IT.CDCAIXA
          AND I.NRSEQVENDA = IT.NRSEQVENDA
          AND I.NRSEQUITVEND = IT.NRSEQUITVEND
      WHERE
      I.CDFILIAL = :CDFILIAL
      AND I.CDCAIXA = :CDCAIXA
      AND I.NRSEQVENDA = :NRSEQVENDA
      AND I.NRORG = :NRORG
    ";

    const BUSCA_SUM_VRMOVIVEND = "
     SELECT  (SUM (VRMOVIVEND)) AS MOVIVENDTOTAL
    FROM MOVCAIXA M
    WHERE M.IDTIPOMOVIVE IN ( 'E', 'S', 'T', 'C' )
    AND M.CDFILIAL        = :CDFILIAL
    AND M.CDCAIXA         = :CDCAIXA
    AND M.NRSEQVENDA      = :NRSEQVENDA
    AND M.NRORG           = :NRORG
  ";

    const INSERT_PARAGERAIS_PRODUTO_PERCENTUAL =  "
    INSERT INTO PERCACRPROD
  (CDFILIAL, NRORG, CDPRODUTO, VRPERCPREPRO)
  VALUES
  (:CDFILIAL, :NRORG, :CDPRODUTO, :VRPERCPREPRO )
    ";

    const DELETE_PARAGERAIS_PRODUTO_PERCENTUAL =  "
    DELETE FROM PERCACRPROD
    WHERE CDFILIAL = :CDFILIAL
  AND NRORG = :NRORG
  AND CDPRODUTO = :CDPRODUTO
    ";

  const DELETE_IMPOSTO_PRODUTO = "
    DELETE
      FROM ALIQIMPFIS
      WHERE CDFILIAL = :CDFILIAL
      AND NRORG      = :NRORG
      AND CDIMPOSTO  = :CDIMPOSTO
      AND CDPRODUTO  = :CDPRODUTO
  ";

  const REL_PRODUTOS_MAIS_VENDIDOS_TOTAL_FILIAL = "
    SELECT VE.CDFILIAL,
        VE.CDLOJA,
        VE.NRORG,
        SUM(IV.QTPRODVEND)                                                                                                            AS QTTOTAL,
        SUM(TRUNC(IV.QTPRODVEND * (NVL(IV.VRUNITVEND,0) + NVL(IV.VRUNITVENDCL,0)),2) - NVL(IV.VRDESITVEND,0) + NVL(IV.VRACRITVEND,0)) AS PORCENTAGEM
      FROM ITEMVENDA IV,
        VENDA VE
      WHERE (VE.CDFILIAL  = IV.CDFILIAL )
      AND (VE.CDCAIXA     = IV.CDCAIXA )
      AND (VE.NRSEQVENDA  = IV.NRSEQVENDA)
      AND (VE.IDSITUVENDA = 'O' )
      AND (VE.NRORG     = IV.NRORG )
      AND (VE.NRORG     = :NRORG )
      AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
      AND ((INSTR(:CDFILIAL, VE.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
      AND ((INSTR(:CDFILILOJA,   VE.CDFILIAL||VE.CDLOJA) <> 0) OR (:TCDFILILOJA = 'T'))
      AND ((INSTR(:CDFILILOJACAIXA,  VE.CDFILIAL||VE.CDLOJA||VE.CDCAIXA) <> 0) OR (:TCDFILILOJACAIXA = 'T'))
      AND ((INSTR(:DTABERCAIX, TO_CHAR(VE.DTABERTUR, 'DD/MM/YYYY HH24:MI:SS')) <> 0) OR (:TDTABERCAIX = 'T'))
      GROUP BY VE.CDFILIAL, VE.CDLOJA, VE.NRORG
  ";

  const REL_PRODUTOS_MAIS_VENDIDOS_VALOR = "
    SELECT RANKING.LINHA AS LINHA, TAB.*
      FROM (SELECT PR.CDPRODUTO,
                    VE.NRORG,
                    TRUNC(SUM(IV.QTPRODVEND), 2) AS QTDE,
                    PR.CDARVPROD || ' - ' ||
                    PR.NMPRODUTO AS NMPRODUTO,
                    SUM(TRUNC(IV.QTPRODVEND * (NVL(IV.VRUNITVEND,0) + NVL(IV.VRUNITVENDCL,0)),2) - NVL(IV.VRDESITVEND,0) + NVL(IV.VRACRITVEND,0)) AS VRTOTAL,
                    IV.VRUNITVEND           + IV.VRUNITVENDCL                                                                                     AS VALOR,
                    VE.CDFILIAL,
                    VE.CDLOJA,
                    LJ.NMLOJA,
                    VE.CDFILIAL
                    || ' - '
                    || FI.NMFILIAL
                    || ' - '
                    || ' Loja: '
                    || VE.CDLOJA
                    || ' - '
                    || LJ.NMLOJA
                    || ' - Período: de '
                    || :DTVENDAINI
                    || ' até '
                    || :DTVENDAFIN             AS LABELFILIAL,
                    SUM(NVL(IV.VRDESITVEND,0)) AS DESCONTO,
                    IV.VRUNITVENDCL,
                    SUM(NVL(IV.VRACRITVEND,0))   AS ACRESCIMO,
                    PR.SGUNIDADE,
                    PR.CDNVPRODUTO
              FROM VENDA VE JOIN FILIAL FI
                              ON (FI.CDFILIAL = VE.CDFILIAL )
                             AND (FI.NRORG   = VE.NRORG )
                            JOIN LOJA LJ
                              ON (LJ.CDFILIAL = VE.CDFILIAL )
                             AND (LJ.CDLOJA  = VE.CDLOJA )
                             AND (LJ.NRORG   = VE.NRORG )
                            JOIN ITEMVENDA IV
                              ON (IV.CDFILIAL    = VE.CDFILIAL )
                             AND (IV.CDLOJA     = VE.CDLOJA )
                             AND (IV.CDCAIXA    = VE.CDCAIXA )
                             AND (IV.NRSEQVENDA = VE.NRSEQVENDA )
                             AND (IV.NRORG      = VE.NRORG )
                            JOIN PRODUTO PR
                              ON (PR.CDPRODUTO      = IV.CDPRODUTO )
                             AND (PR.NRORG         = VE.NRORG )
             WHERE (VE.IDSITUVENDA = 'O' )
               AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
               AND ((INSTR(:CDFILIAL, VE.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
               AND ((INSTR(:CDFILILOJA, VE.CDFILIAL ||VE.CDLOJA)   <> 0) OR (:TCDFILILOJA = 'T'))
               AND ((INSTR(:CDFILILOJACAIXA, VE.CDFILIAL||VE.CDLOJA||VE.CDCAIXA) <> 0) OR (:TCDFILILOJACAIXA = 'T'))
               AND ((INSTR(:DTABERCAIX, TO_CHAR(VE.DTABERTUR, 'DD/MM/YYYY HH24:MI:SS')) <> 0) OR (:TDTABERCAIX = 'T'))
               AND (VE.NRORG = :NRORG)
             GROUP BY VE.CDFILIAL, VE.CDLOJA, VE.NRORG, LJ.NMLOJA, FI.NMFILIAL, PR.CDPRODUTO, PR.NMPRODUTO,
                      PR.SGUNIDADE, PR.CDNVPRODUTO, IV.VRUNITVEND, IV.VRUNITVENDCL, PR.CDARVPROD
     ORDER BY VE.CDFILIAL, VE.CDLOJA, VRTOTAL DESC) TAB, (SELECT ROWNUM LINHA, CDFILIAL, CDLOJA, VRTOTAL, NRORG
                                                         FROM (SELECT DISTINCT CDFILIAL, CDLOJA, VRTOTAL, NRORG
                                                                 FROM (SELECT DISTINCT IV.CDPRODUTO, IV.CDFILIAL, IV.CDLOJA, IV.NRORG,
                                                                               IV.VRUNITVEND, IV.VRUNITVENDCL,
                                                                         SUM(TRUNC(IV.QTPRODVEND * (NVL(IV.VRUNITVEND,0) + NVL(IV.VRUNITVENDCL,0)),2) - NVL(IV.VRDESITVEND,0) + NVL(IV.VRACRITVEND,0)) AS VRTOTAL
                                                                            FROM VENDA VE JOIN ITEMVENDA IV
                                                                                         ON (IV.CDFILIAL    = VE.CDFILIAL )
                                                                                        AND (IV.CDLOJA     = VE.CDLOJA )
                                                                                        AND (IV.CDCAIXA    = VE.CDCAIXA )
                                                                                        AND (IV.NRSEQVENDA = VE.NRSEQVENDA )
                                                                                        AND (IV.NRORG      = VE.NRORG)
                                                                        WHERE (VE.IDSITUVENDA = 'O' )
                                                                          AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
                                                                          AND ((INSTR(:CDFILIAL, VE.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                                          AND ((INSTR(:CDFILILOJA, VE.CDFILIAL ||VE.CDLOJA)   <> 0) OR (:TCDFILILOJA = 'T'))
                                                                          AND ((INSTR(:CDFILILOJACAIXA, VE.CDFILIAL||VE.CDLOJA||VE.CDCAIXA) <> 0) OR (:TCDFILILOJACAIXA = 'T'))
                                                                          AND ((INSTR(:DTABERCAIX, TO_CHAR(VE.DTABERTUR, 'DD/MM/YYYY HH24:MI:SS')) <> 0) OR (:TDTABERCAIX = 'T'))
                                                                          AND (VE.NRORG = :NRORG)
                                                                        GROUP BY IV.CDPRODUTO, IV.CDFILIAL, IV.CDLOJA, IV.NRORG, IV.VRUNITVEND, IV.VRUNITVENDCL
                                                                        ORDER BY 5 DESC) PRODVALORTOT
                                                                ORDER BY 1, 2, 3 DESC
                                                                ) VRTOTAL
                                                        ORDER BY 2, 3, 1) RANKING
    WHERE RANKING.VRTOTAL = TAB.VRTOTAL
      AND RANKING.CDFILIAL = TAB.CDFILIAL
      AND RANKING.CDLOJA = TAB.CDLOJA
      AND RANKING.NRORG = TAB.NRORG
    ORDER BY LINHA
  ";

  const REL_PRODUTOS_MAIS_VENDIDOS_QTDE = "
    SELECT RANKING.LINHA AS LINHA, TAB.*
      FROM (SELECT PR.CDPRODUTO,
                    VE.NRORG,
                    TRUNC(SUM(IV.QTPRODVEND), 2) AS QTDE,
                    PR.CDARVPROD || ' - ' ||
                    PR.NMPRODUTO AS NMPRODUTO,
                    SUM(TRUNC(IV.QTPRODVEND * (NVL(IV.VRUNITVEND,0) + NVL(IV.VRUNITVENDCL,0)),2) - NVL(IV.VRDESITVEND,0) + NVL(IV.VRACRITVEND,0)) AS VRTOTAL,
                    IV.VRUNITVEND           + IV.VRUNITVENDCL                                                                                     AS VALOR,
                    VE.CDFILIAL,
                    VE.CDLOJA,
                    LJ.NMLOJA,
                    VE.CDFILIAL
                    || ' - '
                    || FI.NMFILIAL
                    || ' - '
                    || ' Loja: '
                    || VE.CDLOJA
                    || ' - '
                    || LJ.NMLOJA
                    || ' - Período: de '
                    || :DTVENDAINI
                    || ' até '
                    || :DTVENDAFIN             AS LABELFILIAL,
                    SUM(NVL(IV.VRDESITVEND,0)) AS DESCONTO,
                    IV.VRUNITVENDCL,
                    SUM(NVL(IV.VRACRITVEND,0))   AS ACRESCIMO,
                    PR.SGUNIDADE,
                    PR.CDNVPRODUTO
              FROM VENDA VE JOIN FILIAL FI
                              ON (FI.CDFILIAL = VE.CDFILIAL )
                             AND (FI.NRORG   = VE.NRORG )
                            JOIN LOJA LJ
                              ON (LJ.CDFILIAL = VE.CDFILIAL )
                             AND (LJ.CDLOJA  = VE.CDLOJA )
                             AND (LJ.NRORG   = VE.NRORG )
                            JOIN ITEMVENDA IV
                              ON (IV.CDFILIAL    = VE.CDFILIAL )
                             AND (IV.CDLOJA     = VE.CDLOJA )
                             AND (IV.CDCAIXA    = VE.CDCAIXA )
                             AND (IV.NRSEQVENDA = VE.NRSEQVENDA )
                             AND (IV.NRORG      = VE.NRORG )
                            JOIN PRODUTO PR
                              ON (PR.CDPRODUTO      = IV.CDPRODUTO )
                             AND (PR.NRORG         = VE.NRORG )
             WHERE (VE.IDSITUVENDA = 'O' )
               AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
               AND ((INSTR(:CDFILIAL, VE.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
               AND ((INSTR(:CDFILILOJA, VE.CDFILIAL ||VE.CDLOJA)   <> 0) OR (:TCDFILILOJA = 'T'))
               AND ((INSTR(:CDFILILOJACAIXA, VE.CDFILIAL||VE.CDLOJA||VE.CDCAIXA) <> 0) OR (:TCDFILILOJACAIXA = 'T'))
               AND ((INSTR(:DTABERCAIX, TO_CHAR(VE.DTABERTUR, 'DD/MM/YYYY HH24:MI:SS')) <> 0) OR (:TDTABERCAIX = 'T'))
               AND (VE.NRORG = :NRORG)
             GROUP BY VE.CDFILIAL, VE.CDLOJA, VE.NRORG, LJ.NMLOJA, FI.NMFILIAL, PR.CDPRODUTO, PR.NMPRODUTO,
                      PR.SGUNIDADE, PR.CDNVPRODUTO, IV.VRUNITVEND, IV.VRUNITVENDCL, PR.CDARVPROD
     ORDER BY VE.CDFILIAL, VE.CDLOJA, QTDE DESC) TAB, (SELECT ROWNUM LINHA, CDFILIAL, CDLOJA, QTDE, NRORG
                                                         FROM (SELECT DISTINCT CDFILIAL, CDLOJA, QTDE, NRORG
                                                                 FROM (SELECT DISTINCT IV.CDPRODUTO, IV.CDFILIAL, IV.CDLOJA, IV.NRORG,
                                                                               IV.VRUNITVEND, IV.VRUNITVENDCL,
                                                                              TRUNC(SUM(IV.QTPRODVEND), 2) AS QTDE
                                                                         FROM VENDA VE JOIN ITEMVENDA IV
                                                                                         ON (IV.CDFILIAL    = VE.CDFILIAL )
                                                                                        AND (IV.CDLOJA     = VE.CDLOJA )
                                                                                        AND (IV.CDCAIXA    = VE.CDCAIXA )
                                                                                        AND (IV.NRSEQVENDA = VE.NRSEQVENDA )
                                                                                        AND (IV.NRORG      = VE.NRORG)
                                                                        WHERE (VE.IDSITUVENDA = 'O' )
                                                                          AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
                                                                          AND ((INSTR(:CDFILIAL, VE.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                                          AND ((INSTR(:CDFILILOJA, VE.CDFILIAL ||VE.CDLOJA)   <> 0) OR (:TCDFILILOJA = 'T'))
                                                                          AND ((INSTR(:CDFILILOJACAIXA, VE.CDFILIAL||VE.CDLOJA||VE.CDCAIXA) <> 0) OR (:TCDFILILOJACAIXA = 'T'))
                                                                          AND ((INSTR(:DTABERCAIX, TO_CHAR(VE.DTABERTUR, 'DD/MM/YYYY HH24:MI:SS')) <> 0) OR (:TDTABERCAIX = 'T'))
                                                                          AND (VE.NRORG = :NRORG)
                                                                        GROUP BY IV.CDPRODUTO, IV.CDFILIAL, IV.CDLOJA, IV.NRORG, IV.VRUNITVEND, IV.VRUNITVENDCL
                                                                        ORDER BY 5 DESC) PRODQUANT
                                                                ORDER BY 1, 2, 3 DESC
                                                                ) QUANTIDADE
                                                        ORDER BY 2, 3, 1) RANKING
    WHERE RANKING.QTDE = TAB.QTDE
      AND RANKING.CDFILIAL = TAB.CDFILIAL
      AND RANKING.CDLOJA = TAB.CDLOJA
      AND RANKING.NRORG = TAB.NRORG
    ORDER BY LINHA
  ";

  const BUSCA_DATA_OBS_DESCONTO = "
   SELECT
       F.CDFILIAL, F.NMFILIAL, L.CDLOJA, L.NMLOJA, V.CDCAIXA, NVL(V.NRNOTAFISCALCE, V.NRCUPOMFIS) AS CUPOM, V.DTENTRVENDA, P.CDPRODUTO, P.CDARVPROD,  P.CDARVPROD || ' - ' || P.NMPRODUTO AS NMPRODUTO,
       V.CDGRPOCORDESC, G.DSGRPOCOR, V.DSOBSDESC, V.CDSUPERVISOR, P1.NMOPERADOR AS NMSUPERVISOR, V.CDOPERADOR, P2.NMOPERADOR, V.CDCONSUMIDOR, O.NMCONSUMIDOR, F.CDFILIAL || ' - ' || F.NMFILIAL || '         - ' || '         Loja: ' || L.NMLOJA || '       -       Período: de ' || :P_DTINI || ' até ' || :P_DTFIN AS LABELLOJA,
       SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) + NVL(I.VRACRITVEND,0) - NVL(I.VRDESITVEND,0)) AS VRVENDA,
       SUM(NVL(I.VRDESITVEND,0)) AS VRDESC, 'CUPOM' AS TIPODESC
    FROM
       FILIAL F, LOJA L, VENDA V, ITEMVENDA I, PRODUTO P, GRUPOCOR G, CONSUMIDOR O, OPERADOR P1, OPERADOR P2
    WHERE
       ((INSTR(:CDFILIAL, F.CDFILIAL          ) <> 0) OR (:P_TCDFILIAL = 'T')) AND
       ((INSTR(:CDLOJA  , L.CDFILIAL||L.CDLOJA) <> 0) OR (:P_TCDLOJA   = 'T')) AND
       (L.CDFILIAL      = F.CDFILIAL       ) AND
       (V.IDSITUVENDA   = 'O'              ) AND
       (V.DTENTRVENDA BETWEEN TO_DATE(:P_DTINI, 'DD/MM/YYYY') AND TO_DATE(:P_DTFIN, 'DD/MM/YYYY')) AND
       (V.CDFILIAL      = L.CDFILIAL       ) AND
       (V.CDLOJA        = L.CDLOJA         ) AND
       (I.CDFILIAL      = V.CDFILIAL       ) AND
       (I.CDCAIXA       = V.CDCAIXA        ) AND
       (I.NRSEQVENDA    = V.NRSEQVENDA     ) AND
       (I.CDPRODUTO     = P.CDPRODUTO      ) AND
       (V.CDGRPOCORDESC = G.CDGRPOCOR      ) AND
       (L.NRORG = :NRORG) AND
       (V.NRORG = L.NRORG) AND
       (V.NRORG = I.NRORG) AND
       (P.NRORG = I.NRORG) AND
       (V.CDCLIENTE     = O.CDCLIENTE   (+)) AND
       (V.CDCONSUMIDOR  = O.CDCONSUMIDOR(+)) AND
       (V.CDSUPERVISOR  = P1.CDOPERADOR (+)) AND
       (V.CDOPERADOR    = P2.CDOPERADOR (+))
    GROUP BY
       F.CDFILIAL, F.NMFILIAL, L.CDLOJA, L.NMLOJA, V.CDCAIXA, V.NRCUPOMFIS, V.NRNOTAFISCALCE, V.DTENTRVENDA, P.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO,
       V.CDGRPOCORDESC, G.DSGRPOCOR, V.DSOBSDESC, V.CDSUPERVISOR, P1.NMOPERADOR, V.CDOPERADOR, P2.NMOPERADOR, V.CDCONSUMIDOR, O.NMCONSUMIDOR

    UNION

    SELECT
       F.CDFILIAL, F.NMFILIAL, L.CDLOJA, L.NMLOJA, V.CDCAIXA, NVL(V.NRNOTAFISCALCE, V.NRCUPOMFIS) AS CUPOM, V.DTENTRVENDA, P.CDPRODUTO, P.CDARVPROD,  P.CDARVPROD || ' - ' || P.NMPRODUTO AS NMPRODUTO,
       I.CDGRPOCORDESCIT, G.DSGRPOCOR, I.DSOBSDESCIT, I.CDSUPERVDESC, P1.NMOPERADOR AS NMSUPERVISOR, V.CDOPERADOR, P2.NMOPERADOR, V.CDCONSUMIDOR, O.NMCONSUMIDOR, F.CDFILIAL || ' - ' || F.NMFILIAL || '         - ' || '         Loja: ' || L.NMLOJA || '       -       Período: de ' || :P_DTINI || ' até ' || :P_DTFIN AS LABELLOJA,
       SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) + NVL(I.VRACRITVEND,0) - NVL(I.VRDESITVEND,0)) AS VRVENDA,
       SUM(NVL(I.VRDESITVEND,0)) AS VRDESC, 'ITEM' AS TIPODESC
    FROM
       FILIAL F, LOJA L, VENDA V, ITEMVENDA I, PRODUTO P, GRUPOCOR G, CONSUMIDOR O, OPERADOR P1, OPERADOR P2
    WHERE
       ((INSTR(:CDFILIAL, F.CDFILIAL          ) <> 0) OR (:P_TCDFILIAL = 'T')) AND
       ((INSTR(:CDLOJA  , L.CDFILIAL||L.CDLOJA) <> 0) OR (:P_TCDLOJA   = 'T')) AND
       (L.CDFILIAL        = F.CDFILIAL       ) AND
       (V.IDSITUVENDA     = 'O'              ) AND
       (V.DTENTRVENDA BETWEEN TO_DATE(:P_DTINI, 'dd/mm/YYYY') AND TO_DATE(:P_DTFIN, 'dd/mm/YYYY')) AND
       (V.CDFILIAL        = L.CDFILIAL       ) AND
       (V.CDLOJA          = L.CDLOJA         ) AND
       (I.CDFILIAL        = V.CDFILIAL       ) AND
       (I.CDCAIXA         = V.CDCAIXA        ) AND
       (I.NRSEQVENDA      = V.NRSEQVENDA     ) AND
       (I.CDPRODUTO       = P.CDPRODUTO      ) AND
       (I.CDGRPOCORDESCIT = G.CDGRPOCOR      ) AND
       (L.NRORG = :NRORG) AND
       (V.NRORG = L.NRORG) AND
       (V.NRORG = I.NRORG) AND
       (P.NRORG = I.NRORG) AND
       (V.CDCLIENTE       = O.CDCLIENTE   (+)) AND
       (V.CDCONSUMIDOR    = O.CDCONSUMIDOR(+)) AND
       (I.CDSUPERVDESC    = P1.CDOPERADOR (+)) AND
       (V.CDOPERADOR      = P2.CDOPERADOR (+))
    GROUP BY
       F.CDFILIAL, F.NMFILIAL, L.CDLOJA, L.NMLOJA, V.CDCAIXA, V.NRCUPOMFIS, V.NRNOTAFISCALCE, V.DTENTRVENDA, P.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO,
       I.CDGRPOCORDESCIT, G.DSGRPOCOR, I.DSOBSDESCIT, I.CDSUPERVDESC, P1.NMOPERADOR, V.CDOPERADOR, P2.NMOPERADOR, V.CDCONSUMIDOR, O.NMCONSUMIDOR

    UNION

    SELECT
       F.CDFILIAL, F.NMFILIAL, L.CDLOJA, L.NMLOJA, V.CDCAIXA, NVL(V.NRNOTAFISCALCE, V.NRCUPOMFIS) AS CUPOM, V.DTENTRVENDA, P.CDPRODUTO, P.CDARVPROD,  P.CDARVPROD || ' - ' || P.NMPRODUTO AS NMPRODUTO,
       '', '', '', '', P1.NMOPERADOR AS NMSUPERVISOR, V.CDOPERADOR, P2.NMOPERADOR, V.CDCONSUMIDOR, O.NMCONSUMIDOR, F.CDFILIAL || ' - ' || F.NMFILIAL || '         - ' || '         Loja: ' || L.NMLOJA || '       -       Período: de ' || :P_DTINI || ' até ' || :P_DTFIN AS LABELLOJA,
       SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) + NVL(I.VRACRITVEND,0) - NVL(I.VRDESITVEND,0)) AS VRVENDA,
       SUM(NVL(I.VRDESITVEND,0)) AS VRDESC, 'OBS' AS TIPODESC
    FROM
       FILIAL F, LOJA L, VENDA V, ITEMVENDA I, PRODUTO P, GRUPOCOR G, CONSUMIDOR O, OPERADOR P1, OPERADOR P2
    WHERE
       ((INSTR(:CDFILIAL, F.CDFILIAL          ) <> 0) OR (:P_TCDFILIAL = 'T')) AND
       ((INSTR(:CDLOJA  , L.CDFILIAL||L.CDLOJA) <> 0) OR (:P_TCDLOJA   = 'T')) AND
       (L.CDFILIAL        = F.CDFILIAL       ) AND
       (V.IDSITUVENDA     = 'O'              ) AND
       (V.DTENTRVENDA BETWEEN TO_DATE(:P_DTINI, 'dd/mm/YYYY') AND TO_DATE(:P_DTFIN, 'dd/mm/YYYY')) AND
       (V.CDFILIAL        = L.CDFILIAL       ) AND
       (V.CDLOJA          = L.CDLOJA         ) AND
       (I.CDFILIAL        = V.CDFILIAL       ) AND
       (I.CDCAIXA         = V.CDCAIXA        ) AND
       (I.NRSEQVENDA      = V.NRSEQVENDA     ) AND
       (I.CDPRODUTO       = P.CDPRODUTO      ) AND
       (L.NRORG = :NRORG) AND
       (V.NRORG = L.NRORG) AND
       (V.NRORG = I.NRORG) AND
       (P.NRORG = I.NRORG) AND
       ((I.CDGRPOCORDESCIT IS NULL           ) AND (V.CDGRPOCORDESC IS NULL)) AND
       (V.CDCLIENTE       = O.CDCLIENTE   (+)) AND
       (V.CDCONSUMIDOR    = O.CDCONSUMIDOR(+)) AND
       (I.CDSUPERVDESC    = P1.CDOPERADOR (+)) AND
       (V.CDOPERADOR      = P2.CDOPERADOR (+)) AND
       (I.VRDESITVEND > 0                    )
    GROUP BY
       F.CDFILIAL, F.NMFILIAL, L.CDLOJA, L.NMLOJA, V.CDCAIXA, V.NRCUPOMFIS, V.NRNOTAFISCALCE, V.DTENTRVENDA, P.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO,
       I.CDGRPOCORDESCIT, G.DSGRPOCOR, I.DSOBSDESCIT, I.CDSUPERVDESC, P1.NMOPERADOR, V.CDOPERADOR, P2.NMOPERADOR, V.CDCONSUMIDOR, O.NMCONSUMIDOR
    ORDER BY
       1, 3, 5, 6
  ";

    const UPDATE_ITEMPRECO_INLINE_PRECODIFERENCIADO = "
      UPDATE ITEMPRECODIA
      SET VRPRECODIA = :VRPRECODIA
      WHERE CDFILIAL = :CDFILIAL
        AND CDTABEPREC = :CDTABEPREC
        AND DTINIVGPREC = :DTINIVGPREC
        AND CDPRODUTO = :CDPRODUTO
        AND CDPRPAITABPR = :CDPRPAITABPR
        AND NRDIASEMANPR = :NRDIASEMANPR
        AND HRINIPRECDIA = :HRINIPRECDIA
        AND CDTIPOCONSPD = :CDTIPOCONSPD
        AND NRORG = :NRORG
  ";

const BUSCA_REL_IMPOSTO_PRODUTO = "
      SELECT
      VE.CDFILIAL, F.NMFILIAL, VE.IDTPEMISVEND,
      PR.NMPRODUTO, F.NMFILIAL || '   -   ' || 'Período:  de ' || :DTVENDAINI || ' até ' || :DTVENDAFIN AS LABELFILIAL,
      SUM(IT.QTPRODVEND) AS QTPRODVEND, PR.SGUNIDADE, IT.VRUNITVEND,
      PR.CDARVPROD, PR.NMPRODUTO, PR.CDARVPROD || ' - ' || PR.NMPRODUTO AS CDNMPRODUTO,
      SUM(IT.QTPRODVEND) AS QTPRODVEND, PR.SGUNIDADE, IT.VRUNITVEND,
      II.CDIMPOSTO, I.SGIMPOSTO, II.VRPEALPRODIT,
      TRUNC(SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPEALPRODIT / 100),2) AS VRIMPOPRODIT,
      SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS TOTALVEND,
      VE.CDCAIXA, VE.DTENTRVENDA, IT.CDPRODUTO, SUM(II.VRIMPPIS) AS VRIMPPIS, SUM(II.VRIMPCOFINS) AS VRIMPCOFINS
  FROM
      VENDA VE, ITEMVENDA IT, ITVENDAIMPOS II, PRODUTO PR, FILIAL F, IMPOSTO I
  WHERE ((INSTR(:CDFILIAL, VE.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
      AND ((INSTR(:CDCAIXA, VE.CDFILIAL||VE.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T'))
      AND ( (:TCDIMPOSTO = 'T'))
      AND ( (:TCDPRODUTO = 'T') OR (PR.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM))
      AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
      AND (VE.IDSITUVENDA = 'O')
      AND (VE.NRORG = :NRORG)
      AND (IT.NRORG = VE.NRORG)
      AND (PR.NRORG = VE.NRORG)
      AND (F.NRORG = VE.NRORG)
      AND (I.NRORG = VE.NRORG)
      AND (II.NRORG = VE.NRORG)
      AND (IT.CDFILIAL = VE.CDFILIAL)
      AND (IT.CDCAIXA = VE.CDCAIXA)
      AND (IT.NRSEQVENDA = VE.NRSEQVENDA)
      AND (IT.CDFILIAL = II.CDFILIAL)
      AND (IT.CDCAIXA = II.CDCAIXA)
      AND (IT.NRSEQVENDA = II.NRSEQVENDA)
      AND (IT.NRSEQUITVEND = II.NRSEQUITVEND)
      AND (II.CDIMPOSTO = I.CDIMPOSTO)
      AND (PR.CDPRODUTO = IT.CDPRODUTO)
      AND (F.CDFILIAL = VE.CDFILIAL)
  GROUP BY
      VE.CDFILIAL, F.NMFILIAL, VE.IDTPEMISVEND, PR.CDARVPROD, PR.NMPRODUTO,
      II.CDIMPOSTO, I.SGIMPOSTO, II.VRPEALPRODIT,
      PR.SGUNIDADE, IT.VRUNITVEND, VE.CDCAIXA, VE.DTENTRVENDA, IT.CDPRODUTO
  ORDER BY  VE.CDFILIAL, II.CDIMPOSTO, PR.CDARVPROD,PR.NMPRODUTO
    ";
    const BUSCA_PIS_CONFINS_IMPOSTO_PRODUTO = "

    SELECT NVL(A.COFINS,0) AS COFINS, NVL(B.PIS,0) AS PIS
    FROM
     (SELECT ((IP.VRALIQIT /100)* IP.VRPRODUTO) AS COFINS
        FROM ITEMVENOUTIMPOS IP , IMPOSTO I
       WHERE IP.CDFILIAL =  :CDFILIAL
           AND IP.CDCAIXA = :CDCAIXA
           AND IP.CDPRODUTO  = :CDPRODUTO
           AND IP.DTREDUCAOZ  = :DTENTRVENDA
           AND I.SGIMPOSTO = 'COFINS'
           AND I.NRORG = :NRORG
           AND IP.NRORG = :NRORG
           AND I.CDIMPOSTO = IP.CDIMPOSTO) A,

     (SELECT ((IP.VRALIQIT /100)* IP.VRPRODUTO) AS PIS
        FROM ITEMVENOUTIMPOS IP , IMPOSTO I
       WHERE IP.CDFILIAL  =  :CDFILIAL
           AND IP.CDCAIXA = :CDCAIXA
           AND IP.CDPRODUTO  = :CDPRODUTO
           AND IP.DTREDUCAOZ = :DTENTRVENDA
           AND I.SGIMPOSTO = 'PIS'
           AND I.NRORG = :NRORG
           AND IP.NRORG = :NRORG
           AND I.CDIMPOSTO = IP.CDIMPOSTO) B
      ";

  const BUSCA_FILIAL_REL_IMPOSTO_PRODUTO_GERAL = "
  SELECT DISTINCT (VE.CDFILIAL) CDFILIAL
  FROM VENDA VE, ITVENDAIMPOS II, ITEMVENDA IT, PRODUTO PR
  WHERE ((INSTR(:CDFILIAL, VE.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
    AND ((INSTR(:CDCAIXA, VE.CDFILIAL||VE.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T'))
    AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
    AND ((INSTR(:CDPRODUTO, PR.CDARVPROD) <> 0) OR (:TCDPRODUTO = 'T') OR (PR.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM))
    AND ((INSTR(:CDIMPOSTO, II.CDIMPOSTO) <> 0) OR (:TCDIMPOSTO = 'T'))
    AND (VE.IDSITUVENDA = 'O')
    AND (VE.CDFILIAL = IT.CDFILIAL)
    AND (VE.CDCAIXA = IT.CDCAIXA )
    AND (VE.NRORG = :NRORG)
    AND (IT.NRORG = VE.NRORG)
    AND (PR.NRORG = VE.NRORG)
    AND (II.NRORG = VE.NRORG)
    AND (VE.NRSEQVENDA = IT.NRSEQVENDA)
    AND (IT.CDFILIAL = II.CDFILIAL)
    AND (IT.CDCAIXA = II.CDCAIXA )
    AND (IT.NRSEQVENDA = II.NRSEQVENDA)
    AND (IT.NRSEQUITVEND = II.NRSEQUITVEND)
    AND (IT.CDPRODUTO = PR.CDPRODUTO)
  ";
  const BUSCA_IMPOSTO_REL_IMPOSTO_PRODUTO_GERAL = "
  SELECT
    VE.CDFILIAL, II.CDIMPOSTO, I.SGIMPOSTO,
    SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPEALPRODIT / 100) AS VRIMPOPRODIT
  FROM
    VENDA VE, TURCAIXA TC, ITEMVENDA IT, ITVENDAIMPOS II, PRODUTO PR, FILIAL F, IMPOSTO I
  WHERE VE.CDFILIAL = :CDFILIAL
    AND ((INSTR(:CDCAIXA, VE.CDFILIAL||VE.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T'))
    AND ((INSTR(:CDIMPOSTO, II.CDIMPOSTO) <> 0) OR (:TCDIMPOSTO = 'T'))
    AND ((INSTR(:CDPRODUTO, PR.CDARVPROD) <> 0) OR (:TCDPRODUTO = 'T') OR (PR.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM))
    AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
    AND (VE.IDSITUVENDA = 'O')
    AND (TC.CDFILIAL = VE.CDFILIAL)
    AND (TC.CDCAIXA = VE.CDCAIXA)
    AND (TC.DTABERCAIX = VE.DTABERTUR)
    AND (IT.CDFILIAL = VE.CDFILIAL)
    AND (IT.CDCAIXA = VE.CDCAIXA)
    AND (IT.NRSEQVENDA = VE.NRSEQVENDA)
    AND (IT.CDFILIAL = II.CDFILIAL)
    AND (IT.CDCAIXA = II.CDCAIXA)
    AND (IT.NRSEQVENDA = II.NRSEQVENDA)
    AND (IT.NRSEQUITVEND = II.NRSEQUITVEND)
    AND (II.CDIMPOSTO = I.CDIMPOSTO)
    AND (PR.CDPRODUTO = IT.CDPRODUTO)
    AND (F.CDFILIAL = VE.CDFILIAL)
    AND (VE.NRORG = :NRORG)
    AND (TC.NRORG = VE.NRORG)
    AND (IT.NRORG = VE.NRORG)
    AND (II.NRORG = VE.NRORG)
    AND (PR.NRORG = VE.NRORG)
    AND (F.NRORG = VE.NRORG)
    AND (I.NRORG = VE.NRORG)
  GROUP BY
    VE.CDFILIAL, II.CDIMPOSTO, I.SGIMPOSTO
  ORDER BY VE.CDFILIAL, II.CDIMPOSTO, I.SGIMPOSTO
    ";

  const BUSCA_REL_IMPOSTO_PRODUTO_GERAL = "
    SELECT
      VE.CDFILIAL, F.NMFILIAL, F.NMFILIAL || '   -   ' || 'Período:  de ' || :DTVENDAINI || ' até ' || :DTVENDAFIN || ' | ' AS LABELFILIAL,
      TC.NRECFTURCAIX, VE.NRCUPOMFIS, VE.DTVENDA,
      PR.CDARVPROD, PR.NMPRODUTO, PR.CDARVPROD || ' - ' || PR.NMPRODUTO AS CDNMPRODUTO,
      SUM(IT.QTPRODVEND) AS QTPRODVEND, PR.SGUNIDADE, IT.VRUNITVEND,
      II.CDIMPOSTO, I.SGIMPOSTO, II.VRPEALPRODIT,
      SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPEALPRODIT / 100) AS VRIMPOPRODIT,
      SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS TOTALVEND
    FROM
      VENDA VE, TURCAIXA TC, ITEMVENDA IT, ITVENDAIMPOS II, PRODUTO PR, FILIAL F, IMPOSTO I
    WHERE ((INSTR(:CDFILIAL, VE.CDFILIAL) <> 0)
         OR (:TCDFILIAL = 'T'))
      AND ((INSTR(:CDCAIXA, VE.CDFILIAL||VE.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T'))
      AND ((INSTR(:CDPRODUTO, PR.CDARVPROD) <> 0) OR (:TCDPRODUTO = 'T') OR (PR.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM))
      AND ((INSTR(:CDIMPOSTO, II.CDIMPOSTO) <> 0) OR (:TCDIMPOSTO = 'T'))
      AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
      AND (VE.IDSITUVENDA = 'O')
      AND (TC.CDFILIAL = VE.CDFILIAL)
      AND (TC.CDCAIXA = VE.CDCAIXA)
      AND (TC.DTABERCAIX = VE.DTABERTUR)
      AND (IT.CDFILIAL = VE.CDFILIAL)
      AND (IT.CDCAIXA = VE.CDCAIXA)
      AND (IT.NRSEQVENDA = VE.NRSEQVENDA)
      AND (IT.CDFILIAL = II.CDFILIAL)
      AND (IT.CDCAIXA = II.CDCAIXA)
      AND (IT.NRSEQVENDA = II.NRSEQVENDA)
      AND (IT.NRSEQUITVEND = II.NRSEQUITVEND)
      AND (II.CDIMPOSTO = I.CDIMPOSTO)
      AND (PR.CDPRODUTO = IT.CDPRODUTO)
      AND (F.CDFILIAL = VE.CDFILIAL)
      AND (VE.NRORG = :NRORG)
      AND (TC.NRORG = VE.NRORG)
      AND (IT.NRORG = VE.NRORG)
      AND (PR.NRORG = VE.NRORG)
      AND (F.NRORG = VE.NRORG)
      AND (I.NRORG = VE.NRORG)
      AND (II.NRORG = VE.NRORG)
    GROUP BY
      VE.CDFILIAL, F.NMFILIAL,
      TC.NRECFTURCAIX, VE.NRCUPOMFIS, VE.DTVENDA,
      PR.CDARVPROD, PR.NMPRODUTO, PR.SGUNIDADE, IT.VRUNITVEND,
      II.CDIMPOSTO, I.SGIMPOSTO, II.VRPEALPRODIT
    ORDER BY VE.CDFILIAL, TC.NRECFTURCAIX, VE.DTVENDA, VE.NRCUPOMFIS,  II.CDIMPOSTO,PR.CDARVPROD
";

    const BUSCA_REL_IMPOSTO_NFCESAT = "
    SELECT FI.CDFILIAL,
       FI.NMFILIAL,
       PR.CDARVPROD,
       FI.NMFILIAL || '   -   ' || 'Período:  de ' || :DTVENDAINI || ' até ' || :DTVENDAFIN AS LABELFILIAL,
       PR.CDARVPROD || ' - ' || PR.NMPRODUTO AS NMPRODUTO,
       PR.SGUNIDADE,
       SUM(IT.QTPRODVEND) AS QTPRODVEND,
       II.VRPEALPRODIT,
       II.VRPERPIS,
       II.VRPERCOFINS,
       SUM(TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS VRPRODVEN,
       SUM(NVL(II.VRBASECALCREDUZ,0)) AS VRBASECALCREDUZ,
       SUM(TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS VRBCICMS,

       SUM(DECODE(VE.IDTPEMISVEND,'N',TRUNC((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPEALPRODIT / 100,2),
                                  ROUND((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPEALPRODIT / 100,2))) AS VRICMS,
       SUM(TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS VRBCPIS,

       SUM(DECODE(VE.IDTPEMISVEND,'N',TRUNC((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) * II.VRPERPIS / 100,2),
                                  ROUND((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) * II.VRPERPIS / 100,2))) AS VRPIS,
       SUM(TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS VRBCCOFINS,

       SUM(DECODE(VE.IDTPEMISVEND,'N',TRUNC((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) * II.VRPERCOFINS / 100,2),
                                  ROUND((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) * II.VRPERCOFINS / 100,2))) AS VRCOFINS
  FROM VENDA VE, ITEMVENDA IT, ITVENDAIMPOS II, PRODUTO PR, FILIAL FI
  WHERE VE.CDFILIAL = II.CDFILIAL
   AND VE.CDCAIXA  = II.CDCAIXA
   AND VE.NRSEQVENDA = II.NRSEQVENDA
   AND IT.CDFILIAL = II.CDFILIAL
   AND IT.CDCAIXA  = II.CDCAIXA
   AND IT.NRSEQVENDA = II.NRSEQVENDA
   AND IT.NRSEQUITVEND = II.NRSEQUITVEND
   AND IT.CDPRODUTO = PR.CDPRODUTO
   AND FI.CDFILIAL = VE.CDFILIAL
   AND VE.IDTPAMBNFCE = '1'
   AND VE.IDSITUVENDA = 'O'
   AND VE.IDTPEMISVEND IN ('S','N')
   AND VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
   AND ((INSTR(:CDFILIAL , VE.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T'))
   AND ((INSTR(:CDCAIXA  , VE.CDFILIAL||VE.CDCAIXA ) <> 0) OR (:TCDCAIXA = 'T'))
   AND ((:TCDIMPOSTO = 'T'))
   AND ((:TCDPRODUTO = 'T'))
   AND (VE.NRORG = :NRORG)
   AND (IT.NRORG = VE.NRORG)
   AND (II.NRORG = VE.NRORG)
   AND (PR.NRORG = VE.NRORG)
   AND (FI.NRORG = VE.NRORG)
   GROUP BY FI.CDFILIAL,
            FI.NMFILIAL,
            PR.CDARVPROD,
            PR.NMPRODUTO,
            PR.SGUNIDADE,
            II.VRPEALPRODIT,
            II.VRPERPIS,
            II.VRPERCOFINS
  ORDER BY FI.CDFILIAL, PR.NMPRODUTO
  ";



  const BUSCA_REL_IMPOSTO_CUPOM_FISCAL = "
  SELECT
  F.NMFILIAL || '   -   ' || 'Período:  de ' || :DTVENDAINI || ' até ' || :DTVENDAFIN AS LABELFILIAL,
  TC.NRECFTURCAIX || ' - Nr.Cupom Fiscal: ' ||  (CASE WHEN VE.IDTPEMISVEND = 'E' THEN VE.NRCUPOMFIS ELSE VE.NRNOTAFISCALCE END) || ' - Data Venda: ' || VE.DTVENDA AS LABELCUPOM,

  VE.CDFILIAL, F.NMFILIAL,
  TC.NRECFTURCAIX, VE.DTVENDA,
  PR.CDARVPROD, PR.NMPRODUTO,
  (CASE WHEN VE.IDTPEMISVEND = 'E' THEN VE.NRCUPOMFIS ELSE VE.NRNOTAFISCALCE END) AS NRCUPOMFIS,
  SUM(IT.QTPRODVEND) AS QTPRODVEND, PR.SGUNIDADE, IT.VRUNITVEND,
  II.CDIMPOSTO, I.SGIMPOSTO, II.VRPEALPRODIT,
  TRUNC(SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) + NVL(IT.VRACRITVEND,) - NVL(IT.VRDESITVEND,0)) * II.VRPEALPRODIT / 100),2) AS VRIMPOPRODIT,
  SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS TOTALVEND
FROM
  VENDA VE, TURCAIXA TC, ITEMVENDA IT, ITVENDAIMPOS II, PRODUTO PR, FILIAL F, IMPOSTO I
WHERE ((INSTR(:CDFILIAL, VE.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
  AND ((INSTR(:CDCAIXA, VE.CDFILIAL||VE.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T'))
  AND ((:TCDPRODUTO = 'T') OR (PR.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM))
  AND ((INSTR(:CDIMPOSTO, II.CDIMPOSTO) <> 0) OR (:TCDIMPOSTO = 'T'))
  AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
  AND (VE.IDSITUVENDA = 'O')
  AND (TC.CDFILIAL = VE.CDFILIAL)
  AND (TC.CDCAIXA = VE.CDCAIXA)
  AND (TC.DTABERCAIX = VE.DTABERTUR)
  AND (IT.CDFILIAL = VE.CDFILIAL)
  AND (IT.CDCAIXA = VE.CDCAIXA)
  AND (IT.NRSEQVENDA = VE.NRSEQVENDA)
  AND (IT.CDFILIAL = II.CDFILIAL)
  AND (IT.CDCAIXA = II.CDCAIXA)
  AND (IT.NRSEQVENDA = II.NRSEQVENDA)
  AND (IT.NRSEQUITVEND = II.NRSEQUITVEND)
  AND (II.CDIMPOSTO = I.CDIMPOSTO)
  AND (PR.CDPRODUTO = IT.CDPRODUTO)
  AND (F.CDFILIAL = VE.CDFILIAL)
  AND (VE.NRORG = :NRORG)
  AND (TC.NRORG = VE.NRORG)
  AND (IT.NRORG = VE.NRORG)
  AND (II.NRORG = VE.NRORG)
  AND (PR.NRORG = VE.NRORG)
  AND (F.NRORG = VE.NRORG)
  AND (I.NRORG = VE.NRORG)
GROUP BY
  VE.CDFILIAL, F.NMFILIAL,  TC.NRECFTURCAIX, VE.IDTPEMISVEND, VE.NRCUPOMFIS, VE.NRNOTAFISCALCE,
  VE.DTVENDA, PR.CDARVPROD, PR.NMPRODUTO, PR.SGUNIDADE, IT.VRUNITVEND,
  II.CDIMPOSTO, I.SGIMPOSTO, II.VRPEALPRODIT
UNION ALL
SELECT
  F.NMFILIAL || '   -   ' || 'Período:  de ' || :DTVENDAINI || ' até ' || :DTVENDAFIN AS LABELFILIAL,
  TC.NRECFTURCAIX || ' - Nr.Cupom Fiscal:' || VE.NRNOTAFISCALCE || ' Data Venda: ' || VE.DTVENDA AS LABELCUPOM,

  VE.CDFILIAL, F.NMFILIAL,
  TC.NRECFTURCAIX, VE.DTVENDA,
  PR.CDARVPROD, PR.NMPRODUTO, VE.NRNOTAFISCALCE AS NRCUPOMFIS,
  SUM(IT.QTPRODVEND) AS QTPRODVEND, PR.SGUNIDADE, IT.VRUNITVEND,
  '50' AS CDIMPOSTO, 'PIS' AS SGIMPOSTO, II.VRPERPIS AS VRPEALPRODIT,
  SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPERPIS / 100) AS VRIMPOPRODIT,
  SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS TOTALVEND
FROM
  VENDA VE, TURCAIXA TC, ITEMVENDA IT, ITVENDAIMPOS II, PRODUTO PR, FILIAL F, IMPOSTO I
WHERE ((INSTR(:CDFILIAL, VE.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
  AND ((INSTR(:CDCAIXA, VE.CDFILIAL||VE.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T'))
  AND ((:TCDPRODUTO = 'T') OR (PR.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM))
  AND ((INSTR(:CDIMPOSTO, '50') <> 0) OR (:TCDIMPOSTO = 'T'))
  AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
  AND (VE.IDSITUVENDA = 'O')
  AND (VE.IDTPEMISVEND IN ('S','N'))
  AND (TC.CDFILIAL = VE.CDFILIAL)
  AND (TC.CDCAIXA = VE.CDCAIXA)
  AND (TC.DTABERCAIX = VE.DTABERTUR)
  AND (IT.CDFILIAL = VE.CDFILIAL)
  AND (IT.CDCAIXA = VE.CDCAIXA)
  AND (IT.NRSEQVENDA = VE.NRSEQVENDA)
  AND (IT.CDFILIAL = II.CDFILIAL)
  AND (IT.CDCAIXA = II.CDCAIXA)
  AND (IT.NRSEQVENDA = II.NRSEQVENDA)
  AND (IT.NRSEQUITVEND = II.NRSEQUITVEND)
  AND (II.CDIMPOSTO = I.CDIMPOSTO)
  AND (PR.CDPRODUTO = IT.CDPRODUTO)
  AND (F.CDFILIAL = VE.CDFILIAL)
  AND (VE.NRORG = :NRORG)
  AND (TC.NRORG = VE.NRORG)
  AND (IT.NRORG = VE.NRORG)
  AND (II.NRORG = VE.NRORG)
  AND (PR.NRORG = VE.NRORG)
  AND (F.NRORG = VE.NRORG)
  AND (I.NRORG = VE.NRORG)
GROUP BY
  VE.CDFILIAL, F.NMFILIAL,  TC.NRECFTURCAIX, VE.NRNOTAFISCALCE,
  VE.DTVENDA, PR.CDARVPROD, PR.NMPRODUTO, PR.SGUNIDADE, IT.VRUNITVEND, II.VRPERPIS
UNION ALL
SELECT
  F.NMFILIAL || '   -   ' || 'Período:  de ' || :DTVENDAINI || ' até ' || :DTVENDAFIN AS LABELFILIAL,
  TC.NRECFTURCAIX || ' - Nr.Cupom Fiscal:' || VE.NRNOTAFISCALCE || ' Data Venda: ' || VE.DTVENDA AS LABELCUPOM,
  VE.CDFILIAL, F.NMFILIAL,
  TC.NRECFTURCAIX, VE.DTVENDA,
  PR.CDARVPROD, PR.NMPRODUTO, VE.NRNOTAFISCALCE AS NRCUPOMFIS,
  SUM(IT.QTPRODVEND) AS QTPRODVEND, PR.SGUNIDADE, IT.VRUNITVEND,
  '60' AS CDIMPOSTO, 'COFINS' AS SGIMPOSTO, II.VRPERCOFINS AS VRPEALPRODIT,
  SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPERCOFINS / 100) AS VRIMPOPRODIT,
  SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS TOTALVEND
FROM
  VENDA VE, TURCAIXA TC, ITEMVENDA IT, ITVENDAIMPOS II, PRODUTO PR, FILIAL F, IMPOSTO I
WHERE ((INSTR(:CDFILIAL, VE.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
  AND ((INSTR(:CDCAIXA, VE.CDFILIAL||VE.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T'))
  AND ((:TCDPRODUTO = 'T') OR (PR.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM))
  AND ((INSTR(:CDIMPOSTO, '60') <> 0) OR (:TCDIMPOSTO = 'T'))
  AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
  AND (VE.IDSITUVENDA = 'O')
  AND (VE.IDTPEMISVEND IN ('S','N'))
  AND (TC.CDFILIAL = VE.CDFILIAL)
  AND (TC.CDCAIXA = VE.CDCAIXA)
  AND (TC.DTABERCAIX = VE.DTABERTUR)
  AND (IT.CDFILIAL = VE.CDFILIAL)
  AND (IT.CDCAIXA = VE.CDCAIXA)
  AND (IT.NRSEQVENDA = VE.NRSEQVENDA)
  AND (IT.CDFILIAL = II.CDFILIAL)
  AND (IT.CDCAIXA = II.CDCAIXA)
  AND (IT.NRSEQVENDA = II.NRSEQVENDA)
  AND (IT.NRSEQUITVEND = II.NRSEQUITVEND)
  AND (II.CDIMPOSTO = I.CDIMPOSTO)
  AND (PR.CDPRODUTO = IT.CDPRODUTO)
  AND (F.CDFILIAL = VE.CDFILIAL)
  AND (VE.NRORG = :NRORG)
  AND (TC.NRORG = VE.NRORG)
  AND (IT.NRORG = VE.NRORG)
  AND (II.NRORG = VE.NRORG)
  AND (PR.NRORG = VE.NRORG)
  AND (F.NRORG = VE.NRORG)
  AND (I.NRORG = VE.NRORG)
GROUP BY
  VE.CDFILIAL, F.NMFILIAL,  TC.NRECFTURCAIX, VE.NRNOTAFISCALCE,
  VE.DTVENDA, PR.CDARVPROD, PR.NMPRODUTO, PR.SGUNIDADE, IT.VRUNITVEND, II.VRPERCOFINS
ORDER BY  CDARVPROD
  ";
  const BUSCA_REL_IMPOSTO_SAT = "
  SELECT FI.CDFILIAL,
       FI.NMFILIAL,
       VE.CDCAIXA,
       VE.CDCAIXA || ' - ' || 'Nr. Cupom/Nota: ' || DECODE(VE.IDTPEMISVEND,'E', VE.NRCUPOMFIS, VE.NRNOTAFISCALCE)   AS LABELCAIXA,
       FI.NMFILIAL || '   -   ' || 'Período:  de ' || :DTVENDAINI || ' até ' || :DTVENDAFIN AS LABELFILIAL,
       PR.CDARVPROD || ' - ' || PR.NMPRODUTO AS NMPRODUTO,
       DECODE(VE.IDTPEMISVEND,'E', VE.NRCUPOMFIS, VE.NRNOTAFISCALCE) AS NRNOTAFISCALCE,
       VE.NRACESSONFCE,
       PR.CDARVPROD,
       PR.NMPRODUTO,
       PR.SGUNIDADE,
       IT.QTPRODVEND,
       TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0) AS VRPRODVEN,
       NVL(II.VRBASECALCREDUZ,0) AS VRBASECALCREDUZ,
       TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0) AS VRBCICMS,
       II.VRPEALPRODIT,
       DECODE(VE.IDTPEMISVEND,'N',TRUNC((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPEALPRODIT / 100,2),
                                  ROUND((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPEALPRODIT / 100,2)) AS VRICMS,
       II.CDCFOPPROD,
       TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0) AS VRBCPIS,
       II.VRPERPIS,
       DECODE(VE.IDTPEMISVEND,'N',TRUNC((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) * II.VRPERPIS / 100,2),
                                  ROUND((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) * II.VRPERPIS / 100,2)) AS VRPIS,
       TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0) AS VRBCCOFINS,
       II.VRPERCOFINS,
       DECODE(VE.IDTPEMISVEND,'N',TRUNC((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) * II.VRPERCOFINS / 100,2),
                                  ROUND((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) * II.VRPERCOFINS / 100,2)) AS VRCOFINS,
       IT.VRACRITVEND
  FROM VENDA VE, ITEMVENDA IT, ITVENDAIMPOS II, PRODUTO PR, FILIAL FI
 WHERE VE.CDFILIAL = II.CDFILIAL
   AND VE.CDCAIXA  = II.CDCAIXA
   AND VE.NRSEQVENDA = II.NRSEQVENDA
   AND IT.CDFILIAL = II.CDFILIAL
   AND IT.CDCAIXA  = II.CDCAIXA
   AND IT.NRSEQVENDA = II.NRSEQVENDA
   AND IT.NRSEQUITVEND = II.NRSEQUITVEND
   AND IT.CDPRODUTO = PR.CDPRODUTO
   AND FI.CDFILIAL = VE.CDFILIAL
   AND VE.IDSITUVENDA = 'O'
-- AND VE.IDTPEMISVEND IN ('S','N')
   AND VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
   AND (VE.NRORG = :NRORG)
   AND (IT.NRORG = VE.NRORG)
   AND (II.NRORG = VE.NRORG)
   AND (PR.NRORG = VE.NRORG)
   AND (FI.NRORG = VE.NRORG)
   AND ((INSTR(:CDFILIAL , VE.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T'))
   AND ((INSTR(:CDCAIXA  , VE.CDFILIAL||VE.CDCAIXA ) <> 0) OR (:TCDCAIXA = 'T'))
   AND ((INSTR(:CDIMPOSTO, II.CDIMPOSTO ) <> 0) OR (:TCDIMPOSTO = 'T'))
   AND ((:TCDPRODUTO = 'T') OR (PR.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM))
ORDER BY VE.CDFILIAL, VE.CDCAIXA, VE.NRNOTAFISCALCE
  ";

       const DELETE_LOJA = "
    DELETE FROM LOJA WHERE CDFILIAL = :CDFILIAL AND CDLOJA  = :CDLOJA AND NRORG = :NRORG
    ";

  const DELETE_ITENS = "
  DELETE FROM ITVENDAIMPOS
    WHERE
   (CDFILIAL     = :CDFILIAL    ) AND
   (CDCAIXA      = :CDCAIXA     ) AND
   (NRSEQVENDA   = :NRSEQVENDA  ) AND
   (NRSEQUITVEND = :NRSEQUITVEND) AND
   (NRORG        = :NRORG)
  ";

  const DELETE_IMP_ITENS = "
  DELETE FROM ITEMVENDA
  WHERE
    CDFILIAL = :CDFILIAL AND
    CDCAIXA = :CDCAIXA AND
    NRSEQVENDA = :NRSEQVENDA AND
    NRSEQUITVEND = :NRSEQUITVEND AND
    NRORG        = :NRORG
  ";

  const DELETE_ITENS_CANC = "
  DELETE FROM ITVENDACAN
  WHERE
    CDFILIAL = :CDFILIAL AND
    CDCAIXA = :CDCAIXA AND
    NRSEQVENDA = :NRSEQVENDA AND
    NRSEQITVENDC = :NRSEQITVENDC AND
    NRORG        = :NRORG
  ";

  const DELETE_ITENS_RECEBIMENTOS = "
  DELETE FROM MOVCAIXA
  WHERE
    CDFILIAL = :CDFILIAL AND
    CDCAIXA = :CDCAIXA AND
    DTABERCAIX = :DTABERCAIX AND
    NRSEQUMOVI = :NRSEQUMOVI AND
    NRORG     = :NRORG
  ";
  const UPDATE_ITENS_RECEBIMENTOS = "
  UPDATE MOVCAIXA
  SET
    CDTIPORECE = :CDTIPORECE,
    VRMOVIVEND = :VRMOVIVEND,
    IDTIPOMOVIVE = :IDTIPOMOVIVE,
    DTHRINCMOV = :DTHRINCMOV,
    NRSEQVENDA = :NRSEQVENDA,
    DTMOVIMCAIXA = :DTMOVIMCAIXA,
    VRMOVIVEOUT = :VRMOVIVEOUT,
    VRCOTINDOUT = :VRCOTINDOUT,
    QTPARCRECEB=:QTPARCRECEB
  WHERE
    CDFILIAL =   :CDFILIAL AND
    CDCAIXA =    :CDCAIXA AND
    DTABERCAIX = :DTABERCAIX AND
    NRSEQUMOVI = :NRSEQUMOVIBKP
    ";
  const UPDATE_ITEM = "
  UPDATE ITEMVENDA
  SET
    QTPRODVEND = :QTPRODVEND,
    VRUNITVEND = :VRUNITVEND,
    VRDESITVEND = :VRDESITVEND,
    VRPERCVEND = :VRPERCVEND,
    CDPRODUTO = :CDPRODUTO,
    VRUNITVENDCL = :VRUNITVENDCL,
    CDGRUPPROD = :CDGRUPPROD,
    CDSUBGRPROD = :CDSUBGRPROD,
    CDFISUBGRVND = :CDFISUBGRVND,
    VRACRITVEND = :VRACRITVEND
  WHERE
    CDFILIAL = :CDFILIAL AND
    CDCAIXA = :CDCAIXA AND
    NRSEQVENDA = :NRSEQVENDA AND
    NRSEQUITVEND = :NRSEQUITVEND
    ";

  const UPDATE_ITEM_IMPOSTO = "
  UPDATE ITVENDAIMPOS
  SET
    CDFILIAL = :CDFILIAL,
    CDCAIXA = :CDCAIXA,
    NRSEQVENDA = :NRSEQVENDA,
    NRSEQUITVEND = :NRSEQUITVEND,
    NRSEQITIMPOS = :NRSEQITIMPOS,
    CDIMPOSTO = :CDIMPOSTO,
    VRPEALPRODIT = :VRPEALPRODIT,
    VRIMPOPRODIT = :VRIMPOPRODIT,
    CDIMPOSTOEX = :CDIMPOSTOEX
  WHERE
    CDFILIAL = :CDFILIAL AND
    CDCAIXA = :CDCAIXA AND
    NRSEQVENDA = :NRSEQVENDA AND
    NRSEQUITVEND = :NRSEQUITVEND AND
    NRSEQITIMPOS = :NRSEQITIMPOS
    ";

  const UPDATE_CANCEL_ITEM = "
  UPDATE ITVENDACAN
  SET
    QTPRODVENDC  = :QTPRODVENDC ,
    VRUNITVENDC  = :VRUNITVENDC,
    VRDESITVENDC = :VRDESITVENDC,
    VRPERCVENDC  = :VRPERCVENDC,
    CDPRODUTO    = :CDPRODUTO,
    VRUNITVENCLC = :VRUNITVENCLC,
    CDGRUPPROD   = :CDGRUPPROD,
    CDSUBGRPROD  = :CDSUBGRPROD,
    CDFISUBGRVNC = :CDFISUBGRVNC,
    VRACRITVENDC = :VRACRITVENDC
  WHERE
    CDFILIAL     = :CDFILIAL      AND
    CDCAIXA      = :CDCAIXA       AND
    NRSEQVENDA   = :NRSEQVENDA    AND
    NRSEQITVENDC = :NRSEQITVENDC  AND
    NRORG        = :NRORG
  ";

  const DELETE_OBSPRODUTO = "
  DELETE
    FROM PRODOCORRE
    WHERE (CDGRPOCOR = :CDGRPOCOR)
    AND (CDOCORR = :CDOCORR)
    AND (CDPRODUTO = :CDPRODUTO)
    AND (NRORG = :NRORG)
  ";

  const GET_VRFATOCONV = "
    SELECT NVL(VRFATOCONV, 0) VRFATOCONV
      FROM PRODUTO
    WHERE CDPRODUTO = :CDPRODUTO
  ";

  const UPDATE_ITLANCTOEST = "UPDATE ITLANCTOEST I
        SET IDEVOLESTOQ = 'N'
        WHERE CDFILIAL   = :CDFILIAL   AND
              NRLANCESTQ = :NRLANCESTQ AND
              EXISTS(SELECT CDPRODUTO
                     FROM MOVILOTE M
                     WHERE NRMOVILOTE  = :CDFILIAL || :NRLANCESTQ AND
                           M.CDPRODUTO = I.CDPRODMOVI)";
                           
    const FIND_CODIGOS_SAP = "
	    SELECT CDCODEXTINI, CDCODEXTFIN, CDLETRACORR FROM CONVERSCODEXFIL 
	    WHERE NRORG = :NRORG
    ";
    
    const FIND_OUTROS_CODIGOS_SAP = "
	    SELECT CDCODEXTINI, CDCODEXTFIN, CDLETRACORR FROM CONVERSCODEXFIL 
	    WHERE NRORG = :NRORG
	      AND CDLETRACORR <> :CDLETRACORR
    ";
            
    const UPDATE_CAMPOS_SAP = "
      UPDATE CONVERSCODEXFIL
      SET CDLETRACORR = :CDLETRACORR,
          CDCODEXTINI = :CDCODEXTINI,
          CDCODEXTFIN = :CDCODEXTFIN
      WHERE CDLETRACORR = :LETRAREF
        AND NRORG = :NRORG
    ";

  // Parametrizações NoCash
  const CONSULTA_NOCASH = "SELECT * FROM NOCASHPARAMS WHERE NRORG = :NRORG";
  
  const SAVE_PARAM_NOCASH = "INSERT INTO NOCASHPARAMS
    (URLLOGO, CORESJSON, URLAPIPAG, MERCHANTID, MERCHANTKEY, PAYMENTCOMPANY, HABCADASTRO, NUMEROAJUDA, MAILFALE, RECSENHAMSG, IDIOMAPRINC, IDIOMAADIC, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, URLAPIFINANCEIRO, URLTERMORESP)
    VALUES
    (:URLLOGO, :CORESJSON, :URLAPIPAG, :MERCHANTID, :MERCHANTKEY, :PAYMENTCOMPANY, :HABCADASTRO, :NUMEROAJUDA, :MAILFALE, :RECSENHAMSG, :IDIOMAPRINC, :IDIOMAADIC, :NRORG, :IDATIVO, SYSDATE, :DTULTATU, :NRORGINCLUSAO, :CDOPERINCLUSAO, :NRORGULTATU, :CDOPERULTATU, :URLAPIFINANCEIRO, URLTERMORESP)
  ";
  
  const UPDATE_NOCASHPARAMS = "UPDATE NOCASHPARAMS
    SET 
      URLLOGO = :URLLOGO,
      CORESJSON = :CORESJSON,
      URLAPIPAG = :URLAPIPAG,
      MERCHANTID = :MERCHANTID,
      MERCHANTKEY = :MERCHANTKEY,
      PAYMENTCOMPANY = :PAYMENTCOMPANY,
      HABCADASTRO = :HABCADASTRO,
      NUMEROAJUDA = :NUMEROAJUDA,
      MAILFALE = :MAILFALE,
      RECSENHAMSG = :RECSENHAMSG,
      IDIOMAPRINC = :IDIOMAPRINC,
      IDIOMAADIC = :IDIOMAADIC,
      CDOPERINCLUSAO = :CDOPERINCLUSAO,
      NRORGULTATU = :NRORGULTATU,
      CDOPERULTATU = :CDOPERULTATU,
      URLAPIFINANCEIRO = :URLAPIFINANCEIRO,
      URLTERMORESP = :URLTERMORESP
  ";
  
  const SELECT_FILESERVERURL = "
    SELECT FILESERVERURL FROM PARAMGERAL
    WHERE NRORG = :NRORG
  ";
    
  const SAVELOGIN_NOCASH = "
    UPDATE NOCASHPARAMS
    SET SENHAOPERFIN = :SENHAOPERFIN,
      EMAILOPERFIN = :EMAILOPERFIN
    WHERE NRORG = :NRORG
  ";
    
  // Controle Tipo de Documento
  const FIND_DOCS = "
      SELECT CDCFOP, CDNCM, CDCST, (CDCFOP || CDNCM || CDCST) AS SEQDOCS, CDTPDOC,
    NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO,
    NRORGULTATU, CDOPERULTATU FROM TPDOCINTSAPFOS ORDER BY CDCFOP, CDNCM, CDCST
  ";
  
  const INSERT_DOCS = "
    INSERT INTO TPDOCINTSAPFOS
    (CDCFOP, CDNCM, CDCST, CDTPDOC, NRORG, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, DTULTATU, NRORGULTATU, CDOPERULTATU) VALUES
    (:CDCFOP, :CDNCM, :CDCST, :CDTPDOC, :NRORG, :IDATIVO, SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO, NULL, NULL, NULL)
  ";
  
  const UPDATE_DOCS = "
    UPDATE TPDOCINTSAPFOS
    SET 
      CDCFOP        = :CDCFOP,
      CDNCM         = :CDNCM,
      CDCST         = :CDCST,
      CDTPDOC       = :CDTPDOC,
      DTULTATU      = SYSDATE,
      NRORGULTATU   = :NRORGULTATU,
      CDOPERULTATU  = :CDOPERULTATU
    WHERE
      CDCFOP        = :BCDCFOP AND
      CDNCM         = :BCDNCM AND
      CDCST         = :BCDCST AND
      CDTPDOC       = :BCDTPDOC
  ";
  
  const DELETE_DOC = "
    DELETE FROM TPDOCINTSAPFOS
    WHERE CDCFOP = :CDCFOP
      AND CDNCM = :CDNCM
      AND CDCST = :CDCST
      AND CDTPDOC = :CDTPDOC
      AND NRORG = :NRORG
  ";

  // Configuração para Integração
  const GET_PARAMS_CONFIGINTEGRA = "
    SELECT
       P.CDPARAMINT, P.CDTPINDICE, P.IDPERVALOR, P.CDINDICE, I.NMINDICE,
       P.IDEMISSINVFMES, P.NRCOPIAINVFMES, P.DSMENSAINVFMES, P.DSDIRETINVFMES,
       P.CDTPCUSINVFMES, P.CDGRPROINVFMES, P.DSPROCEINVFMES, T.NMTIPOCUSTO, G.NMGRUPPROD
    FROM
       PARAMINTEGRA P, INDICE I, TIPOCUSTO T, GRUPPROD G
    WHERE
       (P.CDTPINDICE     = I.CDTPINDICE(+))  AND
       (P.IDPERVALOR     = I.IDPERVALOR(+))  AND
       (P.CDINDICE       = I.CDINDICE(+))    AND
       (P.CDTPCUSINVFMES = T.CDTIPOCUSTO(+)) AND
       (P.CDGRPROINVFMES = G.CDGRUPPROD(+))
  ";
  
  const GET_PARAMS_IFE = "
    SELECT CDINDICE, NMINDICE
    FROM INDICE
    WHERE (CDTPINDICE = '1') AND
      (IDPERVALOR = '2') AND
      (CDINDICE   = :CDINDICE)
    ORDER BY CDINDICE
  ";
  
  const GET_TIPY_COST = "
    SELECT P.CDTPCUSINVFMES, T.CDTIPOCUSTO, T.NMTIPOCUSTO
    FROM PARAMINTEGRA P, TIPOCUSTO T
    WHERE (T.CDTIPOCUSTO = P.CDTPCUSINVFMES(+))  AND
      (T.CDTIPOCUSTO = NVL(:CDTIPOCUSTO, T.CDTIPOCUSTO))
    ORDER BY T.CDTIPOCUSTO
  ";
  
  const GET_TIPY_GROUP = "
    SELECT CDGRUPPROD, NMGRUPPROD
    FROM GRUPPROD
    WHERE (CDGRUPPROD = :CDGRUPPROD)
    ORDER BY CDGRUPPROD
  ";
  
  const FIND_EMPRESA = "
    SELECT CDEMPRESA, NMEMPRESA
    FROM EMPRESA
  ";
  
  const FIND_COMPANY = "
    SELECT CDEMPRESA, CDEXPORTEMPR, CDCENTLUCREN, CDEMPINTEGRACAO
    FROM PARAMEMPRESA
    WHERE (CDEMPRESA = :CDEMPRESA)
  ";
  
  const FIND_CLIENTES = "
    SELECT C.CDCLIENTE, E.CDCLIEEXPORT, E.CDFILIEXPORT, C.NRINSJURCLIE, C.IDTPIJURCLIE, C.NMRAZSOCCLIE, E.CDCENTLUCREX
    FROM EXPORTCLIE E, CLIENTE C
    WHERE C.CDCLIENTE = E.CDCLIENTE(+)
    ORDER BY C.CDCLIENTE
  ";
  
  const FIND_FILIAL_FOR_CLIENTS = "
    SELECT CDFILIAL, NMFILIAL
    FROM FILIAL
    ORDER BY CDFILIAL
  ";
  
  const FIND_FILIAL_AFTER = "
  SELECT C.CDCLIENTE, E.CDCLIFILIEXP, E.CDFILIAL, C.NRINSJURCLIE, C.IDTPIJURCLIE, C.NMRAZSOCCLIE, E.CDCENTLFILEX
  FROM CLIENTE C,
    (SELECT * FROM EXPFILCLIE
    WHERE CDFILIAL = :CDFILIAL) E
  WHERE C.CDCLIENTE = E.CDCLIENTE(+)
  ORDER BY C.CDCLIENTE
  ";
  
  const FIND_FORNECEDOR = "
    SELECT NRINSJURFORN, NMRAZSOCFORN, CDEXFORNECED
    FROM FORNECEDOR
  ";
  
  const FIND_FILIAL = "
  SELECT IDCONSREFECH, IDCONSCGCRE,  IDCONSEMISRE, P.CDFILIAL,
       IDCONSTOTARE, CDEXFILIAL,   VRPERCPROJEC, IDTIPODADOTG,
       IDCONSNUMERE, IDCONSCIRE,   IDCONSDTEMRE, IDCONSTOPERE,
       IDCONSRMCFDIA, IDREINICIANUMRE, CDFILIALSAGA, CDOPERADORSAGA,
       O.NMOPERADOR AS NMOPERADORSAGA, IDATUESTLANCNFE, P.DSINFWEBSERVICE,
       P.CDFILWMSMHAARM, F.NMFILIAL AS FILIALARMAZ,
       P.CDFILWMSMHA, P.CDOPERWMSMHA, R.NMOPERADOR AS NMOPERWMSMHA,
       NVL(USR_IDUTPEDVENDEXT, 'N') AS IDUTPEDVENDEXT,
       NVL(USR_IDUTPEDINTEGRAL, 'N') AS IDUTPEDINTEGRAL,
       NVL(USR_VRMINPEDVENDEXT, 0) AS VRMINPEDVENDEXT,
       NVL(USR_VRPERCENTVRMIN, 0) AS VRPERCENTVRMIN,
       USR_CDGROPERAPROV AS CDGROPERAPROV,
       G.DSGRUPOPER,
       USR_CDGROPAPROVFINANC AS CDGROPAPROVFINANC,
       FIN.DSGRUPOPER DSGROPAPROVFINANC
  FROM PARAMFILIAL P, OPERADOR O, FILIAL F, OPERADOR R, GRUPOPER G, GRUPOPER FIN
 WHERE (P.CDFILIAL = :CDFILIAL)
   AND P.CDOPERADORSAGA = O.CDOPERADOR (+)
   AND F.CDFILIAL = P.CDFILIAL
   AND P.CDOPERWMSMHA = R.CDOPERADOR (+)
   AND P.USR_CDGROPERAPROV = G.CDGRUPOPER(+)
   AND P.USR_CDGROPAPROVFINANC = FIN.CDGRUPOPER(+)
  ";
  
  const FIND_OPER_SAGA = "
    SELECT CDOPERADOR, NMOPERADOR
    FROM OPERADOR
    WHERE CDOPERADOR = NVL(:CDOPERADOR, CDOPERADOR)
    ORDER BY CDOPERADOR
  ";
  
  const FIND_OPER_WMS = "
    SELECT CDOPERADOR, NMOPERADOR
    FROM OPERADOR
    WHERE CDOPERADOR = NVL(:P_CDOPERADOR, CDOPERADOR)
    ORDER BY CDOPERADOR
  ";
  
  const FIND_FILIAL_OL = "
    SELECT CDFILIAL, NMFILIAL
    FROM FILIAL
    WHERE (CDFILIAL = :CDFILIAL)
      AND IDFUNCAOFILI = 'O'
      AND CDFILIAL <> :MED_CDFILIAL
    ORDER BY CDFILIAL
  ";
  
  const VERIFICA_DUPLICIDADE_CUPONS = "
    SELECT NVL(V.NRNOTAFISCALCE, V.NRCUPOMFIS) AS CUPOM, V.DTVENDA, V.NRSEQVENDA, V.CDFILIAL, V.CDCAIXA
      FROM VENDA V
     WHERE ((INSTR(:CDFILIAL, V.CDFILIAL) > 0) OR (:CDFILIAL = 'T'))
       AND V.DTENTRVENDA BETWEEN :DTINICIAL AND :DTFINAL
       AND (EXISTS (SELECT NRNOTAFISCALCE
                      FROM VENDA
                     WHERE CDFILIAL       = V.CDFILIAL
                       AND CDCAIXA        = V.CDCAIXA
                       AND DTENTRVENDA    = V.DTENTRVENDA
                       AND NRNOTAFISCALCE = V.NRNOTAFISCALCE
                       AND NRSEQVENDA    <> V.NRSEQVENDA) OR EXISTS (SELECT DTVENDA
                                                                       FROM VENDA
                                                                      WHERE CDFILIAL    = V.CDFILIAL
                                                                        AND CDCAIXA     = V.CDCAIXA
                                                                        AND DTENTRVENDA = V.DTENTRVENDA
                                                                        AND DTVENDA     = V.DTVENDA
                                                                        AND NRSEQVENDA <> V.NRSEQVENDA))
    MINUS
    SELECT NVL(V.NRNOTAFISCALCE, V.NRCUPOMFIS) AS CUPOM, V.DTVENDA, MAX(V.NRSEQVENDA) AS NRSEQVENDA, V.CDFILIAL, V.CDCAIXA
      FROM VENDA V
     WHERE ((INSTR(:CDFILIAL, V.CDFILIAL) > 0) OR (:CDFILIAL = 'T'))
       AND V.DTENTRVENDA BETWEEN :DTINICIAL AND :DTFINAL
       AND (EXISTS (SELECT NRNOTAFISCALCE
                      FROM VENDA
                     WHERE CDFILIAL       = V.CDFILIAL
                       AND CDCAIXA        = V.CDCAIXA
                       AND DTENTRVENDA    = V.DTENTRVENDA
                       AND NRNOTAFISCALCE = V.NRNOTAFISCALCE
                       AND NRSEQVENDA    <> V.NRSEQVENDA) OR EXISTS (SELECT DTVENDA
                                                                       FROM VENDA
                                                                      WHERE CDFILIAL    = V.CDFILIAL
                                                                        AND CDCAIXA     = V.CDCAIXA
                                                                        AND DTENTRVENDA = V.DTENTRVENDA
                                                                        AND DTVENDA     = V.DTVENDA
                                                                        AND NRSEQVENDA <> V.NRSEQVENDA))
    GROUP BY NVL(V.NRNOTAFISCALCE, V.NRCUPOMFIS), V.DTVENDA, V.CDFILIAL, V.CDCAIXA
  ";
  
  const GET_REL_AUD_ITEM = "
    SELECT
        V.CDFILIAL  || ' - ' ||  F.NMFILIAL AS LABELFILIAL,
        L.CDLOJA || ' - ' || L.NMLOJA  AS LABELLOJA,
        V.DTVENDA,
        P.CDARVPROD
        || ' - '
        || P.NMPRODUTO                      AS NMPRODUTO,
        V.NRMESA,
        VE.NMRAZSOCVEN,
        ITV.QTPRODVEND,
        ITV.VRUNITVEND,
        ( ITV.QTPRODVEND * ITV.VRUNITVEND ) AS VRTOTALITVENDA,
        'Finalizado'                        AS STATUS
    FROM
             VENDA V
        JOIN ITEMVENDA ITV ON V.CDFILIAL = ITV.CDFILIAL
                              AND V.NRSEQVENDA = ITV.NRSEQVENDA
                              AND V.CDCAIXA = ITV.CDCAIXA
                              AND V.NRORG = ITV.NRORG
        JOIN FILIAL    F ON F.CDFILIAL = ITV.CDFILIAL
                         AND F.NRORG = ITV.NRORG
        LEFT JOIN VENDEDOR  VE ON V.CDVENDEDOR = VE.CDVENDEDOR
                                 AND V.NRORG = VE.NRORG
        JOIN PRODUTO   P ON ITV.CDPRODUTO = P.CDPRODUTO
                          AND ITV.NRORG = P.NRORG
        JOIN LOJA      L ON V.CDFILIAL = L.CDFILIAL
                       AND V.CDLOJA = L.CDLOJA
                       AND V.NRORG = L.NRORG
    WHERE
        ( :STATUS = 'F'
          OR :STATUS = 'T' )
        AND ( INSTR(:CDFILIAL, V.CDFILIAL) <> 0
              OR ( :TCDFILIAL = 'T' ) )
        AND ( ( INSTR(:CDLOJA, V.CDFILIAL || V.CDLOJA) <> 0 )
              OR ( :TCDLOJA = 'T' ) )
        AND ( ( INSTR(:CDVENDEDOR, V.CDVENDEDOR) <> 0 )
              OR ( :TCDVENDEDOR = 'T' ) )
        AND ( ( INSTR(:NRMESA, V.NRMESA) <> 0 )
              OR ( :TNRMESA = 'T' ) )
        AND V.DTENTRVENDA BETWEEN TO_DATE(:DTINI, 'DD/MM/YYYY') AND TO_DATE(:DTFIN, 'DD/MM/YYYY')
        AND V.IDORIGEMVENDA LIKE 'MES_%'
        AND V.NRORG = :NRORG
    UNION
    SELECT
        V.CDFILIAL  || ' - ' ||  F.NMFILIAL AS LABELFILIAL,
        L.CDLOJA || ' - ' || L.NMLOJA  AS LABELLOJA,
        V.DTVENDA,
        P.CDARVPROD
        || ' - '
        || P.NMPRODUTO                          AS NMPRODUTO,
        V.NRMESA,
        VE.NMRAZSOCVEN,
        ITVC.QTPRODVENDC,
        ITVC.VRUNITVENDC,
        ( ITVC.QTPRODVENDC * ITVC.VRUNITVENDC ) AS VRTOTALITVENDA,
        'Cancelado'                             AS STATUS
    FROM
             VENDA V
        JOIN ITVENDACAN ITVC ON V.CDFILIAL = ITVC.CDFILIAL
                                AND V.NRSEQVENDA = ITVC.NRSEQVENDA
                                AND V.CDCAIXA = ITVC.CDCAIXA
                                AND V.NRORG = ITVC.NRORG
        JOIN FILIAL     F ON F.CDFILIAL = ITVC.CDFILIAL
                         AND F.NRORG = ITVC.NRORG
        LEFT JOIN VENDEDOR   VE ON V.CDVENDEDOR = VE.CDVENDEDOR
                                 AND V.NRORG = VE.NRORG
        JOIN PRODUTO    P ON ITVC.CDPRODUTO = P.CDPRODUTO
                          AND ITVC.NRORG = P.NRORG
        JOIN LOJA       L ON V.CDFILIAL = L.CDFILIAL
                       AND V.CDLOJA = L.CDLOJA
                       AND V.NRORG = L.NRORG
    WHERE
        ( :STATUS = 'C'
          OR :STATUS = 'T' )
        AND ( INSTR(:CDFILIAL, V.CDFILIAL) <> 0
              OR ( :TCDFILIAL = 'T' ) )
        AND ( ( INSTR(:CDLOJA, V.CDFILIAL || V.CDLOJA) <> 0 )
              OR ( :TCDLOJA = 'T' ) )
        AND ( ( INSTR(:CDVENDEDOR, V.CDVENDEDOR) <> 0 )
              OR ( :TCDVENDEDOR = 'T' ) )
        AND ( ( INSTR(:NRMESA, V.NRMESA) <> 0 )
              OR ( :TNRMESA = 'T' ) )
        AND V.DTENTRVENDA BETWEEN TO_DATE(:DTINI, 'DD/MM/YYYY') AND TO_DATE(:DTFIN, 'DD/MM/YYYY')
        AND V.IDORIGEMVENDA LIKE 'MES_%'
        AND V.NRORG = :NRORG"
    ;  
    
    // parametrizações no cash por filial
    const FIND_NOCASH_FILIAL = "
      SELECT NP.CDCLIENTE, CL.NMRAZSOCCLIE, NP.CDFILIAL, FL.NMFILIAL, NP.PAGHABJSON, NP.NRORG, NP.IDATIVO, NP.DTINCLUSAO, NP.DTULTATU, NP.NRORGINCLUSAO, NP.CDOPERINCLUSAO, NP.NRORGULTATU, NP.CDOPERULTATU, (NP.CDCLIENTE || CL.NMRAZSOCCLIE || NP.CDFILIAL || FL.NMFILIAL) AS CHAVE_UNICA
      FROM NOCASHPARAMSFILI NP
      JOIN FILIAL FL
        ON FL.CDFILIAL = NP.CDFILIAL
      JOIN CLIENTE CL
        ON CL.CDCLIENTE = NP.CDCLIENTE
    ";
    
    const DELETE_PARAMS_FILIA = "
      DELETE FROM NOCASHPARAMSFILI
      WHERE CDFILIAL = :CDFILIAL
      AND CDCLIENTE = :CDCLIENTE
    ";
    
    const UPDATE_PARAMS_FILIAL = "
      UPDATE NOCASHPARAMSFILI
      SET PAGHABJSON = :PAGHABJSON,
          NRORGULTATU = :NRORGULTATU,
          CDOPERULTATU = :CDOPERULTATU,
          DTULTATU = SYSDATE
      WHERE CDFILIAL = :CDFILIAL_OLD
        AND CDCLIENTE = :CDCLIENTE_OLD
        AND PAGHABJSON = :PAGHABJSON_OLD
    ";
    
    const INSERT_PARAMS_FILIAL = "
      INSERT INTO NOCASHPARAMSFILI
        (CDCLIENTE, CDFILIAL, PAGHABJSON, NRORG, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU)
      VALUES
        (:CDCLIENTE, :CDFILIAL, :PAGHABJSON, :NRORG, :IDATIVO, SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO, :NRORGULTATU, :CDOPERULTATU)
    ";
    
    const CHECK_NOCASH_USER = "
      SELECT NMOPERADOR
      FROM OPERADOR
      WHERE DSEMAILOPER = :DSEMAILOPER
        AND CDSENHAOPERWEB = :CDSENHAOPERWEB
    ";
    
    // QUERYS IMPORTAÇÃO DADOS CATRACA
    const FIND_LOGCATRACA = "
      SELECT
         LO.CDFILIAL, FL.NMFILIAL, LO.NRSEQLOGCAT, LO.CDCAIXLOGCAT, LO.DSDTHRLOGCAT, LO.NRIDENLOGCAT, LO.IDSIMPLOGCAT, LO.IDCRALOGCAT, LO.IDCATLOGCAT, LO.IDDATLOGCAT, LO.IDPROLOGCAT, LO.IDSERLOGCAT , LO.IDDUPLOGCAT, LO.DTIMPLOGCAT, LO.CDOPERADOR, LO.DSOBSLOGCAT, LO.NMARQLOGCAT, OP.NMOPERADOR, LO.NRSEQARQIMP, LO.IDCRAHABFILI 
      FROM LOGCATRACA LO
      JOIN FILIAL FL 
        ON LO.CDFILIAL = FL.CDFILIAL
      JOIN OPERADOR OP 
        ON LO.CDOPERADOR = OP.CDOPERADOR
      WHERE
         (LO.CDFILIAL   = :CDFILIAL  ) AND
         (LO.CDOPERADOR = OP.CDOPERADOR) AND
         (TRUNC(LO.DTIMPLOGCAT) BETWEEN :DTINI AND :DTFIN) AND
         (((LO.IDCRALOGCAT  = :IDCRALOGCAT   ) OR (:IDCRALOGCAT    = 'T')) OR
          ((LO.IDCATLOGCAT  = :IDCATLOGCAT  ) OR (:IDCATLOGCAT   = 'T')) OR
          ((LO.IDDATLOGCAT  = :IDDATLOGCAT  ) OR (:IDDATLOGCAT   = 'T')) OR
          ((LO.IDSERLOGCAT  = :IDSERLOGCAT  ) OR (:IDSERLOGCAT   = 'T')) OR
          ((LO.IDDUPLOGCAT  = :IDDUPLOGCAT) OR (:IDDUPLOGCAT = 'T')) OR
          ((LO.IDCRAHABFILI = :IDCRAHABFILI) OR (:IDCRAHABFILI = 'T')) OR
          ((LO.IDPROLOGCAT  = :TODOS  ) OR (:TODOS   = 'T')) OR (:TODOS = 'T'))
      ORDER BY
         LO.DTIMPLOGCAT
    ";
  
      const GET_IDCRALOGCAT = "
        SELECT CDIDCONSUMID
        FROM CONSUMIDOR C
        WHERE C.CDIDCONSUMID = :NRIDENLOGCAT
          AND (C.IDSITCONSUMI = '1')
          AND (C.CDCLIENTE IN 
            (SELECT CL.CDCLIENTE
            FROM CLIENFILIAL CL
            WHERE CL.CDCLIENTE = C.CDCLIENTE
              AND CL.CDFILIAL = :CDFILIAL))
      ";
      
      const GET_CAIXA_IMPORT_CATRACA = "
        SELECT C.CDCAIXA
        FROM CAIXA C
        WHERE C.CDFILIAL = :CDFILIAL
        AND C.CDCAIXA  = :CDCAIXA
      ";
      
      const GET_IDSERLOGCAT_IMPORT_CATRACA = "
        SELECT S.CDSERVFILI
        FROM SERVTURCAIXA S
        WHERE (S.CDFILIAL = :CDFILIAL) 
          AND (S.CDCAIXA  = :CDCAIXA) 
          AND ((((S.HRINISERTUR <= SUBSTR(:DSDTHRLOGCAT,INSTR(:DSDTHRLOGCAT, ' ') + 1, 2) 
              ||SUBSTR(:DSDTHRLOGCAT,INSTR(:DSDTHRLOGCAT, ' ') + 4, 2))
          AND (S.HRFINSERTUR >= SUBSTR(:DSDTHRLOGCAT,INSTR(:DSDTHRLOGCAT, ' ') + 1, 2)
              ||SUBSTR(:DSDTHRLOGCAT,INSTR( :DSDTHRLOGCAT, ' ') + 4, 2)))
          AND (S.HRINISERTUR < S.HRFINSERTUR))
          OR (((S.HRINISERTUR <= SUBSTR(:DSDTHRLOGCAT,INSTR(:DSDTHRLOGCAT, ' ') + 1, 2)
              ||SUBSTR(:DSDTHRLOGCAT,INSTR(:DSDTHRLOGCAT, ' ') + 4, 2))
          OR (S.HRFINSERTUR >= SUBSTR(:DSDTHRLOGCAT,INSTR(:DSDTHRLOGCAT, ' ') + 1, 2)
              ||SUBSTR(:DSDTHRLOGCAT,INSTR(:DSDTHRLOGCAT, ' ') + 4, 2))) AND (S.HRINISERTUR > S.HRFINSERTUR)))
      ";
      
      const GET_IDPROLOGCAT_IMPORT_CATRACA = "
        (SELECT P.CDPRODUTO
                 FROM SERVTURCAIXA S, PRODTURCAIXA P
                 WHERE (S.CDFILIAL = :CDFILIAL)
                  AND (S.CDCAIXA  = :CDCAIXA)
                  AND ((((S.HRINISERTUR <= SUBSTR(:DSDTHRLOGCAT,INSTR(:DSDTHRLOGCAT, ' ') + 1, 2) 
                    || SUBSTR(:DSDTHRLOGCAT,INSTR(:DSDTHRLOGCAT, ' ') + 4, 2)) 
                  AND (S.HRFINSERTUR >= SUBSTR(:DSDTHRLOGCAT,INSTR(:DSDTHRLOGCAT, ' ') + 1, 2) 
                    || SUBSTR(:DSDTHRLOGCAT,INSTR(:DSDTHRLOGCAT, ' ') + 4, 2))) 
                  AND (S.HRINISERTUR < S.HRFINSERTUR)) 
                  OR (((S.HRINISERTUR <= SUBSTR(:DSDTHRLOGCAT,INSTR(:DSDTHRLOGCAT, ' ') + 1, 2) 
                    || SUBSTR(:DSDTHRLOGCAT,INSTR(:DSDTHRLOGCAT, ' ') + 4, 2)) 
                  OR (S.HRFINSERTUR >= SUBSTR(:DSDTHRLOGCAT,INSTR(:DSDTHRLOGCAT, ' ') + 1, 2)
                    || SUBSTR(:DSDTHRLOGCAT,INSTR(:DSDTHRLOGCAT, ' ') + 4, 2))) 
                  AND (S.HRINISERTUR > S.HRFINSERTUR))) 
                  AND (S.CDFILIAL   = P.CDFILIAL) 
                  AND (S.CDCAIXA    = P.CDCAIXA) 
                  AND (S.CDSERVFILI = P.CDSERVFILI))
      ";
      
      const INSERT_LOG_CATRACA = "
      INSERT INTO LOGCATRACA
        (CDFILIAL, NRSEQLOGCAT, CDCAIXLOGCAT, DSDTHRLOGCAT, NRIDENLOGCAT, IDSIMPLOGCAT, IDCRALOGCAT , IDCATLOGCAT, IDDATLOGCAT, IDSERLOGCAT, DTIMPLOGCAT, CDOPERADOR, DSOBSLOGCAT, NMARQLOGCAT, NRSEQARQIMP, IDREGDUPLICADO, IDDUPLOGCAT, IDCRAHABFILI, IDPROLOGCAT)
      VALUES
      (:CDFILIAL, :NRSEQLOGCAT, :CDCAIXLOGCAT, :DSDTHRLOGCAT, :NRIDENLOGCAT, :IDSIMPLOGCAT, :IDCRALOGCAT, :IDCATLOGCAT, :IDDATLOGCAT, :IDSERLOGCAT, SYSDATE , :CDOPERADOR, :DSOBSLOGCAT, :NMARQLOGCAT, :NRSEQARQIMP, :IDREGDUPLICADO, :IDDUPLOGCAT, :IDCRAHABFILI, :IDPROLOGCAT)
    ";
    
    const UPDATE_IDDATLOGCAT = "
      UPDATE LOGCATRACA
        SET IDDATLOGCAT = SUBSTR(DATA_OK(DSDTHRLOGCAT),1,1)
      WHERE (CDFILIAL = :CDFILIAL)
        AND (NRSEQLOGCAT = :NRSEQLOGCAT)
    ";
    
    const DELETE_ROW_IMPORTDADOSCATRACA = "
      DELETE FROM LOGCATRACA
      WHERE (CDFILIAL = :CDFILIAL)
      AND (NRSEQARQIMP = :NRSEQARQIMP)
      AND (NRSEQLOGCAT = :NRSEQLOGCAT)
    ";
    
    // QUERYS EXPORTAÇÃO BALANÇA TOLEDO
    const GET_TXT_BALANCA = "
      SELECT '01'||';'|| DECODE(IDPESAPROD,'N','1','0') ||';'|| CASE WHEN LENGTH(NVL(CDATAPRODITM,CDBARPRODUTO)) > 6 THEN
    		SUBSTR(NVL(CDATAPRODITM,CDBARPRODUTO), LENGTH(NVL(CDATAPRODITM,CDBARPRODUTO)) - 5, LENGTH(NVL(CDATAPRODITM,CDBARPRODUTO)))
    		WHEN LENGTH(NVL(CDATAPRODITM,CDBARPRODUTO)) < 6 THEN LPAD(NVL(NVL(CDATAPRODITM,CDBARPRODUTO),0),6,0)
    		ELSE NVL(CDATAPRODITM,CDBARPRODUTO)
    		END ||';'|| TRIM(REPLACE(TO_CHAR(NVL(A.VRPRECITEM,0),'0000.00'),'.','')) ||';'|| LPAD(NVL(QTDIAVALPRODVND,0),3,0)||';'|| RPAD(NVL(NMPRODUTO,'*'),50,'*') ||';'||
    		RPAD(NVL(CDINFOEXTRA,0),6,0) ||';'|| '0000' ||';'|| LPAD(NVL(CDINFORMNUTRI, '000000'),6,0) ||';'|| '1' ||';'|| DECODE(IDIMPDTEMBALAGEM, 'N', '0', '1') ||';'|| '0000' ||';'|| '000000000000'||';'|| '00000000000'||';'|| '1' ||';'||
    		'0000' ||';'|| '0000' ||';'|| '0000' ||';'|| '0000' ||';'|| '0000' ||';'|| '0000' ||';'|| '000000000000' ||';'|| '000000' ||';'|| '|01|' ||';'||
    		RPAD('*',35,'*') ||';'|| RPAD('*',35,'*') ||';'|| '000000' ||';'|| '000000' ||';'|| '000000' ||';'||  '000000' ||';'|| '0' ||';'|| '||' ||';'|| '0' ||';'|| '||'
    		||';' AS TEXTO,
    		IDPESAPROD,		CDATAPRODITM,		CDBARPRODUTO,		A.VRPRECITEM,		QTDIAVALPRODVND,		NMPRODUTO,		CDINFOEXTRA,
    		:CDFILIAL AS CDFILIAL, :CDTABEPREC AS CDTABEPREC, :LISTA AS LISTA, :TODOS AS TODOS, :PRODINI AS PRODINI, :PRODFIN AS PRODFIN

        FROM PRODUTO P
        LEFT JOIN (
        			SELECT DISTINCT I.CDIDENTBUTON, I.CDATAPRODITM
        			FROM ITMENUCONFTE I, CONFTELA C
        			WHERE I.IDTPBUTTON IN ('1','9','A')
        			AND I.CDFILIAL   = :CDFILIAL
        			AND I.CDFILIAL   = C.CDFILIAL
        			AND I.NRCONFTELA = C.NRCONFTELA
        			AND I.CDATAPRODITM IS NOT NULL) I
        	   ON P.CDPRODUTO = I.CDIDENTBUTON,
        	   (SELECT I.CDPRODUTO, I.VRPRECITEM
        	   	  FROM ITEMPRECO I, TABEVEND T
        	   	 WHERE :CDFILIAL = T.CDFILIAL
        	   	 AND T.CDTABEPREC  = :CDTABEPREC
        	   	 AND (SYSDATE BETWEEN T.DTINIVGPREC AND T.DTFINVGPREC)
        	   	 AND T.CDFILIAL  = I.CDFILIAL
        	   	 AND T.CDTABEPREC  = I.CDTABEPREC
        	   	 AND T.DTINIVGPREC = I.DTINIVGPREC)A
        WHERE P.CDPRODUTO = A.CDPRODUTO
          AND ((P.IDPESAPROD = :IDPESAPROD) OR (:IDPESAPROD = 'T'))
          AND (P.CDBARPRODUTO IS NOT NULL OR I.CDATAPRODITM IS NOT NULL)
          AND ((INSTR(:LISTA, CDARVPROD)>0) OR (:TODOS = 'T') OR (CDARVPROD BETWEEN :PRODINI AND :PRODFIN))
    ";
    
    const GET_TXT_BALANCA_GERAL = "
        SELECT '01'||';'|| DECODE(IDPESAPROD,'N','1','0') ||';'|| CASE WHEN LENGTH(NVL(CDATAPRODITM,CDBARPRODUTO)) > 6 THEN
        		SUBSTR(NVL(CDATAPRODITM,CDBARPRODUTO), LENGTH(NVL(CDATAPRODITM,CDBARPRODUTO)) - 5, LENGTH(NVL(CDATAPRODITM,CDBARPRODUTO)))
        		WHEN LENGTH(NVL(CDATAPRODITM,CDBARPRODUTO)) < 6 THEN LPAD(NVL(NVL(CDATAPRODITM,CDBARPRODUTO),0),6,0)
        		ELSE NVL(CDATAPRODITM,CDBARPRODUTO)
        		END ||';'|| TRIM(REPLACE(TO_CHAR(NVL(B.VRPRECITEM,0),'00.00'),'.','')) ||';'|| LPAD(NVL(QTDIAVALPRODVND,0),3,0)||';'|| RPAD(NVL(NMPRODUTO,'*'),50,'*') ||';'||
        		RPAD(NVL(CDINFOEXTRA,0),6,0) ||';'|| '0000' ||';'|| LPAD(NVL(CDINFORMNUTRI, '000000'),6,0) ||';'|| '1' ||';'|| DECODE(IDIMPDTEMBALAGEM, 'N', '0', '1') ||';'|| '0000' ||';'|| '000000000000'||';'|| '00000000000'||';'|| '1' ||';'||
        		'0000' ||';'|| '0000' ||';'|| '0000' ||';'|| '0000' ||';'|| '0000' ||';'|| '0000' ||';'|| '000000000000' ||';'|| '000000' ||';'|| '|01|' ||';'||
        		RPAD('*',35,'*') ||';'|| RPAD('*',35,'*') ||';'|| '000000' ||';'|| '000000' ||';'|| '000000' ||';'||  '000000' ||';'|| '0' ||';'|| '||' ||';'|| '0' ||';'|| '||'
        		||';' AS TEXTO,
        		IDPESAPROD,		CDATAPRODITM,		CDBARPRODUTO,		 B.VRPRECITEM,		QTDIAVALPRODVND,    NMPRODUTO,		CDINFOEXTRA,
        		:CDFILIAL AS CDFILIAL, :CDTABEPREC AS CDTABEPREC, :LISTA AS LISTA, :TODOS AS TODOS, :PRODINI AS PRODINI, :PRODFIN AS PRODFIN

        FROM PRODUTO P
        LEFT JOIN (
            SELECT DISTINCT I.CDIDENTBUTON, I.CDATAPRODITM
            FROM ITMENUCONFTE I, CONFTELA C
            WHERE I.IDTPBUTTON IN ('1','9','A')
              AND I.CDFILIAL = :CDFILIAL
              AND I.CDFILIAL = C.CDFILIAL
              AND I.NRCONFTELA = C.NRCONFTELA
              AND I.CDATAPRODITM IS NOT NULL
        ) I ON P.CDPRODUTO = I.CDIDENTBUTON,
        
        (
            SELECT IM.CDPRODUTO, IM.VRPRECITEM
            FROM ITEMPRECOGER IM, TABEVENDGER T
            WHERE 
              T.CDTABEPREC IN (
                SELECT CDTABEPREC FROM FILITABGER WHERE CDFILIAL = :CDFILIAL
              )
              AND (SYSDATE BETWEEN T.DTINIVGPREC AND T.DTFINVGPREC)
              AND T.CDTABEPREC = IM.CDTABEPREC
              AND T.DTINIVGPREC = IM.DTINIVGPREC
        ) B
        
        WHERE P.CDPRODUTO = B.CDPRODUTO
          AND ((P.IDPESAPROD = :IDPESAPROD) OR (:IDPESAPROD = 'T'))
          AND (P.CDBARPRODUTO IS NOT NULL OR I.CDATAPRODITM IS NOT NULL)
          AND ((INSTR(:LISTA, CDARVPROD) > 0) OR (:TODOS = 'T') OR (CDARVPROD BETWEEN :PRODINI AND :PRODFIN))
    ";

    const GET_TXTINFO = "
        SELECT CDINFOEXTRA||';'|| RPAD(NVL(DSOBSINFOEXTRA,'*'),100,'*') ||';'|| RPAD(NVL(DSINFOEXTRA,'*'),1120,'*') ||';' AS TEXTO  FROM INFOEXTRA
    ";

    const UPDATE_CADAUTOMATICO_PRODUTO = "
        UPDATE PRODUTO
            SET CDINFOEXTRA = :P_CDINFOEXTRA
            WHERE ((INSTR(:P_LISTA, CDARVPROD) > 0) OR (:P_TODOS = 'T') OR (CDARVPROD BETWEEN :P_PRODINI AND :P_PRODFIN))
            AND CDPRODUTO IN (
                SELECT CDPRODUTO
                    FROM ITEMPRECO I
                        JOIN TABEVEND T
                            ON T.CDFILIAL = I.CDFILIAL
                                AND T.CDTABEPREC = I.CDTABEPREC
                                AND T.DTINIVGPREC = I.DTINIVGPREC
                    WHERE T.CDFILIAL = :P_CDFILIAL
                        AND T.CDTABEPREC = :P_CDTABEPREC
                        AND (SYSDATE BETWEEN T.DTINIVGPREC AND T.DTFINVGPREC)
            )
    ";
    
    const UPDATE_CADAUTOMATICO_PRODUTO_GERAL = "
        UPDATE PRODUTO
            SET CDINFOEXTRA = :P_CDINFOEXTRA
            WHERE ((INSTR(:P_LISTA, CDARVPROD) > 0) OR (:P_TODOS = 'T') OR (CDARVPROD BETWEEN :P_PRODINI AND :P_PRODFIN))
            AND CDPRODUTO IN (
                SELECT CDPRODUTO
                    FROM ITEMPRECOGER I
                        JOIN TABEVENDGER T
                            ON T.CDTABEPREC = I.CDTABEPREC
                                AND T.DTINIVGPREC = I.DTINIVGPREC
                    WHERE T.CDTABEPREC = :P_CDTABEPREC
                        AND (SYSDATE BETWEEN T.DTINIVGPREC AND T.DTFINVGPREC)
            )
    ";
    
    const GET_TAB_PRECO_GERAL = "
        SELECT T.CDTABEPREC, T.NMTABEPREC, T.NRORG
            FROM FILITABGER F
                JOIN TABEPRECGER T
                    ON T.CDTABEPREC = F.CDTABEPREC
                        AND T.NRORG = F.NRORG
            WHERE F.CDFILIAL = :CDFILIAL
                AND T.NRORG = :NRORG
        ORDER BY T.CDTABEPREC
    ";
    
    const INSERT_INFOEXTRA = "
	    INSERT INTO INFOEXTRA
		  (CDINFOEXTRA, DSINFOEXTRA, DSOBSINFOEXTRA, NRORG)
		  VALUES (:CDINFOEXTRA, :DSINFOEXTRA, :DSOBSINFOEXTRA, :NRORG)
    ";
    
    const UPDATE_INFOEXTRA = "
	     UPDATE INFOEXTRA
    	  SET
    	    DSINFOEXTRA 	= :DSINFOEXTRA,
    	    DSOBSINFOEXTRA 	= :DSOBSINFOEXTRA
    	  WHERE CDINFOEXTRA = :CDINFOEXTRA
    	   AND NRORG			= :NRORG
    ";
    
    const DELETE_INFOEXTRA = "
        DELETE FROM INFOEXTRA 
        WHERE NRORG = :NRORG 
        AND CDINFOEXTRA = :CDINFOEXTRA
    ";
    
    const GET_ARQUIVO_NUTRI = "
      SELECT CDINFORMNUTRI, QTPORCAOVND, IDUNPORCAOVND, QTMEDCASVND, IDPADEMEDCASVND, IDTIPOMEDCASVND, VRENRGNUTRI, QTDCARBNUTRI, QTDPROTNUTRI, 
        QTDGTOTNUTRI,  QTDGSATNUTRI, QTDGTRANUTRI, QTDFIBRANUTRI, QTDSODNUTRI
      FROM PRODUTO
    ";
}